/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],E=0,T=ge.length;E<T;E++)e[E]=Pe[ge[E]];return e};define(Pe[66],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function E(R){return($,g,b)=>{let A=null,k=null;if(typeof b.value=="function"?(A="value",k=b.value):typeof b.get=="function"&&(A="get",k=b.get),!k)throw new Error("not supported");b[A]=R(k,g)}}function T(R,$,g){let b=null,A=null;if(typeof g.value=="function"?(b="value",A=g.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(b="get",A=g.get),!A)throw new Error("not supported");const k=`$memoize$${$}`;g[b]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[k]}}e.$wh=T;function I(R,$,g){return E((b,A)=>{const k=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...p){this[l]||(this[l]=g?g():void 0),clearTimeout(this[k]),$&&(this[l]=$(this[l],...p),p=[this[l]]),this[k]=setTimeout(()=>{b.apply(this,p),this[l]=g?g():void 0},R)}})}e.$xh=I;function M(R,$,g){return E((b,A)=>{const k=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...r){if(this[l]||(this[l]=g?g():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),$&&(this[l]=$(this[l],...r)),this[w])return;const o=this[p]+R;o<=Date.now()?(this[p]=Date.now(),b.apply(this,[this[l]]),this[l]=g?g():void 0):(this[w]=!0,this[k]=setTimeout(()=>{this[w]=!1,this[p]=Date.now(),b.apply(this,[this[l]]),this[l]=g?g():void 0},o-Date.now()))}})}e.$yh=M}),define(Pe[89],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=void 0;class E{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$bN=E,e.$cN=new E("id#")}),define(Pe[119],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(i,s=!1){let u=0;const d=i.length;let m="",f=0,S=16,L=0;function v(W){let P=0,C=0;for(;P<W;){const J=i.charCodeAt(u);if(J>=48&&J<=57)C=C*16+J-48;else if(J>=65&&J<=70)C=C*16+J-65+10;else if(J>=97&&J<=102)C=C*16+J-97+10;else break;u++,P++}return P<W&&(C=-1),C}function y(W){u=W,m="",f=0,S=16,L=0}function D(){const W=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&b(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&b(i.charCodeAt(u)))for(u++;u<i.length&&b(i.charCodeAt(u));)u++;else return L=3,i.substring(W,u);let P=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&b(i.charCodeAt(u))){for(u++;u<i.length&&b(i.charCodeAt(u));)u++;P=u}else L=3;return i.substring(W,P)}function N(){let W="",P=u;for(;;){if(u>=d){W+=i.substring(P,u),L=2;break}const C=i.charCodeAt(u);if(C===34){W+=i.substring(P,u),u++;break}if(C===92){if(W+=i.substring(P,u),u++,u>=d){L=2;break}switch(i.charCodeAt(u++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const ae=v(4);ae>=0?W+=String.fromCharCode(ae):L=4;break}default:L=5}P=u;continue}if(C>=0&&C<=31)if(g(C)){W+=i.substring(P,u),L=2;break}else L=6;u++}return W}function O(){if(m="",L=0,f=u,u>=d)return f=d,S=17;let W=i.charCodeAt(u);if($(W)){do u++,m+=String.fromCharCode(W),W=i.charCodeAt(u);while($(W));return S=15}if(g(W))return u++,m+=String.fromCharCode(W),W===13&&i.charCodeAt(u)===10&&(u++,m+=`
`),S=14;switch(W){case 123:return u++,S=1;case 125:return u++,S=2;case 91:return u++,S=3;case 93:return u++,S=4;case 58:return u++,S=6;case 44:return u++,S=5;case 34:return u++,m=N(),S=10;case 47:{const P=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<d&&!g(i.charCodeAt(u));)u++;return m=i.substring(P,u),S=12}if(i.charCodeAt(u+1)===42){u+=2;const C=d-1;let J=!1;for(;u<C;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,J=!0;break}u++}return J||(u++,L=1),m=i.substring(P,u),S=13}return m+=String.fromCharCode(W),u++,S=16}case 45:if(m+=String.fromCharCode(W),u++,u===d||!b(i.charCodeAt(u)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=D(),S=11;default:for(;u<d&&H(W);)u++,W=i.charCodeAt(u);if(f!==u){switch(m=i.substring(f,u),m){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return m+=String.fromCharCode(W),u++,S=16}}function H(W){if($(W)||g(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let W;do W=O();while(W>=12&&W<=15);return W}return{setPosition:y,getPosition:()=>u,scan:s?U:O,getToken:()=>S,getTokenValue:()=>m,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>L}}e.$_m=R;function $(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function b(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function k(i,s){const u=[],d=new Object;let m;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function L(v,y,D,N){f.value=v,f.offset=y,f.length=D,f.type=N,f.colonOffset=void 0,m=f}try{a(i,{onObjectBegin:(v,y)=>{if(s<=v)throw d;m=void 0,S=s>v,u.push("")},onObjectProperty:(v,y,D)=>{if(s<y||(L(v,y,D,"property"),u[u.length-1]=v,s<=y+D))throw d},onObjectEnd:(v,y)=>{if(s<=v)throw d;m=void 0,u.pop()},onArrayBegin:(v,y)=>{if(s<=v)throw d;m=void 0,u.push(0)},onArrayEnd:(v,y)=>{if(s<=v)throw d;m=void 0,u.pop()},onLiteralValue:(v,y,D)=>{if(s<y||(L(v,y,D,h(v)),s<=y+D))throw d},onSeparator:(v,y,D)=>{if(s<=y)throw d;if(v===":"&&m&&m.type==="property")m.colonOffset=y,S=!1,m=void 0;else if(v===","){const N=u[u.length-1];typeof N=="number"?u[u.length-1]=N+1:(S=!0,u[u.length-1]=""),m=void 0}}})}catch(v){if(v!==d)throw v}return{path:u,previousNode:m,isAtPropertyKey:S,matches:v=>{let y=0;for(let D=0;y<v.length&&D<u.length;D++)if(v[y]===u[D]||v[y]==="*")y++;else if(v[y]!=="**")return!1;return y===v.length}}}e.$an=k;function l(i,s=[],u=M.DEFAULT){let d=null,m=[];const f=[];function S(v){Array.isArray(m)?m.push(v):d!==null&&(m[d]=v)}return a(i,{onObjectBegin:()=>{const v={};S(v),f.push(m),m=v,d=null},onObjectProperty:v=>{d=v},onObjectEnd:()=>{m=f.pop()},onArrayBegin:()=>{const v=[];S(v),f.push(m),m=v,d=null},onArrayEnd:()=>{m=f.pop()},onLiteralValue:S,onError:(v,y,D)=>{s.push({error:v,offset:y,length:D})}},u),m[0]}e.$bn=l;function p(i,s=[],u=M.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(v){d.type==="property"&&(d.length=v-d.offset,d=d.parent)}function f(v){return d.children.push(v),v}a(i,{onObjectBegin:v=>{d=f({type:"object",offset:v,length:-1,parent:d,children:[]})},onObjectProperty:(v,y,D)=>{d=f({type:"property",offset:y,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:v,offset:y,length:D,parent:d})},onObjectEnd:(v,y)=>{d.length=v+y-d.offset,d=d.parent,m(v+y)},onArrayBegin:(v,y)=>{d=f({type:"array",offset:v,length:-1,parent:d,children:[]})},onArrayEnd:(v,y)=>{d.length=v+y-d.offset,d=d.parent,m(v+y)},onLiteralValue:(v,y,D)=>{f({type:h(v),offset:y,length:D,parent:d,value:v}),m(y+D)},onSeparator:(v,y,D)=>{d.type==="property"&&(v===":"?d.colonOffset=y:v===","&&m(y))},onError:(v,y,D)=>{s.push({error:v,offset:y,length:D})}},u);const L=d.children[0];return L&&delete L.parent,L}e.$cn=p;function w(i,s){if(!i)return;let u=i;for(const d of s)if(typeof d=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===d){u=f.children[1],m=!0;break}if(!m)return}else{const m=d;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}e.$dn=w;function r(i){if(!i.parent||!i.parent.children)return[];const s=r(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;s.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&s.push(u)}return s}e.$en=r;function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const s=Object.create(null);for(const u of i.children){const d=u.children[1];d&&(s[u.children[0].value]=o(d))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$fn=o;function t(i,s,u=!1){return s>=i.offset&&s<i.offset+i.length||u&&s===i.offset+i.length}e.$gn=t;function n(i,s,u=!1){if(t(i,s,u)){const d=i.children;if(Array.isArray(d))for(let m=0;m<d.length&&d[m].offset<=s;m++){const f=n(d[m],s,u);if(f)return f}return i}}e.$hn=n;function a(i,s,u=M.DEFAULT){const d=R(i,!1);function m(ee){return ee?()=>ee(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(ee){return ee?De=>ee(De,d.getTokenOffset(),d.getTokenLength()):()=>!0}const S=m(s.onObjectBegin),L=f(s.onObjectProperty),v=m(s.onObjectEnd),y=m(s.onArrayBegin),D=m(s.onArrayEnd),N=f(s.onLiteralValue),O=f(s.onSeparator),H=m(s.onComment),U=f(s.onError),W=u&&u.disallowComments,P=u&&u.allowTrailingComma;function C(){for(;;){const ee=d.scan();switch(d.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:W||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(ee){case 12:case 13:W?J(10):H();break;case 16:J(1);break;case 15:case 14:break;default:return ee}}}function J(ee,De=[],se=[]){if(U(ee),De.length+se.length>0){let x=d.getToken();for(;x!==17;){if(De.indexOf(x)!==-1){C();break}else if(se.indexOf(x)!==-1)break;x=C()}}}function ae(ee){const De=d.getTokenValue();return ee?N(De):L(De),C(),!0}function fe(){switch(d.getToken()){case 11:{let ee=0;try{ee=JSON.parse(d.getTokenValue()),typeof ee!="number"&&(J(2),ee=0)}catch{J(2)}N(ee);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return C(),!0}function we(){return d.getToken()!==10?(J(3,[],[2,5]),!1):(ae(!1),d.getToken()===6?(O(":"),C(),ve()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function ye(){S(),C();let ee=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(ee||J(4,[],[]),O(","),C(),d.getToken()===2&&P)break}else ee&&J(6,[],[]);we()||J(4,[],[2,5]),ee=!0}return v(),d.getToken()!==2?J(7,[2],[]):C(),!0}function he(){y(),C();let ee=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(ee||J(4,[],[]),O(","),C(),d.getToken()===4&&P)break}else ee&&J(6,[],[]);ve()||J(4,[],[4,5]),ee=!0}return D(),d.getToken()!==4?J(8,[4],[]):C(),!0}function ve(){switch(d.getToken()){case 3:return he();case 1:return ye();case 10:return ae(!0);default:return fe()}}return C(),d.getToken()===17?u.allowEmptyContent?!0:(J(4,[],[]),!1):ve()?(d.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.$in=a;function c(i,s){const u=R(i),d=[];let m,f=0,S;do switch(S=u.getPosition(),m=u.scan(),m){case 12:case 13:case 17:f!==S&&d.push(i.substring(f,S)),s!==void 0&&d.push(u.getTokenValue().replace(/[^\r\n]/g,s)),f=u.getPosition();break}while(m!==17);return d.join("")}e.$jn=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$kn=h}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ce,ce){for(var ie=0;ie<ce.length;ie++){var Q=ce[ie];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ce,Q.key,Q)}}function E(Ce,ce,ie){return ce&&e(Ce.prototype,ce),ie&&e(Ce,ie),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function T(Ce,ce){if(Ce){if(typeof Ce=="string")return I(Ce,ce);var ie=Object.prototype.toString.call(Ce).slice(8,-1);if(ie==="Object"&&Ce.constructor&&(ie=Ce.constructor.name),ie==="Map"||ie==="Set")return Array.from(Ce);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return I(Ce,ce)}}function I(Ce,ce){(ce==null||ce>Ce.length)&&(ce=Ce.length);for(var ie=0,Q=new Array(ce);ie<ce;ie++)Q[ie]=Ce[ie];return Q}function M(Ce,ce){var ie=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(ie)return(ie=ie.call(Ce)).next.bind(ie);if(Array.isArray(Ce)||(ie=T(Ce))||ce&&Ce&&typeof Ce.length=="number"){ie&&(Ce=ie);var Q=0;return function(){return Q>=Ce.length?{done:!0}:{done:!1,value:Ce[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=R();function $(Ce){ge.defaults=Ce}var g=/[&<>"']/,b=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ce){return l[ce]};function w(Ce,ce){if(ce){if(g.test(Ce))return Ce.replace(b,p)}else if(A.test(Ce))return Ce.replace(k,p);return Ce}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ce){return Ce.replace(r,function(ce,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Ce,ce){Ce=typeof Ce=="string"?Ce:Ce.source,ce=ce||"";var ie={replace:function(te,me){return me=me.source||me,me=me.replace(t,"$1"),Ce=Ce.replace(te,me),ie},getRegex:function(){return new RegExp(Ce,ce)}};return ie}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,ce,ie){if(Ce){var Q;try{Q=decodeURIComponent(o(ie)).replace(a,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}ce&&!c.test(ie)&&(ie=m(ce,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var i={},s=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(Ce,ce){i[" "+Ce]||(s.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=v(Ce,"/",!0)),Ce=i[" "+Ce];var ie=Ce.indexOf(":")===-1;return ce.substring(0,2)==="//"?ie?ce:Ce.replace(u,"$1")+ce:ce.charAt(0)==="/"?ie?ce:Ce.replace(d,"$1")+ce:Ce+ce}var f={exec:function(){}};function S(Ce){for(var ce=1,ie,Q;ce<arguments.length;ce++){ie=arguments[ce];for(Q in ie)Object.prototype.hasOwnProperty.call(ie,Q)&&(Ce[Q]=ie[Q])}return Ce}function L(Ce,ce){var ie=Ce.replace(/\|/g,function(me,pe,Ae){for(var le=!1,be=pe;--be>=0&&Ae[be]==="\\";)le=!le;return le?"|":" |"}),Q=ie.split(/ \|/),te=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>ce)Q.splice(ce);else for(;Q.length<ce;)Q.push("");for(;te<Q.length;te++)Q[te]=Q[te].trim().replace(/\\\|/g,"|");return Q}function v(Ce,ce,ie){var Q=Ce.length;if(Q===0)return"";for(var te=0;te<Q;){var me=Ce.charAt(Q-te-1);if(me===ce&&!ie)te++;else if(me!==ce&&ie)te++;else break}return Ce.slice(0,Q-te)}function y(Ce,ce){if(Ce.indexOf(ce[1])===-1)return-1;for(var ie=Ce.length,Q=0,te=0;te<ie;te++)if(Ce[te]==="\\")te++;else if(Ce[te]===ce[0])Q++;else if(Ce[te]===ce[1]&&(Q--,Q<0))return te;return-1}function D(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(Ce,ce){if(ce<1)return"";for(var ie="";ce>1;)ce&1&&(ie+=Ce),ce>>=1,Ce+=Ce;return ie+Ce}function O(Ce,ce,ie,Q){var te=ce.href,me=ce.title?w(ce.title):null,pe=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ae={type:"link",raw:ie,href:te,title:me,text:pe,tokens:Q.inlineTokens(pe)};return Q.state.inLink=!1,Ae}return{type:"image",raw:ie,href:te,title:me,text:w(pe)}}function H(Ce,ce){var ie=Ce.match(/^(\s+)(?:```)/);if(ie===null)return ce;var Q=ie[1];return ce.split(`
`).map(function(te){var me=te.match(/^\s+/);if(me===null)return te;var pe=me[0];return pe.length>=Q.length?te.slice(Q.length):te}).join(`
`)}var U=function(){function Ce(ie){this.options=ie||ge.defaults}var ce=Ce.prototype;return ce.space=function(Q){var te=this.rules.block.newline.exec(Q);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ce.code=function(Q){var te=this.rules.block.code.exec(Q);if(te){var me=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?me:v(me,`
`)}}},ce.fences=function(Q){var te=this.rules.block.fences.exec(Q);if(te){var me=te[0],pe=H(me,te[3]||"");return{type:"code",raw:me,lang:te[2]?te[2].trim():te[2],text:pe}}},ce.heading=function(Q){var te=this.rules.block.heading.exec(Q);if(te){var me=te[2].trim();if(/#$/.test(me)){var pe=v(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:me,tokens:this.lexer.inline(me)}}},ce.hr=function(Q){var te=this.rules.block.hr.exec(Q);if(te)return{type:"hr",raw:te[0]}},ce.blockquote=function(Q){var te=this.rules.block.blockquote.exec(Q);if(te){var me=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},ce.list=function(Q){var te=this.rules.block.list.exec(Q);if(te){var me,pe,Ae,le,be,F,q,K,z,X,Y,Ee,Te=te[1].trim(),We=Te.length>1,Ke={type:"list",raw:"",ordered:We,start:We?+Te.slice(0,-1):"",loose:!1,items:[]};Te=We?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=We?Te:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(Ee=!1,!(!(te=Ze.exec(Q))||this.rules.block.hr.test(Q)));){if(me=te[0],Q=Q.substring(me.length),K=te[2].split(`
`,1)[0],z=Q.split(`
`,1)[0],this.options.pedantic?(le=2,Y=K.trimLeft()):(le=te[2].search(/[^ ]/),le=le>4?1:le,Y=K.slice(le),le+=te[1].length),F=!1,!K&&/^ *$/.test(z)&&(me+=z+`
`,Q=Q.substring(z.length+1),Ee=!0),!Ee)for(var st=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");Q&&(X=Q.split(`
`,1)[0],K=X,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(K)||at.test(K)||st.test(K)||nt.test(Q)));){if(K.search(/[^ ]/)>=le||!K.trim())Y+=`
`+K.slice(le);else if(!F)Y+=`
`+K;else break;!F&&!K.trim()&&(F=!0),me+=X+`
`,Q=Q.substring(X.length+1)}Ke.loose||(q?Ke.loose=!0:/\n *\n *$/.test(me)&&(q=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(Y),pe&&(Ae=pe[0]!=="[ ] ",Y=Y.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:me,task:!!pe,checked:Ae,loose:!1,text:Y}),Ke.raw+=me}Ke.items[Ke.items.length-1].raw=me.trimRight(),Ke.items[Ke.items.length-1].text=Y.trimRight(),Ke.raw=Ke.raw.trimRight();var ct=Ke.items.length;for(be=0;be<ct;be++){this.lexer.state.top=!1,Ke.items[be].tokens=this.lexer.blockTokens(Ke.items[be].text,[]);var je=Ke.items[be].tokens.filter(function(Z){return Z.type==="space"}),vt=je.every(function(Z){for(var _=Z.raw.split(""),$e=0,Be=M(_),Qe;!(Qe=Be()).done;){var it=Qe.value;if(it===`
`&&($e+=1),$e>1)return!0}return!1});!Ke.loose&&je.length&&vt&&(Ke.loose=!0,Ke.items[be].loose=!0)}return Ke}},ce.html=function(Q){var te=this.rules.block.html.exec(Q);if(te){var me={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(te[0]):w(te[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},ce.def=function(Q){var te=this.rules.block.def.exec(Q);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var me=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:te[0],href:te[2],title:te[3]}}},ce.table=function(Q){var te=this.rules.block.table.exec(Q);if(te){var me={type:"table",header:L(te[1]).map(function(q){return{text:q}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=te[0];var pe=me.align.length,Ae,le,be,F;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(pe=me.rows.length,Ae=0;Ae<pe;Ae++)me.rows[Ae]=L(me.rows[Ae],me.header.length).map(function(q){return{text:q}});for(pe=me.header.length,le=0;le<pe;le++)me.header[le].tokens=this.lexer.inline(me.header[le].text);for(pe=me.rows.length,le=0;le<pe;le++)for(F=me.rows[le],be=0;be<F.length;be++)F[be].tokens=this.lexer.inline(F[be].text);return me}}},ce.lheading=function(Q){var te=this.rules.block.lheading.exec(Q);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ce.paragraph=function(Q){var te=this.rules.block.paragraph.exec(Q);if(te){var me=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:me,tokens:this.lexer.inline(me)}}},ce.text=function(Q){var te=this.rules.block.text.exec(Q);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ce.escape=function(Q){var te=this.rules.inline.escape.exec(Q);if(te)return{type:"escape",raw:te[0],text:w(te[1])}},ce.tag=function(Q){var te=this.rules.inline.tag.exec(Q);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):w(te[0]):te[0]}},ce.link=function(Q){var te=this.rules.inline.link.exec(Q);if(te){var me=te[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=v(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Ae=y(te[2],"()");if(Ae>-1){var le=te[0].indexOf("!")===0?5:4,be=le+te[1].length+Ae;te[2]=te[2].substring(0,Ae),te[0]=te[0].substring(0,be).trim(),te[3]=""}}var F=te[2],q="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(F);K&&(F=K[1],q=K[3])}else q=te[3]?te[3].slice(1,-1):"";return F=F.trim(),/^</.test(F)&&(this.options.pedantic&&!/>$/.test(me)?F=F.slice(1):F=F.slice(1,-1)),O(te,{href:F&&F.replace(this.rules.inline._escapes,"$1"),title:q&&q.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ce.reflink=function(Q,te){var me;if((me=this.rules.inline.reflink.exec(Q))||(me=this.rules.inline.nolink.exec(Q))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=te[pe.toLowerCase()],!pe||!pe.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return O(me,pe,me[0],this.lexer)}},ce.emStrong=function(Q,te,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(Q);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var le=pe[0].length-1,be,F,q=le,K=0,z=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,te=te.slice(-1*Q.length+le);(pe=z.exec(te))!=null;)if(be=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!be){if(F=be.length,pe[3]||pe[4]){q+=F;continue}else if((pe[5]||pe[6])&&le%3&&!((le+F)%3)){K+=F;continue}if(q-=F,!(q>0)){if(F=Math.min(F,F+q+K),Math.min(le,F)%2){var X=Q.slice(1,le+pe.index+F);return{type:"em",raw:Q.slice(0,le+pe.index+F+1),text:X,tokens:this.lexer.inlineTokens(X)}}var Y=Q.slice(2,le+pe.index+F-1);return{type:"strong",raw:Q.slice(0,le+pe.index+F+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}}}}},ce.codespan=function(Q){var te=this.rules.inline.code.exec(Q);if(te){var me=te[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return pe&&Ae&&(me=me.substring(1,me.length-1)),me=w(me,!0),{type:"codespan",raw:te[0],text:me}}},ce.br=function(Q){var te=this.rules.inline.br.exec(Q);if(te)return{type:"br",raw:te[0]}},ce.del=function(Q){var te=this.rules.inline.del.exec(Q);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ce.autolink=function(Q,te){var me=this.rules.inline.autolink.exec(Q);if(me){var pe,Ae;return me[2]==="@"?(pe=w(this.options.mangle?te(me[1]):me[1]),Ae="mailto:"+pe):(pe=w(me[1]),Ae=pe),{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.url=function(Q,te){var me;if(me=this.rules.inline.url.exec(Q)){var pe,Ae;if(me[2]==="@")pe=w(this.options.mangle?te(me[0]):me[0]),Ae="mailto:"+pe;else{var le;do le=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(le!==me[0]);pe=w(me[0]),me[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.inlineText=function(Q,te){var me=this.rules.inline.text.exec(Q);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):w(me[0]):me[0]:pe=w(this.options.smartypants?te(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},Ce}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=n(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=n(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=n(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=n(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=n(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=n(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=S({},W),W.gfm=S({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=n(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=n(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=S({},W.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:n(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=n(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=n(W._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=n(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=n(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=n(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=n(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=n(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=n(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=n(P.reflink).replace("label",P._label).replace("ref",W._label).getRegex(),P.nolink=n(P.nolink).replace("ref",W._label).getRegex(),P.reflinkSearch=n(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=S({},P),P.pedantic=S({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=S({},P.normal,{escape:n(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=n(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=S({},P.gfm,{br:n(P.br).replace("{2,}","*").getRegex(),text:n(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function C(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(Ce){var ce="",ie,Q,te=Ce.length;for(ie=0;ie<te;ie++)Q=Ce.charCodeAt(ie),Math.random()>.5&&(Q="x"+Q.toString(16)),ce+="&#"+Q+";";return ce}var ae=function(){function Ce(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||ge.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:W.normal,inline:P.normal};this.options.pedantic?(Q.block=W.pedantic,Q.inline=P.pedantic):this.options.gfm&&(Q.block=W.gfm,this.options.breaks?Q.inline=P.breaks:Q.inline=P.gfm),this.tokenizer.rules=Q}Ce.lex=function(Q,te){var me=new Ce(te);return me.lex(Q)},Ce.lexInline=function(Q,te){var me=new Ce(te);return me.inlineTokens(Q)};var ce=Ce.prototype;return ce.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ce.blockTokens=function(Q,te){var me=this;te===void 0&&(te=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(q,K,z){return K+"    ".repeat(z.length)});for(var pe,Ae,le,be;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(q){return(pe=q.call({lexer:me},Q,te))?(Q=Q.substring(pe.raw.length),te.push(pe),!0):!1}))){if(pe=this.tokenizer.space(Q)){Q=Q.substring(pe.raw.length),pe.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(pe);continue}if(pe=this.tokenizer.code(Q)){Q=Q.substring(pe.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(pe);continue}if(pe=this.tokenizer.fences(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.heading(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.hr(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.blockquote(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.list(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.html(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.def(Q)){Q=Q.substring(pe.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.lheading(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(le=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var q=1/0,K=Q.slice(1),z=void 0;me.options.extensions.startBlock.forEach(function(X){z=X.call({lexer:this},K),typeof z=="number"&&z>=0&&(q=Math.min(q,z))}),q<1/0&&q>=0&&(le=Q.substring(0,q+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(le))){Ae=te[te.length-1],be&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(pe),be=le.length!==Q.length,Q=Q.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(Q)){Q=Q.substring(pe.raw.length),Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(pe);continue}if(Q){var F="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(F);break}else throw new Error(F)}}return this.state.top=!0,te},ce.inline=function(Q,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:Q,tokens:te}),te},ce.inlineTokens=function(Q,te){var me=this;te===void 0&&(te=[]);var pe,Ae,le,be=Q,F,q,K;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(F=this.tokenizer.rules.inline.reflinkSearch.exec(be))!=null;)z.includes(F[0].slice(F[0].lastIndexOf("[")+1,-1))&&(be=be.slice(0,F.index)+"["+N("a",F[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(F=this.tokenizer.rules.inline.blockSkip.exec(be))!=null;)be=be.slice(0,F.index)+"["+N("a",F[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(F=this.tokenizer.rules.inline.escapedEmSt.exec(be))!=null;)be=be.slice(0,F.index)+"++"+be.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(q||(K=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Y){return(pe=Y.call({lexer:me},Q,te))?(Q=Q.substring(pe.raw.length),te.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.tag(Q)){Q=Q.substring(pe.raw.length),Ae=te[te.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):te.push(pe);continue}if(pe=this.tokenizer.link(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(pe.raw.length),Ae=te[te.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):te.push(pe);continue}if(pe=this.tokenizer.emStrong(Q,be,K)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.codespan(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.br(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.del(Q)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(pe=this.tokenizer.autolink(Q,J)){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(Q,J))){Q=Q.substring(pe.raw.length),te.push(pe);continue}if(le=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var Y=1/0,Ee=Q.slice(1),Te=void 0;me.options.extensions.startInline.forEach(function(We){Te=We.call({lexer:this},Ee),typeof Te=="number"&&Te>=0&&(Y=Math.min(Y,Te))}),Y<1/0&&Y>=0&&(le=Q.substring(0,Y+1))}(),pe=this.tokenizer.inlineText(le,C)){Q=Q.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(K=pe.raw.slice(-1)),q=!0,Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):te.push(pe);continue}if(Q){var X="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return te},E(Ce,null,[{key:"rules",get:function(){return{block:W,inline:P}}}]),Ce}(),fe=function(){function Ce(ie){this.options=ie||ge.defaults}var ce=Ce.prototype;return ce.code=function(Q,te,me){var pe=(te||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(Q,pe);Ae!=null&&Ae!==Q&&(me=!0,Q=Ae)}return Q=Q.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+w(pe,!0)+'">'+(me?Q:w(Q,!0))+`</code></pre>
`:"<pre><code>"+(me?Q:w(Q,!0))+`</code></pre>
`},ce.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},ce.html=function(Q){return Q},ce.heading=function(Q,te,me,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug(me);return"<h"+te+' id="'+Ae+'">'+Q+"</h"+te+`>
`}return"<h"+te+">"+Q+"</h"+te+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Q,te,me){var pe=te?"ol":"ul",Ae=te&&me!==1?' start="'+me+'"':"";return"<"+pe+Ae+`>
`+Q+"</"+pe+`>
`},ce.listitem=function(Q){return"<li>"+Q+`</li>
`},ce.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Q){return"<p>"+Q+`</p>
`},ce.table=function(Q,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+te+`</table>
`},ce.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},ce.tablecell=function(Q,te){var me=te.header?"th":"td",pe=te.align?"<"+me+' align="'+te.align+'">':"<"+me+">";return pe+Q+("</"+me+`>
`)},ce.strong=function(Q){return"<strong>"+Q+"</strong>"},ce.em=function(Q){return"<em>"+Q+"</em>"},ce.codespan=function(Q){return"<code>"+Q+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Q){return"<del>"+Q+"</del>"},ce.link=function(Q,te,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var pe='<a href="'+w(Q)+'"';return te&&(pe+=' title="'+te+'"'),pe+=">"+me+"</a>",pe},ce.image=function(Q,te,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var pe='<img src="'+Q+'" alt="'+me+'"';return te&&(pe+=' title="'+te+'"'),pe+=this.options.xhtml?"/>":">",pe},ce.text=function(Q){return Q},Ce}(),we=function(){function Ce(){}var ce=Ce.prototype;return ce.strong=function(Q){return Q},ce.em=function(Q){return Q},ce.codespan=function(Q){return Q},ce.del=function(Q){return Q},ce.html=function(Q){return Q},ce.text=function(Q){return Q},ce.link=function(Q,te,me){return""+me},ce.image=function(Q,te,me){return""+me},ce.br=function(){return""},Ce}(),ye=function(){function Ce(){this.seen={}}var ce=Ce.prototype;return ce.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Q,te){var me=Q,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[Q];do pe++,me=Q+"-"+pe;while(this.seen.hasOwnProperty(me))}return te||(this.seen[Q]=pe,this.seen[me]=0),me},ce.slug=function(Q,te){te===void 0&&(te={});var me=this.serialize(Q);return this.getNextSafeSlug(me,te.dryrun)},Ce}(),he=function(){function Ce(ie){this.options=ie||ge.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ye}Ce.parse=function(Q,te){var me=new Ce(te);return me.parse(Q)},Ce.parseInline=function(Q,te){var me=new Ce(te);return me.parseInline(Q)};var ce=Ce.prototype;return ce.parse=function(Q,te){te===void 0&&(te=!0);var me="",pe,Ae,le,be,F,q,K,z,X,Y,Ee,Te,We,Ke,Ze,st,nt,tt,at,ct=Q.length;for(pe=0;pe<ct;pe++){if(Y=Q[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Y.type]&&(at=this.options.extensions.renderers[Y.type].call({parser:this},Y),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Y.type))){me+=at||"";continue}switch(Y.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(Y.tokens),Y.depth,o(this.parseInline(Y.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(Y.text,Y.lang,Y.escaped);continue}case"table":{for(z="",K="",be=Y.header.length,Ae=0;Ae<be;Ae++)K+=this.renderer.tablecell(this.parseInline(Y.header[Ae].tokens),{header:!0,align:Y.align[Ae]});for(z+=this.renderer.tablerow(K),X="",be=Y.rows.length,Ae=0;Ae<be;Ae++){for(q=Y.rows[Ae],K="",F=q.length,le=0;le<F;le++)K+=this.renderer.tablecell(this.parseInline(q[le].tokens),{header:!1,align:Y.align[le]});X+=this.renderer.tablerow(K)}me+=this.renderer.table(z,X);continue}case"blockquote":{X=this.parse(Y.tokens),me+=this.renderer.blockquote(X);continue}case"list":{for(Ee=Y.ordered,Te=Y.start,We=Y.loose,be=Y.items.length,X="",Ae=0;Ae<be;Ae++)Ze=Y.items[Ae],st=Ze.checked,nt=Ze.task,Ke="",Ze.task&&(tt=this.renderer.checkbox(st),We?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=tt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=tt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:tt}):Ke+=tt),Ke+=this.parse(Ze.tokens,We),X+=this.renderer.listitem(Ke,nt,st);me+=this.renderer.list(X,Ee,Te);continue}case"html":{me+=this.renderer.html(Y.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(Y.tokens));continue}case"text":{for(X=Y.tokens?this.parseInline(Y.tokens):Y.text;pe+1<ct&&Q[pe+1].type==="text";)Y=Q[++pe],X+=`
`+(Y.tokens?this.parseInline(Y.tokens):Y.text);me+=te?this.renderer.paragraph(X):X;continue}default:{var je='Token with "'+Y.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return me},ce.parseInline=function(Q,te){te=te||this.renderer;var me="",pe,Ae,le,be=Q.length;for(pe=0;pe<be;pe++){if(Ae=Q[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(le=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=le||"";continue}switch(Ae.type){case"escape":{me+=te.text(Ae.text);break}case"html":{me+=te.html(Ae.text);break}case"link":{me+=te.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,te));break}case"image":{me+=te.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=te.strong(this.parseInline(Ae.tokens,te));break}case"em":{me+=te.em(this.parseInline(Ae.tokens,te));break}case"codespan":{me+=te.codespan(Ae.text);break}case"br":{me+=te.br();break}case"del":{me+=te.del(this.parseInline(Ae.tokens,te));break}case"text":{me+=te.text(Ae.text);break}default:{var F='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(F);return}else throw new Error(F)}}}return me},Ce}();function ve(Ce,ce,ie){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ce=="function"&&(ie=ce,ce=null),ce=S({},ve.defaults,ce||{}),D(ce),ie){var Q=ce.highlight,te;try{te=ae.lex(Ce,ce)}catch(be){return ie(be)}var me=function(F){var q;if(!F)try{ce.walkTokens&&ve.walkTokens(te,ce.walkTokens),q=he.parse(te,ce)}catch(K){F=K}return ce.highlight=Q,F?ie(F):ie(null,q)};if(!Q||Q.length<3||(delete ce.highlight,!te.length))return me();var pe=0;ve.walkTokens(te,function(be){be.type==="code"&&(pe++,setTimeout(function(){Q(be.text,be.lang,function(F,q){if(F)return me(F);q!=null&&q!==be.text&&(be.text=q,be.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Ae(be){if(be.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(be.message+"",!0)+"</pre>";throw be}try{var le=ae.lex(Ce,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ve.walkTokens(le,ce.walkTokens)).then(function(){return he.parse(le,ce)}).catch(Ae);ve.walkTokens(le,ce.walkTokens)}return he.parse(le,ce)}catch(be){Ae(be)}}ve.options=ve.setOptions=function(Ce){return S(ve.defaults,Ce),$(ve.defaults),ve},ve.getDefaults=R,ve.defaults=ge.defaults,ve.use=function(){for(var Ce=arguments.length,ce=new Array(Ce),ie=0;ie<Ce;ie++)ce[ie]=arguments[ie];var Q=S.apply(void 0,[{}].concat(ce)),te=ve.defaults.extensions||{renderers:{},childTokens:{}},me;ce.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var be=te.renderers?te.renderers[le.name]:null;be?te.renderers[le.name]=function(){for(var F=arguments.length,q=new Array(F),K=0;K<F;K++)q[K]=arguments[K];var z=le.renderer.apply(this,q);return z===!1&&(z=be.apply(this,q)),z}:te.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[le.level]?te[le.level].unshift(le.tokenizer):te[le.level]=[le.tokenizer],le.start&&(le.level==="block"?te.startBlock?te.startBlock.push(le.start):te.startBlock=[le.start]:le.level==="inline"&&(te.startInline?te.startInline.push(le.start):te.startInline=[le.start]))}le.childTokens&&(te.childTokens[le.name]=le.childTokens)})),pe.renderer&&function(){var le=ve.defaults.renderer||new fe,be=function(K){var z=le[K];le[K]=function(){for(var X=arguments.length,Y=new Array(X),Ee=0;Ee<X;Ee++)Y[Ee]=arguments[Ee];var Te=pe.renderer[K].apply(le,Y);return Te===!1&&(Te=z.apply(le,Y)),Te}};for(var F in pe.renderer)be(F);Q.renderer=le}(),pe.tokenizer&&function(){var le=ve.defaults.tokenizer||new U,be=function(K){var z=le[K];le[K]=function(){for(var X=arguments.length,Y=new Array(X),Ee=0;Ee<X;Ee++)Y[Ee]=arguments[Ee];var Te=pe.tokenizer[K].apply(le,Y);return Te===!1&&(Te=z.apply(le,Y)),Te}};for(var F in pe.tokenizer)be(F);Q.tokenizer=le}(),pe.walkTokens){var Ae=ve.defaults.walkTokens;Q.walkTokens=function(le){var be=[];return be.push(pe.walkTokens.call(this,le)),Ae&&(be=be.concat(Ae.call(this,le))),be}}me&&(Q.extensions=te),ve.setOptions(Q)})},ve.walkTokens=function(Ce,ce){for(var ie=[],Q=function(){var Ae=me.value;switch(ie=ie.concat(ce.call(ve,Ae)),Ae.type){case"table":{for(var le=M(Ae.header),be;!(be=le()).done;){var F=be.value;ie=ie.concat(ve.walkTokens(F.tokens,ce))}for(var q=M(Ae.rows),K;!(K=q()).done;)for(var z=K.value,X=M(z),Y;!(Y=X()).done;){var Ee=Y.value;ie=ie.concat(ve.walkTokens(Ee.tokens,ce))}break}case"list":{ie=ie.concat(ve.walkTokens(Ae.items,ce));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Ae.type]?ve.defaults.extensions.childTokens[Ae.type].forEach(function(Te){ie=ie.concat(ve.walkTokens(Ae[Te],ce))}):Ae.tokens&&(ie=ie.concat(ve.walkTokens(Ae.tokens,ce)))}},te=M(Ce),me;!(me=te()).done;)Q();return ie},ve.parseInline=function(Ce,ce){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ce=S({},ve.defaults,ce||{}),D(ce);try{var ie=ae.lexInline(Ce,ce);return ce.walkTokens&&ve.walkTokens(ie,ce.walkTokens),he.parseInline(ie,ce)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(Q.message+"",!0)+"</pre>";throw Q}},ve.Parser=he,ve.parser=he.parse,ve.Renderer=fe,ve.TextRenderer=we,ve.Lexer=ae,ve.lexer=ae.lex,ve.Tokenizer=U,ve.Slugger=ye,ve.parse=ve;var ee=ve.options,De=ve.setOptions,se=ve.use,x=ve.walkTokens,V=ve.parseInline,ne=ve,Ie=he.parse,Me=ae.lex;ge.Lexer=ae,ge.Parser=he,ge.Renderer=fe,ge.Slugger=ye,ge.TextRenderer=we,ge.Tokenizer=U,ge.getDefaults=R,ge.lexer=Me,ge.marked=ve,ge.options=ee,ge.parse=ne,ge.parseInline=V,ge.parser=Ie,ge.setOptions=De,ge.use=se,ge.walkTokens=x,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Pe[121],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=void 0;function E(r){const o=M(r);if(o&&o.length>0)return new Uint32Array(o)}e.$Qj=E;let T=0;const I=new Uint32Array(10);function M(r){if(T=0,R(r,k,4352),T>0||(R(r,l,4449),T>0)||(R(r,p,4520),T>0)||(R(r,w,12593),T))return I.subarray(0,T);if(r>=44032&&r<=55203){const o=r-44032,t=o%588,n=Math.floor(o/588),a=Math.floor(t/28),c=t%28-1;if(n<k.length?R(n,k,0):4352+n-12593<w.length&&R(4352+n,w,12593),a<l.length?R(a,l,0):4449+a-12593<w.length&&R(4449+a-12593,w,12593),c>=0&&(c<p.length?R(c,p,0):4520+c-12593<w.length&&R(4520+c-12593,w,12593)),T>0)return I.subarray(0,T)}}function R(r,o,t){r>=t&&r<t+o.length&&$(o[r-t])}function $(r){r!==0&&(I[T++]=r&255,r>>8&&(I[T++]=r>>8&255),r>>16&&(I[T++]=r>>16&255))}var g;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var b;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(b||(b={}));var A;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(A||(A={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),w=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[122],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.rot=e.$6l=void 0;function E($,g,b){return Math.min(Math.max($,g),b)}e.$6l=E;function T($,g){return(g+$%g)%g}e.rot=T;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$8l=I;class M{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$9l=M;class R{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const b=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$0l=R}),function(){function ge(I){const M=[];typeof I=="number"&&M.push("code/timeOrigin",I);function R(g){M.push(g,Date.now())}function $(){const g=[];for(let b=0;b<M.length;b+=2)g.push({name:M[b],startTime:M[b+1]});return g}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(I+R.startTime)});return M}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function E(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:ge)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function E(T){if(e[T])return e[T].exports;var I=e[T]={i:T,l:!1,exports:{}};return ge[T].call(I.exports,I,I.exports,E),I.l=!0,I.exports}return E.m=ge,E.c=e,E.d=function(T,I,M){E.o(T,I)||Object.defineProperty(T,I,{enumerable:!0,get:M})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,I){if(1&I&&(T=E(T)),8&I||4&I&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&I&&typeof T!="string")for(var R in T)E.d(M,R,function($){return T[$]}.bind(null,R));return M},E.n=function(T){var I=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(I,"a",I),I},E.o=function(T,I){return Object.prototype.hasOwnProperty.call(T,I)},E.p="",E(E.s=0)}([function(ge,e,E){(function(T){var I;e=ge.exports=se,I=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],g=e.src=[],b=0,A=b++;g[A]="0|[1-9]\\d*";var k=b++;g[k]="[0-9]+";var l=b++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=b++;g[p]="("+g[A]+")\\.("+g[A]+")\\.("+g[A]+")";var w=b++;g[w]="("+g[k]+")\\.("+g[k]+")\\.("+g[k]+")";var r=b++;g[r]="(?:"+g[A]+"|"+g[l]+")";var o=b++;g[o]="(?:"+g[k]+"|"+g[l]+")";var t=b++;g[t]="(?:-("+g[r]+"(?:\\."+g[r]+")*))";var n=b++;g[n]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var a=b++;g[a]="[0-9A-Za-z-]+";var c=b++;g[c]="(?:\\+("+g[a]+"(?:\\."+g[a]+")*))";var h=b++,i="v?"+g[p]+g[t]+"?"+g[c]+"?";g[h]="^"+i+"$";var s="[v=\\s]*"+g[w]+g[n]+"?"+g[c]+"?",u=b++;g[u]="^"+s+"$";var d=b++;g[d]="((?:<|>)?=?)";var m=b++;g[m]=g[k]+"|x|X|\\*";var f=b++;g[f]=g[A]+"|x|X|\\*";var S=b++;g[S]="[v=\\s]*("+g[f]+")(?:\\.("+g[f]+")(?:\\.("+g[f]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var L=b++;g[L]="[v=\\s]*("+g[m]+")(?:\\.("+g[m]+")(?:\\.("+g[m]+")(?:"+g[n]+")?"+g[c]+"?)?)?";var v=b++;g[v]="^"+g[d]+"\\s*"+g[S]+"$";var y=b++;g[y]="^"+g[d]+"\\s*"+g[L]+"$";var D=b++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=b++;g[N]="(?:~>?)";var O=b++;g[O]="(\\s*)"+g[N]+"\\s+",$[O]=new RegExp(g[O],"g");var H=b++;g[H]="^"+g[N]+g[S]+"$";var U=b++;g[U]="^"+g[N]+g[L]+"$";var W=b++;g[W]="(?:\\^)";var P=b++;g[P]="(\\s*)"+g[W]+"\\s+",$[P]=new RegExp(g[P],"g");var C=b++;g[C]="^"+g[W]+g[S]+"$";var J=b++;g[J]="^"+g[W]+g[L]+"$";var ae=b++;g[ae]="^"+g[d]+"\\s*("+s+")$|^$";var fe=b++;g[fe]="^"+g[d]+"\\s*("+i+")$|^$";var we=b++;g[we]="(\\s*)"+g[d]+"\\s*("+s+"|"+g[S]+")",$[we]=new RegExp(g[we],"g");var ye=b++;g[ye]="^\\s*("+g[S]+")\\s+-\\s+("+g[S]+")\\s*$";var he=b++;g[he]="^\\s*("+g[L]+")\\s+-\\s+("+g[L]+")\\s*$";var ve=b++;g[ve]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)I(ee,g[ee]),$[ee]||($[ee]=new RegExp(g[ee]));function De(z,X){if(z instanceof se)return z;if(typeof z!="string"||z.length>M||!(X?$[u]:$[h]).test(z))return null;try{return new se(z,X)}catch{return null}}function se(z,X){if(z instanceof se){if(z.loose===X)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof se))return new se(z,X);I("SemVer",z,X),this.loose=X;var Y=z.trim().match(X?$[u]:$[h]);if(!Y)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+Y[1],this.minor=+Y[2],this.patch=+Y[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Y[4]?this.prerelease=Y[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Te=+Ee;if(Te>=0&&Te<R)return Te}return Ee}):this.prerelease=[],this.build=Y[5]?Y[5].split("."):[],this.format()}e.parse=De,e.valid=function(z,X){var Y=De(z,X);return Y?Y.version:null},e.clean=function(z,X){var Y=De(z.trim().replace(/^[=v]+/,""),X);return Y?Y.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(z){return I("SemVer.compare",this.version,this.loose,z),z instanceof se||(z=new se(z,this.loose)),this.compareMain(z)||this.comparePre(z)},se.prototype.compareMain=function(z){return z instanceof se||(z=new se(z,this.loose)),V(this.major,z.major)||V(this.minor,z.minor)||V(this.patch,z.patch)},se.prototype.comparePre=function(z){if(z instanceof se||(z=new se(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var X=0;do{var Y=this.prerelease[X],Ee=z.prerelease[X];if(I("prerelease compare",X,Y,Ee),Y===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(Y===void 0)return-1;if(Y!==Ee)return V(Y,Ee)}while(++X)},se.prototype.inc=function(z,X){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Y=this.prerelease.length;--Y>=0;)typeof this.prerelease[Y]=="number"&&(this.prerelease[Y]++,Y=-2);Y===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,X,Y,Ee){typeof Y=="string"&&(Ee=Y,Y=void 0);try{return new se(z,Y).inc(X,Ee).version}catch{return null}},e.diff=function(z,X){if(Ce(z,X))return null;var Y=De(z),Ee=De(X);if(Y.prerelease.length||Ee.prerelease.length){for(var Te in Y)if((Te==="major"||Te==="minor"||Te==="patch")&&Y[Te]!==Ee[Te])return"pre"+Te;return"prerelease"}for(var Te in Y)if((Te==="major"||Te==="minor"||Te==="patch")&&Y[Te]!==Ee[Te])return Te},e.compareIdentifiers=V;var x=/^[0-9]+$/;function V(z,X){var Y=x.test(z),Ee=x.test(X);return Y&&Ee&&(z=+z,X=+X),Y&&!Ee?-1:Ee&&!Y?1:z<X?-1:z>X?1:0}function ne(z,X,Y){return new se(z,Y).compare(new se(X,Y))}function Ie(z,X,Y){return ne(z,X,Y)>0}function Me(z,X,Y){return ne(z,X,Y)<0}function Ce(z,X,Y){return ne(z,X,Y)===0}function ce(z,X,Y){return ne(z,X,Y)!==0}function ie(z,X,Y){return ne(z,X,Y)>=0}function Q(z,X,Y){return ne(z,X,Y)<=0}function te(z,X,Y,Ee){var Te;switch(X){case"===":typeof z=="object"&&(z=z.version),typeof Y=="object"&&(Y=Y.version),Te=z===Y;break;case"!==":typeof z=="object"&&(z=z.version),typeof Y=="object"&&(Y=Y.version),Te=z!==Y;break;case"":case"=":case"==":Te=Ce(z,Y,Ee);break;case"!=":Te=ce(z,Y,Ee);break;case">":Te=Ie(z,Y,Ee);break;case">=":Te=ie(z,Y,Ee);break;case"<":Te=Me(z,Y,Ee);break;case"<=":Te=Q(z,Y,Ee);break;default:throw new TypeError("Invalid operator: "+X)}return Te}function me(z,X){if(z instanceof me){if(z.loose===X)return z;z=z.value}if(!(this instanceof me))return new me(z,X);I("comparator",z,X),this.loose=X,this.parse(z),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(z,X){return V(X,z)},e.major=function(z,X){return new se(z,X).major},e.minor=function(z,X){return new se(z,X).minor},e.patch=function(z,X){return new se(z,X).patch},e.compare=ne,e.compareLoose=function(z,X){return ne(z,X,!0)},e.rcompare=function(z,X,Y){return ne(X,z,Y)},e.sort=function(z,X){return z.sort(function(Y,Ee){return e.compare(Y,Ee,X)})},e.rsort=function(z,X){return z.sort(function(Y,Ee){return e.rcompare(Y,Ee,X)})},e.gt=Ie,e.lt=Me,e.eq=Ce,e.neq=ce,e.gte=ie,e.lte=Q,e.cmp=te,e.Comparator=me;var pe={};function Ae(z,X){if(z instanceof Ae)return z.loose===X?z:new Ae(z.raw,X);if(z instanceof me)return new Ae(z.value,X);if(!(this instanceof Ae))return new Ae(z,X);if(this.loose=X,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(Y){return this.parseRange(Y.trim())},this).filter(function(Y){return Y.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function le(z){return!z||z.toLowerCase()==="x"||z==="*"}function be(z,X,Y,Ee,Te,We,Ke,Ze,st,nt,tt,at,ct){return((X=le(Y)?"":le(Ee)?">="+Y+".0.0":le(Te)?">="+Y+"."+Ee+".0":">="+X)+" "+(Ze=le(st)?"":le(nt)?"<"+(+st+1)+".0.0":le(tt)?"<"+st+"."+(+nt+1)+".0":at?"<="+st+"."+nt+"."+tt+"-"+at:"<="+Ze)).trim()}function F(z,X){for(var Y=0;Y<z.length;Y++)if(!z[Y].test(X))return!1;if(X.prerelease.length){for(Y=0;Y<z.length;Y++)if(I(z[Y].semver),z[Y].semver!==pe&&z[Y].semver.prerelease.length>0){var Ee=z[Y].semver;if(Ee.major===X.major&&Ee.minor===X.minor&&Ee.patch===X.patch)return!0}return!1}return!0}function q(z,X,Y){try{X=new Ae(X,Y)}catch{return!1}return X.test(z)}function K(z,X,Y,Ee){var Te,We,Ke,Ze,st;switch(z=new se(z,Ee),X=new Ae(X,Ee),Y){case">":Te=Ie,We=Q,Ke=Me,Ze=">",st=">=";break;case"<":Te=Me,We=ie,Ke=Ie,Ze="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(q(z,X,Ee))return!1;for(var nt=0;nt<X.set.length;++nt){var tt=X.set[nt],at=null,ct=null;if(tt.forEach(function(je){je.semver===pe&&(je=new me(">=0.0.0")),at=at||je,ct=ct||je,Te(je.semver,at.semver,Ee)?at=je:Ke(je.semver,ct.semver,Ee)&&(ct=je)}),at.operator===Ze||at.operator===st||(!ct.operator||ct.operator===Ze)&&We(z,ct.semver)||ct.operator===st&&Ke(z,ct.semver))return!1}return!0}me.prototype.parse=function(z){var X=this.loose?$[ae]:$[fe],Y=z.match(X);if(!Y)throw new TypeError("Invalid comparator: "+z);this.operator=Y[1],this.operator==="="&&(this.operator=""),Y[2]?this.semver=new se(Y[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(z){return I("Comparator.test",z,this.loose),this.semver===pe||(typeof z=="string"&&(z=new se(z,this.loose)),te(z,this.operator,this.semver,this.loose))},me.prototype.intersects=function(z,X){if(!(z instanceof me))throw new TypeError("a Comparator is required");var Y;if(this.operator==="")return Y=new Ae(z.value,X),q(this.value,Y,X);if(z.operator==="")return Y=new Ae(this.value,X),q(z.semver,Y,X);var Ee=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),We=this.semver.version===z.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ze=te(this.semver,"<",z.semver,X)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),st=te(this.semver,">",z.semver,X)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return Ee||Te||We&&Ke||Ze||st},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(z){var X=this.loose;z=z.trim(),I("range",z,X);var Y=X?$[he]:$[ye];z=z.replace(Y,be),I("hyphen replace",z),z=z.replace($[we],"$1$2$3"),I("comparator trim",z,$[we]),z=(z=(z=z.replace($[O],"$1~")).replace($[P],"$1^")).split(/\s+/).join(" ");var Ee=X?$[ae]:$[fe],Te=z.split(" ").map(function(We){return function(Ke,Ze){return I("comp",Ke),Ke=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){I("caret",at,ct);var je=ct?$[J]:$[C];return at.replace(je,function(vt,Z,_,$e,Be){var Qe;return I("caret",at,vt,Z,_,$e,Be),le(Z)?Qe="":le(_)?Qe=">="+Z+".0.0 <"+(+Z+1)+".0.0":le($e)?Qe=Z==="0"?">="+Z+"."+_+".0 <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+".0 <"+(+Z+1)+".0.0":Be?(I("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=Z==="0"?_==="0"?">="+Z+"."+_+"."+$e+Be+" <"+Z+"."+_+"."+(+$e+1):">="+Z+"."+_+"."+$e+Be+" <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+"."+$e+Be+" <"+(+Z+1)+".0.0"):(I("no pr"),Qe=Z==="0"?_==="0"?">="+Z+"."+_+"."+$e+" <"+Z+"."+_+"."+(+$e+1):">="+Z+"."+_+"."+$e+" <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+"."+$e+" <"+(+Z+1)+".0.0"),I("caret return",Qe),Qe})}(tt,nt)}).join(" ")}(Ke,Ze),I("caret",Ke),Ke=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){var je=ct?$[U]:$[H];return at.replace(je,function(vt,Z,_,$e,Be){var Qe;return I("tilde",at,vt,Z,_,$e,Be),le(Z)?Qe="":le(_)?Qe=">="+Z+".0.0 <"+(+Z+1)+".0.0":le($e)?Qe=">="+Z+"."+_+".0 <"+Z+"."+(+_+1)+".0":Be?(I("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+Z+"."+_+"."+$e+Be+" <"+Z+"."+(+_+1)+".0"):Qe=">="+Z+"."+_+"."+$e+" <"+Z+"."+(+_+1)+".0",I("tilde return",Qe),Qe})}(tt,nt)}).join(" ")}(Ke,Ze),I("tildes",Ke),Ke=function(st,nt){return I("replaceXRanges",st,nt),st.split(/\s+/).map(function(tt){return function(at,ct){at=at.trim();var je=ct?$[y]:$[v];return at.replace(je,function(vt,Z,_,$e,Be,Qe){I("xRange",at,vt,Z,_,$e,Be,Qe);var it=le(_),rt=it||le($e),Ne=rt||le(Be);return Z==="="&&Ne&&(Z=""),it?vt=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Ne?(rt&&($e=0),Ne&&(Be=0),Z===">"?(Z=">=",rt?(_=+_+1,$e=0,Be=0):Ne&&($e=+$e+1,Be=0)):Z==="<="&&(Z="<",rt?_=+_+1:$e=+$e+1),vt=Z+_+"."+$e+"."+Be):rt?vt=">="+_+".0.0 <"+(+_+1)+".0.0":Ne&&(vt=">="+_+"."+$e+".0 <"+_+"."+(+$e+1)+".0"),I("xRange return",vt),vt})}(tt,nt)}).join(" ")}(Ke,Ze),I("xrange",Ke),Ke=function(st,nt){return I("replaceStars",st,nt),st.trim().replace($[ve],"")}(Ke,Ze),I("stars",Ke),Ke}(We,X)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(We){return!!We.match(Ee)})),Te=Te.map(function(We){return new me(We,X)})},Ae.prototype.intersects=function(z,X){if(!(z instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(Y){return Y.every(function(Ee){return z.set.some(function(Te){return Te.every(function(We){return Ee.intersects(We,X)})})})})},e.toComparators=function(z,X){return new Ae(z,X).set.map(function(Y){return Y.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new se(z,this.loose));for(var X=0;X<this.set.length;X++)if(F(this.set[X],z))return!0;return!1},e.satisfies=q,e.maxSatisfying=function(z,X,Y){var Ee=null,Te=null;try{var We=new Ae(X,Y)}catch{return null}return z.forEach(function(Ke){We.test(Ke)&&(Ee&&Te.compare(Ke)!==-1||(Te=new se(Ee=Ke,Y)))}),Ee},e.minSatisfying=function(z,X,Y){var Ee=null,Te=null;try{var We=new Ae(X,Y)}catch{return null}return z.forEach(function(Ke){We.test(Ke)&&(Ee&&Te.compare(Ke)!==1||(Te=new se(Ee=Ke,Y)))}),Ee},e.validRange=function(z,X){try{return new Ae(z,X).range||"*"}catch{return null}},e.ltr=function(z,X,Y){return K(z,X,"<",Y)},e.gtr=function(z,X,Y){return K(z,X,">",Y)},e.outside=K,e.prerelease=function(z,X){var Y=De(z,X);return Y&&Y.prerelease.length?Y.prerelease:null},e.intersects=function(z,X,Y){return z=new Ae(z,Y),X=new Ae(X,Y),z.intersects(X)},e.coerce=function(z){if(z instanceof se)return z;if(typeof z!="string")return null;var X=z.match($[D]);return X==null?null:De((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,E(1))},function(ge,e){var E,T,I=ge.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(o){if(E===setTimeout)return setTimeout(o,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var g,b=[],A=!1,k=-1;function l(){A&&g&&(A=!1,g.length?b=g.concat(b):k=-1,b.length&&p())}function p(){if(!A){var o=$(l);A=!0;for(var t=b.length;t;){for(g=b,b=[];++k<t;)g&&g[k].run();k=-1,t=b.length}g=null,A=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(o)}}function w(o,t){this.fun=o,this.array=t}function r(){}I.nextTick=function(o){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];b.push(new w(o,t)),b.length!==1||A||$(p)},w.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(o){return[]},I.binding=function(o){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(o){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Pe[123],Re([1,0,15,6]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=void 0;function I(c){const h=c;return h?typeof h.read=="function":!1}e.$6d=I;function M(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$7d=M;function R(c){const h=c;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$8d=R;function $(c,h){return new g(c,h)}e.$9d=$;class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,E.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const u=s.indexOf(i);u>=0&&s.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(c,h){const i=[];let s;for(;(s=c.read())!==null;)i.push(s);return h(i)}e.$0d=b;function A(c,h,i){const s=[];let u;for(;(u=c.read())!==null&&s.length<i;)s.push(u);return u===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof u<"u"){const d=u;return u=void 0,d}return c.read()}}}e.$$d=A;function k(c,h){return new Promise((i,s)=>{const u=[];l(c,{onData:d=>{h&&u.push(d)},onError:d=>{h?s(d):i(void 0)},onEnd:()=>{i(h?h(u):void 0)}})})}e.$_d=k;function l(c,h,i){c.on("error",s=>{i?.isCancellationRequested||h.onError(s)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",s=>{i?.isCancellationRequested||h.onData(s)})}e.$ae=l;function p(c,h){return new Promise((i,s)=>{const u=new T.$Sc,d=[],m=L=>{if(d.push(L),d.length>h)return u.dispose(),c.pause(),i({stream:c,buffer:d,ended:!1})},f=L=>(u.dispose(),s(L)),S=()=>(u.dispose(),i({stream:c,buffer:d,ended:!0}));u.add((0,T.$Rc)(()=>c.removeListener("error",f))),c.on("error",f),u.add((0,T.$Rc)(()=>c.removeListener("end",S))),c.on("end",S),u.add((0,T.$Rc)(()=>c.removeListener("data",m))),c.on("data",m)})}e.$be=p;function w(c,h){const i=$(h);return i.end(c),i}e.$ce=w;function r(){const c=$(()=>{throw new Error("not supported")});return c.end(),c}e.$de=r;function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$ee=o;function t(c,h,i){const s=$(i);return l(c,{onData:u=>s.write(h.data(u)),onError:u=>s.error(h.error?h.error(u):u),onEnd:()=>s.end()}),s}e.$fe=t;function n(c,h,i){let s=!1;return{read:()=>{const u=h.read();return s?u:(s=!0,u!==null?i([c,u]):c)}}}e.$ge=n;function a(c,h,i){let s=!1;const u=$(i);return l(h,{onData:d=>s?u.write(d):(s=!0,u.write(i([c,d]))),onError:d=>u.error(d),onEnd:()=>{s||(s=!0,u.write(c)),u.end()}}),u}e.$he=a}),define(Pe[24],Re([1,0,39,123]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;const I=typeof Buffer<"u",M=new E.$V(()=>new Uint8Array(256));let R,$;class g{static alloc(D){return I?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return I&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,N){return!(N?.dontUseNodeBuffer||!1)&&I?new g(Buffer.from(D)):(R||(R=new TextEncoder),new g(R.encode(D)))}static fromByteArray(D){const N=g.alloc(D.length);for(let O=0,H=D.length;O<H;O++)N.buffer[O]=D[O];return N}static concat(D,N){if(typeof N>"u"){N=0;for(let U=0,W=D.length;U<W;U++)N+=D[U].byteLength}const O=g.alloc(N);let H=0;for(let U=0,W=D.length;U<W;U++){const P=D[U];O.set(P,H),H+=P.byteLength}return O}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return I?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(D,N){return new g(this.buffer.subarray(D,N))}set(D,N){if(D instanceof g)this.buffer.set(D.buffer,N);else if(D instanceof Uint8Array)this.buffer.set(D,N);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),N);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return l(this.buffer,D)}writeUInt32BE(D,N){p(this.buffer,D,N)}readUInt32LE(D){return w(this.buffer,D)}writeUInt32LE(D,N){r(this.buffer,D,N)}readUInt8(D){return o(this.buffer,D)}writeUInt8(D,N){t(this.buffer,D,N)}indexOf(D,N=0){return b(this.buffer,D instanceof g?D.buffer:D,N)}}e.$ie=g;function b(y,D,N=0){const O=D.byteLength,H=y.byteLength;if(O===0)return 0;if(O===1)return y.indexOf(D[0]);if(O>H-N)return-1;const U=M.value;U.fill(D.length);for(let J=0;J<D.length;J++)U[D[J]]=D.length-J-1;let W=N+D.length-1,P=W,C=-1;for(;W<H;)if(y[W]===D[P]){if(P===0){C=W;break}W--,P--}else W+=Math.max(D.length-P,U[y[W]]),P=D.length-1;return C}e.$je=b;function A(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0}e.$ke=A;function k(y,D,N){y[N+0]=D&255,D=D>>>8,y[N+1]=D&255}e.$le=k;function l(y,D){return y[D]*2**24+y[D+1]*2**16+y[D+2]*2**8+y[D+3]}e.$me=l;function p(y,D,N){y[N+3]=D,D=D>>>8,y[N+2]=D,D=D>>>8,y[N+1]=D,D=D>>>8,y[N]=D}e.$ne=p;function w(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0|y[D+2]<<16>>>0|y[D+3]<<24>>>0}e.$oe=w;function r(y,D,N){y[N+0]=D&255,D=D>>>8,y[N+1]=D&255,D=D>>>8,y[N+2]=D&255,D=D>>>8,y[N+3]=D&255}e.$pe=r;function o(y,D){return y[D]}e.$qe=o;function t(y,D,N){y[N]=D}e.$re=t;function n(y){return T.$0d(y,D=>g.concat(D))}e.$se=n;function a(y){return T.$ee(y)}e.$te=a;function c(y){return T.$_d(y,D=>g.concat(D))}e.$ue=c;async function h(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await c(y.stream)])}e.$ve=h;function i(y){return T.$ce(y,D=>g.concat(D))}e.$we=i;function s(y){return T.$fe(y,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}e.$xe=s;function u(y){return T.$9d(D=>g.concat(D),y)}e.$ye=u;function d(y,D){return T.$ge(y,D,N=>g.concat(N))}e.$ze=d;function m(y,D){return T.$he(y,D,N=>g.concat(N))}e.$Ae=m;function f(y){let D=0,N=0,O=0;const H=new Uint8Array(Math.floor(y.length/4*3)),U=P=>{switch(N){case 3:H[O++]=D|P,N=0;break;case 2:H[O++]=D|P>>>2,D=P<<6,N=3;break;case 1:H[O++]=D|P>>>4,D=P<<4,N=2;break;default:D=P<<2,N=1}};for(let P=0;P<y.length;P++){const C=y.charCodeAt(P);if(C>=65&&C<=90)U(C-65);else if(C>=97&&C<=122)U(C-97+26);else if(C>=48&&C<=57)U(C-48+52);else if(C===43||C===45)U(62);else if(C===47||C===95)U(63);else{if(C===61)break;throw new SyntaxError(`Unexpected base64 character ${y[P]}`)}}const W=O;for(;N>0;)U(0);return g.wrap(H).slice(0,W)}e.$Be=f;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:y},D=!0,N=!1){const O=N?L:S;let H="";const U=y.byteLength%3;let W=0;for(;W<y.byteLength-U;W+=3){const P=y[W+0],C=y[W+1],J=y[W+2];H+=O[P>>>2],H+=O[(P<<4|C>>>4)&63],H+=O[(C<<2|J>>>6)&63],H+=O[J&63]}if(U===1){const P=y[W+0];H+=O[P>>>2],H+=O[P<<4&63],D&&(H+="==")}else if(U===2){const P=y[W+0],C=y[W+1];H+=O[P>>>2],H+=O[(P<<4|C>>>4)&63],H+=O[C<<2&63],D&&(H+="=")}return H}e.$Ce=v}),define(Pe[124],Re([1,0,28,121,11]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.FuzzyScore=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.or=void 0;function M(...le){return function(be,F){for(let q=0,K=le.length;q<K;q++){const z=le[q](be,F);if(z)return z}return null}}e.or=M,e.$Sj=R.bind(void 0,!1),e.$Tj=R.bind(void 0,!0);function R(le,be,F){if(!F||F.length<be.length)return null;let q;return le?q=I.$_e(F,be):q=F.indexOf(be)===0,q?be.length>0?[{start:0,end:be.length}]:[]:null}function $(le,be){const F=be.toLowerCase().indexOf(le.toLowerCase());return F===-1?null:[{start:F,end:F+le.length}]}e.$Uj=$;function g(le,be){return b(le.toLowerCase(),be.toLowerCase(),0,0)}e.$Vj=g;function b(le,be,F,q){if(F===le.length)return[];if(q===be.length)return null;if(le[F]===be[q]){let K=null;return(K=b(le,be,F+1,q+1))?c({start:q,end:q+1},K):null}return b(le,be,F,q+1)}function A(le){return 97<=le&&le<=122}function k(le){return 65<=le&&le<=90}e.$Wj=k;function l(le){return 48<=le&&le<=57}function p(le){return le===32||le===9||le===10||le===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>w.add(le.charCodeAt(0)));function r(le){return p(le)||w.has(le)}function o(le,be){return le===be||r(le)&&r(be)}const t=new Map;function n(le){if(t.has(le))return t.get(le);let be;const F=(0,T.$Qj)(le);return F&&(be=F),t.set(le,be),be}function a(le){return A(le)||k(le)||l(le)}function c(le,be){return be.length===0?be=[le]:le.end===be[0].start?be[0].start=le.start:be.unshift(le),be}function h(le,be){for(let F=be;F<le.length;F++){const q=le.charCodeAt(F);if(k(q)||l(q)||F>0&&!a(le.charCodeAt(F-1)))return F}return le.length}function i(le,be,F,q){if(F===le.length)return[];if(q===be.length)return null;if(le[F]!==be[q].toLowerCase())return null;{let K=null,z=q+1;for(K=i(le,be,F+1,q+1);!K&&(z=h(be,z))<be.length;)K=i(le,be,F+1,z),z++;return K===null?null:c({start:q,end:q+1},K)}}function s(le){let be=0,F=0,q=0,K=0,z=0;for(let We=0;We<le.length;We++)z=le.charCodeAt(We),k(z)&&be++,A(z)&&F++,a(z)&&q++,l(z)&&K++;const X=be/le.length,Y=F/le.length,Ee=q/le.length,Te=K/le.length;return{upperPercent:X,lowerPercent:Y,alphaPercent:Ee,numericPercent:Te}}function u(le){const{upperPercent:be,lowerPercent:F}=le;return F===0&&be>.6}function d(le){const{upperPercent:be,lowerPercent:F,alphaPercent:q,numericPercent:K}=le;return F>.2&&be<.8&&q>.6&&K<.2}function m(le){let be=0,F=0,q=0,K=0;for(let z=0;z<le.length;z++)q=le.charCodeAt(z),k(q)&&be++,A(q)&&F++,p(q)&&K++;return(be===0||F===0)&&K===0?le.length<=30:be<=5}function f(le,be){if(!be||(be=be.trim(),be.length===0)||!m(le)||be.length>60)return null;const F=s(be);if(!d(F)){if(!u(F))return null;be=be.toLowerCase()}let q=null,K=0;for(le=le.toLowerCase();K<be.length&&(q=i(le,be,0,K))===null;)K=h(be,K+1);return q}e.$Xj=f;function S(le,be,F=!1){if(!be||be.length===0)return null;let q=null,K=0;for(le=le.toLowerCase(),be=be.toLowerCase();K<be.length&&(q=L(le,be,0,K,F),q===null);)K=v(be,K+1);return q}e.$Yj=S;function L(le,be,F,q,K){let z=0;if(F===le.length)return[];if(q===be.length)return null;if(!o(le.charCodeAt(F),be.charCodeAt(q))){const Ee=n(le.charCodeAt(F));if(!Ee)return null;for(let Te=0;Te<Ee.length;Te++)if(!o(Ee[Te],be.charCodeAt(q+Te)))return null;z+=Ee.length-1}let X=null,Y=q+z+1;if(X=L(le,be,F+1,Y,K),!K)for(;!X&&(Y=v(be,Y))<be.length;)X=L(le,be,F+1,Y,K),Y++;if(!X)return null;if(le.charCodeAt(F)!==be.charCodeAt(q)){const Ee=n(le.charCodeAt(F));if(!Ee)return X;for(let Te=0;Te<Ee.length;Te++)if(Ee[Te]!==be.charCodeAt(q+Te))return X}return c({start:q,end:q+z+1},X)}function v(le,be){for(let F=be;F<le.length;F++)if(r(le.charCodeAt(F))||F>0&&r(le.charCodeAt(F-1)))return F;return le.length}const y=M(e.$Tj,f,$),D=M(e.$Tj,f,g),N=new E.$Dc(1e4);function O(le,be,F=!1){if(typeof le!="string"||typeof be!="string")return null;let q=N.get(le);q||(q=new RegExp(I.$Ue(le),"i"),N.set(le,q));const K=q.exec(be);return K?[{start:K.index,end:K.index+K[0].length}]:F?D(le,be):y(le,be)}e.$Zj=O;function H(le,be){const F=ce(le,le.toLowerCase(),0,be,be.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?W(F):null}e.$1j=H;function U(le,be,F,q,K,z){const X=Math.min(13,le.length);for(;F<X;F++){const Y=ce(le,be,F,q,K,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Y)return Y}return[0,z]}e.$2j=U;function W(le){if(typeof le>"u")return[];const be=[],F=le[1];for(let q=le.length-1;q>1;q--){const K=le[q]+F,z=be[be.length-1];z&&z.end===K?z.end=K+1:be.push({start:K,end:K+1})}return be}e.$3j=W;const P=128;function C(){const le=[],be=[];for(let F=0;F<=P;F++)be[F]=0;for(let F=0;F<=P;F++)le.push(be.slice(0));return le}function J(le){const be=[];for(let F=0;F<=le;F++)be[F]=0;return be}const ae=J(2*P),fe=J(2*P),we=C(),ye=C(),he=C(),ve=!1;function ee(le,be,F,q,K){function z(Y,Ee,Te=" "){for(;Y.length<Ee;)Y=Te+Y;return Y}let X=` |   |${q.split("").map(Y=>z(Y,3)).join("|")}
`;for(let Y=0;Y<=F;Y++)Y===0?X+=" |":X+=`${be[Y-1]}|`,X+=le[Y].slice(0,K+1).map(Ee=>z(Ee.toString(),3)).join("|")+`
`;return X}function De(le,be,F,q){le=le.substr(be),F=F.substr(q),console.log(ee(ye,le,le.length,F,F.length)),console.log(ee(he,le,le.length,F,F.length)),console.log(ee(we,le,le.length,F,F.length))}function se(le,be){if(be<0||be>=le.length)return!1;const F=le.codePointAt(be);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$rf(F)}}function x(le,be){if(be<0||be>=le.length)return!1;switch(le.charCodeAt(be)){case 32:case 9:return!0;default:return!1}}function V(le,be,F){return be[le]!==F[le]}function ne(le,be,F,q,K,z,X=!1){for(;be<F&&K<z;)le[be]===q[K]&&(X&&(ae[be]=K),be+=1),K+=1;return be===F}e.$4j=ne;var Ie;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Me;(function(le){le.Default=[-100,0];function be(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}le.isDefault=be})(Me||(e.FuzzyScore=Me={}));class Ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(be,F){this.firstMatchCanBeWeak=be,this.boostFullMatch=F}}e.$5j=Ce;function ce(le,be,F,q,K,z,X=Ce.default){const Y=le.length>P?P:le.length,Ee=q.length>P?P:q.length;if(F>=Y||z>=Ee||Y-F>Ee-z||!ne(be,F,Y,K,z,Ee,!0))return;ie(Y,Ee,F,z,be,K);let Te=1,We=1,Ke=F,Ze=z;const st=[!1];for(Te=1,Ke=F;Ke<Y;Te++,Ke++){const je=ae[Ke],vt=fe[Ke],Z=Ke+1<Y?fe[Ke+1]:Ee;for(We=je-z+1,Ze=je;Ze<Z;We++,Ze++){let _=Number.MIN_SAFE_INTEGER,$e=!1;Ze<=vt&&(_=Q(le,be,Ke,F,q,K,Ze,Ee,z,we[Te-1][We-1]===0,st));let Be=0;_!==Number.MAX_SAFE_INTEGER&&($e=!0,Be=_+ye[Te-1][We-1]);const Qe=Ze>je,it=Qe?ye[Te][We-1]+(we[Te][We-1]>0?-5:0):0,rt=Ze>je+1&&we[Te][We-1]>0,Ne=rt?ye[Te][We-2]+(we[Te][We-2]>0?-5:0):0;if(rt&&(!Qe||Ne>=it)&&(!$e||Ne>=Be))ye[Te][We]=Ne,he[Te][We]=3,we[Te][We]=0;else if(Qe&&(!$e||it>=Be))ye[Te][We]=it,he[Te][We]=2,we[Te][We]=0;else if($e)ye[Te][We]=Be,he[Te][We]=1,we[Te][We]=we[Te-1][We-1]+1;else throw new Error("not possible")}}if(ve&&De(le,F,q,z),!st[0]&&!X.firstMatchCanBeWeak)return;Te--,We--;const nt=[ye[Te][We],z];let tt=0,at=0;for(;Te>=1;){let je=We;do{const vt=he[Te][je];if(vt===3)je=je-2;else if(vt===2)je=je-1;else break}while(je>=1);tt>1&&be[F+Te-1]===K[z+We-1]&&!V(je+z-1,q,K)&&tt+1>we[Te][je]&&(je=We),je===We?tt++:tt=1,at||(at=je),Te--,We=je-1,nt.push(We)}Ee===Y&&X.boostFullMatch&&(nt[0]+=2);const ct=at-Y;return nt[0]-=ct,nt}e.$6j=ce;function ie(le,be,F,q,K,z){let X=le-1,Y=be-1;for(;X>=F&&Y>=q;)K[X]===z[Y]&&(fe[X]=Y,X--),Y--}function Q(le,be,F,q,K,z,X,Y,Ee,Te,We){if(be[F]!==z[X])return Number.MIN_SAFE_INTEGER;let Ke=1,Ze=!1;return X===F-q?Ke=le[F]===K[X]?7:5:V(X,K,z)&&(X===0||!V(X-1,K,z))?(Ke=le[F]===K[X]?7:5,Ze=!0):se(z,X)&&(X===0||!se(z,X-1))?Ke=5:(se(z,X-1)||x(z,X-1))&&(Ke=5,Ze=!0),Ke>1&&F===q&&(We[0]=!0),Ze||(Ze=V(X,K,z)||se(z,X-1)||x(z,X-1)),F===q?X>Ee&&(Ke-=Ze?3:5):Te?Ke+=Ze?2:0:Ke+=Ze?0:1,X+1===Y&&(Ke-=Ze?3:5),Ke}function te(le,be,F,q,K,z,X){return pe(le,be,F,q,K,z,!0,X)}e.$7j=te;function me(le,be,F,q,K,z,X){return pe(le,be,F,q,K,z,!1,X)}e.$8j=me;function pe(le,be,F,q,K,z,X,Y){let Ee=ce(le,be,F,q,K,z,Y);if(Ee&&!X)return Ee;if(le.length>=3){const Te=Math.min(7,le.length-1);for(let We=F+1;We<Te;We++){const Ke=Ae(le,We);if(Ke){const Ze=ce(Ke,Ke.toLowerCase(),F,q,K,z,Y);Ze&&(Ze[0]-=3,(!Ee||Ze[0]>Ee[0])&&(Ee=Ze))}}}return Ee}function Ae(le,be){if(be+1>=le.length)return;const F=le[be],q=le[be+1];if(F!==q)return le.slice(0,be)+q+F+le.slice(be+2)}}),define(Pe[31],Re([1,0,11]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(T||(T={})),function(I){const M="error",R="warning",$="warn",g="info",b="ignore";function A(l){return l?E.$$e(M,l)?I.Error:E.$$e(R,l)||E.$$e($,l)?I.Warning:E.$$e(g,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function k(l){switch(l){case I.Error:return M;case I.Warning:return R;case I.Info:return g;default:return b}}I.toString=k}(T||(T={})),e.default=T}),define(Pe[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Rd=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,11]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class I{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const w=p.charCodeAt(0),r=this.b.charCodeAt(this.c);return w-r}value(){return this.b[this.c]}}e.$7h=I;class M{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.$5e)(p,this.b,0,p.length,this.c,this.d):(0,T.$7e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$8h=M;class R{constructor(p=!0,w=!0){this.f=p,this.g=w}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let w=p.length-1;w>=0;w--,this.c--){const r=this.b.charCodeAt(w);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.$5e)(p,this.b,0,p.length,this.d,this.e):(0,T.$7e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$9h=R;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class g{constructor(p,w){this.f=p,this.g=w,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.$6e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.$6e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.$4e)(p,this.c.query);if(this.d[this.e]===5)return(0,T.$4e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$0h=g;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class k{static forUris(p=()=>!1,w=()=>!1){return new k(new g(p,w))}static forPaths(p=!1){return new k(new R(void 0,!p))}static forStrings(){return new k(new I)}static forConfigKeys(){return new k(new M)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,w){if(w){const r=w.slice(0);(0,E.$Xb)(r);for(const o of r)this.set(o,p)}else{const r=p.slice(0);(0,E.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(p,w){const r=this.b.reset(p);let o;this.c||(this.c=new b,this.c.segment=r.value());const t=[];for(o=this.c;;){const a=r.cmp(o.segment);if(a>0)o.left||(o.left=new b,o.left.segment=r.value()),t.push([-1,o]),o=o.left;else if(a<0)o.right||(o.right=new b,o.right.segment=r.value()),t.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new b,o.mid.segment=r.value()),t.push([0,o]),o=o.mid;else break}const n=o.value;o.value=w,o.key=p;for(let a=t.length-1;a>=0;a--){const c=t[a][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=t[a][0],s=t[a+1][0];if(i===1&&s===1)t[a][1]=c.rotateLeft();else if(i===-1&&s===-1)t[a][1]=c.rotateRight();else if(i===1&&s===-1)c.right=t[a+1][1]=t[a+1][1].rotateRight(),t[a][1]=c.rotateLeft();else if(i===-1&&s===1)c.left=t[a+1][1]=t[a+1][1].rotateLeft(),t[a][1]=c.rotateRight();else throw new Error;if(a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const w=this.b.reset(p);let r=this.c;for(;r;){const o=w.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(w.hasNext())w.next(),r=r.mid;else break}return r}has(p){const w=this.d(p);return!(w?.value===void 0&&w?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,w){const r=this.b.reset(p),o=[];let t=this.c;for(;t;){const n=r.cmp(t.segment);if(n>0)o.push([-1,t]),t=t.left;else if(n<0)o.push([1,t]),t=t.right;else if(r.hasNext())r.next(),o.push([0,t]),t=t.mid;else break}if(t){if(w?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:a,value:c,segment:h}=n;this.e(n.key,!1),t.key=a,t.value=c,t.segment=h}}else{const n=t.left??t.right;if(o.length>0){const[a,c]=o[o.length-1];switch(a){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const a=o[n][1];a.updateHeight();const c=a.balanceFactor();if(c>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),o[n][1]=a.rotateLeft()):c<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),o[n][1]=a.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const w=this.b.reset(p);let r=this.c,o;for(;r;){const t=w.cmp(r.segment);if(t>0)r=r.left;else if(t<0)r=r.right;else if(w.hasNext())w.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(p){return this.g(p,!1)}g(p,w){const r=this.b.reset(p);let o=this.c;for(;o;){const t=r.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):w?o.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[w,r]of this)p(r,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const w=[];return this.j(p,w),w[Symbol.iterator]()}j(p,w){p&&(p.left&&this.j(p.left,w),p.value&&w.push([p.key,p.value]),p.mid&&this.j(p.mid,w),p.right&&this.j(p.right,w))}_isBalanced(){const p=w=>{if(!w)return!0;const r=w.balanceFactor();return r<-1||r>1?!1:p(w.left)&&p(w.right)};return p(this.c)}}e.$$h=k}),define(Pe[45],Re([1,0,90]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$_j=e.ThemeColor=void 0;var T;(function(R){function $(g){return g&&typeof g=="object"&&typeof g.id=="string"}R.isThemeColor=$})(T||(e.ThemeColor=T={}));function I(R){return{id:R}}e.$_j=I;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function g(n){const a=$.exec(n.id);if(!a)return g(E.$$j.error);const[,c,h]=a,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}R.asClassNameArray=g;function b(n){return g(n).join(" ")}R.asClassName=b;function A(n){return"."+g(n).join(".")}R.asCSSSelector=A;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}R.isThemeIcon=k;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function p(n){const a=l.exec(n);if(!a)return;const[,c]=a;return{id:c}}R.fromString=p;function w(n){return{id:n}}R.fromId=w;function r(n,a){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),a&&(c=`${c}~${a}`),{id:c}}R.modify=r;function o(n){const a=n.id.lastIndexOf("~");if(a!==-1)return n.id.substring(a+1)}R.getModifier=o;function t(n,a){return n.id===a.id&&n.color?.id===a.color?.id}R.isEqual=t})(M||(e.ThemeIcon=M={}))}),define(Pe[126],Re([1,0,124,11,45]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=void 0;const M="$(",R=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function g(t){return t.replace($,(n,a)=>a?n:`\\${n}`)}e.$ak=g;const b=new RegExp(`\\\\${R.source}`,"g");function A(t){return t.replace(b,n=>`\\${n}`)}e.$bk=A;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(t){return t.indexOf(M)===-1?t:t.replace(k,(n,a,c,h)=>c?n:a||h||"")}e.$ck=l;function p(t){return t?t.replace(/\$\((.*?)\)/g,(n,a)=>` ${a} `).trim():""}e.$dk=p;const w=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(t){w.lastIndex=0;let n="";const a=[];let c=0;for(;;){const h=w.lastIndex,i=w.exec(t),s=t.substring(h,i?.index);if(s.length>0){n+=s;for(let u=0;u<s.length;u++)a.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:a}}e.$ek=r;function o(t,n,a=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,E.$Zj)(t,c,a);const i=(0,T.$Se)(c," "),s=c.length-i.length,u=(0,E.$Zj)(t,i,a);if(u)for(const d of u){const m=h[d.start+s]+s;d.start+=m,d.end+=m}return u}e.$fk=o}),define(Pe[33],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pg=e.$og=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(I){return E.test(I)}e.$og=T,e.$pg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function($){for(let g=0;g<$.length;g++)$[g]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){I(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let g=0,b="";return b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b+="-",b+=R[M[g++]],b+=R[M[g++]],b+="-",b+=R[M[g++]],b+=R[M[g++]],b+="-",b+=R[M[g++]],b+=R[M[g++]],b+="-",b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b}}()}),define(Pe[127],Re([1,0,18,67,33]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.$ot=e.$nt=e.$mt=void 0;function M(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$mt=M;function R(k,l,p){const w={id:(0,I.$pg)(),name:k,uri:l,data:p};return{asString:async()=>"",asFile:()=>w,value:void 0}}e.$nt=R;class ${constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return T.Iterable.some(this,([w,r])=>r.asFile())&&p.push("files"),A(g(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const w=this.a.get(l);w?w.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const w of p)yield[l,w]}b(l){return g(l)}}e.$ot=$;function g(k){return k.toLowerCase()}function b(k,l){return A(g(k),l.map(g))}e.$pt=b;function A(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const p=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[w,r,o]=p;return o==="*"?l.some(t=>t.startsWith(r+"/")):!1}e.$qt=Object.freeze({create:k=>(0,E.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$qt.split(k).filter(l=>!l.startsWith("#"))})}),define(Pe[128],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.StringEOL=void 0;var E;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(I){let M=0,R=0,$=0,g=0;for(let b=0,A=I.length;b<A;b++){const k=I.charCodeAt(b);k===13?(M===0&&(R=b),M++,b+1<A&&I.charCodeAt(b+1)===10?(g|=2,b++):g|=3,$=b+1):k===10&&(g|=1,M===0&&(R=b),M++,$=b+1)}return M===0&&(R=I.length),[M,R,I.length-$,g]}e.$tt=T}),define(Pe[129],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0,e.$rs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=e.$Qt=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let g=0,b=$.notIn.length;g<b;g++)switch($.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,g){if($.getTokenCount()===0)return!0;const b=$.findTokenIndexAtOffset(g-2),A=$.getStandardTokenType(b);return this.isOK(A)}g($,g){for(let b=$;b<=g;b++){const A=String.fromCharCode(b);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Qt=T;class I{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of $)M(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),M(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),M(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),M(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&M(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Rt=I;function M(R,$,g){R.has($)?R.get($).push(g):R.set($,[g])}}),define(Pe[131],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.$SB=e.NodeColor=e.$RB=void 0;class E{constructor(o,t){this.piece=o,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$SB)return I(this.right);let o=this;for(;o.parent!==e.$SB&&o.parent.left!==o;)o=o.parent;return o.parent===e.$SB?e.$SB:o.parent}prev(){if(this.left!==e.$SB)return M(this.left);let o=this;for(;o.parent!==e.$SB&&o.parent.right!==o;)o=o.parent;return o.parent===e.$SB?e.$SB:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$RB=E;var T;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$SB=new E(null,0),e.$SB.parent=e.$SB,e.$SB.left=e.$SB,e.$SB.right=e.$SB,e.$SB.color=0;function I(r){for(;r.left!==e.$SB;)r=r.left;return r}e.$TB=I;function M(r){for(;r.right!==e.$SB;)r=r.right;return r}e.$UB=M;function R(r){return r===e.$SB?0:r.size_left+r.piece.length+R(r.right)}function $(r){return r===e.$SB?0:r.lf_left+r.piece.lineFeedCnt+$(r.right)}function g(){e.$SB.parent=e.$SB}function b(r,o){const t=o.right;t.size_left+=o.size_left+(o.piece?o.piece.length:0),t.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=t.left,t.left!==e.$SB&&(t.left.parent=o),t.parent=o.parent,o.parent===e.$SB?r.root=t:o.parent.left===o?o.parent.left=t:o.parent.right=t,t.left=o,o.parent=t}e.$VB=b;function A(r,o){const t=o.left;o.left=t.right,t.right!==e.$SB&&(t.right.parent=o),t.parent=o.parent,o.size_left-=t.size_left+(t.piece?t.piece.length:0),o.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),o.parent===e.$SB?r.root=t:o===o.parent.right?o.parent.right=t:o.parent.left=t,t.right=o,o.parent=t}e.$WB=A;function k(r,o){let t,n;if(o.left===e.$SB?(n=o,t=n.right):o.right===e.$SB?(n=o,t=n.left):(n=I(o.right),t=n.right),n===r.root){r.root=t,t.color=0,o.detach(),g(),r.root.parent=e.$SB;return}const a=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===o?(t.parent=n.parent,w(r,t)):(n.parent===o?t.parent=n:t.parent=n.parent,w(r,t),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===r.root?r.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$SB&&(n.left.parent=n),n.right!==e.$SB&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,w(r,n)),o.detach(),t.parent.left===t){const h=R(t),i=$(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const s=h-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,p(r,t.parent,s,u)}}if(w(r,t.parent),a){g();return}let c;for(;t!==r.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,b(r,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,A(r,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,b(r,t.parent),t=r.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,A(r,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,b(r,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,A(r,t.parent),t=r.root));t.color=0,g()}e.$XB=k;function l(r,o){for(w(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const t=o.parent.parent.right;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,b(r,o)),o.parent.color=0,o.parent.parent.color=1,A(r,o.parent.parent))}else{const t=o.parent.parent.left;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,A(r,o)),o.parent.color=0,o.parent.parent.color=1,b(r,o.parent.parent))}r.root.color=0}e.$YB=l;function p(r,o,t,n){for(;o!==r.root&&o!==e.$SB;)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}e.$ZB=p;function w(r,o){let t=0,n=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,t=R(o.left)-o.size_left,n=$(o.left)-o.lf_left,o.size_left+=t,o.lf_left+=n;o!==r.root&&(t!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}}e.$1B=w}),define(Pe[91],Re([1,0,92,29,93,131,94]),function(ge,e,E,T,I,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_B=e.$$B=e.$0B=e.$9B=e.$8B=void 0;const $=65535;function g(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class b{constructor(n,a,c,h,i){this.lineStarts=n,this.cr=a,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function A(t,n=!0){const a=[0];let c=1;for(let h=0,i=t.length;h<i;h++){const s=t.charCodeAt(h);s===13?h+1<i&&t.charCodeAt(h+1)===10?(a[c++]=h+2,h++):a[c++]=h+1:s===10&&(a[c++]=h+1)}return n?g(a):a}e.$8B=A;function k(t,n){t.length=0,t[0]=0;let a=1,c=0,h=0,i=0,s=!0;for(let d=0,m=n.length;d<m;d++){const f=n.charCodeAt(d);f===13?d+1<m&&n.charCodeAt(d+1)===10?(i++,t[a++]=d+2,d++):(c++,t[a++]=d+1):f===10?(h++,t[a++]=d+1):s&&f!==9&&(f<32||f>126)&&(s=!1)}const u=new b(g(t),c,h,i,s);return t.length=0,u}e.$9B=k;class l{constructor(n,a,c,h,i){this.bufferIndex=n,this.start=a,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$0B=l;class p{constructor(n,a){this.buffer=n,this.lineStarts=a}}e.$$B=p;class w{constructor(n,a){this.a=[],this.c=n,this.d=a,this.b=0,n.root!==M.$SB&&n.iterate(n.root,c=>(c!==M.$SB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let a=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,a=!0;continue}}if(a){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(n,a,c){this.create(n,a,c)}create(n,a,c){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=M.$SB,this.b=1,this.c=0,this.d=a,this.e=a.length,this.f=c;let h=null;for(let i=0,s=n.length;i<s;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=A(n[i].buffer));const u=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,u)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const a=$,c=a-Math.floor(a/3),h=c*2;let i="",s=0;const u=[];if(this.iterate(this.root,d=>{const m=this.R(d),f=m.length;if(s<=c||s+f<h)return i+=m,s+=f,!0;const S=i.replace(/\r\n|\r|\n/g,n);return u.push(new p(S,A(S))),i=m,s=f,!0}),s>0){const d=i.replace(/\r\n|\r|\n/g,n);u.push(new p(d,A(d)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new w(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let a=0;return this.iterate(this.root,h=>{if(h===M.$SB)return!0;const i=this.R(h),s=i.length,u=n.G(a),d=n.G(a+s),m=n.getValueInRange2(u,d);return a+=s,i===m})}getOffsetAt(n,a){let c=0,h=this.root;for(;h!==M.$SB;)if(h.left!==M.$SB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+a-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let a=this.root,c=0;const h=n;for(;a!==M.$SB;)if(a.size_left!==0&&a.size_left>=n)a=a.left;else if(a.size_left+a.piece.length>=n){const i=this.A(a,n-a.size_left);if(c+=a.lf_left+i.index,i.index===0){const s=this.getOffsetAt(c+1,1),u=h-s;return new E.$Ss(c+1,u+1)}return new E.$Ss(c+1,i.remainder+1)}else if(n-=a.size_left+a.piece.length,c+=a.lf_left+a.piece.lineFeedCnt,a.right===M.$SB){const i=this.getOffsetAt(c+1,1),s=h-n-i;return new E.$Ss(c+1,s+1)}else a=a.right;return new E.$Ss(1,1)}getValueInRange(n,a){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return a?a!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,a):i}getValueInRange2(n,a){if(n.node===a.node){const u=n.node,d=this.a[u.piece.bufferIndex].buffer,m=this.u(u.piece.bufferIndex,u.piece.start);return d.substring(m+n.remainder,m+a.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let s=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==M.$SB;){const u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===a.node){s+=u.substring(d,d+a.remainder);break}else s+=u.substr(d,c.piece.length);c=c.next()}return s}getLinesContent(){const n=[];let a=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===M.$SB)return!0;const s=i.piece;let u=s.length;if(u===0)return!0;const d=this.a[s.bufferIndex].buffer,m=this.a[s.bufferIndex].lineStarts,f=s.start.line,S=s.end.line;let L=m[f]+s.start.column;if(h&&(d.charCodeAt(L)===10&&(L++,u--),n[a++]=c,c="",h=!1,u===0))return!0;if(f===S)return!this.f&&d.charCodeAt(L+u-1)===13?(h=!0,c+=d.substr(L,u-1)):c+=d.substr(L,u),!0;c+=this.f?d.substring(L,Math.max(L,m[f+1]-this.e)):d.substring(L,m[f+1]).replace(/(\r\n|\r|\n)$/,""),n[a++]=c;for(let v=f+1;v<S;v++)c=this.f?d.substring(m[v],m[v+1]-this.e):d.substring(m[v],m[v+1]).replace(/(\r\n|\r|\n)$/,""),n[a++]=c;return!this.f&&d.charCodeAt(m[S]+s.end.column-1)===13?(h=!0,s.end.column===0?a--:c=d.substr(m[S],s.end.column-1)):c=d.substr(m[S],s.end.column),!0}),h&&(n[a++]=c,c=""),n[a++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const a=n.node.next();if(!a)return 0;const c=this.a[a.piece.bufferIndex],h=this.u(a.piece.bufferIndex,a.piece.start);return c.buffer.charCodeAt(h)}else{const a=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return a.buffer.charCodeAt(h)}}getLineCharCode(n,a){const c=this.H(n,a+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const a=this.getOffsetAt(n,1);return this.getLength()-a}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const a=this.G(n);return this.l(a)}findMatchesInNode(n,a,c,h,i,s,u,d,m,f,S){const L=this.a[n.piece.bufferIndex],v=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,i),D=this.u(n.piece.bufferIndex,s);let N;const O={line:0,column:0};let H,U;a._wordSeparators?(H=L.buffer.substring(y,D),U=W=>W+y,a.reset(0)):(H=L.buffer,U=W=>W,a.reset(y));do if(N=a.next(H),N){if(U(N.index)>=D)return f;this.s(n,U(N.index)-v,O);const W=this.t(n.piece.bufferIndex,i,O),P=O.line===i.line?O.column-i.column+h:O.column+1,C=P+N[0].length;if(S[f++]=(0,R.$4B)(new T.$Ts(c+W,P,c+W,C),N,d),U(N.index)+N[0].length>=D||f>=m)return f}while(N);return f}findMatchesLineByLine(n,a,c,h){const i=[];let s=0;const u=new R.$7B(a.wordSeparators,a.regex);let d=this.H(n.startLineNumber,n.startColumn);if(d===null)return[];const m=this.H(n.endLineNumber,n.endColumn);if(m===null)return[];let f=this.s(d.node,d.remainder);const S=this.s(m.node,m.remainder);if(d.node===m.node)return this.findMatchesInNode(d.node,u,n.startLineNumber,n.startColumn,f,S,a,c,h,s,i),i;let L=n.startLineNumber,v=d.node;for(;v!==m.node;){const D=this.t(v.piece.bufferIndex,f,v.piece.end);if(D>=1){const O=this.a[v.piece.bufferIndex].lineStarts,H=this.u(v.piece.bufferIndex,v.piece.start),U=O[f.line+D],W=L===n.startLineNumber?n.startColumn:1;if(s=this.findMatchesInNode(v,u,L,W,f,this.s(v,U-H),a,c,h,s,i),s>=h)return i;L+=D}const N=L===n.startLineNumber?n.startColumn-1:0;if(L===n.endLineNumber){const O=this.getLineContent(L).substring(N,n.endColumn-1);return s=this.n(a,u,O,n.endLineNumber,N,s,i,c,h),i}if(s=this.n(a,u,this.getLineContent(L).substr(N),L,N,s,i,c,h),s>=h)return i;L++,d=this.H(L,1),v=d.node,f=this.s(d.node,d.remainder)}if(L===n.endLineNumber){const D=L===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(L).substring(D,n.endColumn-1);return s=this.n(a,u,N,n.endLineNumber,D,s,i,c,h),i}const y=L===n.startLineNumber?n.startColumn:1;return s=this.findMatchesInNode(m.node,u,L,y,f,S,a,c,h,s,i),i}n(n,a,c,h,i,s,u,d,m){const f=n.wordSeparators;if(!d&&n.simpleSearch){const L=n.simpleSearch,v=L.length,y=c.length;let D=-v;for(;(D=c.indexOf(L,D+v))!==-1;)if((!f||(0,R.$6B)(f,c,y,D,v))&&(u[s++]=new I.$_u(new T.$Ts(h,D+1+i,h,D+1+v+i),null),s>=m))return s;return s}let S;a.reset(0);do if(S=a.next(c),S&&(u[s++]=(0,R.$4B)(new T.$Ts(h,S.index+1+i,h,S.index+1+S[0].length+i),S,d),s>=m))return s;while(S);return s}insert(n,a,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==M.$SB){const{node:h,remainder:i,nodeStartOffset:s}=this.G(n),u=h.piece,d=u.bufferIndex,m=this.s(h,i);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&s+u.length===n&&a.length<$){this.F(h,a),this.y();return}if(s===n)this.o(a,h),this.h.validate(n);else if(s+h.piece.length>n){const f=[];let S=new l(u.bufferIndex,m,u.end,this.t(u.bufferIndex,m,u.end),this.u(d,u.end)-this.u(d,m));if(this.K()&&this.M(a)&&this.I(h,i)===10){const D={line:S.start.line+1,column:0};S=new l(S.bufferIndex,D,S.end,this.t(S.bufferIndex,D,S.end),S.length-1),a+=`
`}if(this.K()&&this.L(a))if(this.I(h,i-1)===13){const D=this.s(h,i-1);this.C(h,D),a="\r"+a,h.piece.length===0&&f.push(h)}else this.C(h,m);else this.C(h,m);const L=this.w(a);S.length>0&&this.S(h,S);let v=h;for(let y=0;y<L.length;y++)v=this.S(v,L[y]);this.v(f)}else this.q(a,h)}else{const h=this.w(a);let i=this.T(null,h[0]);for(let s=1;s<h.length;s++)i=this.S(i,h[s])}this.y()}delete(n,a){if(this.j.lineNumber=0,this.j.value="",a<=0||this.root===M.$SB)return;const c=this.G(n),h=this.G(n+a),i=c.node,s=h.node;if(i===s){const L=this.s(i,c.remainder),v=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(a===i.piece.length){const y=i.next();(0,M.$XB)(this,i),this.N(y),this.y();return}this.D(i,v),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+a){this.C(i,L),this.O(i),this.y();return}this.E(i,L,v),this.y();return}const u=[],d=this.s(i,c.remainder);this.C(i,d),this.h.validate(n),i.piece.length===0&&u.push(i);const m=this.s(s,h.remainder);this.D(s,m),s.piece.length===0&&u.push(s);const f=i.next();for(let L=f;L!==M.$SB&&L!==s;L=L.next())u.push(L);const S=i.piece.length===0?i.prev():i;this.v(u),this.O(S),this.y()}o(n,a){const c=[];if(this.K()&&this.M(n)&&this.L(a)){const s=a.piece,u={line:s.start.line+1,column:0},d=new l(s.bufferIndex,u,s.end,this.t(s.bufferIndex,u,s.end),s.length-1);a.piece=d,n+=`
`,(0,M.$ZB)(this,a,-1,-1),a.piece.length===0&&c.push(a)}const h=this.w(n);let i=this.T(a,h[h.length-1]);for(let s=h.length-2;s>=0;s--)i=this.T(i,h[s]);this.N(i),this.v(c)}q(n,a){this.Q(n,a)&&(n+=`
`);const c=this.w(n),h=this.S(a,c[0]);let i=h;for(let s=1;s<c.length;s++)i=this.S(i,c[s]);this.N(h)}s(n,a,c){const h=n.piece,i=n.piece.bufferIndex,s=this.a[i].lineStarts,d=s[h.start.line]+h.start.column+a;let m=h.start.line,f=h.end.line,S=0,L=0,v=0;for(;m<=f&&(S=m+(f-m)/2|0,v=s[S],S!==f);)if(L=s[S+1],d<v)f=S-1;else if(d>=L)m=S+1;else break;return c?(c.line=S,c.column=d-v,null):{line:S,column:d-v}}t(n,a,c){if(c.column===0)return c.line-a.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-a.line;const i=h[c.line+1],s=h[c.line]+c.column;if(i>s+1)return c.line-a.line;const u=s-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-a.line+1:c.line-a.line}u(n,a){return this.a[n].lineStarts[a.line]+a.column}v(n){for(let a=0;a<n.length;a++)(0,M.$XB)(this,n[a])}w(n){if(n.length>$){const f=[];for(;n.length>$;){const L=n.charCodeAt($-1);let v;L===13||L>=55296&&L<=56319?(v=n.substring(0,$-1),n=n.substring($-1)):(v=n.substring(0,$),n=n.substring($));const y=A(v);f.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:v.length-y[y.length-1]},y.length-1,v.length)),this.a.push(new p(v,y))}const S=A(n);return f.push(new l(this.a.length,{line:0,column:0},{line:S.length-1,column:n.length-S[S.length-1]},S.length-1,n.length)),this.a.push(new p(n,S)),f}let a=this.a[0].buffer.length;const c=A(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===a&&a!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=a+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,a+=1}else{if(a!==0)for(let f=0;f<c.length;f++)c[f]+=a;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[s],d={line:s,column:u},m=new l(0,h,d,this.t(0,h,d),i-a);return this.g=d,[m]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,a=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const s=this.B(c,n-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=u.substring(d+s,d+c.piece.length);else{const m=this.B(c,n-i.nodeStartLineNumber);return u.substring(d+s,d+m-a)}}else{let s=0;const u=n;for(;c!==M.$SB;)if(c.left!==M.$SB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const d=this.B(c,n-c.lf_left-2),m=this.B(c,n-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);return s+=c.size_left,this.h.set({node:c,nodeStartOffset:s,nodeStartLineNumber:u-(n-1-c.lf_left)}),f.substring(S+d,S+m-a)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const d=this.B(c,n-c.lf_left-2),m=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=m.substring(f+d,f+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,s+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==M.$SB;){const s=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return h+=s.substring(d,d+u-a),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=s.substr(u,c.piece.length)}c=c.next()}return h}y(){let n=this.root,a=1,c=0;for(;n!==M.$SB;)a+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=a,this.c=c,this.h.validate(this.c)}A(n,a){const c=n.piece,h=this.s(n,a),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===a){const s=this.t(n.piece.bufferIndex,c.start,h);if(s!==i)return{index:s,remainder:0}}return{index:i,remainder:h.column}}B(n,a){if(a<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+a+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,a){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),s=a,u=this.u(c.bufferIndex,s),d=this.t(c.bufferIndex,c.start,s),m=d-h,f=u-i,S=c.length+f;n.piece=new l(c.bufferIndex,c.start,s,d,S),(0,M.$ZB)(this,n,f,m)}D(n,a){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),s=a,u=this.t(c.bufferIndex,s,c.end),d=this.u(c.bufferIndex,s),m=u-h,f=i-d,S=c.length+f;n.piece=new l(c.bufferIndex,s,c.end,u,S),(0,M.$ZB)(this,n,f,m)}E(n,a,c){const h=n.piece,i=h.start,s=h.end,u=h.length,d=h.lineFeedCnt,m=a,f=this.t(h.bufferIndex,h.start,m),S=this.u(h.bufferIndex,a)-this.u(h.bufferIndex,i);n.piece=new l(h.bufferIndex,h.start,m,f,S),(0,M.$ZB)(this,n,S-u,f-d);const L=new l(h.bufferIndex,c,s,this.t(h.bufferIndex,c,s),this.u(h.bufferIndex,s)-this.u(h.bufferIndex,c)),v=this.S(n,L);this.N(v)}F(n,a){this.Q(a,n)&&(a+=`
`);const c=this.K()&&this.L(a)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=a;const i=A(a,!1);for(let v=0;v<i.length;v++)i[v]+=h;if(c){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const s=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:u},m=n.piece.length+a.length,f=n.piece.lineFeedCnt,S=this.t(0,n.piece.start,d),L=S-f;n.piece=new l(n.piece.bufferIndex,n.piece.start,d,S,m),this.g=d,(0,M.$ZB)(this,n,a.length,L)}G(n){let a=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;a!==M.$SB;)if(a.size_left>n)a=a.left;else if(a.size_left+a.piece.length>=n){h+=a.size_left;const i={node:a,remainder:n-a.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=a.size_left+a.piece.length,h+=a.size_left+a.piece.length,a=a.right;return null}H(n,a){let c=this.root,h=0;for(;c!==M.$SB;)if(c.left!==M.$SB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),s=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+a-1,s),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+a-1<=c.piece.length)return{node:c,remainder:i+a-1,nodeStartOffset:h};a-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==M.$SB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),s=this.J(c);return{node:c,remainder:Math.min(a-1,i),nodeStartOffset:s}}else if(c.piece.length>=a-1){const i=this.J(c);return{node:c,remainder:a-1,nodeStartOffset:i}}else a-=c.piece.length;c=c.next()}return null}I(n,a){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+a;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let a=n.size_left;for(;n!==this.root;)n.parent.right===n&&(a+=n.parent.size_left+n.parent.piece.length),n=n.parent;return a}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$SB||n.piece.lineFeedCnt===0)return!1;const a=n.piece,c=this.a[a.bufferIndex].lineStarts,h=a.start.line,i=c[h]+a.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[a.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$SB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const a=n.prev();this.M(a)&&this.P(a,n)}}O(n){if(this.K()&&this.M(n)){const a=n.next();this.L(a)&&this.P(n,a)}}P(n,a){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const s=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,u,s),(0,M.$ZB)(this,n,-1,-1),n.piece.length===0&&c.push(n);const d={line:a.piece.start.line+1,column:0},m=a.piece.length-1,f=this.t(a.piece.bufferIndex,d,a.piece.end);a.piece=new l(a.piece.bufferIndex,d,a.piece.end,f,m),(0,M.$ZB)(this,a,-1,-1),a.piece.length===0&&c.push(a);const S=this.w(`\r
`);this.S(n,S[0]);for(let L=0;L<c.length;L++)(0,M.$XB)(this,c[L])}Q(n,a){if(this.K()&&this.M(n)){const c=a.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,M.$XB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},s=h.length-1,u=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,u,s),(0,M.$ZB)(this,c,-1,-1)}return!0}}return!1}iterate(n,a){if(n===M.$SB)return a(M.$SB);const c=this.iterate(n.left,a);return c&&a(n)&&this.iterate(n.right,a)}R(n){if(n===M.$SB)return"";const a=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return a.buffer.substring(h,i)}getPieceContent(n){const a=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return a.buffer.substring(c,h)}S(n,a){const c=new M.$RB(a,1);if(c.left=M.$SB,c.right=M.$SB,c.parent=M.$SB,c.size_left=0,c.lf_left=0,this.root===M.$SB)this.root=c,c.color=0;else if(n.right===M.$SB)n.right=c,c.parent=n;else{const i=(0,M.$TB)(n.right);i.left=c,c.parent=i}return(0,M.$YB)(this,c),c}T(n,a){const c=new M.$RB(a,1);if(c.left=M.$SB,c.right=M.$SB,c.parent=M.$SB,c.size_left=0,c.lf_left=0,this.root===M.$SB)this.root=c,c.color=0;else if(n.left===M.$SB)n.left=c,c.parent=n;else{const h=(0,M.$UB)(n.left);h.right=c,c.parent=h}return(0,M.$YB)(this,c),c}U(n){let a="";return this.iterate(n,c=>(a+=this.R(c),!0)),a}}e.$_B=o}),define(Pe[132],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8=e.$f8=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$f8=E;class T{constructor(M){this.identifier=M}}e.$g8=T}),define(Pe[133],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Pe[134],Re([1,0,5,6,133]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=void 0;class M extends T.$Tc{constructor(l,p="",w="",r=!0,o){super(),this.h=this.B(new E.$Ud),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=w,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Ji=M;class R extends T.$Tc{constructor(){super(...arguments),this.f=this.B(new E.$Ud),this.onWillRun=this.f.event,this.m=this.B(new E.$Ud),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let w;try{await this.u(l,p)}catch(r){w=r}this.m.fire({action:l,error:w})}async u(l,p){await l.run(p)}}e.$Ki=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const w of l)w.length&&(p.length?p=[...p,new $,...w]:p=w);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Li=$;class g{get actions(){return this.a}constructor(l,p,w,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=r,this.a=w}async run(){}}e.$Mi=g;class b extends M{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,I.localize(0,null),void 0,!1)}}e.$Ni=b;function A(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$Oi=A}),define(Pe[135],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Pe[136],Re([1,0,135]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0;const T=60,I=T*60,M=I*24,R=M*7,$=M*30,g=M*365;function b(k,l,p,w){typeof k!="number"&&(k=k.getTime());const r=Math.round((new Date().getTime()-k)/1e3);if(r<-30)return(0,E.localize)(0,null,b(new Date().getTime()+r*1e3,!1));if(!w&&r<30)return(0,E.localize)(1,null);let o;return r<T?(o=r,l?o===1?p?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):p?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?p?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):p?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):r<I?(o=Math.floor(r/T),l?o===1?p?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):p?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?p?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):p?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):r<M?(o=Math.floor(r/I),l?o===1?p?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):p?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?p?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):p?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):r<R?(o=Math.floor(r/M),l?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):r<$?(o=Math.floor(r/R),l?o===1?p?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):p?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?p?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):p?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):r<g?(o=Math.floor(r/$),l?o===1?p?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):p?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?p?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):p?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(r/g),l?o===1?p?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):p?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?p?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):p?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.$um=b;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$vm=A}),define(Pe[137],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Pe[40],Re([1,0,18,16,137]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=void 0;function M(k,l){return l&&(k.stack||k.stacktrace)?I.localize(0,null,$(k),R(k.stack)||R(k.stacktrace)):$(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function $(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?I.localize(1,null,k.message):k.message||I.localize(2,null)}function g(k=null,l=!1){if(!k)return I.localize(3,null);if(Array.isArray(k)){const p=E.$Hb(k),w=g(p[0],l);return p.length>1?I.localize(4,null,w,p.length):w}if(T.$Hf(k))return k;if(k.detail){const p=k.detail;if(p.error)return M(p.error,l);if(p.exception)return M(p.exception,l)}return k.stack?M(k,l):k.message?k.message:I.localize(5,null)}e.$Pi=g;function b(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$Qi=b;function A(k,l){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=l,p}e.$Ri=A}),define(Pe[138],Re([1,0,39,19]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=e.$Hq=void 0;const I=new E.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),M=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(L,v,y=!1){const D=L||"",N=v||"",O=I.value.collator.compare(D,N);return I.value.collatorIsNumeric&&O===0&&D!==N?D<N?-1:1:O}e.$Hq=$;function g(L,v){const y=M.value.collator;return L=L||"",v=v||"",c(y,L,v)}e.$Iq=g;function b(L,v){const y=M.value.collator;return L=L||"",v=v||"",u(L,v)||c(y,L,v)}e.$Jq=b;function A(L,v){const y=M.value.collator;return L=L||"",v=v||"",s(L,v)||c(y,L,v)}e.$Kq=A;function k(L,v){return L=L||"",v=v||"",L===v?0:L<v?-1:1}e.$Lq=k;function l(L,v){const[y,D]=n(L),[N,O]=n(v);let H=I.value.collator.compare(D,O);if(H===0){if(I.value.collatorIsNumeric&&D!==O)return D<O?-1:1;if(H=I.value.collator.compare(y,N),I.value.collatorIsNumeric&&H===0&&y!==N)return y<N?-1:1}return H}e.$Mq=l;function p(L,v){L=L||"",v=v||"";const y=a(L),D=a(v),N=M.value.collator,O=R.value.collator;return c(O,y,D)||c(N,L,v)}e.$Nq=p;function w(L,v){L=L||"",v=v||"";const y=a(L),D=a(v),N=M.value.collator,O=R.value.collator;return c(O,y,D)||u(L,v)||c(N,L,v)}e.$Oq=w;function r(L,v){L=L||"",v=v||"";const y=a(L),D=a(v),N=M.value.collator,O=R.value.collator;return c(O,y,D)||s(L,v)||c(N,L,v)}e.$Pq=r;function o(L,v){L=L||"",v=v||"";const y=a(L).toLowerCase(),D=a(v).toLowerCase();return y!==D?y<D?-1:1:L!==v?L<v?-1:1:0}e.$Qq=o;const t=/^(.*?)(\.([^.]*))?$/;function n(L,v=!1){const y=L?t.exec(L):[];let D=[y&&y[1]||"",y&&y[3]||""];return v&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function a(L){const v=L?t.exec(L):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function c(L,v,y){const D=L.compare(v,y);return D!==0?D:v.length!==y.length?v.length<y.length?-1:1:0}function h(L){const v=L.charAt(0);return v.toLocaleUpperCase()!==v}function i(L){const v=L.charAt(0);return v.toLocaleLowerCase()!==v}function s(L,v){return h(L)&&i(v)?-1:i(L)&&h(v)?1:0}function u(L,v){return i(L)&&h(v)?-1:h(L)&&i(v)?1:0}function d(L,v,y=!1){return y||(L=L&&L.toLowerCase(),v=v&&v.toLowerCase()),L===v?0:L<v?-1:1}function m(L,v,y=!1){const D=L.split(T.sep),N=v.split(T.sep),O=D.length-1,H=N.length-1;let U,W;for(let P=0;;P++){if(U=O===P,W=H===P,U&&W)return $(D[P],N[P],y);if(U)return-1;if(W)return 1;const C=d(D[P],N[P],y);if(C!==0)return C}}e.$Rq=m;function f(L,v,y){const D=L.toLowerCase(),N=v.toLowerCase(),O=S(L,v,y);if(O)return O;const H=D.endsWith(y),U=N.endsWith(y);if(H!==U)return H?-1:1;const W=$(D,N);return W!==0?W:D.localeCompare(N)}e.$Sq=f;function S(L,v,y){const D=L.toLowerCase(),N=v.toLowerCase(),O=D.startsWith(y),H=N.startsWith(y);if(O!==H)return O?-1:1;if(O&&H){if(D.length<N.length)return-1;if(D.length>N.length)return 1}return 0}e.$Tq=S}),define(Pe[46],Re([1,0,19,21,11,16]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=void 0;function R(f){return f===47||f===92}e.$Zf=R;function $(f){return f.replace(/[\\/]/g,E.$gc.sep)}e.$1f=$;function g(f){return f.indexOf("/")===-1&&(f=$(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$2f=g;function b(f,S=E.$gc.sep){if(!f)return"";const L=f.length,v=f.charCodeAt(0);if(R(v)){if(R(f.charCodeAt(1))&&!R(f.charCodeAt(2))){let D=3;const N=D;for(;D<L&&!R(f.charCodeAt(D));D++);if(N!==D&&!R(f.charCodeAt(D+1))){for(D+=1;D<L;D++)if(R(f.charCodeAt(D)))return f.slice(0,D+1).replace(/[\\/]/g,S)}}return S}else if(t(v)&&f.charCodeAt(1)===58)return R(f.charCodeAt(2))?f.slice(0,2)+S:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<L;y++)if(R(f.charCodeAt(y)))return f.slice(0,y+1)}return""}e.$3f=b;function A(f){if(!T.$i||!f||f.length<5)return!1;let S=f.charCodeAt(0);if(S!==92||(S=f.charCodeAt(1),S!==92))return!1;let L=2;const v=L;for(;L<f.length&&(S=f.charCodeAt(L),S!==92);L++);return!(v===L||(S=f.charCodeAt(L+1),isNaN(S)||S===92))}e.$4f=A;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(f,S=T.$i){const L=S?k:l;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||S&&p.test(f)||f==="."||f===".."||S&&f[f.length-1]==="."||S&&f.length!==f.trim().length||f.length>255)}e.$5f=w;function r(f,S,L){const v=f===S;return!L||v?v:!f||!S?!1:(0,I.$$e)(f,S)}e.$6f=r;function o(f,S,L,v=E.sep){if(f===S)return!0;if(!f||!S||S.length>f.length)return!1;if(L){if(!(0,I.$_e)(f,S))return!1;if(S.length===f.length)return!0;let D=S.length;return S.charAt(S.length-1)===v&&D--,f.charAt(D)===v}return S.charAt(S.length-1)!==v&&(S+=v),f.indexOf(S)===0}e.$7f=o;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.$8f=t;function n(f,S){return T.$i&&f.endsWith(":")&&(f+=E.sep),(0,E.$ic)(f)||(f=(0,E.$jc)(S,f)),f=(0,E.$hc)(f),T.$i?(f=(0,I.$Te)(f,E.sep),f.endsWith(":")&&(f+=E.sep)):(f=(0,I.$Te)(f,E.sep),f||(f=E.sep)),f}e.$9f=n;function a(f){const S=(0,E.$hc)(f);return T.$i?f.length>3?!1:c(S)&&(f.length===2||S.charCodeAt(2)===92):S===E.$gc.sep}e.$0f=a;function c(f,S=T.$i){return S?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$$f=c;function h(f,S=T.$i){return c(f,S)?f[0]:void 0}e.$_f=h;function i(f,S,L){return S.length>f.length?-1:f===S?0:(L&&(f=f.toLowerCase(),S=S.toLowerCase()),f.indexOf(S))}e.$ag=i;function s(f){const S=f.split(":");let L,v,y;for(const D of S){const N=Number(D);(0,M.$Lf)(N)?v===void 0?v=N:y===void 0&&(y=N):L=L?[L,D].join(":"):D}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:v!==void 0?v:void 0,column:y!==void 0?y:v!==void 0?1:void 0}}e.$bg=s;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(f,S,L=8){let v="";for(let D=0;D<L;D++){let N;D===0&&T.$i&&!S&&(L===3||L===4)?N=d:N=u,v+=N.charAt(Math.floor(Math.random()*N.length))}let y;return S?y=`${S}-${v}`:y=v,f?(0,E.$jc)(f,y):y}e.$cg=m}),define(Pe[68],Re([1,0,19]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=e.$gs=e.$fs=e.$es=void 0,e.$es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const k=(0,E.$oc)(A),l=T[k.toLowerCase()];return l!==void 0?l:R(A)}e.$fs=M;function R(A){const k=(0,E.$oc)(A);return I[k.toLowerCase()]}e.$gs=R;function $(A){for(const k in I)if(I[k]===A)return k}e.$hs=$;const g=/^(.+)\/(.+?)(;.+)?$/;function b(A,k){const l=g.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:A}e.$is=b}),define(Pe[51],Re([1,0,24,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function I(g){return JSON.stringify(g,R)}e.$zh=I;function M(g){let b=JSON.parse(g);return b=$(b),b}e.$Ah=M;function R(g,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function $(g,b=0){if(!g||b>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof E.$ie||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let A=0;A<g.length;++A)g[A]=$(g[A],b+1);else for(const A in g)Object.hasOwnProperty.call(g,A)&&(g[A]=$(g[A],b+1))}return g}e.$Bh=$}),define(Pe[12],Re([1,0,15,21,11,2]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.Schemas=void 0;var R;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function $(l,p){return M.URI.isUri(l)?(0,I.$$e)(l.scheme,p):(0,I.$_e)(l,p+":")}e.$dg=$;function g(l,...p){return p.some(w=>$(l,w))}e.$eg=g,e.$fg="vscode-tkn",e.$gg="tkn";class b{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${R.vscodeRemoteResource}`}set(p,w,r){this.a[p]=w,this.b[p]=r}setConnectionToken(p,w){this.c[p]=w}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(a){return E.$1(a),p}const w=p.authority;let r=this.a[w];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const o=this.b[w],t=this.c[w];let n=`path=${encodeURIComponent(p.path)}`;return typeof t=="string"&&(n+=`&${e.$gg}=${encodeURIComponent(t)}`),M.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${r}:${o}`,path:this.f,query:n})}}e.$hg=new b,e.$ig="vs/../../extensions",e.$jg="vs/../../node_modules",e.$kg="vs/../../node_modules.asar",e.$lg="vs/../../node_modules.asar.unpacked",e.$mg="vscode-app";class A{static{this.a=e.$mg}asBrowserUri(p){const w=this.b(p,ge);return this.uriToBrowserUri(w)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.$hg.rewrite(p):p.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${A.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||A.a,query:null,fragment:null}):p}asFileUri(p){const w=this.b(p,ge);return this.uriToFileUri(w)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==A.a?p.authority:null,query:null,fragment:null}):p}b(p,w){return M.URI.isUri(p)?p:M.URI.parse(w.toUrl(p))}}e.$ng=new A;var k;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const w="vscode-coi";function r(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:M.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const a=n?.get(w);if(a)return p.get(a)}l.getHeadersFromQuery=r;function o(t,n,a){if(!globalThis.crossOriginIsolated)return;const c=n&&a?"3":a?"2":"1";t instanceof URLSearchParams?t.set(w,c):t[w]=c}l.addSearchParam=o})(k||(e.COI=k={}))}),define(Pe[25],Re([1,0,46,12,19,21,11,2]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.DataUri=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=void 0;function g(p){return(0,$.$wc)(p,!0)}e.$ug=g;class b{constructor(w){this.a=w}compare(w,r,o=!1){return w===r?0:(0,R.$4e)(this.getComparisonKey(w,o),this.getComparisonKey(r,o))}isEqual(w,r,o=!1){return w===r?!0:!w||!r?!1:this.getComparisonKey(w,o)===this.getComparisonKey(r,o)}getComparisonKey(w,r=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,r,o=!1){if(w.scheme===r.scheme){if(w.scheme===T.Schemas.file)return E.$7f(g(w),g(r),this.a(w))&&w.query===r.query&&(o||w.fragment===r.fragment);if((0,e.$Lg)(w.authority,r.authority))return E.$7f(w.path,r.path,this.a(w),"/")&&w.query===r.query&&(o||w.fragment===r.fragment)}return!1}joinPath(w,...r){return $.URI.joinPath(w,...r)}basenameOrAuthority(w){return(0,e.$Dg)(w)||w.authority}basename(w){return I.$gc.basename(w.path)}extname(w){return I.$gc.extname(w.path)}dirname(w){if(w.path.length===0)return w;let r;return w.scheme===T.Schemas.file?r=$.URI.file(I.$mc(g(w))).path:(r=I.$gc.dirname(w.path),w.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),r="/")),w.with({path:r})}normalizePath(w){if(!w.path.length)return w;let r;return w.scheme===T.Schemas.file?r=$.URI.file(I.$hc(g(w))).path:r=I.$gc.normalize(w.path),w.with({path:r})}relativePath(w,r){if(w.scheme!==r.scheme||!(0,e.$Lg)(w.authority,r.authority))return;if(w.scheme===T.Schemas.file){const n=I.$lc(g(w),g(r));return M.$i?E.$1f(n):n}let o=w.path||"/";const t=r.path||"/";if(this.a(w)){let n=0;for(const a=Math.min(o.length,t.length);n<a&&!(o.charCodeAt(n)!==t.charCodeAt(n)&&o.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);o=t.substr(0,n)+o.substr(n)}return I.$gc.relative(o,t)}resolvePath(w,r){if(w.scheme===T.Schemas.file){const o=$.URI.file(I.$kc(g(w),r));return w.with({authority:o.authority,path:o.path})}return r=E.$2f(r),w.with({path:I.$gc.resolve(w.path,r)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,r){return w===r||w!==void 0&&r!==void 0&&(0,R.$$e)(w,r)}hasTrailingPathSeparator(w,r=I.sep){if(w.scheme===T.Schemas.file){const o=g(w);return o.length>E.$3f(o).length&&o[o.length-1]===r}else{const o=w.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,r=I.sep){return(0,e.$Mg)(w,r)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,r=I.sep){let o=!1;if(w.scheme===T.Schemas.file){const t=g(w);o=t!==void 0&&t.length===E.$3f(t).length&&t[t.length-1]===r}else{r="/";const t=w.path;o=t.length===1&&t.charCodeAt(t.length-1)===47}return!o&&!(0,e.$Mg)(w,r)?w.with({path:w.path+"/"}):w}}e.$vg=b,e.$wg=new b(()=>!1),e.$xg=new b(p=>p.scheme===T.Schemas.file?!M.$k:!0),e.$yg=new b(p=>!0),e.$zg=e.$wg.isEqual.bind(e.$wg),e.$Ag=e.$wg.isEqualOrParent.bind(e.$wg),e.$Bg=e.$wg.getComparisonKey.bind(e.$wg),e.$Cg=e.$wg.basenameOrAuthority.bind(e.$wg),e.$Dg=e.$wg.basename.bind(e.$wg),e.$Eg=e.$wg.extname.bind(e.$wg),e.$Fg=e.$wg.dirname.bind(e.$wg),e.$Gg=e.$wg.joinPath.bind(e.$wg),e.$Hg=e.$wg.normalizePath.bind(e.$wg),e.$Ig=e.$wg.relativePath.bind(e.$wg),e.$Jg=e.$wg.resolvePath.bind(e.$wg),e.$Kg=e.$wg.isAbsolutePath.bind(e.$wg),e.$Lg=e.$wg.isEqualAuthority.bind(e.$wg),e.$Mg=e.$wg.hasTrailingPathSeparator.bind(e.$wg),e.$Ng=e.$wg.removeTrailingPathSeparator.bind(e.$wg),e.$Og=e.$wg.addTrailingPathSeparator.bind(e.$wg);function A(p,w){const r=[];for(let o=0;o<p.length;o++){const t=w(p[o]);p.some((n,a)=>a===o?!1:(0,e.$Ag)(t,w(n)))||r.push(p[o])}return r}e.$Pg=A;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function w(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,h]=a.split(":");c&&h&&o.set(c,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&o.set(p.META_DATA_MIME,n),o}p.parseMetaData=w})(k||(e.DataUri=k={}));function l(p,w,r){if(w){let o=p.path;return o&&o[0]!==I.$gc.sep&&(o=I.$gc.sep+o),p.with({scheme:r,authority:w,path:o})}return p.with({scheme:r})}e.$Qg=l}),define(Pe[13],Re([1,0,20,15,5,6,25,21,125,39]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.Promises=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=void 0;function A(ce){return!!ce&&typeof ce.then=="function"}e.$Rg=A;function k(ce){const ie=new E.$5d,Q=ce(ie.token),te=new Promise((me,pe)=>{const Ae=ie.token.onCancellationRequested(()=>{Ae.dispose(),pe(new T.$5)});Promise.resolve(Q).then(le=>{Ae.dispose(),ie.dispose(),me(le)},le=>{Ae.dispose(),ie.dispose(),pe(le)})});return new class{cancel(){ie.cancel(),ie.dispose()}then(me,pe){return te.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return te.finally(me)}}}e.$Sg=k;function l(ce,ie,Q){return new Promise((te,me)=>{const pe=ie.onCancellationRequested(()=>{pe.dispose(),te(Q)});ce.then(te,me).finally(()=>pe.dispose())})}e.$Tg=l;function p(ce,ie){return new Promise((Q,te)=>{const me=ie.onCancellationRequested(()=>{me.dispose(),te(new T.$5)});ce.then(Q,te).finally(()=>me.dispose())})}e.$Ug=p;async function w(ce){let ie=-1;const Q=ce.map((te,me)=>te.then(pe=>(ie=me,pe)));try{return await Promise.race(Q)}finally{ce.forEach((te,me)=>{me!==ie&&te.cancel()})}}e.$Vg=w;function r(ce,ie,Q){let te;const me=setTimeout(()=>{te?.(void 0),Q?.()},ie);return Promise.race([ce.finally(()=>clearTimeout(me)),new Promise(pe=>te=pe)])}e.$Wg=r;function o(ce){return new Promise((ie,Q)=>{const te=ce();A(te)?te.then(ie,Q):ie(te)})}e.$Xg=o;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const Q=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(Q,Q).then(te)})}return new Promise((Q,te)=>{this.b.then(Q,te)})}return this.a=ie(),new Promise((Q,te)=>{this.a.then(me=>{this.a=null,Q(me)},me=>{this.a=null,te(me)})})}dispose(){this.f=!0}}e.$Yg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Zg=n;class a{constructor(){this.a=new Map}queue(ie,Q){const me=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(ie)===me&&this.a.delete(ie)});return this.a.set(ie,me),me}}e.$1g=a;const c=(ce,ie)=>{let Q=!0;const te=setTimeout(()=>{Q=!1,ie()},ce);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(te),Q=!1}}},h=ce=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,ce())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class i{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,Q=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((me,pe)=>{this.d=me,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=Q===g.$Rd?h(te):c(Q,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$2g=i;class s{constructor(ie){this.a=new i(ie),this.b=new t}trigger(ie,Q){return this.a.trigger(()=>this.b.queue(ie),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$3g=s;class u{constructor(){this.a=!1,this.b=new Promise((ie,Q)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$4g=u;class d extends u{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$5g=d;function m(ce,ie){return ie?new Promise((Q,te)=>{const me=setTimeout(()=>{pe.dispose(),Q()},ce),pe=ie.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),te(new T.$5)})}):k(Q=>m(ce,Q))}e.$6g=m;function f(ce,ie=0,Q){const te=setTimeout(()=>{ce(),Q&&me.dispose()},ie),me=(0,M.$Rc)(()=>{clearTimeout(te),Q?.deleteAndLeak(me)});return Q?.add(me),me}e.$7g=f;function S(ce){const ie=[];let Q=0;const te=ce.length;function me(){return Q<te?ce[Q++]():null}function pe(Ae){Ae!=null&&ie.push(Ae);const le=me();return le?le.then(pe):Promise.resolve(ie)}return Promise.resolve(null).then(pe)}e.$8g=S;function L(ce,ie=te=>!!te,Q=null){let te=0;const me=ce.length,pe=()=>{if(te>=me)return Promise.resolve(Q);const Ae=ce[te++];return Promise.resolve(Ae()).then(be=>ie(be)?Promise.resolve(be):pe())};return pe()}e.$9g=L;function v(ce,ie=te=>!!te,Q=null){if(ce.length===0)return Promise.resolve(Q);let te=ce.length;const me=()=>{te=-1;for(const pe of ce)pe.cancel?.()};return new Promise((pe,Ae)=>{for(const le of ce)le.then(be=>{--te>=0&&ie(be)?(me(),pe(be)):te===0&&pe(Q)}).catch(be=>{--te>=0&&(me(),Ae(be))})})}e.$0g=v;class y{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new I.$Ud}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((Q,te)=>{this.f.push({factory:ie,c:Q,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const Q=ie.factory();Q.then(ie.c,ie.e),Q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$$g=y;class D extends y{constructor(){super(1)}}e.$_g=D;class N{constructor(){this.a=new ye,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$ah=N;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new ee;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,Q=R.$wg){const te=Q.getComparisonKey(ie);let me=this.a.get(te);if(!me){me=new D;const pe=this.f++,Ae=I.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$3c),this.d.set(pe,Ae),this.a.set(te,me)}return me}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$bh=O;class H{constructor(ie,Q){this.a=-1,typeof ie=="function"&&typeof Q=="number"&&this.setIfNotSet(ie,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},Q)}setIfNotSet(ie,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},Q))}}e.$ch=H;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,Q,te=globalThis){this.cancel();const me=te.setInterval(()=>{ie()},Q);this.d=(0,M.$Rc)(()=>{te.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$dh=U;class W{constructor(ie,Q){this.b=-1,this.a=ie,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$eh=W;class P{constructor(ie,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=ie,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$fh=P;class C extends W{constructor(ie,Q){super(ie,Q),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$gh=C;class J extends M.$Tc{constructor(ie,Q){super(),this.g=ie,this.h=Q,this.a=[],this.b=this.B(new M.$Uc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of ie)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$hh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$jh=(ce,ie)=>{(0,$.$B)(()=>{if(Q)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$jh=(ce,ie,Q)=>{const te=ce.requestIdleCallback(ie,typeof Q=="number"?{timeout:Q}:void 0);let me=!1;return{dispose(){me||(me=!0,ce.cancelIdleCallback(te))}}},e.$ih=ce=>(0,e.$jh)(globalThis,ce)}();class ae{constructor(ie,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$jh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$kh=ae;class fe extends ae{constructor(ie){super(globalThis,ie)}}e.$lh=fe;async function we(ce,ie,Q){let te;for(let me=0;me<Q;me++)try{return await ce()}catch(pe){te=pe,await m(ie)}throw te}e.$mh=we;class ye{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,Q,te){return this.a={taskId:ie,cancel:()=>te?.(),promise:Q},Q.then(()=>this.d(ie),()=>this.d(ie)),Q}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let Q,te;const me=new Promise((pe,Ae)=>{Q=pe,te=Ae});this.b={run:ie,promise:me,promiseResolve:Q,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$nh=ye;class he{constructor(ie,Q=()=>Date.now()){this.d=ie,this.f=Q,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$oh=he;var ve;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(ve||(ve={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,Q)=>{this.a=ie,this.b=Q})}complete(ie){return new Promise(Q=>{this.a(ie),this.d={outcome:0,value:ie},Q()})}error(ie){return new Promise(Q=>{this.b(ie),this.d={outcome:1,value:ie},Q()})}cancel(){return this.error(new T.$5)}}e.$ph=ee;var De;(function(ce){async function ie(te){let me;const pe=await Promise.all(te.map(Ae=>Ae.then(le=>le,le=>{me||(me=le)})));if(typeof me<"u")throw me;return pe}ce.settled=ie;function Q(te){return new Promise(async(me,pe)=>{try{await te(me,pe)}catch(Ae){pe(Ae)}})}ce.withAsyncBody=Q})(De||(e.Promises=De={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$qh=se;class x{constructor(ie){this.b=ie,this.a=new b.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$rh=x;var V;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(V||(V={}));class ne{static fromArray(ie){return new ne(Q=>{Q.emitMany(ie)})}static fromPromise(ie){return new ne(async Q=>{Q.emitMany(await ie)})}static fromPromises(ie){return new ne(async Q=>{await Promise.all(ie.map(async te=>Q.emitOne(await te)))})}static merge(ie){return new ne(async Q=>{await Promise.all(ie.map(async te=>{for await(const me of te)Q.emitOne(me)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new I.$Ud,queueMicrotask(async()=>{const Q={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ie(Q)),this.j()}catch(te){this.k(te)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,Q){return new ne(async te=>{for await(const me of ie)te.emitOne(Q(me))})}map(ie){return ne.map(this,ie)}static filter(ie,Q){return new ne(async te=>{for await(const me of ie)Q(me)&&te.emitOne(me)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,Q=>!!Q)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const Q=[];for await(const te of ie)Q.push(te);return Q}toPromise(){return ne.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$sh=ne;class Ie extends ne{constructor(ie,Q){super(Q),this.l=ie}cancel(){this.l.cancel()}}e.$th=Ie;function Me(ce){const ie=new E.$5d,Q=ce(ie.token);return new Ie(ie,async te=>{const me=ie.token.onCancellationRequested(()=>{me.dispose(),ie.dispose(),te.reject(new T.$5)});try{for await(const pe of Q){if(ie.token.isCancellationRequested)return;te.emitOne(pe)}me.dispose(),ie.dispose()}catch(pe){me.dispose(),ie.dispose(),te.reject(pe)}})}e.$uh=Me;class Ce{constructor(){this.a=new ee,this.b=new ne(te=>{if(ie){te.reject(ie);return}return Q&&te.emitMany(Q),this.d=me=>te.reject(me),this.f=me=>te.emitOne(me),this.a.p});let ie,Q;this.f=te=>{Q||(Q=[]),Q.push(te)},this.d=te=>{ie||(ie=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$vh=Ce}),define(Pe[34],Re([1,0,18,13,46,28,19,21,11]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=void 0;function b(){return Object.create(null)}e.$Gj=b,e.$Hj="**",e.$Ij="/";const A="[/\\\\]",k="[^/\\\\]",l=/\//g;function p(fe,we){switch(fe){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${we?`|${A}${k}+`:""})*?`}}function w(fe,we){if(!fe)return[];const ye=[];let he=!1,ve=!1,ee="";for(const De of fe){switch(De){case we:if(!he&&!ve){ye.push(ee),ee="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}ee+=De}return ee&&ye.push(ee),ye}e.$Jj=w;function r(fe){if(!fe)return"";let we="";const ye=w(fe,e.$Ij);if(ye.every(he=>he===e.$Hj))we=".*";else{let he=!1;ye.forEach((ve,ee)=>{if(ve===e.$Hj){if(he)return;we+=p(2,ee===ye.length-1)}else{let De=!1,se="",x=!1,V="";for(const ne of ve){if(ne!=="}"&&De){se+=ne;continue}if(x&&(ne!=="]"||!V)){let Ie;ne==="-"?Ie=ne:(ne==="^"||ne==="!")&&!V?Ie="^":ne===e.$Ij?Ie="":Ie=(0,g.$Ne)(ne),V+=Ie;continue}switch(ne){case"{":De=!0;continue;case"[":x=!0;continue;case"}":{const Me=`(?:${w(se,",").map(Ce=>r(Ce)).join("|")})`;we+=Me,De=!1,se="";break}case"]":{we+="["+V+"]",x=!1,V="";break}case"?":we+=k;continue;case"*":we+=p(1);continue;default:we+=(0,g.$Ne)(ne)}}ee<ye.length-1&&(ye[ee+1]!==e.$Hj||ee+2<ye.length)&&(we+=A)}he=ve===e.$Hj})}return we}const o=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Dc(1e4),s=function(){return!1},u=function(){return null};function d(fe,we){if(!fe)return u;let ye;typeof fe!="string"?ye=fe.pattern:ye=fe,ye=ye.trim();const he=`${ye}_${!!we.trimForExclusions}`;let ve=i.get(he);if(ve)return m(ve,fe);let ee;return o.test(ye)?ve=S(ye.substr(4),ye):(ee=t.exec(f(ye,we)))?ve=L(ee[1],ye):(we.trimForExclusions?a:n).test(ye)?ve=v(ye,we):(ee=c.exec(f(ye,we)))?ve=y(ee[1].substr(1),ye,!0):(ee=h.exec(f(ye,we)))?ve=y(ee[1],ye,!1):ve=D(ye),i.set(he,ve),m(ve,fe)}function m(fe,we){if(typeof we=="string")return fe;const ye=function(he,ve){return(0,I.$7f)(he,we.base,!$.$k)?fe((0,g.$Se)(he.substr(we.base.length),R.sep),ve):null};return ye.allBasenames=fe.allBasenames,ye.allPaths=fe.allPaths,ye.basenames=fe.basenames,ye.patterns=fe.patterns,ye}function f(fe,we){return we.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function S(fe,we){return function(ye,he){return typeof ye=="string"&&ye.endsWith(fe)?we:null}}function L(fe,we){const ye=`/${fe}`,he=`\\${fe}`,ve=function(De,se){return typeof De!="string"?null:se?se===fe?we:null:De===fe||De.endsWith(ye)||De.endsWith(he)?we:null},ee=[fe];return ve.basenames=ee,ve.patterns=[we],ve.allBasenames=ee,ve}function v(fe,we){const ye=J(fe.slice(1,-1).split(",").map(se=>d(se,we)).filter(se=>se!==u),fe),he=ye.length;if(!he)return u;if(he===1)return ye[0];const ve=function(se,x){for(let V=0,ne=ye.length;V<ne;V++)if(ye[V](se,x))return fe;return null},ee=ye.find(se=>!!se.allBasenames);ee&&(ve.allBasenames=ee.allBasenames);const De=ye.reduce((se,x)=>x.allPaths?se.concat(x.allPaths):se,[]);return De.length&&(ve.allPaths=De),ve}function y(fe,we,ye){const he=R.sep===R.$gc.sep,ve=he?fe:fe.replace(l,R.sep),ee=R.sep+ve,De=R.$gc.sep+fe;let se;return ye?se=function(x,V){return typeof x=="string"&&(x===ve||x.endsWith(ee)||!he&&(x===fe||x.endsWith(De)))?we:null}:se=function(x,V){return typeof x=="string"&&(x===ve||!he&&x===fe)?we:null},se.allPaths=[(ye?"*/":"./")+fe],se}function D(fe){try{const we=new RegExp(`^${r(fe)}$`);return function(ye){return we.lastIndex=0,typeof ye=="string"&&we.test(ye)?fe:null}}catch{return u}}function N(fe,we,ye){return!fe||typeof we!="string"?!1:O(fe)(we,void 0,ye)}e.$Kj=N;function O(fe,we={}){if(!fe)return s;if(typeof fe=="string"||H(fe)){const ye=d(fe,we);if(ye===u)return s;const he=function(ve,ee){return!!ye(ve,ee)};return ye.allBasenames&&(he.allBasenames=ye.allBasenames),ye.allPaths&&(he.allPaths=ye.allPaths),he}return P(fe,we)}e.$Lj=O;function H(fe){const we=fe;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}e.$Mj=H;function U(fe){return fe.allBasenames||[]}e.$Nj=U;function W(fe){return fe.allPaths||[]}e.$Oj=W;function P(fe,we){const ye=J(Object.getOwnPropertyNames(fe).map(se=>C(se,fe[se],we)).filter(se=>se!==u)),he=ye.length;if(!he)return u;if(!ye.some(se=>!!se.requiresSiblings)){if(he===1)return ye[0];const se=function(ne,Ie){let Me;for(let Ce=0,ce=ye.length;Ce<ce;Ce++){const ie=ye[Ce](ne,Ie);if(typeof ie=="string")return ie;(0,T.$Rg)(ie)&&(Me||(Me=[]),Me.push(ie))}return Me?(async()=>{for(const Ce of Me){const ce=await Ce;if(typeof ce=="string")return ce}return null})():null},x=ye.find(ne=>!!ne.allBasenames);x&&(se.allBasenames=x.allBasenames);const V=ye.reduce((ne,Ie)=>Ie.allPaths?ne.concat(Ie.allPaths):ne,[]);return V.length&&(se.allPaths=V),se}const ve=function(se,x,V){let ne,Ie;for(let Me=0,Ce=ye.length;Me<Ce;Me++){const ce=ye[Me];ce.requiresSiblings&&V&&(x||(x=(0,R.$nc)(se)),ne||(ne=x.substr(0,x.length-(0,R.$oc)(se).length)));const ie=ce(se,x,ne,V);if(typeof ie=="string")return ie;(0,T.$Rg)(ie)&&(Ie||(Ie=[]),Ie.push(ie))}return Ie?(async()=>{for(const Me of Ie){const Ce=await Me;if(typeof Ce=="string")return Ce}return null})():null},ee=ye.find(se=>!!se.allBasenames);ee&&(ve.allBasenames=ee.allBasenames);const De=ye.reduce((se,x)=>x.allPaths?se.concat(x.allPaths):se,[]);return De.length&&(ve.allPaths=De),ve}function C(fe,we,ye){if(we===!1)return u;const he=d(fe,ye);if(he===u)return u;if(typeof we=="boolean")return he;if(we){const ve=we.when;if(typeof ve=="string"){const ee=(De,se,x,V)=>{if(!V||!he(De,se))return null;const ne=ve.replace("$(basename)",()=>x),Ie=V(ne);return(0,T.$Rg)(Ie)?Ie.then(Me=>Me?fe:null):Ie?fe:null};return ee.requiresSiblings=!0,ee}}return he}function J(fe,we){const ye=fe.filter(se=>!!se.basenames);if(ye.length<2)return fe;const he=ye.reduce((se,x)=>{const V=x.basenames;return V?se.concat(V):se},[]);let ve;if(we){ve=[];for(let se=0,x=he.length;se<x;se++)ve.push(we)}else ve=ye.reduce((se,x)=>{const V=x.patterns;return V?se.concat(V):se},[]);const ee=function(se,x){if(typeof se!="string")return null;if(!x){let ne;for(ne=se.length;ne>0;ne--){const Ie=se.charCodeAt(ne-1);if(Ie===47||Ie===92)break}x=se.substr(ne)}const V=he.indexOf(x);return V!==-1?ve[V]:null};ee.basenames=he,ee.patterns=ve,ee.allBasenames=he;const De=fe.filter(se=>!se.basenames);return De.push(ee),De}function ae(fe,we){return(0,E.$ub)(fe,we,(ye,he)=>typeof ye=="string"&&typeof he=="string"?ye===he:typeof ye!="string"&&typeof he!="string"?ye.base===he.base&&ye.pattern===he.pattern:!1)}e.$Pj=ae}),define(Pe[52],Re([1,0,15,126,25,11,2]),function(ge,e,E,T,I,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class g{constructor(n="",a=!1){if(this.value=n,typeof this.value!="string")throw(0,E.$7)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(n,a=0){return this.value+=l(this.supportThemeIcons?(0,T.$ak)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,a){return this.value+=`
${p(a,n)}
`,this}appendLink(n,a,c){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,a){const c=new RegExp((0,M.$Ne)(a),"g");return n.replace(c,(h,i)=>n.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$gk=g;function b(t){return A(t)?!t.value:Array.isArray(t)?t.every(b):!0}e.$hk=b;function A(t){return t instanceof g?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$ik=A;function k(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,I.$zg)(R.URI.from(t.baseUri),R.URI.from(n.baseUri)))}e.$jk=k;function l(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$kk=l;function p(t,n){const a=t.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=a>=3?a+1:3;return[`${"`".repeat(c)}${n}`,t,`${"`".repeat(c)}`].join(`
`)}e.$lk=p;function w(t){return t.replace(/"/g,"&quot;")}e.$mk=w;function r(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$nk=r;function o(t){const n=[],a=t.split("|").map(h=>h.trim());t=a[0];const c=a[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),s=h?h[1]:"",u=i?i[1]:"",d=isFinite(parseInt(u)),m=isFinite(parseInt(s));d&&n.push(`width="${u}"`),m&&n.push(`height="${s}"`)}return{href:t,dimensions:n}}e.$ok=o}),define(Pe[95],Re([1,0,18,46,19,21,25,11]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=void 0;function g(d,m){const{os:f,tildify:S,relative:L}=m;if(L){const D=b(d,L,f);if(typeof D=="string")return D}let v=d.fsPath;if(f===1&&!M.$i?v=v.replace(/\//g,"\\"):f!==1&&M.$i&&(v=v.replace(/\\/g,"/")),f!==1&&S?.userHome){const D=S.userHome.fsPath;let N;d.scheme!==S.userHome.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep?N=S.userHome.with({path:d.path}).fsPath:N=v,v=l(N,D,f)}return(f===1?I.$fc:I.$gc).normalize(A(v,f===1))}e.$Uv=g;function b(d,m,f){const S=f===1?I.$fc:I.$gc,L=f===3?R.$wg:R.$yg,v=m.getWorkspace(),y=(0,E.$Ob)(v.folders);if(!y)return;d.scheme!==y.uri.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep&&(d=y.uri.with({path:d.path}));const D=m.getWorkspaceFolder(d);if(!D)return;let N;if(L.isEqual(D.uri,d)?N="":N=L.relativePath(D.uri,d)??"",N&&(N=S.normalize(N)),v.folders.length>1&&!m.noPrefix){const O=D.name?D.name:L.basenameOrAuthority(D.uri);N=N?`${O} \u2022 ${N}`:O}return N}function A(d,m=M.$i){return(0,T.$$f)(d,m)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Vv=A;let k=Object.create(null);function l(d,m,f=M.OS){if(f===1||!d||!m)return d;let S=k.original===m?k.normalized:void 0;S||(S=m,M.$i&&(S=(0,T.$1f)(S)),S=`${(0,$.$Te)(S,I.$gc.sep)}${I.$gc.sep}`,k={original:m,normalized:S});let L=d;return M.$i&&(L=(0,T.$1f)(L)),(f===3?L.startsWith(S):(0,$.$_e)(L,S))?`~/${L.substr(S.length)}`:d}e.$Wv=l;function p(d,m){return d.replace(/^~($|\/|\\)/,`${m}$1`)}e.$Xv=p;const w="\u2026",r="\\\\",o="~";function t(d,m=I.sep){const f=new Array(d.length);let S=!1;for(let L=0;L<d.length;L++){const v=d[L];if(v===""){f[L]=`.${m}`;continue}if(!v){f[L]=v;continue}S=!0;let y="",D=v;D.indexOf(r)===0?(y=D.substr(0,D.indexOf(r)+r.length),D=D.substr(D.indexOf(r)+r.length)):D.indexOf(m)===0?(y=D.substr(0,D.indexOf(m)+m.length),D=D.substr(D.indexOf(m)+m.length)):D.indexOf(o)===0&&(y=D.substr(0,D.indexOf(o)+o.length),D=D.substr(D.indexOf(o)+o.length));const N=D.split(m);for(let O=1;S&&O<=N.length;O++)for(let H=N.length-O;S&&H>=0;H--){S=!1;let U=N.slice(H,H+O).join(m);for(let W=0;!S&&W<d.length;W++)if(W!==L&&d[W]&&d[W].indexOf(U)>-1){const P=H+O===N.length,C=H>0&&d[W].indexOf(m)>-1?m+U:U,J=d[W].endsWith(C);S=!P||J}if(!S){let W="";(N[0].endsWith(":")||y!=="")&&(H===1&&(H=0,O++,U=N[0]+m+U),H>0&&(W=N[0]+m),W=y+W),H>0&&(W=W+w+m),W=W+U,H+O<N.length&&(W=W+m+w),f[L]=W}}S&&(f[L]=v)}return f}e.$Yv=t;var n;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function a(d,m=Object.create(null)){const f=[];let S=!1,L="";for(const v of d)if(v==="$"||S&&v==="{")L&&f.push({value:L,type:n.TEXT}),L="",S=!0;else if(v==="}"&&S){const y=m[L];if(typeof y=="string")y.length&&f.push({value:y,type:n.VARIABLE});else if(y){const D=f[f.length-1];(!D||D.type!==n.SEPARATOR)&&f.push({value:y.label,type:n.SEPARATOR})}L="",S=!1}else L+=v;return L&&!S&&f.push({value:L,type:n.TEXT}),f.filter((v,y)=>{if(v.type===n.SEPARATOR){const D=f[y-1],N=f[y+1];return[D,N].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(v=>v.value).join("")}e.$Zv=a;function c(d,m){return M.$j||m?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):d.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$1v=c;function h(d,m){return M.$j||m?d.replace(/\(&&\w\)|&&/g,""):M.$i?d.replace(/&&|&/g,f=>f==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$2v=h;function i(d){return d.replace(/&/g,"&&")}e.$3v=i;function s(d){if(d.endsWith("]")){const m=d.lastIndexOf(" [",d.length-2);if(m!==-1){const f=u(d.substring(0,m)),S=d.substring(m);return{name:f.name+S,parentPath:f.parentPath}}}return u(d)}e.$4v=s;function u(d){const m=d.indexOf("/")!==-1?I.$gc:I.$fc,f=m.basename(d),S=m.dirname(d);return f.length?{name:f,parentPath:S}:{name:S,parentPath:""}}}),define(Pe[139],Re([1,0,24,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=void 0;function I(k){return k.toJSON()}class M{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:I(T.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:I(T.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:T.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$3m=M,e.$4m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,l,p){if(!k||p>200)return null;if(typeof k=="object"){if(k instanceof T.URI)return l.transformOutgoing(k);for(const w in k)if(Object.hasOwnProperty.call(k,w)){const r=R(k[w],l,p+1);r!==null&&(k[w]=r)}}return null}function $(k,l){const p=R(k,l,0);return p===null?k:p}e.$5m=$;function g(k,l,p,w){if(!k||w>200)return null;if(typeof k=="object"){if(k.$mid===1)return p?T.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof E.$ie)return null;for(const r in k)if(Object.hasOwnProperty.call(k,r)){const o=g(k[r],l,p,w+1);o!==null&&(k[r]=o)}}return null}function b(k,l){const p=g(k,l,!1,0);return p===null?k:p}e.$6m=b;function A(k,l){const p=g(k,l,!0,0);return p===null?k:p}e.$7m=A}),define(Pe[140],Re([1,0,11,21,24]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=e.$at=e.$_s=void 0;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function g(){return $||($=new TextDecoder("UTF-16BE")),$}let b;function A(){return b||(b=T.$D()?R():g()),b}e.$_s=A;function k(w,r,o){const t=new Uint16Array(w.buffer,r,o);return o>0&&(t[0]===65279||t[0]===65534)?l(w,r,o):R().decode(t)}e.$at=k;function l(w,r,o){const t=[];let n=0;for(let a=0;a<o;a++){const c=I.$ke(w,r);r+=2,t[n++]=String.fromCharCode(c)}return t.join("")}class p{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return A().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||E.$cf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let t=0;t<o;t++)this.b[this.d++]=r.charCodeAt(t)}}e.$bt=p}),define(Pe[141],Re([1,0,24,140]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=void 0;function I(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(b,A,k,l){this.oldPosition=b,this.oldText=A,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(b){return 4+2*b.length}static c(b,A,k){const l=A.length;E.$ne(b,l,k),k+=4;for(let p=0;p<l;p++)E.$le(b,A.charCodeAt(p),k),k+=2;return k}static d(b,A){const k=E.$me(b,A);return A+=4,(0,T.$at)(b,A,k)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(b,A){return E.$ne(b,this.oldPosition,A),A+=4,E.$ne(b,this.newPosition,A),A+=4,A=M.c(b,this.oldText,A),A=M.c(b,this.newText,A),A}static read(b,A,k){const l=E.$me(b,A);A+=4;const p=E.$me(b,A);A+=4;const w=M.d(b,A);A+=M.a(w);const r=M.d(b,A);return A+=M.a(r),k.push(new M(l,w,p,r)),A}}e.$ct=M;function R(g,b){return g===null||g.length===0?b:new $(g,b).compress()}e.$dt=R;class ${constructor(b,A){this.a=b,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let b=0,A=0,k=this.n(b),l=this.l(A);for(;b<this.f||A<this.h;){if(k===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(k),k=this.n(++b);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++A);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++b);continue}if(l.oldPosition<k.newPosition){const[t,n]=$.r(l,k.newPosition-l.oldPosition);this.k(t),l=n;continue}if(k.newPosition<l.oldPosition){const[t,n]=$.q(k,l.oldPosition-k.newPosition);this.m(t),k=n;continue}let r,o;if(l.oldEnd===k.newEnd)r=k,o=l,k=this.n(++b),l=this.l(++A);else if(l.oldEnd<k.newEnd){const[t,n]=$.q(k,l.oldLength);r=t,o=l,k=n,l=this.l(++A)}else{const[t,n]=$.r(l,k.newLength);r=k,o=t,k=this.n(++b),l=n}this.d[this.e++]=new M(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const p=$.s(this.d);return $.t(p)}k(b){this.d[this.e++]=$.o(this.g,b),this.j+=b.newLength-b.oldLength}l(b){return b<this.h?this.c[b]:null}m(b){this.d[this.e++]=$.p(this.j,b),this.g+=b.newLength-b.oldLength}n(b){return b<this.f?this.a[b]:null}static o(b,A){return new M(A.oldPosition-b,A.oldText,A.newPosition,A.newText)}static p(b,A){return new M(A.oldPosition,A.oldText,A.newPosition+b,A.newText)}static q(b,A){const k=b.newText.substr(0,A),l=b.newText.substr(A);return[new M(b.oldPosition,b.oldText,b.newPosition,k),new M(b.oldEnd,"",b.newPosition+A,l)]}static r(b,A){const k=b.oldText.substr(0,A),l=b.oldText.substr(A);return[new M(b.oldPosition,k,b.newPosition,b.newText),new M(b.oldPosition+A,l,b.newEnd,"")]}static s(b){if(b.length===0)return b;const A=[];let k=0,l=b[0];for(let p=1;p<b.length;p++){const w=b[p];l.oldEnd===w.oldPosition?l=new M(l.oldPosition,l.oldText+w.oldText,l.newPosition,l.newText+w.newText):(A[k++]=l,l=w)}return A[k++]=l,A}static t(b){if(b.length===0)return b;const A=[];let k=0;for(let l=0;l<b.length;l++){const p=b[l];p.oldText!==p.newText&&(A[k++]=p)}return A}}}),define(Pe[142],Re([1,0,34,19]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=void 0;function I(M,R,$,g,b,A){if(Array.isArray(M)){let k=0;for(const l of M){const p=I(l,R,$,g,b,A);if(p===10)return p;p>k&&(k=p)}return k}else{if(typeof M=="string")return g?M==="*"?5:M===$?10:0:0;if(M){const{language:k,pattern:l,scheme:p,hasAccessToAllModels:w,notebookType:r}=M;if(!g&&!w)return 0;r&&b&&(R=b);let o=0;if(p)if(p===R.scheme)o=10;else if(p==="*")o=5;else return 0;if(k)if(k===$)o=10;else if(k==="*")o=Math.max(o,5);else return 0;if(r)if(r===A)o=10;else if(r==="*"&&A!==void 0)o=Math.max(o,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,T.$hc)(l.base)},t===R.fsPath||(0,E.$Kj)(t,R.fsPath))o=10;else return 0}return o}else return 0}}e.$At=I}),define(Pe[143],Re([1,0,5,11,29,93,91,128,141,6]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=void 0;class A extends b.$Tc{constructor(l,p,w,r,o,t,n){super(),this.m=this.B(new E.$Ud),this.onDidChangeContent=this.m.event,this.f=p,this.j=!t,this.g=r,this.h=o,this.c=new R.$_B(l,w,n)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const w=l+p,r=this.getPositionAt(l),o=this.getPositionAt(w);return new I.$Ts(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const w=this.n(p);return this.c.getValueInRange(l,w)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const w=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const t=this.n(p),n=this.getEOL();if(t.length!==n.length){const a=t.length-n.length,c=l.endLineNumber-l.startLineNumber;o=a*c}return r-w+o}getCharacterCountInRange(l,p=0){if(this.j){let w=0;const r=l.startLineNumber,o=l.endLineNumber;for(let t=r;t<=o;t++){const n=this.getLineContent(t),a=t===r?l.startColumn-1:0,c=t===o?l.endColumn-1:n.length;for(let h=a;h<c;h++)T.$cf(n.charCodeAt(h))?(w=w+1,h=h+1):w=w+1}return w+=this.n(p).length*(o-r),w}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=T.$Ze(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=T.$2e(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,w){let r=this.g,o=this.h,t=this.j,n=!0,a=[];for(let m=0;m<l.length;m++){const f=l[m];n&&f._isTracked&&(n=!1);const S=f.range;if(f.text){let N=!0;t||(N=!T.$nf(f.text),t=N),!r&&N&&(r=T.$mf(f.text)),!o&&N&&(o=T.$pf(f.text))}let L="",v=0,y=0,D=0;if(f.text){let N;[v,y,D,N]=(0,$.$tt)(f.text);const O=this.getEOL();N===0||N===(O===`\r
`?2:1)?L=f.text:L=f.text.replace(/\r\n|\r|\n/g,O)}a[m]={sortIndex:m,identifier:f.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:L,eolCount:v,firstLineLength:y,lastLineLength:D,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}a.sort(A.u);let c=!1;for(let m=0,f=a.length-1;m<f;m++){const S=a[m].range.getEndPosition(),L=a[m+1].range.getStartPosition();if(L.isBeforeOrEqual(S)){if(L.isBefore(S))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(a=this.s(a));const h=w||p?A._getInverseEditRanges(a):[],i=[];if(p)for(let m=0;m<a.length;m++){const f=a[m],S=h[m];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let L=S.startLineNumber;L<=S.endLineNumber;L++){let v="";L===S.startLineNumber&&(v=this.getLineContent(f.range.startLineNumber),T.$Ze(v)!==-1)||i.push({lineNumber:L,oldContent:v})}}let s=null;if(w){let m=0;s=[];for(let f=0;f<a.length;f++){const S=a[f],L=h[f],v=this.getValueInRange(S.range),y=S.rangeOffset+m;m+=S.text.length-v.length,s[f]={sortIndex:S.sortIndex,identifier:S.identifier,range:L,text:v,textChange:new g.$ct(S.rangeOffset,v,y,S.text)}}c||s.sort((f,S)=>f.sortIndex-S.sortIndex)}this.g=r,this.h=o,this.j=t;const u=this.t(a);let d=null;if(p&&i.length>0){i.sort((m,f)=>f.lineNumber-m.lineNumber),d=[];for(let m=0,f=i.length;m<f;m++){const S=i[m].lineNumber;if(m>0&&i[m-1].lineNumber===S)continue;const L=i[m].oldContent,v=this.getLineContent(S);v.length===0||v===L||T.$Ze(v)!==-1||d.push(S)}}return this.m.fire(),new M.$dv(s,u,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const w=l[0].range,r=l[l.length-1].range,o=new I.$Ts(w.startLineNumber,w.startColumn,r.endLineNumber,r.endColumn);let t=w.startLineNumber,n=w.startColumn;const a=[];for(let u=0,d=l.length;u<d;u++){const m=l[u],f=m.range;p=p||m.forceMoveMarkers,a.push(this.getValueInRange(new I.$Ts(t,n,f.startLineNumber,f.startColumn))),m.text.length>0&&a.push(m.text),t=f.endLineNumber,n=f.endColumn}const c=a.join(""),[h,i,s]=(0,$.$tt)(c);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:s,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const p=[];for(let w=0;w<l.length;w++){const r=l[w],o=r.range.startLineNumber,t=r.range.startColumn,n=r.range.endLineNumber,a=r.range.endColumn;if(o===n&&t===a&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new I.$Ts(o,t,n,a);p.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,w,r){return this.c.findMatchesLineByLine(l,p,w,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const w=l.startLineNumber,r=l.startColumn,[o,t,n]=(0,$.$tt)(p);let a;if(p.length>0){const c=o+1;c===1?a=new I.$Ts(w,r,w,r+t):a=new I.$Ts(w,r,w+c-1,n+1)}else a=new I.$Ts(w,r,w,r);return a}static _getInverseEditRanges(l){const p=[];let w=0,r=0,o=null;for(let t=0,n=l.length;t<n;t++){const a=l[t];let c,h;o?o.range.endLineNumber===a.range.startLineNumber?(c=w,h=r+(a.range.startColumn-o.range.endColumn)):(c=w+(a.range.startLineNumber-o.range.endLineNumber),h=a.range.startColumn):(c=a.range.startLineNumber,h=a.range.startColumn);let i;if(a.text.length>0){const s=a.eolCount+1;s===1?i=new I.$Ts(c,h,c,h+a.firstLineLength):i=new I.$Ts(c,h,c+s-1,a.lastLineLength+1)}else i=new I.$Ts(c,h,c,h);w=i.endLineNumber,r=i.endColumn,p.push(i),o=a}return p}static u(l,p){const w=I.$Ts.compareRangesUsingEnds(l.range,p.range);return w===0?l.sortIndex-p.sortIndex:w}static w(l,p){const w=I.$Ts.compareRangesUsingEnds(l.range,p.range);return w===0?p.sortIndex-l.sortIndex:-w}}e.$aC=A}),define(Pe[144],Re([1,0,11,91,143]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class M{constructor(g,b,A,k,l,p,w,r,o){this.a=g,this.b=b,this.c=A,this.d=k,this.e=l,this.f=p,this.g=w,this.h=r,this.j=o}k(g){const b=this.c+this.d+this.e,A=this.c+this.e;return b===0?g===1?`
`:`\r
`:A>b/2?`\r
`:`
`}create(g){const b=this.k(g),A=this.a;if(this.j&&(b===`\r
`&&(this.c>0||this.d>0)||b===`
`&&(this.c>0||this.e>0)))for(let l=0,p=A.length;l<p;l++){const w=A[l].buffer.replace(/\r\n|\r|\n/g,b),r=(0,T.$8B)(w);A[l]=new T.$$B(w,r)}const k=new I.$aC(A,this.b,b,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&E.$vf(g)&&(this.b=E.$uf,g=g.substr(1));const b=g.charCodeAt(g.length-1);b===13||b>=55296&&b<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=b):(this.m(g,!1),this.c=!1,this.d=b)}m(g,b){!b&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const b=(0,T.$9B)(this.e,g);this.a.push(new T.$$B(g,b.lineStarts)),this.f+=b.cr,this.g+=b.lf,this.h+=b.crlf,b.isBasicASCII||(this.l=!1,this.j||(this.j=E.$mf(g)),this.k||(this.k=E.$pf(g)))}finish(g=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const b=(0,T.$8B)(g.buffer);g.lineStarts=b,this.d===13&&this.f++}}}e.$bC=R}),define(Pe[96],Re([1,0,24,21]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p$=e.$o$=void 0;var I;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(I||(I={}));function M(k){for(let l=0,p=k.length;l<p;l+=4){const w=k[l+0],r=k[l+1],o=k[l+2],t=k[l+3];k[l+0]=t,k[l+1]=o,k[l+2]=r,k[l+3]=w}}function R(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return T.$D()||M(l),E.$ie.wrap(l)}function $(k){const l=k.buffer;if(T.$D()||M(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function g(k){const l=new Uint32Array(b(k));let p=0;if(l[p++]=k.id,k.type==="full")l[p++]=1,l[p++]=k.data.length,l.set(k.data,p),p+=k.data.length;else{l[p++]=2,l[p++]=k.deltas.length;for(const w of k.deltas)l[p++]=w.start,l[p++]=w.deleteCount,w.data?(l[p++]=w.data.length,l.set(w.data,p),p+=w.data.length):l[p++]=0}return R(l)}e.$o$=g;function b(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const p of k.deltas)p.data&&(l+=p.data.length)}return l}function A(k){const l=$(k);let p=0;const w=l[p++];if(l[p++]===1){const n=l[p++],a=l.subarray(p,p+n);return p+=n,{id:w,type:"full",data:a}}const o=l[p++],t=[];for(let n=0;n<o;n++){const a=l[p++],c=l[p++],h=l[p++];let i;h>0&&(i=l.subarray(p,p+h),p+=h),t[n]={start:a,deleteCount:c,data:i}}return{id:w,type:"delta",deltas:t}}e.$p$=A}),define(Pe[145],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Re([1,0,18,26,21,129,147,145]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=b;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(_,$e,Be,Qe){this.id=_,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,$e){return p(_,$e)}compute(_,$e,Be){return Be}}class l{constructor(_,$e){this.newValue=_,this.didChange=$e}}e.ApplyUpdateResult=l;function p(Z,_){if(typeof Z!="object"||typeof _!="object"||!Z||!_)return new l(_,Z!==_);if(Array.isArray(Z)||Array.isArray(_)){const Be=Array.isArray(Z)&&Array.isArray(_)&&E.$ub(Z,_);return new l(_,!Be)}let $e=!1;for(const Be in _)if(_.hasOwnProperty(Be)){const Qe=p(Z[Be],_[Be]);Qe.didChange&&(Z[Be]=Qe.newValue,$e=!0)}return new l(Z,$e)}class w{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,$e){return p(_,$e)}validate(_){return this.defaultValue}}class r{constructor(_,$e,Be,Qe){this.id=_,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,$e){return p(_,$e)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,$e,Be){return Be}}function o(Z,_){return typeof Z>"u"?_:Z==="false"?!1:!!Z}e.boolean=o;class t extends r{constructor(_,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(_,$e,Be,Qe)}validate(_){return o(_,this.defaultValue)}}function n(Z,_,$e,Be){if(typeof Z>"u")return _;let Qe=parseInt(Z,10);return isNaN(Qe)?_:(Qe=Math.max($e,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=n;class a extends r{static clampedInt(_,$e,Be,Qe){return n(_,$e,Be,Qe)}constructor(_,$e,Be,Qe,it,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Qe,rt.maximum=it),super(_,$e,Be,rt),this.minimum=Qe,this.maximum=it}validate(_){return a.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function c(Z,_,$e,Be){if(typeof Z>"u")return _;const Qe=h.float(Z,_);return h.clamp(Qe,$e,Be)}e.clampedFloat=c;class h extends r{static clamp(_,$e,Be){return _<$e?$e:_>Be?Be:_}static float(_,$e){if(typeof _=="number")return _;if(typeof _>"u")return $e;const Be=parseFloat(_);return isNaN(Be)?$e:Be}constructor(_,$e,Be,Qe,it){typeof it<"u"&&(it.type="number",it.default=Be),super(_,$e,Be,it),this.validationFn=Qe}validate(_){return this.validationFn(h.float(_,this.defaultValue))}}class i extends r{static string(_,$e){return typeof _!="string"?$e:_}constructor(_,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(_,$e,Be,Qe)}validate(_){return i.string(_,this.defaultValue)}}function s(Z,_,$e,Be){return typeof Z!="string"?_:Be&&Z in Be?Be[Z]:$e.indexOf(Z)===-1?_:Z}e.stringSet=s;class u extends r{constructor(_,$e,Be,Qe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=Be),super(_,$e,Be,it),this.c=Qe}validate(_){return s(_,this.defaultValue,this.c)}}class d extends k{constructor(_,$e,Be,Qe,it,rt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=it,Ne.default=Qe),super(_,$e,Be,Ne),this.c=it,this.d=rt}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function m(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,$e,Be){return Be===0?_.accessibilitySupport:Be}}class S extends k{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:$.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{insertSpace:o($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function v(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function D(Z){switch(Z){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function N(Z){switch(Z){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class O extends w{constructor(){super(140)}compute(_,$e,Be){const Qe=["monaco-editor"];return $e.get(39)&&Qe.push($e.get(39)),_.extraEditorClassName&&Qe.push(_.extraEditorClassName),$e.get(73)==="default"?Qe.push("mouse-default"):$e.get(73)==="copy"&&Qe.push("mouse-copy"),$e.get(110)&&Qe.push("showUnused"),$e.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class H extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(_,$e,Be){return Be&&_.emptySelectionClipboard}}class U extends k{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:$.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:$.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{cursorMoveOnType:o($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":s($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":s($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o($e.loop,this.defaultValue.loop)}}}class W extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?W.OFF:_==="true"?W.ON:_:_?W.ON:W.OFF}}e.EditorFontLigatures=W;class P extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",P.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?P.OFF:_==="true"?P.TRANSLATE:_:_?P.TRANSLATE:P.OFF}compute(_,$e,Be){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=P;class C extends w{constructor(){super(50)}compute(_,$e,Be){return _.fontInfo}}class J extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(_){const $e=h.float(_,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp($e,6,100)}compute(_,$e,Be){return _.fontInfo.fontSize}}class ae extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ae.d,maximum:ae.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ae.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(a.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,ae.d,ae.e))}}class fe extends k{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{multiple:s($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??s($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??s($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??s($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??s($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??s($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class we extends k{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:$.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),delay:a.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:o($e.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o($e.above,this.defaultValue.above)}}}var ye;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(ye||(e.RenderMinimap=ye={}));class he extends w{constructor(){super(143)}compute(_,$e,Be){return he.computeLayout($e,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const $e=_.height/_.lineHeight,Be=Math.floor(_.paddingTop/_.lineHeight);let Qe=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Qe=Math.max(Qe,$e-1));const it=(Be+_.viewLineCount+Qe)/(_.pixelRatio*_.height),rt=Math.floor(_.viewLineCount/it);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:it,minimapLineCount:rt}}static c(_,$e){const Be=_.outerWidth,Qe=_.outerHeight,it=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const rt=$e.stableMinimapLayoutInput,Ne=rt&&_.outerHeight===rt.outerHeight&&_.lineHeight===rt.lineHeight&&_.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&_.pixelRatio===rt.pixelRatio&&_.scrollBeyondLastLine===rt.scrollBeyondLastLine&&_.paddingTop===rt.paddingTop&&_.paddingBottom===rt.paddingBottom&&_.minimap.enabled===rt.minimap.enabled&&_.minimap.side===rt.minimap.side&&_.minimap.size===rt.minimap.size&&_.minimap.showSlider===rt.minimap.showSlider&&_.minimap.renderCharacters===rt.minimap.renderCharacters&&_.minimap.maxColumn===rt.minimap.maxColumn&&_.minimap.scale===rt.minimap.scale&&_.verticalScrollbarWidth===rt.verticalScrollbarWidth&&_.isViewportWrapping===rt.isViewportWrapping,Pt=_.lineHeight,Tt=_.typicalHalfwidthCharacterWidth,Kt=_.scrollBeyondLastLine,Bt=_.minimap.renderCharacters;let yt=it>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Ht=_.minimap.maxColumn,Nt=_.minimap.size,Xt=_.minimap.side,Ut=_.verticalScrollbarWidth,Rt=_.viewLineCount,Ye=_.remainingWidth,Gt=_.isViewportWrapping,Jt=Bt?2:3;let lt=Math.floor(it*Qe);const $t=lt/it;let jt=!1,Wt=!1,Dt=Jt*yt,dt=yt/it,Ct=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Se,desiredRatio:Fe,minimapLineCount:de}=he.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Kt,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Qe,lineHeight:Pt,pixelRatio:it});if(Rt/de>1)jt=!0,Wt=!0,yt=1,Dt=1,dt=yt/it;else{let Le=!1,ze=yt+1;if(Nt==="fit"){const Xe=Math.ceil((Ft+Rt+Se)*Dt);Gt&&Ne&&Ye<=$e.stableFitRemainingWidth?(Le=!0,ze=$e.stableFitMaxMinimapScale):Le=Xe>lt}if(Nt==="fill"||Le){jt=!0;const Xe=yt;Dt=Math.min(Pt*it,Math.max(1,Math.floor(1/Fe))),Gt&&Ne&&Ye<=$e.stableFitRemainingWidth&&(ze=$e.stableFitMaxMinimapScale),yt=Math.min(ze,Math.max(1,Math.floor(Dt/Jt))),yt>Xe&&(Ct=Math.min(2,yt/Xe)),dt=yt/it/Ct,lt=Math.ceil(Math.max(ft,Ft+Rt+Se)*Dt),Gt?($e.stableMinimapLayoutInput=_,$e.stableFitRemainingWidth=Ye,$e.stableFitMaxMinimapScale=yt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const xt=Math.floor(Ht*dt),kt=Math.min(xt,Math.max(0,Math.floor((Ye-Ut-2)*dt/(Tt+dt)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(it*kt);const Mt=qe/it;qe=Math.floor(qe*Ct);const Vt=Bt?1:2,Qt=Xt==="left"?0:Be-kt-Ut;return{renderMinimap:Vt,minimapLeft:Qt,minimapWidth:kt,minimapHeightIsEditorHeight:jt,minimapIsSampling:Wt,minimapScale:yt,minimapLineHeight:Dt,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:$t}}static computeLayout(_,$e){const Be=$e.outerWidth|0,Qe=$e.outerHeight|0,it=$e.lineHeight|0,rt=$e.lineNumbersDigitCount|0,Ne=$e.typicalHalfwidthCharacterWidth,Pt=$e.maxDigitWidth,Tt=$e.pixelRatio,Kt=$e.viewLineCount,Bt=_.get(135),yt=Bt==="inherit"?_.get(134):Bt,Ht=yt==="inherit"?_.get(130):yt,Nt=_.get(133),Xt=$e.isDominatedByLongLines,Ut=_.get(57),Rt=_.get(67).renderType!==0,Ye=_.get(68),Gt=_.get(104),Jt=_.get(83),lt=_.get(72),$t=_.get(102),jt=$t.verticalScrollbarSize,Wt=$t.verticalHasArrows,Dt=$t.arrowSize,dt=$t.horizontalScrollbarSize,Ct=_.get(43),xt=_.get(109)!=="never";let kt=_.get(65);Ct&&xt&&(kt+=16);let qe=0;if(Rt){const _e=Math.max(rt,Ye);qe=Math.round(_e*Pt)}let Mt=0;Ut&&(Mt=it*$e.glyphMarginDecorationLaneCount);let Vt=0,Qt=Vt+Mt,ft=Qt+qe,Ft=ft+kt;const Se=Be-Mt-qe-kt;let Fe=!1,de=!1,G=-1;yt==="inherit"&&Xt?(Fe=!0,de=!0):Ht==="on"||Ht==="bounded"?de=!0:Ht==="wordWrapColumn"&&(G=Nt);const Le=he.c({outerWidth:Be,outerHeight:Qe,lineHeight:it,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Tt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:lt,verticalScrollbarWidth:jt,viewLineCount:Kt,remainingWidth:Se,isViewportWrapping:de},$e.memory||new A);Le.renderMinimap!==0&&Le.minimapLeft===0&&(Vt+=Le.minimapWidth,Qt+=Le.minimapWidth,ft+=Le.minimapWidth,Ft+=Le.minimapWidth);const ze=Se-Le.minimapWidth,Xe=Math.max(1,Math.floor((ze-jt-2)/Ne)),Ve=Wt?Dt:0;return de&&(G=Math.max(1,Xe),Ht==="bounded"&&(G=Math.min(G,Nt))),{width:Be,height:Qe,glyphMarginLeft:Vt,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:kt,contentLeft:Ft,contentWidth:ze,minimap:Le,viewportColumn:Xe,isWordWrapMinified:Fe,isViewportWrapping:de,wrappingColumn:G,verticalScrollbarWidth:jt,horizontalScrollbarHeight:dt,overviewRuler:{top:Ve,width:jt,height:Qe-2*Ve,right:0}}}}e.EditorLayoutInfoComputer=he;class ve extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(_){return s(_,"simple",["simple","advanced"])}compute(_,$e,Be){return $e.get(2)===2?"advanced":Be}}var ee;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(ee||(e.ShowLightbulbIconMode=ee={}));class De extends k{constructor(){const _={enabled:ee.On};super(64,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",enum:[ee.Off,ee.OnCode,ee.On],default:_.enabled,enumDescriptions:[$.localize(50,null),$.localize(51,null),$.localize(52,null)],description:$.localize(53,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:s(_.enabled,this.defaultValue.enabled,[ee.Off,ee.OnCode,ee.On])}}}class se extends k{constructor(){const _={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:$.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:$.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:$.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:$.localize(57,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class x extends k{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:$.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(59,null),$.localize(60,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:$.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:$.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:$.localize(65,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:s($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),padding:o($e.padding,this.defaultValue.padding)}}}class V extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):a.clampedInt(_,this.defaultValue,0,1e3)}compute(_,$e,Be){return Be<0?a.clampedInt(-Be*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ne extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>h.clamp(_,0,150),{markdownDescription:$.localize(66,null)})}compute(_,$e,Be){return _.fontInfo.lineHeight}}class Ie extends k{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:$.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:$.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(69,null),$.localize(70,null),$.localize(71,null)],default:_.size,description:$.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:$.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:$.localize(74,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:$.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:$.localize(77,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),autohide:o($e.autohide,this.defaultValue.autohide),size:s($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:s($e.side,this.defaultValue.side,["right","left"]),showSlider:s($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o($e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt($e.scale,1,1,3),maxColumn:a.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Me(Z){return Z==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(79,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{top:a.clampedInt($e.top,0,0,1e3),bottom:a.clampedInt($e.bottom,0,0,1e3)}}}class ce extends k{constructor(){const _={enabled:!0,cycle:!0};super(85,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:$.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:$.localize(81,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),cycle:o($e.cycle,this.defaultValue.cycle)}}}class ie extends w{constructor(){super(141)}compute(_,$e,Be){return _.pixelRatio}}class Q extends k{constructor(){const _={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(82,null),$.localize(83,null),$.localize(84,null)]}];super(88,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:_.strings,description:$.localize(85,null)},comments:{anyOf:$e,default:_.comments,description:$.localize(86,null)},other:{anyOf:$e,default:_.other,description:$.localize(87,null)}},default:_,markdownDescription:$.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Tt=_?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!_||typeof _!="object")return this.defaultValue;const{other:$e,comments:Be,strings:Qe}=_,it=["on","inline","off"];let rt,Ne,Pt;return typeof $e=="boolean"?rt=$e?"on":"off":rt=s($e,this.defaultValue.other,it),typeof Be=="boolean"?Ne=Be?"on":"off":Ne=s(Be,this.defaultValue.comments,it),typeof Qe=="boolean"?Pt=Qe?"on":"off":Pt=s(Qe,this.defaultValue.strings,it),{other:rt,comments:Ne,strings:Pt}}}var te;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class me extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(89,null),$.localize(90,null),$.localize(91,null),$.localize(92,null)],default:"on",description:$.localize(93,null)})}validate(_){let $e=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?($e=4,Be=_):_==="interval"?$e=3:_==="relative"?$e=2:_==="on"?$e=1:$e=0),{renderType:$e,renderFn:Be}}}function pe(Z){const _=Z.get(97);return _==="editable"?Z.get(90):_!=="on"}e.filterValidationDecorations=pe;class Ae extends k{constructor(){const _=[],$e={type:"number",description:$.localize(94,null)};super(101,"rulers",_,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:$.localize(95,null),format:"color-hex"}}}]},default:_,description:$.localize(96,null)})}validate(_){if(Array.isArray(_)){const $e=[];for(const Be of _)if(typeof Be=="number")$e.push({column:a.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;$e.push({column:a.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return $e.sort((Be,Qe)=>Be.column-Qe.column),$e}return this.defaultValue}}class le extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function be(Z,_){if(typeof Z!="string")return _;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(97,null),$.localize(98,null),$.localize(99,null)],default:"auto",description:$.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(101,null),$.localize(102,null),$.localize(103,null)],default:"auto",description:$.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:$.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:$.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:$.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:$.localize(108,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_,Be=a.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=a.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:be($e.vertical,this.defaultValue.vertical),horizontal:be($e.horizontal,this.defaultValue.horizontal),useShadows:o($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:o($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:a.clampedInt($e.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:a.clampedInt($e.verticalSliderSize,Qe,0,1e3),scrollByPage:o($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends k{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:$.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:$.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:$.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:$.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:$.localize(115,null)}})}applyUpdate(_,$e){let Be=!1;$e.allowedCharacters&&_&&(T.$yn(_.allowedCharacters,$e.allowedCharacters)||(_={..._,allowedCharacters:$e.allowedCharacters},Be=!0)),$e.allowedLocales&&_&&(T.$yn(_.allowedLocales,$e.allowedLocales)||(_={..._,allowedLocales:$e.allowedLocales},Be=!0));const Qe=super.applyUpdate(_,$e);return Be?new l(Qe.newValue,!0):Qe}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{nonBasicASCII:Y($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Y($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Y($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,$e){if(typeof _!="object"||!_)return $e;const Be={};for(const[Qe,it]of Object.entries(_))it===!0&&(Be[Qe]=!0);return Be}}class K extends k{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:$.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(117,null),$.localize(118,null),$.localize(119,null)],description:$.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:$.localize(121,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),mode:s($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class z extends k{constructor(){const _={enabled:M.$rs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$rs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:$.localize(123,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends k{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:_.bracketPairs,description:$.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(128,null),$.localize(129,null),$.localize(130,null)],default:_.bracketPairsHorizontal,description:$.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:$.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:$.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(134,null),$.localize(135,null),$.localize(136,null)],default:_.highlightActiveIndentation,description:$.localize(137,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{bracketPairs:Y($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Y($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:Y($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Y(Z,_,$e){const Be=$e.indexOf(Z);return Be===-1?_:$e[Be]}class Ee extends k{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(138,null),$.localize(139,null)],default:_.insertMode,description:$.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:$.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:$.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:$.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(144,null),$.localize(145,null),$.localize(146,null),$.localize(147,null)],default:_.selectionMode,markdownDescription:$.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:$.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:$.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:$.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:$.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:$.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(185,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{insertMode:s($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o($e.showIcons,this.defaultValue.showIcons),showStatusBar:o($e.showStatusBar,this.defaultValue.showStatusBar),preview:o($e.preview,this.defaultValue.preview),previewMode:s($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o($e.showMethods,this.defaultValue.showMethods),showFunctions:o($e.showFunctions,this.defaultValue.showFunctions),showConstructors:o($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:o($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o($e.showFields,this.defaultValue.showFields),showVariables:o($e.showVariables,this.defaultValue.showVariables),showClasses:o($e.showClasses,this.defaultValue.showClasses),showStructs:o($e.showStructs,this.defaultValue.showStructs),showInterfaces:o($e.showInterfaces,this.defaultValue.showInterfaces),showModules:o($e.showModules,this.defaultValue.showModules),showProperties:o($e.showProperties,this.defaultValue.showProperties),showEvents:o($e.showEvents,this.defaultValue.showEvents),showOperators:o($e.showOperators,this.defaultValue.showOperators),showUnits:o($e.showUnits,this.defaultValue.showUnits),showValues:o($e.showValues,this.defaultValue.showValues),showConstants:o($e.showConstants,this.defaultValue.showConstants),showEnums:o($e.showEnums,this.defaultValue.showEnums),showEnumMembers:o($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o($e.showKeywords,this.defaultValue.showKeywords),showWords:o($e.showWords,this.defaultValue.showWords),showColors:o($e.showColors,this.defaultValue.showColors),showFiles:o($e.showFiles,this.defaultValue.showFiles),showReferences:o($e.showReferences,this.defaultValue.showReferences),showFolders:o($e.showFolders,this.defaultValue.showFolders),showTypeParameters:o($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o($e.showSnippets,this.defaultValue.showSnippets),showUsers:o($e.showUsers,this.defaultValue.showUsers),showIssues:o($e.showIssues,this.defaultValue.showIssues)}}}class Te extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(187,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(_.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class Ke extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(188,null),$.localize(189,null),$.localize(190,null),$.localize(191,null)],description:$.localize(192,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,$e,Be){return $e.get(2)===2?0:Be}}class Ze extends w{constructor(){super(144)}compute(_,$e,Be){const Qe=$e.get(143);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class st extends k{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),showDropSelector:s($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends k{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(199,null),$.localize(200,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),showPasteSelector:s($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?at:I.$k?ct:tt,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var vt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.occurrencesHighlight=80]="occurrencesHighlight",Z[Z.overviewRulerBorder=81]="overviewRulerBorder",Z[Z.overviewRulerLanes=82]="overviewRulerLanes",Z[Z.padding=83]="padding",Z[Z.pasteAs=84]="pasteAs",Z[Z.parameterHints=85]="parameterHints",Z[Z.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=88]="quickSuggestions",Z[Z.quickSuggestionsDelay=89]="quickSuggestionsDelay",Z[Z.readOnly=90]="readOnly",Z[Z.readOnlyMessage=91]="readOnlyMessage",Z[Z.renameOnType=92]="renameOnType",Z[Z.renderControlCharacters=93]="renderControlCharacters",Z[Z.renderFinalNewline=94]="renderFinalNewline",Z[Z.renderLineHighlight=95]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=97]="renderValidationDecorations",Z[Z.renderWhitespace=98]="renderWhitespace",Z[Z.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Z[Z.roundedSelection=100]="roundedSelection",Z[Z.rulers=101]="rulers",Z[Z.scrollbar=102]="scrollbar",Z[Z.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=104]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=105]="scrollPredominantAxis",Z[Z.selectionClipboard=106]="selectionClipboard",Z[Z.selectionHighlight=107]="selectionHighlight",Z[Z.selectOnLineNumbers=108]="selectOnLineNumbers",Z[Z.showFoldingControls=109]="showFoldingControls",Z[Z.showUnused=110]="showUnused",Z[Z.snippetSuggestions=111]="snippetSuggestions",Z[Z.smartSelect=112]="smartSelect",Z[Z.smoothScrolling=113]="smoothScrolling",Z[Z.stickyScroll=114]="stickyScroll",Z[Z.stickyTabStops=115]="stickyTabStops",Z[Z.stopRenderingLineAfter=116]="stopRenderingLineAfter",Z[Z.suggest=117]="suggest",Z[Z.suggestFontSize=118]="suggestFontSize",Z[Z.suggestLineHeight=119]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Z[Z.suggestSelection=121]="suggestSelection",Z[Z.tabCompletion=122]="tabCompletion",Z[Z.tabIndex=123]="tabIndex",Z[Z.unicodeHighlighting=124]="unicodeHighlighting",Z[Z.unusualLineTerminators=125]="unusualLineTerminators",Z[Z.useShadowDOM=126]="useShadowDOM",Z[Z.useTabStops=127]="useTabStops",Z[Z.wordBreak=128]="wordBreak",Z[Z.wordSeparators=129]="wordSeparators",Z[Z.wordWrap=130]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=133]="wordWrapColumn",Z[Z.wordWrapOverride1=134]="wordWrapOverride1",Z[Z.wordWrapOverride2=135]="wordWrapOverride2",Z[Z.wrappingIndent=136]="wrappingIndent",Z[Z.wrappingStrategy=137]="wrappingStrategy",Z[Z.showDeprecated=138]="showDeprecated",Z[Z.inlayHints=139]="inlayHints",Z[Z.editorClassName=140]="editorClassName",Z[Z.pixelRatio=141]="pixelRatio",Z[Z.tabFocusMode=142]="tabFocusMode",Z[Z.layoutInfo=143]="layoutInfo",Z[Z.wrappingInfo=144]="wrappingInfo",Z[Z.defaultColorDecorators=145]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(201,null)})),acceptSuggestionOnEnter:je(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(202,null),""],markdownDescription:$.localize(203,null)})),accessibilitySupport:je(new f),accessibilityPageSize:je(new a(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(204,null),tags:["accessibility"]})),ariaLabel:je(new i(4,"ariaLabel",$.localize(205,null))),ariaRequired:je(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:je(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(207,null),$.localize(208,null),""],description:$.localize(209,null)})),autoClosingComments:je(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(210,null),$.localize(211,null),""],description:$.localize(212,null)})),autoClosingDelete:je(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(213,null),""],description:$.localize(214,null)})),autoClosingOvertype:je(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(215,null),""],description:$.localize(216,null)})),autoClosingQuotes:je(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(217,null),$.localize(218,null),""],description:$.localize(219,null)})),autoIndent:je(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[$.localize(220,null),$.localize(221,null),$.localize(222,null),$.localize(223,null),$.localize(224,null)],description:$.localize(225,null)})),automaticLayout:je(new t(13,"automaticLayout",!1)),autoSurround:je(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(226,null),$.localize(227,null),$.localize(228,null),""],description:$.localize(229,null)})),bracketPairColorization:je(new z),bracketPairGuides:je(new X),stickyTabStops:je(new t(115,"stickyTabStops",!1,{description:$.localize(230,null)})),codeLens:je(new t(17,"codeLens",!0,{description:$.localize(231,null)})),codeLensFontFamily:je(new i(18,"codeLensFontFamily","",{description:$.localize(232,null)})),codeLensFontSize:je(new a(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(233,null)})),colorDecorators:je(new t(20,"colorDecorators",!0,{description:$.localize(234,null)})),colorDecoratorActivatedOn:je(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(235,null),$.localize(236,null),$.localize(237,null)],description:$.localize(238,null)})),colorDecoratorsLimit:je(new a(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(239,null)})),columnSelection:je(new t(22,"columnSelection",!1,{description:$.localize(240,null)})),comments:je(new S),contextmenu:je(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new t(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(241,null)})),cursorBlinking:je(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:$.localize(242,null)})),cursorSmoothCaretAnimation:je(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(243,null),$.localize(244,null),$.localize(245,null)],description:$.localize(246,null)})),cursorStyle:je(new d(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:$.localize(247,null)})),cursorSurroundingLines:je(new a(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(248,null)})),cursorSurroundingLinesStyle:je(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(249,null),$.localize(250,null)],markdownDescription:$.localize(251,null)})),cursorWidth:je(new a(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(252,null)})),disableLayerHinting:je(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new t(34,"domReadOnly",!1)),dragAndDrop:je(new t(35,"dragAndDrop",!0,{description:$.localize(253,null)})),emptySelectionClipboard:je(new H),dropIntoEditor:je(new st),stickyScroll:je(new se),experimentalWhitespaceRendering:je(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(254,null),$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),extraEditorClassName:je(new i(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:$.localize(258,null)})),find:je(new U),fixedOverflowWidgets:je(new t(42,"fixedOverflowWidgets",!1)),folding:je(new t(43,"folding",!0,{description:$.localize(259,null)})),foldingStrategy:je(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(260,null),$.localize(261,null)],description:$.localize(262,null)})),foldingHighlight:je(new t(45,"foldingHighlight",!0,{description:$.localize(263,null)})),foldingImportsByDefault:je(new t(46,"foldingImportsByDefault",!1,{description:$.localize(264,null)})),foldingMaximumRegions:je(new a(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(265,null)})),unfoldOnClickAfterEndOfLine:je(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(266,null)})),fontFamily:je(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(267,null)})),fontInfo:je(new C),fontLigatures2:je(new W),fontSize:je(new J),fontWeight:je(new ae),fontVariations:je(new P),formatOnPaste:je(new t(55,"formatOnPaste",!1,{description:$.localize(268,null)})),formatOnType:je(new t(56,"formatOnType",!1,{description:$.localize(269,null)})),glyphMargin:je(new t(57,"glyphMargin",!0,{description:$.localize(270,null)})),gotoLocation:je(new fe),hideCursorInOverviewRuler:je(new t(59,"hideCursorInOverviewRuler",!1,{description:$.localize(271,null)})),hover:je(new we),inDiffEditor:je(new t(61,"inDiffEditor",!1)),letterSpacing:je(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:$.localize(272,null)})),lightbulb:je(new De),lineDecorationsWidth:je(new V),lineHeight:je(new ne),lineNumbers:je(new me),lineNumbersMinChars:je(new a(68,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new t(69,"linkedEditing",!1,{description:$.localize(273,null)})),links:je(new t(70,"links",!0,{description:$.localize(274,null)})),matchBrackets:je(new u(71,"matchBrackets","always",["always","near","never"],{description:$.localize(275,null)})),minimap:je(new Ie),mouseStyle:je(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:$.localize(276,null)})),mouseWheelZoom:je(new t(75,"mouseWheelZoom",!1,{markdownDescription:I.$j?$.localize(277,null):$.localize(278,null)})),multiCursorMergeOverlapping:je(new t(76,"multiCursorMergeOverlapping",!0,{description:$.localize(279,null)})),multiCursorModifier:je(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Me,{markdownEnumDescriptions:[$.localize(280,null),$.localize(281,null)],markdownDescription:$.localize(282,null)})),multiCursorPaste:je(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(283,null),$.localize(284,null)],markdownDescription:$.localize(285,null)})),multiCursorLimit:je(new a(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(286,null)})),occurrencesHighlight:je(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(287,null),$.localize(288,null),$.localize(289,null)],markdownDescription:$.localize(290,null)})),overviewRulerBorder:je(new t(81,"overviewRulerBorder",!0,{description:$.localize(291,null)})),overviewRulerLanes:je(new a(82,"overviewRulerLanes",3,0,3)),padding:je(new Ce),pasteAs:je(new nt),parameterHints:je(new ce),peekWidgetDefaultFocus:je(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(292,null),$.localize(293,null)],description:$.localize(294,null)})),definitionLinkOpensInPeek:je(new t(87,"definitionLinkOpensInPeek",!1,{description:$.localize(295,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new a(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(296,null)})),readOnly:je(new t(90,"readOnly",!1)),readOnlyMessage:je(new le),renameOnType:je(new t(92,"renameOnType",!1,{description:$.localize(297,null),markdownDeprecationMessage:$.localize(298,null)})),renderControlCharacters:je(new t(93,"renderControlCharacters",!0,{description:$.localize(299,null),restricted:!0})),renderFinalNewline:je(new u(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(300,null)})),renderLineHighlight:je(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(301,null)],description:$.localize(302,null)})),renderLineHighlightOnlyWhenFocus:je(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(303,null)})),renderValidationDecorations:je(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(304,null),$.localize(305,null),$.localize(306,null),""],description:$.localize(307,null)})),revealHorizontalRightPadding:je(new a(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new t(100,"roundedSelection",!0,{description:$.localize(308,null)})),rulers:je(new Ae),scrollbar:je(new F),scrollBeyondLastColumn:je(new a(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(309,null)})),scrollBeyondLastLine:je(new t(104,"scrollBeyondLastLine",!0,{description:$.localize(310,null)})),scrollPredominantAxis:je(new t(105,"scrollPredominantAxis",!0,{description:$.localize(311,null)})),selectionClipboard:je(new t(106,"selectionClipboard",!0,{description:$.localize(312,null),included:I.$k})),selectionHighlight:je(new t(107,"selectionHighlight",!0,{description:$.localize(313,null)})),selectOnLineNumbers:je(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:je(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),showUnused:je(new t(110,"showUnused",!0,{description:$.localize(318,null)})),showDeprecated:je(new t(138,"showDeprecated",!0,{description:$.localize(319,null)})),inlayHints:je(new x),snippetSuggestions:je(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(320,null),$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),smartSelect:je(new Te),smoothScrolling:je(new t(113,"smoothScrolling",!1,{description:$.localize(325,null)})),stopRenderingLineAfter:je(new a(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new Ee),inlineSuggest:je(new K),inlineCompletionsAccessibilityVerbose:je(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(326,null)})),suggestFontSize:je(new a(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new a(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new t(120,"suggestOnTriggerCharacters",!0,{description:$.localize(329,null)})),suggestSelection:je(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(330,null),$.localize(331,null),$.localize(332,null)],description:$.localize(333,null)})),tabCompletion:je(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),tabIndex:je(new a(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new q),unusualLineTerminators:je(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null)],description:$.localize(341,null)})),useShadowDOM:je(new t(126,"useShadowDOM",!0)),useTabStops:je(new t(127,"useTabStops",!0,{description:$.localize(342,null)})),wordBreak:je(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null)],description:$.localize(345,null)})),wordSeparators:je(new i(129,"wordSeparators",R.$ss,{description:$.localize(346,null)})),wordWrap:je(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(347,null),$.localize(348,null),$.localize(349,null),$.localize(350,null)],description:$.localize(351,null)})),wordWrapBreakAfterCharacters:je(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new a(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(352,null)})),wordWrapOverride1:je(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new O),defaultColorDecorators:je(new t(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(353,null)})),pixelRatio:je(new ie),tabFocusMode:je(new t(142,"tabFocusMode",!1,{markdownDescription:$.localize(354,null)})),layoutInfo:je(new he),wrappingInfo:je(new Ze),wrappingIndent:je(new Ke),wrappingStrategy:je(new ve)}}),define(Pe[148],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Pe[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Pe[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Pe[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Pe[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[180],Re([1,0,15,150]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.TokenType=void 0;var I;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(I||(e.TokenType=I={}));function M(...b){switch(b.length){case 1:return(0,T.localize)(0,null,b[0]);case 2:return(0,T.localize)(1,null,b[0],b[1]);case 3:return(0,T.localize)(2,null,b[0],b[1],b[2]);default:return}}const R=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:A}),this.f.push(p)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),l=g.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const w=this.c.charCodeAt(A);if(k)k=!1;else if(w===47&&!l){A++;break}else w===91?l=!0:w===92?k=!0:w===93&&(l=!1);A++}for(;A<this.c.length&&g.a.has(this.c.charCodeAt(A));)A++;this.e=A;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Zi=g}),define(Pe[181],Re([1,0,25,31,152,293]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function g(t){return t=t.trim(),t==="*"||R.test(t)}e.$_o=g;function b(t){if(!g(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$ap=b;function A(t){if(!t)return null;const n=t.majorBase,a=t.majorMustEqual,c=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let s=t.patchMustEqual;t.hasCaret&&(n===0||(h=!1),s=!1);let u=0;if(t.preRelease){const d=$.exec(t.preRelease);if(d){const[,m,f,S]=d;u=Date.UTC(Number(m),Number(f)-1,Number(S))}}return{majorBase:n,majorMustEqual:a,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:s,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$bp=A;function k(t,n,a){let c;typeof t=="string"?c=A(b(t)):c=t;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof a=="string"?i=A(b(a)):i=a,!c||!i)return!1;const s=c.majorBase,u=c.minorBase,d=c.patchBase;let m=i.majorBase,f=i.minorBase,S=i.patchBase;const L=i.notBefore;let v=i.majorMustEqual,y=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?s>m?!0:s<m?!1:u>f?!0:u<f||h&&h<L?!1:d>=S:(s===1&&m===0&&(!v||!y||!D)&&(m=1,f=0,S=0,v=!0,y=!1,D=!1),s<m?!1:s>m?!v:u<f?!1:u>f?!y:d<S?!1:d>S?!D:!(h&&h<L))}e.$cp=k;function l(t,n,a,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,I.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,I.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,I.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,I.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([T.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([T.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,I.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,I.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,I.localize(9,null,"main")]),i;{const d=(0,E.$Gg)(a,c.main);(0,E.$Ag)(d,a)||i.push([T.default.Warning,I.localize(10,null,d.path,a.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,I.localize(11,null,"browser")]),i;{const d=(0,E.$Gg)(a,c.browser);(0,E.$Ag)(d,a)||i.push([T.default.Warning,I.localize(12,null,d.path,a.path)])}}if(!M.valid(c.version))return i.push([T.default.Error,I.localize(13,null)]),i;const s=[];if(!p(t,n,c,h,s))for(const d of s)i.push([T.default.Error,d]);return i}e.$dp=l;function p(t,n,a,c,h){return c||typeof a.main>"u"&&typeof a.browser>"u"?!0:r(t,n,a.engines.vscode,h)}e.$ep=p;function w(t,n,a){return t==="*"||r(n,a,t)}e.$fp=w;function r(t,n,a,c=[]){const h=A(b(a));if(!h)return c.push(I.localize(14,null,a)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(I.localize(15,null,a)),!1}else if(!h.majorMustEqual)return c.push(I.localize(16,null,a)),!1;return k(t,n,h)?!0:(c.push(I.localize(17,null,t,a)),!1)}function o(t){if(!Array.isArray(t))return!1;for(let n=0,a=t.length;n<a;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Pe[69],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=void 0;class E{constructor(I,M=[],R=!1){this.ctor=I,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$2h=E}),define(Pe[70],Re([1,0,69]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=e.InstantiationType=void 0;const T=[];var I;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function M($,g,b){g instanceof E.$2h||(g=new E.$2h(g,[],!!b)),T.push([$,g])}e.$Xr=M;function R(){return T}e.$Yr=R}),define(Pe[182],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0;class E{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Bq=E;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const $=this.lookupOrInsertNode(M),g=this.lookupOrInsertNode(R);$.outgoing.set(g.key,g),g.incoming.set($.key,$)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let $=this.a.get(R);return $||($=new E(R,M),this.a.set(R,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,$]of this.a)M.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const $=new Set([M]),g=this.c(R,$);if(g)return g}}c(M,R){for(const[$,g]of M.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const b=this.c(g,R);if(b)return b;R.delete($)}}}e.$Cq=T}),define(Pe[4],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(g){return g[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$4h=I("instantiationService");function T(R,$,g){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:g}):($[E.DI_DEPENDENCIES]=[{id:R,index:g}],$[E.DI_TARGET]=$)}function I(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(g,b,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,g,A)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$5h=I;function M(R){return R}e.$6h=M}),define(Pe[41],Re([1,0,16,2,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.ConfigurationTarget=e.$Ai=e.$zi=e.$yi=void 0,e.$yi=(0,I.$5h)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$zi=M;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$Ai=R;var $;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function g(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Bi=g;function b(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$Ci=b;function A(t,n){const a=Object.create(null);for(const c in t)k(a,c,t[c],n);return a}e.$Di=A;function k(t,n,a,c){const h=n.split("."),i=h.pop();let s=t;for(let u=0;u<h.length;u++){const d=h[u];let m=s[d];switch(typeof m){case"undefined":m=s[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(m)}`);return}s=m}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(s)}`)}e.$Ei=k;function l(t,n){const a=n.split(".");p(t,a)}e.$Fi=l;function p(t,n){const a=n.shift();if(n.length===0){delete t[a];return}if(Object.keys(t).indexOf(a)!==-1){const c=t[a];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete t[a])}}function w(t,n,a){function c(s,u){let d=s;for(const m of u){if(typeof d!="object"||d===null)return;d=d[m]}return d}const h=n.split("."),i=c(t,h);return typeof i>"u"?a:i}e.$Gi=w;function r(t,n,a){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in t?E.$Jf(t[c])&&E.$Jf(n[c])?r(t[c],n[c],a):a&&(t[c]=n[c]):t[c]=n[c])})}e.$Hi=r;function o(t){return t.replace(/[\[\]]/g,"")}e.$Ii=o}),define(Pe[35],Re([1,0,21,11,180,4,149,15]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.ContextKeyExprType=e.$1i=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",E.$j),g.set("isLinux",E.$k),g.set("isWindows",E.$i),g.set("isWeb",E.$o),g.set("isMacNative",E.$j&&!E.$o),g.set("isEdge",E.$H),g.set("isFirefox",E.$F),g.set("isChrome",E.$E),g.set("isSafari",E.$G);function b(x,V){if(g.get(x)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(x,V)}e.$1i=b;const A=Object.prototype.hasOwnProperty;var k;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),w=(0,R.localize)(1,null),r=(0,R.localize)(2,null),o=(0,R.localize)(3,null),t=(0,R.localize)(4,null),n=(0,R.localize)(5,null),a=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new I.$Zi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ie=this.D(),Me=Ie.type===17?n:void 0;throw this.h.push({message:t,offset:Ie.offset,lexeme:I.$Zi.getLexeme(Ie),additionalInfo:Me}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ne=this.o();V.push(ne)}return V.length===1?V[0]:i.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ne=this.s();V.push(ne)}return V.length===1?V[0]:i.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),m.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,o),ne?.negate()}case 17:return this.z(),N.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,o),ne}case 17:{const ne=V.lexeme;if(this.z(),this.y(9)){const Me=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Me.type!==10)throw this.B("REGEX",Me);const Ce=Me.lexeme,ce=Ce.lastIndexOf("/"),ie=ce===Ce.length-1?void 0:this.w(Ce.substring(ce+1));let Q;try{Q=new RegExp(Ce.substring(1,ce),ie)}catch{throw this.B("REGEX",Me)}return C.create(ne,Q)}switch(Me.type){case 10:case 19:{const Ce=[Me.lexeme];this.z();let ce=this.D(),ie=0;for(let Ae=0;Ae<Me.lexeme.length;Ae++)Me.lexeme.charCodeAt(Ae)===40?ie++:Me.lexeme.charCodeAt(Ae)===41&&ie--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let Ae=0;Ae<ce.lexeme.length;Ae++)ce.lexeme.charCodeAt(Ae)===40?ie++:Me.lexeme.charCodeAt(Ae)===41&&ie--}if(ie<0)break;Ce.push(I.$Zi.getLexeme(ce)),this.z(),ce=this.D()}const Q=Ce.join(""),te=Q.lastIndexOf("/"),me=te===Q.length-1?void 0:this.w(Q.substring(te+1));let pe;try{pe=new RegExp(Q.substring(1,te),me)}catch{throw this.B("REGEX",Me)}return i.regex(ne,pe)}case 18:{const Ce=Me.lexeme;this.z();let ce=null;if(!(0,T.$Ie)(Ce)){const ie=Ce.indexOf("/"),Q=Ce.lastIndexOf("/");if(ie!==Q&&ie>=0){const te=Ce.slice(ie+1,Q),me=Ce[Q+1]==="i"?"i":"";try{ce=new RegExp(te,me)}catch{throw this.B("REGEX",Me)}}}if(ce===null)throw this.B("REGEX",Me);return C.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Me=this.u();return i.notIn(ne,Me)}switch(this.D().type){case 3:{this.z();const Me=this.u();if(this.x().type===18)return i.equals(ne,Me);switch(Me){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Me)}}case 4:{this.z();const Me=this.u();if(this.x().type===18)return i.notEquals(ne,Me);switch(Me){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Me)}}case 5:return this.z(),W.create(ne,this.u());case 6:return this.z(),P.create(ne,this.u());case 7:return this.z(),H.create(ne,this.u());case 8:return this.z(),U.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:a,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ne){if(this.C(V))return this.z();throw this.B(ne,this.D())}B(V,ne,Ie){const Me=(0,R.localize)(8,null,V,I.$Zi.getLexeme(ne)),Ce=ne.offset,ce=I.$Zi.getLexeme(ne);return this.h.push({message:Me,offset:Ce,lexeme:ce,additionalInfo:Ie}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$2i=h;class i{static false(){return m.INSTANCE}static true(){return f.INSTANCE}static has(V){return S.create(V)}static equals(V,ne){return L.create(V,ne)}static notEquals(V,ne){return D.create(V,ne)}static regex(V,ne){return C.create(V,ne)}static in(V,ne){return v.create(V,ne)}static notIn(V,ne){return y.create(V,ne)}static not(V){return N.create(V)}static and(...V){return fe.create(V,null,!0)}static or(...V){return we.create(V,null,!0)}static greater(V,ne){return H.create(V,ne)}static greaterEquals(V,ne){return U.create(V,ne)}static smaller(V,ne){return W.create(V,ne)}static smallerEquals(V,ne){return P.create(V,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$3i=i;function s(x){const V=new h({regexParsingWithErrorRecovery:!1});return x.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,R.localize)(9,null,Ie.additionalInfo):(0,R.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$4i=s;function u(x,V){const ne=x?x.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ne&&!Ie?!0:!ne||!Ie?!1:ne.equals(Ie)}e.$5i=u;function d(x,V){return x.cmp(V)}class m{static{this.INSTANCE=new m}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return f.INSTANCE}}e.$6i=m;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return m.INSTANCE}}e.$7i=f;class S{static create(V,ne=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?f.INSTANCE:m.INSTANCE:new S(V,ne)}constructor(V,ne){this.key=V,this.c=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:he(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=g.get(this.key);return typeof V=="boolean"?V?f.INSTANCE:m.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$8i=S;class L{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?S.create(V,Ie):N.create(V,Ie);const Me=g.get(V);return typeof Me=="boolean"?ne===(Me?"true":"false")?f.INSTANCE:m.INSTANCE:new L(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?f.INSTANCE:m.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$9i=L;class v{static create(V,ne){return new v(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ne)?ne.includes(Ie):typeof Ie=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$0i=v;class y{static create(V,ne){return new y(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=11,this.c=v.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$$i=y;class D{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?N.create(V,Ie):S.create(V,Ie);const Me=g.get(V);return typeof Me=="boolean"?ne===(Me?"true":"false")?m.INSTANCE:f.INSTANCE:new D(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?m.INSTANCE:f.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$_i=D;class N{static create(V,ne=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?m.INSTANCE:f.INSTANCE:new N(V,ne)}constructor(V,ne){this.c=V,this.d=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=g.get(this.c);return typeof V=="boolean"?V?m.INSTANCE:f.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$aj=N;function O(x,V){if(typeof x=="string"){const ne=parseFloat(x);isNaN(ne)||(x=ne)}return typeof x=="string"||typeof x=="number"?V(x):m.INSTANCE}class H{static create(V,ne,Ie=null){return O(ne,Me=>new H(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$bj=H;class U{static create(V,ne,Ie=null){return O(ne,Me=>new U(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$cj=U;class W{static create(V,ne,Ie=null){return O(ne,Me=>new W(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$dj=W;class P{static create(V,ne,Ie=null){return O(ne,Me=>new P(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$ej=P;class C{static create(V,ne){return new C(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ne<Ie?-1:ne>Ie?1:0}equals(V){if(V.type===this.type){const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ne===Ie}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=J.create(this)),this.c}}e.$fj=C;class J{static create(V){return new J(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new J(this.c.map(V))}negate(){return this.c}}e.$gj=J;function ae(x){let V=null;for(let ne=0,Ie=x.length;ne<Ie;ne++){const Me=x[ne].substituteConstants();if(x[ne]!==Me&&V===null){V=[];for(let Ce=0;Ce<ne;Ce++)V[Ce]=x[Ce]}V!==null&&(V[ne]=Me)}return V===null?x:V}class fe{static create(V,ne,Ie){return fe.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Me=d(this.expr[ne],V.expr[ne]);if(Me!==0)return Me}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:fe.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static d(V,ne,Ie){const Me=[];let Ce=!1;for(const ce of V)if(ce){if(ce.type===1){Ce=!0;continue}if(ce.type===0)return m.INSTANCE;if(ce.type===6){Me.push(...ce.expr);continue}Me.push(ce)}if(Me.length===0&&Ce)return f.INSTANCE;if(Me.length!==0){if(Me.length===1)return Me[0];Me.sort(d);for(let ce=1;ce<Me.length;ce++)Me[ce-1].equals(Me[ce])&&(Me.splice(ce,1),ce--);if(Me.length===1)return Me[0];for(;Me.length>1;){const ce=Me[Me.length-1];if(ce.type!==9)break;Me.pop();const ie=Me.pop(),Q=Me.length===0,te=we.create(ce.expr.map(me=>fe.create([me,ie],null,Ie)),null,Q);te&&(Me.push(te),Me.sort(d))}if(Me.length===1)return Me[0];if(Ie){for(let ce=0;ce<Me.length;ce++)for(let ie=ce+1;ie<Me.length;ie++)if(Me[ce].negate().equals(Me[ie]))return m.INSTANCE;if(Me.length===1)return Me[0]}return new fe(Me,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new fe(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());this.c=we.create(V,this,!0)}return this.c}}e.$hj=fe;class we{static create(V,ne,Ie){return we.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Me=d(this.expr[ne],V.expr[ne]);if(Me!==0)return Me}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:we.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static d(V,ne,Ie){let Me=[],Ce=!1;if(V){for(let ce=0,ie=V.length;ce<ie;ce++){const Q=V[ce];if(Q){if(Q.type===0){Ce=!0;continue}if(Q.type===1)return f.INSTANCE;if(Q.type===9){Me=Me.concat(Q.expr);continue}Me.push(Q)}}if(Me.length===0&&Ce)return m.INSTANCE;Me.sort(d)}if(Me.length!==0){if(Me.length===1)return Me[0];for(let ce=1;ce<Me.length;ce++)Me[ce-1].equals(Me[ce])&&(Me.splice(ce,1),ce--);if(Me.length===1)return Me[0];if(Ie){for(let ce=0;ce<Me.length;ce++)for(let ie=ce+1;ie<Me.length;ie++)if(Me[ce].negate().equals(Me[ie]))return f.INSTANCE;if(Me.length===1)return Me[0]}return new we(Me,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new we(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ie=V.shift(),Me=[];for(const Ce of se(ne))for(const ce of se(Ie))Me.push(fe.create([Ce,ce],null,!1));V.unshift(we.create(Me,null,!1))}this.c=we.create(V,this,!0)}return this.c}}e.$ij=we;class ye extends S{static{this.d=[]}static all(){return ye.d.values()}constructor(V,ne,Ie){super(V,null),this.f=ne,typeof Ie=="object"?ye.d.push({...Ie,key:V}):Ie!==!0&&ye.d.push({key:V,description:Ie,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return L.create(this.key,V)}notEqualsTo(V){return D.create(this.key,V)}}e.$jj=ye,e.$kj=(0,M.$5h)("contextKeyService");function he(x,V){return x<V?-1:x>V?1:0}function ve(x,V,ne,Ie){return x<ne?-1:x>ne?1:V<Ie?-1:V>Ie?1:0}function ee(x,V){if(x.type===0||V.type===1)return!0;if(x.type===9)return V.type===9?De(x.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(ee(x,ne))return!0;return!1}if(x.type===6){if(V.type===6)return De(V.expr,x.expr);for(const ne of x.expr)if(ee(ne,V))return!0;return!1}return x.equals(V)}e.$lj=ee;function De(x,V){let ne=0,Ie=0;for(;ne<x.length&&Ie<V.length;){const Me=x[ne].cmp(V[Ie]);if(Me<0)return!1;Me===0&&ne++,Ie++}return ne===x.length}function se(x){return x.type===9?x.expr:[x]}}),define(Pe[183],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=void 0,e.$_h=(0,E.$5h)("environmentService"),e.$ai=(0,E.$6h)(e.$_h)}),define(Pe[97],Re([1,0,151,4]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$xo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=void 0,e.$lo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$mo=new RegExp(e.$lo),e.$no="__web_extension",e.$oo="skipWalkthrough",e.$po="extensionsSync",e.$qo="dependecyOrPackExtensionInstall";function I(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$ro=I;function M(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$so=M;function R(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$to=R;function $(t,n){return n==="web"&&!t.includes("web")}e.$uo=$;function g(t,n,a){return $(n,a)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===a}e.$vo=g;function b(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$wo=b;var A;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var k;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$xo=(0,T.$5h)("extensionGalleryService");var w;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var r;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class o extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.$yo=o,e.$zo=(0,T.$5h)("extensionManagementService"),e.$Ao="extensionsIdentifiers/disabled",e.$Bo="extensionsIdentifiers/enabled",e.$Co=(0,T.$5h)("IGlobalExtensionEnablementService"),e.$Do=(0,T.$5h)("IExtensionTipsService"),e.$Eo=(0,E.localize)(0,null),e.$Fo={value:e.$Eo,original:"Extensions"},e.$Go=(0,E.localize2)(1,"Preferences")}),define(Pe[42],Re([1,0,50,19,11,16,2,153,4,21,12,39]),function(ge,e,E,T,I,M,R,$,g,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileKind=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileOperationResult=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileChangeType=e.$Hk=e.FileOperation=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileSystemProviderErrorCode=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileSystemProviderCapabilities=e.$rk=e.FilePermission=e.FileType=e.$qk=e.$pk=void 0,e.$pk=(0,g.$5h)("fileService");function l(ee){return ee.create===!0}e.$qk=l;var p;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var w;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(w||(e.FilePermission=w={}));function r(ee){const De=ee;return!!De&&typeof De.onDidChange=="function"}e.$rk=r;var o;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function t(ee){return!!(ee.capabilities&2)}e.$sk=t;function n(ee){return!!(ee.capabilities&8)}e.$tk=n;function a(ee){return!!(ee.capabilities&131072)}e.$uk=a;function c(ee){return!!(ee.capabilities&4)}e.$vk=c;function h(ee){return!!(ee.capabilities&16)}e.$wk=h;function i(ee){return t(ee)?!!(ee.capabilities&16384):!1}e.$xk=i;function s(ee){return t(ee)?!!(ee.capabilities&32768):!1}e.$yk=s;function u(ee){return!!(ee.capabilities&65536)}e.$zk=u;function d(ee){return!!(ee.capabilities&2048)}e.$Ak=d;var m;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(m||(e.FileSystemProviderErrorCode=m={}));class f extends Error{static create(De,se){const x=new f(De.toString(),se);return v(x,se),x}constructor(De,se){super(De),this.code=se}}e.$Bk=f;function S(ee,De){return f.create(ee,De)}e.$Ck=S;function L(ee){return ee||S((0,$.localize)(0,null),m.Unknown)}e.$Dk=L;function v(ee,De){return ee.name=De?`${De} (FileSystemError)`:"FileSystemError",ee}e.$Ek=v;function y(ee){if(!ee)return m.Unknown;if(ee instanceof f)return ee.code;const De=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!De)return m.Unknown;switch(De[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.$Fk=y;function D(ee){if(ee instanceof P)return ee.fileOperationResult;switch(y(ee)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 9;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileTooLarge:return 7;default:return 10}}e.$Gk=D;var N;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class O{constructor(De,se,x){this.resource=De,this.operation=se,this.target=x}isOperation(De){return this.operation===De}}e.$Hk=O;var H;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(H||(e.FileChangeType=H={}));class U{static{this.a=null}constructor(De,se){this.c=se,this.b=void 0,this.d=new k.$V(()=>{const x=E.$$h.forUris(()=>this.c);return x.fill(this.rawAdded.map(V=>[V,!0])),x}),this.f=new k.$V(()=>{const x=E.$$h.forUris(()=>this.c);return x.fill(this.rawUpdated.map(V=>[V,!0])),x}),this.g=new k.$V(()=>{const x=E.$$h.forUris(()=>this.c);return x.fill(this.rawDeleted.map(V=>[V,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of De){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.b!==U.a&&(typeof x.cId=="number"?this.b===void 0?this.b=x.cId:this.b!==x.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(De,...se){return this.h(De,{includeChildren:!1},...se)}affects(De,...se){return this.h(De,{includeChildren:!0},...se)}h(De,se,...x){if(!De)return!1;const V=x.length>0;return!!((!V||x.includes(1))&&(this.d.value.get(De)||se.includeChildren&&this.d.value.findSuperstr(De))||(!V||x.includes(0))&&(this.f.value.get(De)||se.includeChildren&&this.f.value.findSuperstr(De))||(!V||x.includes(2))&&(this.g.value.findSubstr(De)||se.includeChildren&&this.g.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.b===De}hasCorrelation(){return typeof this.b=="number"}}e.$Ik=U;function W(ee,De,se){return!ee||!De||ee===De||De.length>ee.length?!1:(De.charAt(De.length-1)!==T.sep&&(De+=T.sep),se?(0,I.$_e)(ee,De):ee.indexOf(De)===0)}e.$Jk=W;class P extends Error{constructor(De,se,x){super(De),this.fileOperationResult=se,this.options=x}}e.$Kk=P;class C extends P{constructor(De,se,x,V){super(De,se,V),this.fileOperationResult=se,this.size=x}}e.$Lk=C;class J extends P{constructor(De,se,x){super(De,2,x),this.stat=se}}e.$Mk=J;var ae;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Nk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ok={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Pk="files.associations",e.$Qk="files.exclude",e.$Rk="files.readonlyInclude",e.$Sk="files.readonlyExclude",e.$Tk="files.readonlyFromPermissions";var fe;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$Uk="";function we(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.$Vk=we;async function ye(ee,De){if(!De.hasProvider(R.URI.from({scheme:ee.scheme})))return new Promise(se=>{const x=De.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===ee.scheme&&V.added&&(x.dispose(),se())})})}e.$Wk=ye;class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize(De){return(0,M.$Lf)(De)||(De=0),De<he.KB?(0,$.localize)(1,null,De.toFixed(0)):De<he.MB?(0,$.localize)(2,null,(De/he.KB).toFixed(2)):De<he.GB?(0,$.localize)(3,null,(De/he.MB).toFixed(2)):De<he.TB?(0,$.localize)(4,null,(De/he.GB).toFixed(2)):(0,$.localize)(5,null,(De/he.TB).toFixed(2))}}e.$Xk=he;function ve(ee){const De=typeof ee=="string"||ee?.scheme===A.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===A.Schemas.file?1024*he.MB:De?10*he.MB:b.$o?50*he.MB:1024*he.MB}e.$Yk=ve}),define(Pe[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class E{constructor(...I){this.a=new Map;for(const[M,R]of I)this.set(M,R)}set(I,M){const R=this.a.get(I);return this.a.set(I,M),R}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$3h=E}),define(Pe[184],Re([1,0,13,15,6,69,182,4,71,185]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0;const A=!1;class k extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new g.$3h,t=!1,n,a=A){this.f=o,this.g=t,this.h=n,this.i=a,this.o=new Set,this.f.set($.$4h,this),this._globalGraph=a?n?._globalGraph??new R.$Cq(c=>c):void 0}createChild(o){return new l(o,this.g,this,this.i)}invokeFunction(o,...t){const n=w.traceInvocation(this.i,o);let a=!1;try{return o({get:h=>{if(a)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{a=!0,n.stop()}}createInstance(o,...t){let n,a;return o instanceof M.$2h?(n=w.traceCreation(this.i,o.ctor),a=this.j(o.ctor,o.staticArguments.concat(t),n)):(n=w.traceCreation(this.i,o),a=this.j(o,t,n)),n.stop(),a}j(o,t=[],n){const a=$._util.getServiceDependencies(o).sort((i,s)=>i.index-s.index),c=[];for(const i of a){const s=this.m(i.id,n);s||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(s)}const h=a.length>0?a[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(o,t.concat(c))}k(o,t){if(this.f.get(o)instanceof M.$2h)this.f.set(o,t);else if(this.h)this.h.k(o,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const t=this.f.get(o);return!t&&this.h?this.h.l(o):t}m(o,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof M.$2h?this.q(o,n,t.branch(o,!0)):(t.branch(o,!1),n)}q(o,t,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,t,n)}finally{this.o.delete(o)}}r(o,t,n){const a=new R.$Cq(i=>i.id.toString());let c=0;const h=[{id:o,desc:t,_trace:n}];for(;h.length;){const i=h.pop();if(a.lookupOrInsertNode(i),c++>1e3)throw new k(a);for(const s of $._util.getServiceDependencies(i.desc.ctor)){const u=this.l(s.id);if(u||this.u(`[createInstance] ${o} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),u instanceof M.$2h){const d={id:s.id,desc:u,_trace:i._trace.branch(s.id,!0)};a.insertEdge(i,d),h.push(d)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new k(a);break}for(const{data:s}of i){if(this.l(s.id)instanceof M.$2h){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}a.removeNode(s)}}return this.l(o)}s(o,t,n=[],a,c){if(this.f.get(o)instanceof M.$2h)return this.t(o,t,n,a,c);if(this.h)return this.h.s(o,t,n,a,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(o,t,n=[],a,c){if(a){const h=new l(void 0,this.g,this,this.i);h.c=String(o);const i=new Map,s=new E.$lh(()=>{const u=h.j(t,n,c);for(const[d,m]of i){const f=u[d];if(typeof f=="function")for(const S of m)S.disposable=f.apply(u,S.listener)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let S=i.get(d);return S||(S=new b.$4c,i.set(d,S)),(v,y,D)=>{if(s.isInitialized)return s.value[d](v,y,D);{const N={listener:[v,y,D],disposable:void 0},O=S.push(N);return(0,I.$Rc)(()=>{O(),N.disposable?.dispose()})}}}if(d in u)return u[d];const m=s.value;let f=m[d];return typeof f!="function"||(f=f.bind(m),u[d]=f),f},set(u,d,m){return s.value[d]=m,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,n,c)}u(o,t){if(t&&console.warn(o),this.g)throw new Error(o)}}e.$Dq=l;var p;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(p||(p={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,t){return o?new w(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(o,t){return o?new w(1,t.name):w.c}static{this.f=0}constructor(o,t){this.type=o,this.name=t,this.g=Date.now(),this.h=[]}branch(o,t){const n=new w(3,o.toString());return this.h.push([o,t,n]),n}stop(){const o=Date.now()-this.g;w.f+=o;let t=!1;function n(c,h){const i=[],s=new Array(c+1).join("	");for(const[u,d,m]of h.h)if(d&&m){t=!0,i.push(`${s}CREATES -> ${u}`);const f=n(c+1,m);f&&i.push(f)}else i.push(`${s}uses -> ${u}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(o>2||t)&&w.all.add(a.join(`
`))}}e.$Eq=w}),define(Pe[14],Re([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.log=e.$pj=e.LogLevel=e.$oj=e.$nj=e.$mj=void 0,e.$mj=(0,l.$5h)("logService"),e.$nj=(0,l.$5h)("loggerService");function p(){return new Date().toISOString()}function w(v){return(0,b.$Lf)(v)}e.$oj=w;var r;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$pj=r.Info;function o(v,y,D){switch(y){case r.Trace:v.trace(D);break;case r.Debug:v.debug(D);break;case r.Info:v.info(D);break;case r.Warning:v.warn(D);break;case r.Error:v.error(D);break;case r.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=o;function t(v,y=!1){let D="";for(let N=0;N<v.length;N++){let O=v[N];if(O instanceof Error&&(O=(0,E.$Pi)(O,y)),typeof O=="object")try{O=JSON.stringify(O)}catch{}D+=(N>0?" ":"")+O}return D}class n extends M.$Tc{constructor(){super(...arguments),this.b=e.$pj,this.c=this.B(new T.$Ud),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==r.Off&&this.b<=y}}e.$rj=n;class a extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...D){this.f(r.Trace)&&this.g(r.Trace,t([y,...D],!0))}debug(y,...D){this.f(r.Debug)&&this.g(r.Debug,t([y,...D]))}info(y,...D){this.f(r.Info)&&this.g(r.Info,t([y,...D]))}warn(y,...D){this.f(r.Warning)&&this.g(r.Warning,t([y,...D]))}error(y,...D){if(this.f(r.Error))if(y instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=y.stack,this.g(r.Error,t(N))}else this.g(r.Error,t([y,...D]))}flush(){}}e.$sj=a;class c extends n{constructor(y=e.$pj){super(),this.setLevel(y),this.g=!$.$i}trace(y,...D){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}debug(y,...D){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}info(y,...D){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}warn(y,...D){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,y,...D):console.warn(`[main ${p()}]`,y,...D))}error(y,...D){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,y,...D):console.error(`[main ${p()}]`,y,...D))}flush(){}}e.$tj=c;class h extends n{constructor(y=e.$pj,D=!0){super(),this.g=D,this.setLevel(y)}trace(y,...D){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...D):console.log(y,...D))}debug(y,...D){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...D):console.log(y,...D))}info(y,...D){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...D):console.log(y,...D))}warn(y,...D){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...D):console.log(y,...D))}error(y,...D){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...D):console.error(y,...D))}flush(){}}e.$uj=h;class i extends n{constructor(y,D=e.$pj){super(),this.g=y,this.setLevel(D)}trace(y,...D){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(y),...D])}debug(y,...D){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(y),...D])}info(y,...D){this.f(r.Info)&&this.g.log(r.Info,[this.h(y),...D])}warn(y,...D){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(y),...D])}error(y,...D){this.f(r.Error)&&this.g.log(r.Error,[this.h(y),...D])}h(y){return typeof y=="string"?y:(0,E.$Pi)(y,this.f(r.Trace))}flush(){}}e.$vj=i;class s extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const D of this.g)D.setLevel(y);super.setLevel(y)}trace(y,...D){for(const N of this.g)N.trace(y,...D)}debug(y,...D){for(const N of this.g)N.debug(y,...D)}info(y,...D){for(const N of this.g)N.info(y,...D)}warn(y,...D){for(const N of this.g)N.warn(y,...D)}error(y,...D){for(const N of this.g)N.error(y,...D)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$wj=s;class u extends M.$Tc{constructor(y,D,N){if(super(),this.h=y,this.j=D,this.b=new R.$Ac,this.c=this.B(new T.$Ud),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Ud),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Ud),this.onDidChangeVisibility=this.g.event,N)for(const O of N)this.b.set(O.resource,{logger:void 0,info:O})}m(y){return(0,b.$Hf)(y)?[...this.b.values()].find(D=>D.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,D){const N=this.n(y),O=(0,b.$Hf)(y)?y:D?.id??(0,I.$Si)(N.toString()).toString(16);let H=this.b.get(N)?.logger;const U=D?.logLevel==="always"?r.Trace:D?.logLevel;H||(H=this.s(N,U??this.getLogLevel(N)??this.h,{...D,id:O}));const W={logger:H,info:{resource:N,id:O,logLevel:U,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(W.info),this.b.set(N,W),H}n(y){return(0,b.$Hf)(y)?(0,g.$Gg)(this.j,`${y}.log`):y}setLogLevel(y,D){if(A.URI.isUri(y)){const N=y,O=D,H=this.b.get(N);H&&O!==H.info.logLevel&&(H.info.logLevel=O===this.h?void 0:O,H.logger?.setLevel(O),this.b.set(H.info.resource,H),this.f.fire([N,O]))}else{this.h=y;for(const[N,O]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,D){const N=this.m(y);N&&D!==!N.info.hidden&&(N.info.hidden=!D,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,D]))}getLogLevel(y){let D;return y&&(D=this.b.get(y)?.info.logLevel),D??this.h}registerLogger(y){const D=this.b.get(y.resource);D?D.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const D=this.b.get(y);D&&(D.logger&&D.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$xj=u;class d{constructor(){this.onDidChangeLogLevel=new T.$Ud().event}setLevel(y){}getLevel(){return r.Info}trace(y,...D){}debug(y,...D){}info(y,...D){}warn(y,...D){}error(y,...D){}critical(y,...D){}dispose(){}flush(){}}e.$yj=d;class m extends d{}e.$zj=m;function f(v){if(v.verbose)return r.Trace;if(typeof v.logLevel=="string"){const y=L(v.logLevel.toLowerCase());if(y!==void 0)return y}return e.$pj}e.$Aj=f;function S(v){switch(v){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}e.$Bj=S;function L(v){switch(v){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$Cj=L,e.$Dj=new k.$jj("logLevel",S(r.Info))}),define(Pe[186],Re([1,0,6,14]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=void 0;class I extends E.$Tc{constructor(R,$=[]){super(),this.a=new T.$wj([R,...$]),this.B(R.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$tO=I}),define(Pe[99],Re([1,0,31,154,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(g){function b(w,r){return r-w}g.compare=b;const A=Object.create(null);A[g.Error]=(0,T.localize)(0,null),A[g.Warning]=(0,T.localize)(1,null),A[g.Info]=(0,T.localize)(2,null);function k(w){return A[w]||""}g.toString=k;function l(w){switch(w){case E.default.Error:return g.Error;case E.default.Warning:return g.Warning;case E.default.Info:return g.Info;case E.default.Ignore:return g.Hint}}g.fromSeverity=l;function p(w){switch(w){case g.Error:return E.default.Error;case g.Warning:return E.default.Warning;case g.Info:return E.default.Info;case g.Hint:return E.default.Ignore}}g.toSeverity=p}(R||(e.MarkerSeverity=R={}));var $;(function(g){const b="";function A(l){return k(l,!0)}g.makeKey=A;function k(l,p){const w=[b];return l.source?w.push(l.source.replace("\xA6","\\\xA6")):w.push(b),l.code?typeof l.code=="string"?w.push(l.code.replace("\xA6","\\\xA6")):w.push(l.code.value.replace("\xA6","\\\xA6")):w.push(b),l.severity!==void 0&&l.severity!==null?w.push(R.toString(l.severity)):w.push(b),l.message&&p?w.push(l.message.replace("\xA6","\\\xA6")):w.push(b),l.startLineNumber!==void 0&&l.startLineNumber!==null?w.push(l.startLineNumber.toString()):w.push(b),l.startColumn!==void 0&&l.startColumn!==null?w.push(l.startColumn.toString()):w.push(b),l.endLineNumber!==void 0&&l.endLineNumber!==null?w.push(l.endLineNumber.toString()):w.push(b),l.endColumn!==void 0&&l.endColumn!==null?w.push(l.endColumn.toString()):w.push(b),w.push(b),w.join("\xA6")}g.makeKeyOptionalMessage=k})($||(e.IMarkerData=$={})),e.$zt=(0,I.$5h)("markerService")}),define(Pe[187],Re([1,0,5,31,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.NotificationsFilter=e.$pv=e.NeverShowAgainScope=e.NotificationPriority=e.$ov=e.Severity=void 0,e.Severity=T.default,e.$ov=(0,I.$5h)("notificationService");var M;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function $(k){if(k){const l=k;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$pv=$;var g;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class b{constructor(){this.progress=new A,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$qv=b;class A{infinite(){}done(){}total(l){}worked(l){}}e.$rv=A}),define(Pe[188],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=void 0,e.$Ej=(0,E.$5h)("productService"),e.$Fj="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,E,T){var I=arguments.length,M=I<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ge,e,E,T);else for(var $=ge.length-1;$>=0;$--)(R=ge[$])&&(M=(I<3?R(M):I>3?R(e,E,M):R(e,E))||M);return I>3&&M&&Object.defineProperty(e,E,M),M},He=this&&this.__param||function(ge,e){return function(E,T){e(E,T,ge)}};define(Pe[72],Re([1,0,13,20,6,4]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.ProgressLocation=e.$sv=void 0,e.$sv=(0,M.$5h)("progressService");var R;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$tv=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$uv=$;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$vv=g;let b=class extends I.$Tc{constructor(l,p){super(),this.a=new E.$ph,p.withProgress(l,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,I.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$wv=b,e.$wv=b=Je([He(1,e.$sv)],b);class A extends I.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Sc)}start(l){this.stop();const p=++this.a,w=new T.$5d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Rc)(()=>w.cancel())),this.b.add((0,I.$Rc)(()=>this.c?this.c.done():void 0)),{id:p,token:w.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$xv=A,e.$yv=(0,M.$5h)("editorProgressService")}),define(Pe[30],Re([1,0,53,16]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0;class I{constructor(){this.a=new Map}add(R,$){E.ok(T.$Hf(R)),E.ok(T.$Jf($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Gn=new I}),define(Pe[73],Re([1,0,5,30]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0,e.$Hn={JSONContribution:"base.contributions.json"};function I($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Ud,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,b){this.a[I(g)]=b,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;T.$Gn.add(e.$Hn.JSONContribution,R)}),define(Pe[54],Re([1,0,18,5,16,148,41,73,30]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.ConfigurationScope=e.$Ln=e.EditPresentationTypes=void 0;var b;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$Ln={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Mn={properties:{},patternProperties:{}},e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn="vscode://schemas/settings/resourceLanguage",e.$Tn="vscode://schemas/settings/configurationDefaults";const k=g.$Gn.as($.$Hn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Ud,this.onDidSchemaChange=this.i.event,this.j=new T.$Ud,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Sn,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const u=new Set;this.n(i,s,u),k.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const s=new Set;this.o(i,s),k.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const u=new Set;this.o(s,u),this.n(i,!1,u),k.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const u=[];for(const{overrides:d,source:m}of i)for(const f in d)if(s.add(f),e.$Vn.test(f)){const S=this.a.get(f),L=S?.valuesSources??new Map;if(m)for(const N of Object.keys(d[f]))L.set(N,m);const v={...S?.value||{},...d[f]};this.a.set(f,{source:m,value:v,valuesSources:L});const y=(0,R.$Ii)(f),D={type:"object",default:v,description:M.localize(1,null,y),$ref:e.$Sn,defaultDefaultValue:v,source:I.$Hf(m)?void 0:m,defaultValueSource:m};u.push(...r(f)),this.d[f]=D,this.b.properties[f]=D}else{this.a.set(f,{value:d[f],source:m});const S=this.d[f];S&&(this.w(f,S),this.r(f,S))}this.m(u)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:u,source:d}of i)for(const m in u){const f=this.a.get(m),S=I.$Hf(d)?d:d?.id,L=I.$Hf(f?.source)?f?.source:f?.source?.id;if(S===L)if(s.add(m),this.a.delete(m),e.$Vn.test(m))delete this.d[m],delete this.b.properties[m];else{const v=this.d[m];v&&(this.w(m,v),this.r(m,v))}}this.u()}deltaConfiguration(i){let s=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,u){i.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,u),this.c.push(d),this.q(d)})}o(i,s){const u=d=>{if(d.properties)for(const m in d.properties){s.add(m);const f=this.d[m];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[m],this.s(m,d.properties[m])}d.allOf?.forEach(m=>u(m))};for(const d of i){u(d);const m=this.c.indexOf(d);m!==-1&&this.c.splice(m,1)}}p(i,s=!0,u,d,m=3,f){m=I.$Qf(i.scope)?m:i.scope;const S=i.properties;if(S)for(const v in S){const y=S[v];if(s&&a(v,y)){delete S[v];continue}if(y.source=u,y.defaultDefaultValue=S[v].default,this.w(v,y),e.$Vn.test(v)?y.scope=void 0:(y.scope=I.$Qf(y.scope)?m:y.scope,y.restricted=I.$Qf(y.restricted)?!!d?.includes(v):y.restricted),S[v].hasOwnProperty("included")&&!S[v].included){this.f[v]=S[v],delete S[v];continue}else this.d[v]=S[v],S[v].policy?.name&&this.e.set(S[v].policy.name,v);!S[v].deprecationMessage&&S[v].markdownDeprecationMessage&&(S[v].deprecationMessage=S[v].markdownDeprecationMessage),f.add(v)}const L=i.allOf;if(L)for(const v of L)this.p(v,s,u,d,m,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=u=>{const d=u.properties;if(d)for(const f in d)this.r(f,d[f]);u.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$Mn.properties[i]=s,s.scope){case 1:e.$Nn.properties[i]=s;break;case 2:e.$On.properties[i]=s;break;case 6:e.$Pn.properties[i]=s;break;case 3:e.$Qn.properties[i]=s;break;case 4:e.$Rn.properties[i]=s;break;case 5:e.$Rn.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$Mn.properties[i],s.scope){case 1:delete e.$Nn.properties[i];break;case 2:delete e.$On.properties[i];break;case 6:delete e.$Pn.properties[i];break;case 3:delete e.$Qn.properties[i];break;case 4:case 5:delete e.$Rn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$Sn};this.w(s,u),e.$Mn.properties[s]=u,e.$Nn.properties[s]=u,e.$On.properties[s]=u,e.$Pn.properties[s]=u,e.$Qn.properties[s]=u,e.$Rn.properties[s]=u}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$Sn};e.$Mn.patternProperties[e.$Un]=i,e.$Nn.patternProperties[e.$Un]=i,e.$On.patternProperties[e.$Un]=i,e.$Pn.patternProperties[e.$Un]=i,e.$Qn.patternProperties[e.$Un]=i,e.$Rn.patternProperties[e.$Un]=i,this.i.fire()}w(i,s){const u=this.a.get(i);let d=u?.value,m=u?.source;I.$Of(d)&&(d=s.defaultDefaultValue,m=void 0),I.$Of(d)&&(d=t(s.type)),s.default=d,s.defaultValueSource=m}}const p="\\[([^\\]]+)\\]",w=new RegExp(p,"g");e.$Un=`^(${p})+$`,e.$Vn=new RegExp(e.$Un);function r(h){const i=[];if(e.$Vn.test(h)){let s=w.exec(h);for(;s?.length;){const u=s[1].trim();u&&i.push(u),s=w.exec(h)}}return(0,E.$Mb)(i)}e.$Wn=r;function o(h){return h.reduce((i,s)=>`${i}[${s}]`,"")}e.$Xn=o;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Yn=t;const n=new l;g.$Gn.add(e.$Ln.Configuration,n);function a(h,i){return h.trim()?e.$Vn.test(h)?M.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$Zn=a;function c(){const h=[],i=n.getConfigurationProperties();for(const s of Object.keys(i))h.push([s,i[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$1n=c}),define(Pe[189],Re([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0;function p(s){return Object.isFrozen(s)?s:$.$vn(s)}class w{constructor(u={},d=[],m=[],f){this.b=u,this.c=d,this.d=m,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(d=>{if(d instanceof w)return d;const m=new r("");return m.parseRaw(d),m.configurationModel});this.f=u.reduce((d,m)=>m===d?m:d.merge(m),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,A.$Gi)(this.contents,u):this.contents}inspect(u,d){const m=this.rawConfiguration.getValue(u),f=d?this.rawConfiguration.getOverrideValue(u,d):void 0,S=d?this.rawConfiguration.override(d).getValue(u):m;return{value:m,override:f,merged:S}}getOverrideValue(u,d){const m=this.i(d);return m?u?(0,A.$Gi)(m,u):m:void 0}getKeysForOverrideIdentifier(u){const d=[];for(const m of this.overrides)m.identifiers.includes(u)&&d.push(...m.keys);return E.$Mb(d)}getAllOverrideIdentifiers(){const u=[];for(const d of this.overrides)u.push(...d.identifiers);return E.$Mb(u)}override(u){let d=this.a.get(u);return d||(d=this.g(u),this.a.set(u,d)),d}merge(...u){const d=$.$un(this.contents),m=$.$un(this.overrides),f=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const L of u)if(S.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(d,L.contents);for(const v of L.overrides){const[y]=m.filter(D=>E.$ub(D.identifiers,v.identifiers));y?(this.h(y.contents,v.contents),y.keys.push(...v.keys),y.keys=E.$Mb(y.keys)):m.push($.$un(v))}for(const v of L.keys)f.indexOf(v)===-1&&f.push(v)}return new w(d,f,m,S.every(L=>L instanceof w)?void 0:S)}g(u){const d=this.i(u);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const m={};for(const f of E.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let S=this.contents[f];const L=d[f];L&&(typeof S=="object"&&typeof L=="object"?(S=$.$un(S),this.h(S,L)):S=L),m[f]=S}return new w(m,this.keys,this.overrides)}h(u,d){for(const m of Object.keys(d)){if(m in u&&g.$Jf(u[m])&&g.$Jf(d[m])){this.h(u[m],d[m]);continue}u[m]=$.$un(d[m])}}i(u){let d=null,m=null;const f=S=>{S&&(m?this.h(m,S):m=$.$un(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===u?d=S.contents:S.identifiers.includes(u)&&f(S.contents);return f(d),m}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,d){this.j(u,d,!0)}setValue(u,d){this.j(u,d,!1)}removeValue(u){const d=this.keys.indexOf(u);d!==-1&&(this.keys.splice(d,1),(0,A.$Fi)(this.contents,u),k.$Vn.test(u)&&this.overrides.splice(this.overrides.findIndex(m=>E.$ub(m.identifiers,(0,k.$Wn)(u))),1))}j(u,d,m){(0,A.$Ei)(this.contents,u,d,f=>console.error(f)),m=m||this.keys.indexOf(u)===-1,m&&this.keys.push(u),k.$Vn.test(u)&&this.overrides.push({identifiers:(0,k.$Wn)(u),keys:Object.keys(this.contents[u]),contents:(0,A.$Di)(this.contents[u],f=>console.error(f))})}}e.$2n=w;class r{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,d){if(!g.$Qf(u)){const m=this.g(u);this.parseRaw(m,d)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,d){this.a=u;const{contents:m,keys:f,overrides:S,restricted:L,hasExcludedProperties:v}=this.h(u,d);this.b=new w(m,f,S,v?[u]:void 0),this.c=L||[]}g(u){let d={},m=null,f=[];const S=[],L=[];function v(D){Array.isArray(f)?f.push(D):m!==null&&(f[m]=D)}const y={onObjectBegin:()=>{const D={};v(D),S.push(f),f=D,m=null},onObjectProperty:D=>{m=D},onObjectEnd:()=>{f=S.pop()},onArrayBegin:()=>{const D=[];v(D),S.push(f),f=D,m=null},onArrayEnd:()=>{f=S.pop()},onLiteralValue:v,onError:(D,N,O)=>{L.push({error:D,offset:N,length:O})}};if(u)try{I.$in(u,y),d=f[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return d}h(u,d){const m=l.$Gn.as(k.$Ln.Configuration).getConfigurationProperties(),f=this.i(u,m,!0,d);u=f.raw;const S=(0,A.$Di)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),L=Object.keys(u),v=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:S,keys:L,overrides:v,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(u,d,m,f){let S=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:S};const L={},v=[];for(const y in u)if(k.$Vn.test(y)&&m){const D=this.i(u[y],d,!1,f);L[y]=D.raw,S=S||D.hasExcludedProperties,v.push(...D.restricted)}else{const D=d[y],N=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&v.push(y),!f.exclude?.includes(y)&&(f.include?.includes(y)||(N===void 0||f.scopes===void 0||f.scopes.includes(N))&&!(f.skipRestricted&&D?.restricted))?L[y]=u[y]:S=!0}return{raw:L,restricted:v,hasExcludedProperties:S}}j(u,d){const m=[];for(const f of Object.keys(u))if(k.$Vn.test(f)){const S={};for(const L in u[f])S[L]=u[f][L];m.push({identifiers:(0,k.$Wn)(f),keys:Object.keys(S),contents:(0,A.$Di)(S,d)})}return m}}e.$3n=r;class o extends M.$Tc{constructor(u,d,m,f){super(),this.c=u,this.f=d,this.g=f,this.b=this.B(new T.$Ud),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(m.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&m.isEqual(S.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$4n=o;class t{constructor(u,d,m,f,S,L,v,y,D,N,O,H,U){this.a=u,this.b=d,this.c=m,this.overrideIdentifiers=f,this.d=S,this.f=L,this.g=v,this.h=y,this.i=D,this.j=N,this.k=O,this.l=H,this.m=U}get value(){return p(this.c)}n(u,d,m){const f=u.inspect(d,m);return{get value(){return p(f.value)},get override(){return p(f.override)},get merged(){return p(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(u,d,m,f,S=new w,L=new w,v=new R.$Ac,y=new w,D=new R.$Ac){this.c=u,this.d=d,this.f=m,this.g=f,this.h=S,this.i=L,this.j=v,this.l=y,this.m=D,this.a=null,this.b=new R.$Ac,this.n=null}getValue(u,d,m){return this.p(u,d,m).getValue(u)}updateValue(u,d,m={}){let f;m.resource?(f=this.m.get(m.resource),f||(f=new w,this.m.set(m.resource,f))):f=this.l,d===void 0?f.removeValue(u):f.setValue(u,d),m.resource||(this.a=null)}inspect(u,d,m){const f=this.p(u,d,m),S=this.t(d.resource,m),L=d.resource?this.m.get(d.resource)||this.l:this.l,v=new Set;for(const y of f.overrides)for(const D of y.identifiers)f.getOverrideValue(u,D)!==void 0&&v.add(D);return new t(u,d,f.getValue(u),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,m?this.i:void 0,S||void 0,L)}keys(u){const d=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,d){this.j.set(u,d),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,d){const m=[];if(!d){const{added:f,updated:S,removed:L}=h(this.c,u);d=[...f,...S,...L]}for(const f of d)for(const S of(0,k.$Wn)(f)){const L=this.c.getKeysForOverrideIdentifier(S),v=u.getKeysForOverrideIdentifier(S),y=[...v.filter(D=>L.indexOf(D)===-1),...L.filter(D=>v.indexOf(D)===-1),...L.filter(D=>!$.$yn(this.c.override(S).getValue(D),u.override(S).getValue(D)))];m.push([S,y])}return this.updateDefaultConfiguration(u),{keys:d,overrides:m}}compareAndUpdatePolicyConfiguration(u){const{added:d,updated:m,removed:f}=h(this.d,u),S=[...d,...m,...f];return S.length&&this.updatePolicyConfiguration(u),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.applicationConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateApplicationConfiguration(u),{keys:L,overrides:S}}compareAndUpdateLocalUserConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.localUserConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateLocalUserConfiguration(u),{keys:L,overrides:S}}compareAndUpdateRemoteUserConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.remoteUserConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateRemoteUserConfiguration(u),{keys:L,overrides:S}}compareAndUpdateWorkspaceConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.workspaceConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateWorkspaceConfiguration(u),{keys:L,overrides:S}}compareAndUpdateFolderConfiguration(u,d){const m=this.folderConfigurations.get(u),{added:f,updated:S,removed:L,overrides:v}=h(m,d),y=[...f,...S,...L];return(y.length||!m)&&this.updateFolderConfiguration(u,d),{keys:y,overrides:v}}compareAndDeleteFolderConfiguration(u){const d=this.folderConfigurations.get(u);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:m,updated:f,removed:S,overrides:L}=h(d,void 0);return{keys:[...m,...f,...S],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,d,m){let f=this.q(d,m);return d.overrideIdentifier&&(f=f.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(f=f.merge(this.d)),f}q({resource:u},d){let m=this.r();if(d&&u){const f=d.getFolder(u);f&&(m=this.s(f.uri)||m);const S=this.m.get(u);S&&(m=m.merge(S))}return m}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let d=this.b.get(u);if(!d){const m=this.r(),f=this.j.get(u);f?(d=m.merge(f),this.b.set(u,d)):d=m}return d}t(u,d){if(d&&u){const m=d.getFolder(u);if(m)return this.j.get(m.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,d)=>{const{contents:m,overrides:f,keys:S}=this.j.get(d);return u.push([d,{contents:m,overrides:f,keys:S}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(d=>u.add(d)),this.userConfiguration.keys.forEach(d=>u.add(d)),this.i.keys.forEach(d=>u.add(d)),this.j.forEach(d=>d.keys.forEach(m=>u.add(m))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(m=>u.add(m))),[...u.values()]}v(u){const d=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.i.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.j.forEach(m=>m.getKeysForOverrideIdentifier(u).forEach(f=>d.add(f))),[...d.values()]}static parse(u){const d=this.w(u.defaults),m=this.w(u.policy),f=this.w(u.application),S=this.w(u.user),L=this.w(u.workspace),v=u.folders.reduce((y,D)=>(y.set(b.URI.revive(D[0]),this.w(D[1])),y),new R.$Ac);return new n(d,m,f,S,new w,L,v,new w,new R.$Ac)}static w(u){return new w(u.contents,u.keys,u.overrides)}}e.$5n=n;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,d=new Map;for(const f of s)f.keys.forEach(S=>u.add(S)),f.overrides.forEach(([S,L])=>{const v=(0,R.$xc)(d,S,new Set);L.forEach(y=>v.add(y))});const m=[];return d.forEach((f,S)=>m.push([S,[...f.values()]])),{keys:[...u.values()],overrides:m}}e.$6n=a;class c{constructor(u,d,m,f){this.change=u,this.f=d,this.g=m,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of u.keys)this.affectedKeys.add(S);for(const[,S]of u.overrides)for(const L of S)this.affectedKeys.add(L);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,d){const m=this.a+u,f=this.d.indexOf(m);if(f<0)return!1;const S=f+m.length;if(S>=this.d.length)return!1;const L=this.d.charCodeAt(S);if(L!==this.b&&L!==this.c)return!1;if(d){const v=this.previousConfiguration?this.previousConfiguration.getValue(u,d,this.f?.workspace):void 0,y=this.g.getValue(u,d,this.h);return!$.$yn(v,y)}return!0}}e.$7n=c;function h(s,u){const{added:d,removed:m,updated:f}=i(u?.rawConfiguration,s?.rawConfiguration),S=[],L=s?.getAllOverrideIdentifiers()||[],v=u?.getAllOverrideIdentifiers()||[];if(u){const y=v.filter(D=>!L.includes(D));for(const D of y)S.push([D,u.getKeysForOverrideIdentifier(D)])}if(s){const y=L.filter(D=>!v.includes(D));for(const D of y)S.push([D,s.getKeysForOverrideIdentifier(D)])}if(u&&s){for(const y of L)if(v.includes(y)){const D=i({contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});S.push([y,[...D.added,...D.removed,...D.updated]])}}return{added:d,removed:m,updated:f,overrides:S}}function i(s,u){const d=s?u?s.keys.filter(S=>u.keys.indexOf(S)===-1):[...s.keys]:[],m=u?s?u.keys.filter(S=>s.keys.indexOf(S)===-1):[...u.keys]:[],f=[];if(s&&u){for(const S of u.keys)if(s.keys.indexOf(S)!==-1){const L=(0,A.$Gi)(u.contents,S),v=(0,A.$Gi)(s.contents,S);$.$yn(L,v)||f.push(S)}}return{added:d,removed:m,updated:f}}}),define(Pe[100],Re([1,0,15,4]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.RemoteAuthorityResolverErrorCode=e.$9k=e.$8k=e.RemoteConnectionType=e.$7k=void 0,e.$7k=(0,T.$5h)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class M{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$8k=M;class R{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$9k=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class g extends E.$bb{static isNotAvailable(k){return k instanceof g&&k._code===$.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof g&&k._code===$.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof g&&k._code===$.NoResolverFound}static isInvalidAuthority(k){return k instanceof g&&k._code===$.InvalidAuthority}static isHandled(k){return k instanceof g&&k.isHandled}constructor(k,l=$.Unknown,p){super(k),this._message=k,this._code=l,this._detail=p,this.isHandled=l===$.NotAvailable&&p===!0,Object.setPrototypeOf(this,g.prototype)}}e.$0k=g;function b(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$$k=b}),define(Pe[55],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0;function T(b){return b.scheme===E.Schemas.vscodeRemote?b.authority:void 0}e.$_k=T;function I(b){if(!b)return;const A=b.indexOf("+");return A<0?b:b.substr(0,A)}e.$al=I;function M(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$bl=M;function R(b){const{host:A,port:k}=g(b);if(typeof k>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:k}}e.$cl=R;function $(b,A){let{host:k,port:l}=g(b);return typeof l>"u"&&(l=A),{host:k,port:l}}e.$dl=$;function g(b){const A=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=b.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=b.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:b,port:void 0}}}),define(Pe[22],Re([1,0,11,4,55]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.TargetPlatform=e.ExtensionType=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em="extensions.user.cache",e.$fm="extensions.builtin.cache",e.$gm="undefined_publisher",e.$hm=["ui","workspace","web"];function M(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$im=M,e.$jm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,t){if(typeof o>"u"||o===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof o=="string"||typeof t=="string"){const n=typeof o=="string"?o:o.value,a=typeof t=="string"?t:t.value;return E.$$e(n,a)}return o._lower===t._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$km=g;class b{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const t of o)this.add(t)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$lm=b;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,t){this.c.set(g.toKey(o),t)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$mm=A;function k(r){return l(r)}e.$nm=k;function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.$om=l;function p(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.$pm=p;function w(r,o){if(o){const t=`onResolveRemoteAuthority:${(0,I.$al)(o)}`;return!!r.activationEvents?.includes(t)}return!1}e.$qm=w,e.$rm=(0,T.$5h)("IBuiltinExtensionsScannerService")}),define(Pe[101],Re([1,0,15,22]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const g of R){const b=this.readActivationEvents(g);b.length>0&&($[T.$km.toKey(g.identifier)]=b)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let g=0;g<$.length;g++)$[g]==="onUri"&&($[g]=`onUri:${T.$km.toKey(R.identifier)}`);if(!R.contributes)return $;for(const g in R.contributes){const b=this.a.get(g);if(!b)continue;const A=R.contributes[g],k=Array.isArray(A)?A:[A];try{b(k,$)}catch(l){(0,E.$1)(l)}}return $}}e.$gF=I,e.$hF=new I}),define(Pe[190],Re([1,0,21,74,33]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=void 0;function M(g){if(E.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function R(g,b,A,k,l,p,w,r,o){const t=Object.create(null);t["common.machineId"]=p,t["common.sqmId"]=w,t.sessionID=(0,I.$pg)()+Date.now(),t.commitHash=k,t.version=l,t["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$dc,t["common.nodeArch"]=A,t["common.product"]=o||"desktop",r&&(t["common.msftInternal"]=r);let n=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=M(b);return c&&(t["common.platformDetail"]=c),t}e.$Ho=R;function $(g){const b=T.env.USERDNSDOMAIN;if(!b)return!1;const A=b.toLowerCase();return g.some(k=>A===k)}e.$Io=$}),define(Pe[191],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=void 0,e.$tl=(0,E.$5h)("telemetryService"),e.$ul=(0,E.$5h)("customEndpointTelemetryService"),e.$vl="telemetry.currentSessionDate",e.$wl="telemetry.firstSessionDate",e.$xl="telemetry.lastSessionDate",e.$yl="telemetry.machineId",e.$zl="telemetry.sqmId",e.$Al="telemetry",e.$Bl="telemetry.telemetryLevel",e.$Cl="telemetry.enableCrashReporter",e.$Dl="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var I;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Pe[56],Re([1,0,26,16,5,41,55,190,191]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;class b{constructor(m){this.value=m,this.isTrustedTelemetryValue=!0}}e.$Jo=b;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ko=A,e.$Lo=new A;class k{async publicLog(m,f,S){}async publicLogError(m,f,S){}}e.$Mo=k,e.$No="telemetry",e.$Oo="extensionTelemetryLog",e.$Po={log:()=>null,flush:()=>Promise.resolve(null)};function l(d,m){return I.Event.debounce(m.onDidChangeConfiguration,(S,L)=>{const v=S?new Set([...S.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:v}},1e3,!0)(S=>{S.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.$Bi)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$Qo=l;function p(d,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!d.enableTelemetry)}e.$Ro=p;function w(d,m){return m.extensionTestsLocationURI?!0:!(m.isBuilt||m.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$So=w;function r(d){const m=d.getValue(g.$Bl),f=d.getValue(g.$Cl);if(d.getValue(g.$Dl)===!1||f===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$To=r;function o(d){const m={},f={},S={};a(d,S);for(let L in S){L=L.length>150?L.substr(L.length-149):L;const v=S[L];typeof v=="number"?f[L]=v:typeof v=="boolean"?f[L]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${v.length}`),m[L]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(m[L]=v)}return{properties:m,measurements:f}}e.$Uo=o;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(d){if(!d)return"none";const m=(0,R.$al)(d);return t.has(m)?m:"other"}e.$Vo=n;function a(d,m,f=0,S){if(d)for(const L of Object.getOwnPropertyNames(d)){const v=d[L],y=S?S+L:L;Array.isArray(v)?m[y]=(0,E.$zn)(v):v instanceof Date?m[y]=v.toISOString():(0,T.$Jf)(v)?f<2?a(v,m,f+1,y+"."):m[y]=(0,E.$zn)(v):m[y]=v}}function c(d,m){const f=d.msftInternalDomains||[],S=m.getValue("telemetry.internalTesting");return(0,$.$Io)(f)||S}e.$Wo=c;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Xo=h;function i(d,m){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let f=d;const S=[];for(const D of m)for(;;){const N=D.exec(d);if(!N)break;S.push([N.index,D.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(f="";;){const D=v.exec(d);if(!D)break;const N=S.some(([O,H])=>D.index<H&&O<v.lastIndex);!L.test(D[0])&&!N&&(f+=d.substring(y,D.index)+"<REDACTED: user-file-path>",y=v.lastIndex)}return y<d.length&&(f+=d.substr(y)),f}function s(d){if(!d)return d;const m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of m)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return d}function u(d,m){return(0,E.$wn)(d,f=>{if(f instanceof b||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let S=f.replaceAll("%20"," ");S=i(S,m);for(const L of m)S=S.replace(L,"");return S=s(S),S}})}e.$Yo=u}),define(Pe[192],Re([1,0,11,97,22,21,2,15,74,56]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;function A(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,E.$6e)(u.id,d.id)===0}e.$Zo=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const m=d.manifest?d.manifest.version:d.version,f=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,m,f)}static parse(d){const m=k.exec(d);return m&&m[1]&&m[2]?new l({id:m[1]},m[2],m[4]||void 0):null}constructor(d,m,f="undefined"){this.version=m,this.targetPlatform=f,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?A(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$1o=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(u){const d=p.exec(u);return d&&d[1]?[o(d[1]),d[2]]:[o(u),void 0]}e.$2o=w;function r(u,d){return`${u}.${d}`}e.$3o=r;function o(u){return u.toLowerCase()}e.$4o=o;function t(u,d){return o(r(u??I.$gm,d))}e.$5o=t;function n(u,d){const m=[],f=S=>{for(const L of m)if(L.some(v=>A(d(v),d(S))))return L;return null};for(const S of u){const L=f(S);L?L.push(S):m.push([S])}return m}e.$6o=n;function a(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$7o=a;function c(u){return{id:new b.$Jo(u.identifier.id),name:new b.$Jo(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$8o=c,e.$9o=new I.$km("pprice.better-merge");function h(u,d){const m=[],f=d.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const S=f.shift();if(S&&m.every(L=>!A(L.identifier,{id:S}))){const L=u.filter(v=>A(v.identifier,{id:S}));L.length===1&&(m.push(L[0]),f.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.$0o=h;async function i(u,d){if(!M.$k)return!1;let m;try{m=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{m=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){d.debug("Error while getting the os-release file.",(0,$.$0)(S))}}return!!m&&(m.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(u,d){const m=await i(u,d),f=(0,T.$to)(m?"alpine":M.$u,g.$ec);return d.debug("ComputeTargetPlatform:",f),f}e.$$o=s}),define(Pe[193],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=e.$Lr=void 0;function E(g){return[...g.entries()]}e.$Lr=E;function T(g){return g?[...g.entries()]:[]}e.$Mr=T;function I(g){return new Map(g)}e.$Nr=I;function M(g){return new Map(g??[])}e.$Or=M;function R(g){return Array.from(g.entries()).map(b=>[b[0],E(b[1].map),T(b[1].descriptionMap)])}e.$Pr=R;function $(g){return new Map(g.map(b=>[b[0],{map:I(b[1]),descriptionMap:M(b[2])}]))}e.$Qr=$}),define(Pe[194],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erb=void 0;class E{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,M,R=5){const $=M(g=>{const b=typeof g=="string"?g:g.data;let A=this.a.get(I);if(A){A.data.push(b);return}const k=setTimeout(()=>this.flushBuffer(I),R);A={data:[b],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(I),$.dispose()}},this.a.set(I,A)});return $}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const M=this.a.get(I);M&&(this.a.delete(I),this.b(I,M.data.join("")))}}e.$Erb=E}),define(Pe[195],Re([1,0,13,90,45,5,16,2,155,73,30]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.IconFontDefinition=e.IconContribution=e.$vw=void 0,e.$vw={IconContribution:"base.contributions.icons"};var k;(function(c){function h(i,s){let u=i.defaults;for(;I.ThemeIcon.isThemeIcon(u);){const d=w.getIcon(u.id);if(!d)return;u=d.defaults}return u}c.getDefinition=h})(k||(e.IconContribution=k={}));var l;(function(c){function h(s){return{weight:s.weight,style:s.style,src:s.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=h;function i(s){const u=d=>(0,R.$Hf)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,R.$Hf)(d.format)&&(0,R.$Hf)(d.location)))return{weight:u(s.weight),style:u(s.style),src:s.src.map(d=>({format:d.format,location:$.URI.parse(d.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new M.$Ud,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,s,u){const d=this.b[h];if(d){if(s&&!d.description){d.description=s,this.d.properties[h].markdownDescription=`${s} $(${h})`;const S=this.e.enum.indexOf(h);S!==-1&&(this.e.enumDescriptions[S]=s),this.a.fire()}return d}const m={id:h,description:s,defaults:i,deprecationMessage:u};this.b[h]=m;const f={$ref:"#/definitions/icons"};return u&&(f.deprecationMessage=u),s&&(f.markdownDescription=`${s}: $(${h})`),this.d.properties[h]=f,this.e.enum.push(h),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const s=this.f[h];return s||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(d,m)=>d.id.localeCompare(m.id),i=d=>{for(;I.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(d=>this.b[d]);for(const d of u.filter(m=>!!m.description).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|${I.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of u.filter(m=>!I.ThemeIcon.isThemeIcon(m.defaults)).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|`);return s.join(`
`)}}const w=new p;A.$Gn.add(e.$vw.IconContribution,w);function r(c,h,i,s){return w.registerIcon(c,h,i,s)}e.$ww=r;function o(){return w}e.$xw=o;function t(){const c=(0,T.$9j)();for(const h in c){const i="\\"+c[h].toString(16);w.registerIcon(h,{fontCharacter:i})}}t(),e.$yw="vscode://schemas/icons";const n=A.$Gn.as(b.$Hn.JSONContribution);n.registerSchema(e.$yw,w.getIconSchema());const a=new E.$eh(()=>n.notifySchemaChanged(e.$yw),200);w.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$zw=r("widget-close",T.$$j.close,(0,g.localize)(2,null)),e.$Aw=r("goto-previous-location",T.$$j.arrowUp,(0,g.localize)(3,null)),e.$Bw=r("goto-next-location",T.$$j.arrowDown,(0,g.localize)(4,null)),e.$Cw=I.ThemeIcon.modify(T.$$j.sync,"spin"),e.$Dw=I.ThemeIcon.modify(T.$$j.loading,"spin")}),define(Pe[196],Re([1,0,5,41,4,14]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.ProvidedOnAutoForward=e.$Bv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Av=e.$zv=void 0,e.$zv=(0,I.$5h)("tunnelService"),e.$Av=(0,I.$5h)("sharedTunnelsService");var R;(function(o){o.Http="http",o.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})($||(e.TunnelPrivacyId=$={}));function g(o){return!!o.forwardPort}e.$Bv=g;var b;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}e.$Cv=A,e.$Dv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(o){return e.$Dv.indexOf(o)>=0}e.$Ev=k,e.$Fv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(o){return e.$Fv.indexOf(o)>=0}e.$Gv=l;function p(o,t,n,a){if(n===1)return!1;if(n===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(c?.length===4&&parseInt(c[1])>=18)return!1}return o<1024}e.$Hv=p;class w{constructor(t,n,a){this.remoteAddress=t,this.localAddress=n,this.b=a,this.a=new E.$Ud,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Iv=w;let r=class{constructor(t,n){this.k=t,this.l=n,this.a=new E.$Ud,this.onTunnelOpened=this.a.event,this.b=new E.$Ud,this.onTunnelClosed=this.b.event,this.c=new E.$Ud,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],n=Array.from(this.e.values());for(const a of n){const c=Array.from(a.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(a=>typeof a!="string"?a?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,a,c,h){this.q(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:a,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(l(t)||k(t))&&(t=e.$Dv[0]);const a=this.s(t,n);if(a)return++a.refcount,a.value}openTunnel(t,n,a,c,h,i=!1,s,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${a} on local port ${h}.`);const d=this.f??t;if(!d)return;if(n||(n="localhost"),c||(c=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.t(d,n,a,c,h,i,s,u);return m?m.then(f=>{if(f){if(typeof f=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,a),f}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(f);return(f.tunnelRemoteHost!==n||f.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&f.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const a=n.get(t.tunnelRemotePort);a&&(a.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,a))}}}}async p(t,n,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const c=a.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),c}}async closeTunnel(t,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const a=this.e.get(t);if(a&&a.has(n)){const c=a.get(n);c.refcount=0,await this.p(t,n,c)}}q(t,n,a){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:a})}async r(t,n){const a=this.e.get(t);if(a){const c=a.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&a.delete(n),a.size===0&&this.e.delete(t)}}s(t,n){const a=[t];k(t)?(a.push(...e.$Dv),a.push(...e.$Fv)):l(t)&&a.push(...e.$Fv);const c=a.map(h=>this.e.get(h));for(const h of c){const i=h?.get(n);if(i)return i}}canTunnel(t){return!!A(t)}u(t,n,a,c,h,i,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${a} on local port ${c}.`);const u=a;this.j.add(u);const d=c===void 0?a:c,m={elevationRequired:h?this.isPortPrivileged(d):!1},f={remoteAddress:{host:n,port:a},localAddressPort:c,privacy:i,public:i?i!==$.Private:void 0,protocol:s},S=t.forwardPort(f,m);return S?(this.q(n,a,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),S}};e.$Jv=r,e.$Jv=r=Je([He(0,M.$mj),He(1,T.$yi)],r)}),define(Pe[197],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Kv=void 0,e.$Kv=(0,E.$5h)("editSessionIdentityService");var T;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[198],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=void 0;function T(g){return g.scheme!==E.Schemas.file&&g.scheme!==E.Schemas.vscodeRemote}e.$BK=T;function I(g){if(g.folders.length)return g.folders.every(b=>T(b.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}e.$CK=I;function M(g){return I(g)?.scheme}e.$DK=M;function R(g){return I(g)?.authority}e.$EK=R;function $(g){return I(g)!==void 0}e.$FK=$}),define(Pe[47],Re([1,0,156,19,50,25,2,4,12]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.WorkbenchState=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=void 0,e.$bi=(0,$.$5h)("contextService");function b(d){const m=d;return typeof m?.id=="string"&&R.URI.isUri(m.uri)}e.$ci=b;function A(d){return typeof d?.id=="string"&&!b(d)&&!l(d)}e.$di=A,e.$ei={id:"ext-dev"},e.$fi={id:"empty-window"};function k(d,m){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,T.$nc)(d)}:m?e.$ei:e.$fi;const f=d;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$gi=k;function l(d){const m=d;return typeof m?.id=="string"&&R.URI.isUri(m.configPath)}e.$hi=l;function p(d){const m=d;if(m?.uri)return{id:m.id,uri:R.URI.revive(m.uri)};const f=d;if(f?.configPath)return{id:f.id,configPath:R.URI.revive(f.configPath)};if(d?.id)return{id:d.id}}e.$ii=p;var w;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function r(d){const m=d;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.$ji=r;function o(d){const m=d;return!!(m&&typeof m=="object"&&R.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.$ki=o;class t{constructor(m,f,S,L,v){this.h=m,this.j=S,this.k=L,this.l=v,this.c=I.$$h.forUris(this.l,()=>!0),this.folders=f}update(m){this.h=m.id,this.k=m.configuration,this.j=m.transient,this.l=m.l,this.folders=m.folders}get folders(){return this.g}set folders(m){this.g=m,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(m){this.k=m}getFolder(m){return m&&this.c.findSubstr(m)||null}n(){this.c=I.$$h.forUris(this.l,()=>!0);for(const m of this.folders)this.c.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$li=t;class n{constructor(m,f){this.raw=f,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.$Gg)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$mi=n;function a(d){return new n({uri:d,index:0,name:(0,M.$Cg)(d)},{uri:d.toString()})}e.$ni=a,e.$oi="code-workspace",e.$pi=`.${e.$oi}`,e.$qi=[{name:(0,E.localize)(0,null),extensions:[e.$oi]}],e.$ri="workspace.json";function c(d,m){return M.$xg.isEqualOrParent(d,m.untitledWorkspacesHome)}e.$si=c;function h(d){let m;return R.URI.isUri(d)?m=d:m=d.configuration,m?.scheme===g.Schemas.tmp}e.$ti=h,e.$ui="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(d){return d.id===e.$ui}e.$vi=i;function s(d,m){return!c(d,m)&&!h(d)}e.$wi=s;function u(d){return(typeof d=="string"?(0,T.$oc)(d):(0,M.$Eg)(d))===e.$pi}e.$xi=u}),define(Pe[75],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;class E{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const M=this.c++;return this.b.set(M,I),this.e(),M}get(I,M){return this.b.has(I)?this.b.get(I)[M]:void 0}delete(I){this.b.delete(I),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Rfc=E}),define(Pe[43],Re([1,0,12,25,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=e.$Ufc=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$vg($=>{const g=this.b.get($.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos($,g){g===null?this.b.delete($.scheme):this.b.set($.scheme,g)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Ufc=M,e.$Vfc=(0,I.$5h)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0,e.$mN=(0,E.$5h)("IExtHostInitDataService")}),define(Pe[199],Re([1,0,161,14,186,27]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;let R=class extends I.$tO{constructor(g,b,A){const k=A.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=A.remote.isRemote?(0,E.localize)(0,null):g?(0,E.localize)(1,null):(0,E.localize)(2,null);super(b.createLogger(k,{name:l}))}};e.$2hc=R,e.$2hc=R=Je([He(1,T.$nj),He(2,M.$mN)],R)}),define(Pe[200],Re([1,0,13]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=void 0;class T{constructor(R,$,g){this.h=new Map,this.a=R,this.b=$,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(b=>(this.f=b,this)),this.g=this.c.onDidChangeStorage(b=>{b.shared===this.b&&b.key===this.a&&(this.f=b.value)}),this.i=new E.$eh(()=>{const b=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of b.values())A.complete()}catch(A){for(const k of b.values())k.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let g=this.f[R];return typeof g>"u"&&(g=$),g}update(R,$){this.f[R]=$;const g=this.h.get(R);if(g!==void 0)return g.p;const b=new E.$ph;return this.h.set(R,b),this.i.isScheduled()||this.i.schedule(),b.p}dispose(){this.g.dispose()}}e.$Dgc=T;class I extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$Egc=I}),define(Pe[201],Re([1,0,5,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class I{constructor(R){this.c=R,this.a=new E.$Ud,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Ud,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,g,b){const k=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged($.value,g,b);this.b.fire(k)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire($.apiNotebook)}}e.$rhc=I}),define(Pe[17],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0,e.$9M=(0,E.$5h)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$0M=T}),define(Pe[202],Re([1,0,22,5]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;class I{#e;constructor(R,$){this.b=new T.$Ud,this.onDidChange=this.b.event,this.a=E.$km.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$Lgc=I}),define(Pe[57],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=void 0,e.$bgc=(0,E.$5h)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$cgc=T}),define(Pe[203],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kb=e.$9kb=void 0;class T{constructor(){this.buffers=[]}add(g){let b=this.buffers.indexOf(g);return b<0&&(b=this.buffers.length,this.buffers.push(g)),b}}function I($,g){if(g.serializeBuffersForPostMessage){const b=new T,k=JSON.stringify($,(p,w)=>{if(w instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(w)};if(ArrayBuffer.isView(w)){const r=M(w);if(r)return{$$vscode_array_buffer_reference$$:!0,index:b.add(w.buffer),view:{type:r,byteLength:w.byteLength,byteOffset:w.byteOffset}}}return w}),l=b.buffers.map(p=>{const w=new Uint8Array(p);return E.$ie.wrap(w)});return{message:k,buffers:l}}else return{message:JSON.stringify($),buffers:[]}}e.$9kb=I;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,g){const b=g.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),A=g.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const w=p,{index:r}=w,o=b[r];if(w.view)switch(w.view.type){case 1:return new Int8Array(o,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return p}:void 0;return{message:JSON.parse($,A),arrayBuffers:b}}e.$0kb=R}),define(Pe[102],Re([1,0,170,16,2,6,4,30,42,12,40,134,31]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=e.$2E=e.EditorsOrder=e.$1E=e.CloseDirection=e.$ZE=e.$YE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.EditorInputCapabilities=e.$PE=e.SaveReason=e.Verbosity=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=void 0,e.$CE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$DE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$EE="workbench.editor.sidebysideEditor",e.$FE="workbench.editors.textDiffEditor",e.$GE="workbench.editors.binaryResourceDiffEditor";var p;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var w;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function r(se){const x=se;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.$HE=r;function o(se,x,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===x&&se.matches(ne.input))return ne.getViewState()}e.$IE=o;function t(se){if(S(se))return!1;const x=se;return I.URI.isUri(x?.resource)}e.$JE=t;function n(se){if(S(se))return!1;const x=se;return x?.original!==void 0&&x.modified!==void 0}e.$KE=n;function a(se){if(S(se))return!1;const x=se;return!x||x.resources&&!Array.isArray(x.resources)?!1:!!x.resources||!!x.multiDiffSource}e.$LE=a;function c(se){if(S(se)||n(se))return!1;const x=se;return x?.primary!==void 0&&x.secondary!==void 0}e.$ME=c;function h(se){if(S(se))return!1;const x=se;return x?x.resource===void 0||x.resource.scheme===b.Schemas.untitled||x.forceUntitled===!0:!1}e.$NE=h;function i(se){if(S(se))return!1;const x=se;return I.URI.isUri(x?.base?.resource)&&I.URI.isUri(x?.input1?.resource)&&I.URI.isUri(x?.input2?.resource)&&I.URI.isUri(x?.result?.resource)}e.$OE=i;var s;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var u;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class d{constructor(){this.a=new Map}registerSource(x,V){let ne=this.a.get(x);return ne||(ne={source:x,label:V},this.a.set(x,ne)),ne.source}getSourceLabel(x){return this.a.get(x)?.label??x}}e.$PE=new d;var m;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(m||(e.EditorInputCapabilities=m={}));class f extends M.$Tc{}e.$QE=f;function S(se){return se instanceof f}e.$RE=S;function L(se){const x=se;return I.URI.isUri(x?.preferredResource)}function v(se){const x=se;return S(x?.primary)&&S(x?.secondary)}e.$SE=v;function y(se){const x=se;return S(x?.modified)&&S(x?.original)}e.$TE=y;function D(se,x,V,ne,Ie){return De(ne,[(0,k.$Oi)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Me={...V,limits:{size:Number.MAX_VALUE}};se.openEditor(x,Me)}}),(0,k.$Oi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$UE=D;function N(se){return S(se?.editor)}e.$VE=N;function O(se){const x=se;return N(se)&&x?.group!==void 0}e.$WE=O;function H(se){const x=se;return typeof x?.groupId=="number"&&S(x.editor)}e.$XE=H;var U;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var W;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(W||(e.GroupModelChangeKind=W={}));var P;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(P||(e.SideBySideEditor=P={}));class C{getOriginalUri(x,V){if(!x)return;if(i(x))return e.$ZE.getOriginalUri(x.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Me}=this.a(x);if(Ie&&Me){if(V?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Me,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===P.PRIMARY?Ie:Me}}if(n(x)||a(x)||c(x)||i(x))return;const ne=L(x)?x.preferredResource:x.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}a(x){return v(x)||c(x)?{primary:x.primary,secondary:x.secondary}:y(x)||n(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,V){if(!x)return;if(i(x))return e.$ZE.getCanonicalUri(x.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Me}=this.a(x);if(Ie&&Me){if(V?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Me,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===P.PRIMARY?Ie:Me}}if(n(x)||a(x)||c(x)||i(x))return;const ne=x.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}b(x,V){if(Array.isArray(V)){if(V.some(ne=>x.scheme===ne))return x}else if(V===x.scheme)return x}}var J;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(J||(e.EditorCloseMethod=J={}));function ae(se,x,V,ne){if(!se.isSticky(x))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===J.MOUSE||V===J.KEYBOARD;case"mouse":return V===J.MOUSE;case"keyboard":return V===J.KEYBOARD}return!1}e.$YE=ae,e.$ZE=new C;var fe;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(fe||(e.CloseDirection=fe={}));class we{constructor(){this.c=new Map,this.d=new Map}start(x){const V=this.a=x.get(R.$4h);for(const[ne,Ie]of this.c)this.e(ne,Ie,V);this.c.clear()}e(x,V,ne){const Ie=ne.createInstance(V);this.d.set(x,Ie)}registerFileEditorFactory(x){if(this.b)throw new Error("Can only register one file editor factory.");this.b=x}getFileEditorFactory(){return(0,T.$Sf)(this.b)}registerEditorSerializer(x,V){if(this.c.has(x)||this.d.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.a?this.e(x,V,this.a):this.c.set(x,V),(0,M.$Rc)(()=>{this.c.delete(x),this.d.delete(x)})}getEditorSerializer(x){return this.d.get(typeof x=="string"?x:x.typeId)}}$.$Gn.add(e.$CE.EditorFactory,new we);async function ye(se,x,V){return!se||!se.length?[]:await Promise.all(se.map(async ne=>{const Ie=I.URI.revive(ne.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await x.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let Ce=ne.exists,ce=ne.type;if(typeof Ce!="boolean"||typeof ce!="number")try{ce=(await x.stat(Ie)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Ce=!0}catch(Q){V.error(Q),Ce=!1}if(!Ce&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(ce===g.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return Ce?{resource:Ie,options:ie}:{resource:Ie,options:ie,forceUntitled:!0}}))}e.$1E=ye;var he;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ve(se){const x=se;if(!x)return!1;const V=x;if(V.modified)return ve(V.modified);const ne=x;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$2E=ve;function ee(se){return(0,A.$Qi)(se)}e.$3E=ee;function De(se,x,V){const ne=(0,A.$Ri)(se,x);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.$4E=De}),define(Pe[204],Re([1,0,5,171,4,6,28,30,18,26,90,195]),function(ge,e,E,T,I,M,R,$,g,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$$E=e.$0E=e.ViewContentGroups=e.$9E=e.$8E=e.ViewContainerLocation=e.Extensions=e.$7E=e.$6E=e.$5E=void 0,e.$5E="views",e.$6E=(0,T.localize)(0,null),e.$7E=(0,k.$ww)("default-view-icon",A.$$j.window,(0,T.localize)(1,null));var l;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$8E=[0,1,2];function w(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$9E=w;class r extends M.$Tc{constructor(){super(...arguments),this.c=this.B(new E.$Ud),this.onDidRegister=this.c.event,this.f=this.B(new E.$Ud),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(u,d,m){const f=this.get(u.id);if(f)return f;const S=u;return S.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$xc)(this.g,d,[]).push(S),m?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:d}),S}deregisterViewContainer(u){for(const d of this.g.keys()){const m=this.g.get(d),f=m?.indexOf(u);if(f!==-1){m?.splice(f,1),m.length===0&&this.g.delete(d),this.f.fire({viewContainer:u,viewContainerLocation:d});return}}}get(u){return this.all.filter(d=>d.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(d=>this.getViewContainerLocation(d)===u)}}$.$Gn.add(l.ViewContainersRegistry,new r);var o;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(o||(e.ViewContentGroups=o={}));function t(s,u){const d=s.group??o.More,m=u.group??o.More;return d!==m?d.localeCompare(m):(s.order??5)-(u.order??5)}class n extends M.$Tc{constructor(){super(...arguments),this.c=this.B(new E.$Ud),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Ud),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Ud),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Ud),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,d){this.registerViews2([{views:u,viewContainer:d}])}registerViews2(u){u.forEach(({views:d,viewContainer:m})=>this.r(d,m)),this.c.fire(u)}deregisterViews(u,d){const m=this.s(u,d);m.length&&this.f.fire({views:m,viewContainer:d})}moveViews(u,d){for(const m of this.m.keys())if(m!==d){const f=this.s(u,m);f.length&&(this.r(f,d),this.g.fire({views:f,from:m,to:d}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const d of this.j){const m=(this.m.get(d)||[]).filter(f=>f.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===u)[0])return d;return null}registerViewWelcomeContent(u,d){return this.n.add(u,d),this.h.fire(u),(0,M.$Rc)(()=>{this.n.delete(u,d),this.h.fire(u)})}registerViewWelcomeContent2(u,d){const m=new Map;for(const[f,S]of d)this.n.add(u,S),m.set(f,(0,M.$Rc)(()=>{this.n.delete(u,S),this.h.fire(u)}));return this.h.fire(u),m}getViewWelcomeContent(u){const d=[];return this.n.forEach(u,m=>d.push(m)),d.sort(t)}r(u,d){let m=this.m.get(d);m||(m=[],this.m.set(d,m),this.j.push(d));for(const f of u){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(2,null,f.id));m.push(f)}}s(u,d){const m=this.m.get(d);if(!m)return[];const f=[],S=[];for(const L of m)u.includes(L)?f.push(L):S.push(L);return f.length&&(S.length?this.m.set(d,S):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}$.$Gn.add(l.ViewsRegistry,new n),e.$0E=(0,I.$5h)("viewsService"),e.$$E=(0,I.$5h)("viewDescriptorService");var a;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var c;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,d){this.c=!1,this.d=!1,(0,b.$xn)(this,u),this.d=!!d,this.resolve=async m=>{if(d&&!this.c){const f=await d(m);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$_E=h;class i extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$aF=i}),define(Pe[205],Re([1,0,2,29,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$4F=e.$3F=void 0;function M(b){return!!b&&typeof b=="object"&&"uri"in b&&b.uri instanceof E.URI&&"version"in b&&typeof b.version=="number"&&"ranges"in b&&Array.isArray(b.ranges)&&b.ranges.every(T.$Ts.isIRange)}e.$3F=M;function R(b){return!!b&&typeof b=="object"&&"documents"in b&&Array.isArray(b.documents)&&b.documents.every(M)}e.$4F=R;var $;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var g;(function(b){b[b.Action=1]="Action",b[b.Toolbar=2]="Toolbar"})(g||(e.ChatAgentCopyKind=g={})),e.$5F=(0,I.$5h)("IChatService")}),define(Pe[206],Re([1,0,5,13,172]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Ud,this.n=new E.$Ud,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,g,b,A){const k={command:$};if(g&&Object.keys(g).length>0&&(k.arguments=g),this.s("request",k),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(k.seq);if(p){this.f.delete(k.seq);const w={type:"response",seq:0,request_seq:k.seq,success:!1,command:$,message:(0,I.localize)(0,null,A,$)};p(w)}},A)}return b&&this.f.set(k.seq,b),k.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,g){return $.type!=="event"||g.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$6g)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const g=$,b=this.f.get(g.request_seq);b&&(this.f.delete(g.request_seq),b(g));break}}}}s($,g){g.type=$,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((g,b)=>$.set(b,g)),await(0,T.$6g)(500),$.forEach((g,b)=>{g({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.f.delete(b)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Clb=M}),define(Pe[207],Re([1,0,173,35,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$NH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$MH=e.MemoryRangeType=e.$LH=e.State=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG="workbench.view.debug",e.$JG="workbench.debug.variablesView",e.$KG="workbench.debug.watchExpressionsView",e.$LG="workbench.debug.callStackView",e.$MG="workbench.debug.loadedScriptsView",e.$NG="workbench.debug.breakPointsView",e.$OG="workbench.debug.disassemblyView",e.$PG="workbench.panel.repl",e.$QG="workbench.panel.repl.view",e.$RG=new T.$jj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$SG=new T.$jj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$TG=new T.$jj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$UG="debugUx",e.$VG=new T.$jj(e.$UG,"default",{type:"string",description:E.localize(3,null)}),e.$WG=new T.$jj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$XG=new T.$jj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$YG=new T.$jj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$ZG=new T.$jj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$1G=new T.$jj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$2G=new T.$jj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$3G=new T.$jj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$4G=new T.$jj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$5G=new T.$jj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$6G=new T.$jj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$7G=new T.$jj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$8G=new T.$jj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$9G=new T.$jj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$0G=new T.$jj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$$G=new T.$jj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$_G=new T.$jj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$aH=new T.$jj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$bH=new T.$jj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$cH=new T.$jj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$dH=new T.$jj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$eH=new T.$jj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$fH=new T.$jj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$gH=new T.$jj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$hH=new T.$jj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$iH=new T.$jj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$jH=new T.$jj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$kH=new T.$jj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$lH=new T.$jj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$mH=new T.$jj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$nH=new T.$jj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$oH=new T.$jj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$pH=new T.$jj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$qH=new T.$jj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$rH=new T.$jj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$sH=new T.$jj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$tH=new T.$jj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$uH=new T.$jj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$vH=new T.$jj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$wH=new T.$jj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$xH=new T.$jj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$yH=new T.$jj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$zH=new T.$jj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$AH=new T.$jj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$BH=new T.$jj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$CH=new T.$jj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$DH=new T.$jj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$EH=new T.$jj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$FH=new T.$jj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=l=>E.localize(52,null,l);e.$GH=M,e.$HH="editor.contrib.debug",e.$IH="editor.contrib.breakpoint",e.$JH="debug",e.$KH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(R||(e.State=R={}));function $(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$LH=$;var g;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$MH="vscode-debug-memory";var b;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var A;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$NH=(0,I.$5h)("debugService");var k;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Pe[208],Re([1,0,11,2,19,26,12,29,20,18]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0;const A=/{([^}]+)}/g;function k(L,v,y){return L.replace(A,function(D,N){return v&&N.length>0&&N[0]!=="_"?D:y&&y.hasOwnProperty(N)?y[N]:D})}e.$0F=k;function l(L){const v={};for(const y of Object.keys(L))y.startsWith("!")||(v[y]=L[y]);return v}e.$$F=l;function p(L){return L.configuration.request==="attach"&&!w(L)&&(!L.parentSession||p(L.parentSession))}e.$_F=p;function w(L){let v=L.configuration.type;if(v)return v==="vslsShare"&&(v=L.configuration.adapterProxy.configuration.type),(0,E.$$e)(v,"extensionhost")||(0,E.$$e)(v,"pwa-extensionhost")?L:L.parentSession?w(L.parentSession):void 0}e.$aG=w;function r(L){return L.type&&(L.label||L.program||L.runtime)}e.$bG=r;function o(L,v,y){let D,N=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let H=null;for(;H=O.exec(L);){const U=H.index+1,W=U+H[0].length;if(U<=v&&W>=y){D=H[0],N=U;break}}if(D){const U=/\w+/g;let W=null;for(;(W=U.exec(D))&&!(W.index+1+N+W[0].length>=y););W&&(D=D.substring(0,U.lastIndex))}return D?{start:N,end:N+D.length-1}:{start:0,end:0}}e.$cG=o;async function t(L,v,y,D){if(L.evaluatableExpressionProvider.has(v)){const N=L.evaluatableExpressionProvider.ordered(v),O=(0,b.$Hb)(await Promise.all(N.map(async H=>{try{return await H.provideEvaluatableExpression(v,y,D??g.CancellationToken.None)}catch{return}})));if(O.length>0){let H=O[0].expression;const U=O[0].range;return H||(H=v.getLineContent(y.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:H}}}else{const N=v.getLineContent(y.lineNumber),{start:O,end:H}=o(N,y.column,y.column),U=N.substring(O-1,H);return{matchingExpression:U,range:new $.$Ts(y.lineNumber,O,y.lineNumber,O+U.length)}}return null}e.$dG=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(L){return!!(L&&L.match(n))}e.$eG=a;function c(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(a(L.path))return T.URI.parse(L.path);if((0,I.$ic)(L.path))return T.URI.file(L.path)}return L.path}function h(L){if(typeof L.path=="object"){const v=T.URI.revive(L.path);if(v)return v.scheme===R.Schemas.file?v.fsPath:v.toString()}return L.path}function i(L,v){const y=v?c:h,D=(0,M.$un)(L);return u(D,(N,O)=>{N&&O&&(O.path=y(O))}),D}e.$fG=i;function s(L,v){const y=v?c:h,D=(0,M.$un)(L);return u(D,(N,O)=>{!N&&O&&(O.path=y(O))}),D}e.$gG=s;function u(L,v){switch(L.type){case"event":{const y=L;switch(y.event){case"output":v(!1,y.body.source);break;case"loadedSource":v(!1,y.body.source);break;case"breakpoint":v(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=L;switch(y.command){case"setBreakpoints":v(!0,y.arguments.source);break;case"breakpointLocations":v(!0,y.arguments.source);break;case"source":v(!0,y.arguments.source);break;case"gotoTargets":v(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(D=>v(!1,D));break;default:break}break}case"response":{const y=L;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(D=>v(!1,D.source));break;case"loadedSources":y.body.sources.forEach(D=>v(!1,D));break;case"scopes":y.body.scopes.forEach(D=>v(!1,D.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(D=>v(!1,D.source));break;case"setBreakpoints":y.body.breakpoints.forEach(D=>v(!1,D.source));break;case"disassemble":y.body?.instructions.forEach(N=>v(!1,N.location));break;default:break}break}}}function d(L){return L.filter(v=>!v.presentation?.hidden).sort((v,y)=>v.presentation?y.presentation?v.presentation.group?y.presentation.group?v.presentation.group!==y.presentation.group?v.presentation.group.localeCompare(y.presentation.group):m(v.presentation.order,y.presentation.order):-1:y.presentation.group?1:m(v.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$hG=d;function m(L,v){return typeof L!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:L-v}async function f(L,v){const y=L.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(y!=="none"&&(await v.saveAll(),y==="allEditorsInActiveGroup")){const D=v.activeEditorPane;D&&D.input.resource?.scheme===R.Schemas.untitled&&await v.save({editor:D.input,groupId:D.group.id})}await L.reloadConfiguration()}e.$iG=f;const S=(L,v)=>!L||!v?L===v:L.name===v.name&&L.path===v.path&&L.sourceReference===v.sourceReference;e.$jG=S}),define(Pe[76],Re([1,0,24,34,67,68,12,19,21,35]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.$0I=e.$9I=e.$8I=e.CellStatusbarAlignment=e.$7I=e.$6I=e.$5I=e.NotebookEditorPriority=e.$4I=e.$3I=e.$2I=e.$1I=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$ZI=e.$YI=e.$XI=e.$WI=e.CellKind=e.$VI=e.$UI=e.$TI=void 0,e.$TI="workbench.editor.notebook",e.$UI="workbench.editor.notebookTextDiffEditor",e.$VI="workbench.editor.interactive";var A;(function(C){C[C.Markup=1]="Markup",C[C.Code=2]="Code"})(A||(e.CellKind=A={})),e.$WI=["application/json","application/javascript","text/html","image/svg+xml",M.$es.latex,M.$es.markdown,"image/png","image/jpeg",M.$es.text],e.$XI=[M.$es.latex,M.$es.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$es.text],e.$YI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$ZI="_notAvailable";var k;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var l;(function(C){C[C.Unconfirmed=1]="Unconfirmed",C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var p;(function(C){C[C.Unconfirmed=1]="Unconfirmed",C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var w;(function(C){C[C.WithHardKernelDependency=0]="WithHardKernelDependency",C[C.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",C[C.Pure=2]="Pure",C[C.Never=3]="Never"})(w||(e.NotebookRendererMatch=w={}));var r;(function(C){C.Always="always",C.Never="never",C.Optional="optional"})(r||(e.RendererMessagingSpec=r={}));var o;(function(C){C[C.ModelChange=1]="ModelChange",C[C.Move=2]="Move",C[C.ChangeCellLanguage=5]="ChangeCellLanguage",C[C.Initialize=6]="Initialize",C[C.ChangeCellMetadata=7]="ChangeCellMetadata",C[C.Output=8]="Output",C[C.OutputItem=9]="OutputItem",C[C.ChangeCellContent=10]="ChangeCellContent",C[C.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",C[C.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",C[C.ChangeCellMime=13]="ChangeCellMime",C[C.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var t;(function(C){C[C.Handle=0]="Handle",C[C.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(C){C[C.Replace=1]="Replace",C[C.Output=2]="Output",C[C.Metadata=3]="Metadata",C[C.CellLanguage=4]="CellLanguage",C[C.DocumentMetadata=5]="DocumentMetadata",C[C.Move=6]="Move",C[C.OutputItems=7]="OutputItems",C[C.PartialMetadata=8]="PartialMetadata",C[C.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var a;(function(C){C.scheme=R.Schemas.vscodeNotebookCell;const J=["W","X","Y","Z","a","b","c","d","e","f"],ae=new RegExp(`^[${J.join("")}]+`),fe=7;function we(se,x){const V=x.toString(fe),Ie=`${V.length<J.length?J[V.length-1]:"z"}${V}s${(0,E.$Ce)(E.$ie.fromString(se.scheme),!0,!0)}`;return se.with({scheme:C.scheme,fragment:Ie})}C.generate=we;function ye(se){if(se.scheme!==C.scheme)return;const x=se.fragment.indexOf("s");if(x<0)return;const V=parseInt(se.fragment.substring(0,x).replace(ae,""),fe),ne=(0,E.$Be)(se.fragment.substring(x+1)).toString();if(!isNaN(V))return{handle:V,notebook:se.with({scheme:ne,fragment:null})}}C.parse=ye;function he(se,x){return se.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${x??""},${se.scheme!==R.Schemas.file?se.scheme:""}`})}C.generateCellOutputUri=he;function ve(se){if(se.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const x=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!x)return;const V=x[1]&&x[1]!==""?x[1]:void 0,ne=x[2];return{outputId:V,notebook:se.with({scheme:ne||R.Schemas.file,fragment:null})}}C.parseCellOutputUri=ve;function ee(se,x,V){return C.generate(se,x).with({scheme:V})}C.generateCellPropertyUri=ee;function De(se,x){if(se.scheme===x)return C.parse(se.with({scheme:C.scheme}))}C.parseCellPropertyUri=De})(a||(e.CellUri=a={}));const c=C=>g.$i?C.replace(/\//g,"\\"):C;class h{constructor(J=[],ae=e.$WI){this.e=ae,this.d=[...new Set(J)].map(fe=>({pattern:fe,matches:T.$Lj(c(fe))}))}sort(J){const ae=new Map(I.Iterable.map(J,we=>[we,c(we)]));let fe=[];for(const{matches:we}of this.d)for(const[ye,he]of ae)if(we(he)){fe.push(ye),ae.delete(ye);break}return ae.size&&(fe=fe.concat([...ae.keys()].sort((we,ye)=>this.e.indexOf(we)-this.e.indexOf(ye)))),fe}prioritize(J,ae){const fe=this.f(J);if(fe===-1){this.d.unshift({pattern:J,matches:T.$Lj(c(J))});return}const we=new Set(ae.map(he=>this.f(he,fe)));we.delete(-1);const ye=Array.from(we).sort();this.d.splice(fe+1,0,...ye.map(he=>this.d[he]));for(let he=ye.length-1;he>=0;he--)this.d.splice(ye[he],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,ae=this.d.length){const fe=c(J);for(let we=0;we<ae;we++)if(this.d[we].matches(fe))return we;return-1}}e.$1I=h;function i(C,J,ae,fe=(we,ye)=>we===ye){const we=[];function ye(ee,De,se){if(De===0&&se.length===0)return;const x=we[we.length-1];x&&x.start+x.deleteCount===ee?(x.deleteCount+=De,x.toInsert.push(...se)):we.push({start:ee,deleteCount:De,toInsert:se})}let he=0,ve=0;for(;;){if(he===C.length){ye(he,0,J.slice(ve));break}if(ve===J.length){ye(he,C.length-he,[]);break}const ee=C[he],De=J[ve];if(fe(ee,De)){he+=1,ve+=1;continue}ae(De)?(ye(he,1,[]),he+=1):(ye(he,0,[De]),ve+=1)}return we}e.$2I=i,e.$3I=new b.$jj("notebookEditorCursorAtBoundary","none"),e.$4I=new b.$jj("notebookEditorCursorAtLineBoundary","none");var s;(function(C){C.default="default",C.option="option"})(s||(e.NotebookEditorPriority=s={}));function u(C){const J=C;return!!((typeof J.include=="string"||T.$Mj(J.include))&&(typeof J.exclude=="string"||T.$Mj(J.exclude)))}e.$5I=u;function d(C,J,ae){if(Array.isArray(C.viewType)&&C.viewType.indexOf(J)>=0||C.viewType===J)return!0;if(C.filenamePattern){const fe=u(C.filenamePattern)?C.filenamePattern.include:C.filenamePattern,we=u(C.filenamePattern)?C.filenamePattern.exclude:void 0;if(T.$Kj(fe,(0,$.$nc)(ae.fsPath).toLowerCase()))return!(we&&T.$Kj(we,(0,$.$nc)(ae.fsPath).toLowerCase()))}return!1}e.$6I=d,e.$7I={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var m;(function(C){C[C.Left=1]="Left",C[C.Right=2]="Right"})(m||(e.CellStatusbarAlignment=m={}));class f{static{this.d="notebook/"}static create(J){return`${f.d}${J}`}static parse(J){if(J.startsWith(f.d))return J.substring(f.d.length)}}e.$8I=f;function S(C){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(C)}e.$9I=S;const L=new TextDecoder;function v(C){const J=[];let ae=!1;for(const he of C)(J.length===0||ae)&&(J.push(he),ae=!0);let fe=N(J);const we=E.$ie.concat(J.map(he=>E.$ie.wrap(he))),ye=P(we);return fe=fe||ye.byteLength!==we.byteLength,{data:ye,didCompression:fe}}e.$0I=v,e.$$I=`${String.fromCharCode(27)}[A`;const y=e.$$I.split("").map(C=>C.charCodeAt(0)),D=10;function N(C){let J=!1;return C.forEach((ae,fe)=>{if(fe===0||ae.length<e.$$I.length)return;const we=C[fe-1],ye=ae.subarray(0,e.$$I.length);if(ye[0]===y[0]&&ye[1]===y[1]&&ye[2]===y[2]){const he=we.lastIndexOf(D);if(he===-1)return;J=!0,C[fe-1]=we.subarray(0,he),C[fe]=ae.subarray(e.$$I.length)}}),J}function O(C){let J=C;do C=J,J=C.replace(/[^\n]\x08/gm,"");while(J.length<C.length);return C}function H(C){for(C=C.replace(/\r+\n/gm,`
`);C.search(/\r[^$]/g)>-1;){const J=C.match(/^(.*)\r+/m)[1];let ae=C.match(/\r+(.*)$/m)[1];ae=ae+J.slice(ae.length,J.length),C=C.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return C}const U="\b".charCodeAt(0),W="\r".charCodeAt(0);function P(C){return!C.buffer.includes(U)&&!C.buffer.includes(W)?C:E.$ie.fromString(H(O(L.decode(C.buffer))))}}),define(Pe[7],Re([1,0,18,15,52,28,68,11,16,2,33,22,42,100,76]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w){"use strict";var r,o,t,n,a,c,h,i,s,u,d,m,f,S,L,v,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$XM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$WM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.TestRunProfileKind=e.TestResultState=e.$CM=e.$BM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$AM=e.NotebookVariablesRequestKind=e.$zM=e.$yM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$xM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.ColorThemeKind=e.$rM=e.$qM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$pM=e.DebugConsoleMode=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$jM=e.$iM=e.FileChangeType=e.$hM=e.$gM=e.$fM=e.$eM=e.InlineCompletionTriggerKind=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.ConfigurationTarget=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$TL=e.ViewBadge=e.ProgressLocation=e.$SL=e.$RL=e.TaskScope=e.ShellQuoting=e.$QL=e.$PL=e.$OL=e.TaskPanelKind=e.TaskRevealKind=e.$NL=e.TerminalLocation=e.$ML=e.$LL=e.$KL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$JL=e.$IL=e.$HL=e.$GL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$FL=e.StatusBarAlignment=e.ViewColumn=e.$EL=e.$DL=e.$CL=e.$BL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$AL=e.$zL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.LanguageStatusSeverity=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.CodeActionTriggerKind=e.$nL=e.$mL=e.SymbolTag=e.SymbolKind=e.$lL=e.$kL=e.DocumentHighlightKind=e.$jL=e.$iL=e.$hL=e.$gL=e.DiagnosticSeverity=e.DiagnosticTag=e.$fL=e.$eL=e.FileEditType=e.$dL=e.$cL=e.$bL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(B){return Object.assign(B,{apply:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const ke=oe.length===1?[]:oe[1];return Reflect.construct(B,ke,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const[ke,...Ge]=oe;return Reflect.construct(B,Ge,ke.constructor)}}})}var N;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let H=r=class{static from(...j){let oe=j;return new r(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$7K=H,e.$7K=H=r=Je([D],H);let U=o=class{static Min(...j){if(j.length===0)throw new TypeError;let oe=j[0];for(let ke=1;ke<j.length;ke++){const Ge=j[ke];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...j){if(j.length===0)throw new TypeError;let oe=j[0];for(let ke=1;ke<j.length;ke++){const Ge=j[ke];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(j){if(!j)return!1;if(j instanceof o)return!0;const{line:oe,character:ke}=j;return typeof oe=="number"&&typeof ke=="number"}static of(j){if(j instanceof o)return j;if(this.isPosition(j))return new o(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,oe){if(j<0)throw(0,T.$7)("line must be non-negative");if(oe<0)throw(0,T.$7)("character must be non-negative");this.c=j,this.e=oe}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,oe=0){if(j===null||oe===null)throw(0,T.$7)();let ke;return typeof j>"u"?ke=0:typeof j=="number"?ke=j:(ke=typeof j.lineDelta=="number"?j.lineDelta:0,oe=typeof j.characterDelta=="number"?j.characterDelta:0),ke===0&&oe===0?this:new o(this.line+ke,this.character+oe)}with(j,oe=this.character){if(j===null||oe===null)throw(0,T.$7)();let ke;return typeof j>"u"?ke=this.line:typeof j=="number"?ke=j:(ke=typeof j.line=="number"?j.line:this.line,oe=typeof j.character=="number"?j.character:this.character),ke===this.line&&oe===this.character?this:new o(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$8K=U,e.$8K=U=o=Je([D],U);let W=t=class{static isRange(j){return j instanceof t?!0:j?U.isPosition(j.start)&&U.isPosition(j.end):!1}static of(j){if(j instanceof t)return j;if(this.isRange(j))return new t(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,oe,ke,Ge){let xe,ut;if(typeof j=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"?(xe=new U(j,oe),ut=new U(ke,Ge)):U.isPosition(j)&&U.isPosition(oe)&&(xe=U.of(j),ut=U.of(oe)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(j){return t.isRange(j)?this.contains(j.start)&&this.contains(j.end):U.isPosition(j)?!(U.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const oe=U.Max(j.start,this.c),ke=U.Min(j.end,this.e);if(!oe.isAfter(ke))return new t(oe,ke)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const oe=U.Min(j.start,this.c),ke=U.Max(j.end,this.end);return new t(oe,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,oe=this.end){if(j===null||oe===null)throw(0,T.$7)();let ke;return j?U.isPosition(j)?ke=j:(ke=j.start||this.start,oe=j.end||this.end):ke=this.start,ke.isEqual(this.c)&&oe.isEqual(this.end)?this:new t(ke,oe)}toJSON(){return[this.start,this.end]}};e.$9K=W,e.$9K=W=t=Je([D],W);let P=n=class extends W{static isSelection(j){return j instanceof n?!0:j?W.isRange(j)&&U.isPosition(j.anchor)&&U.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,oe,ke,Ge){let xe,ut;if(typeof j=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"?(xe=new U(j,oe),ut=new U(ke,Ge)):U.isPosition(j)&&U.isPosition(oe)&&(xe=U.of(j),ut=U.of(oe)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$0K=P,e.$0K=P=n=Je([D],P);const C=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,T.$7)("connectionToken")};class J{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,oe,ke){if(typeof j!="string"||j.length===0)throw(0,T.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,T.$7)("port");typeof ke<"u"&&C(ke),this.host=j,this.port=Math.round(oe),this.connectionToken=ke}}e.$$K=J;class ae{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,oe){this.makeConnection=j,this.connectionToken=oe,typeof oe<"u"&&C(oe)}}e.$_K=ae;class fe extends Error{static NotAvailable(j,oe){return new fe(j,p.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(j){return new fe(j,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,oe=p.RemoteAuthorityResolverErrorCode.Unknown,ke){super(j),this._message=j,this._code=oe,this._detail=ke,Object.setPrototypeOf(this,fe.prototype)}}e.$aL=fe;var we;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var ye;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ye||(e.EnvironmentVariableMutatorType=ye={}));let he=a=class{static isTextEdit(j){return j instanceof a?!0:j?W.isRange(j)&&typeof j.newText=="string":!1}static replace(j,oe){return new a(j,oe)}static insert(j,oe){return a.replace(new W(j,j),oe)}static delete(j){return a.replace(j,"")}static setEndOfLine(j){const oe=new a(new W(new U(0,0),new U(0,0)),"");return oe.newEol=j,oe}get range(){return this.c}set range(j){if(j&&!W.isRange(j))throw(0,T.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,T.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,T.$7)("newEol");this.f=j}constructor(j,oe){this.c=j,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$bL=he,e.$bL=he=a=Je([D],he);let ve=c=class{static isNotebookCellEdit(j){return j instanceof c?!0:j?ei.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,oe){return new c(j,oe)}static insertCells(j,oe){return new c(new ei(j,j),oe)}static deleteCells(j){return new c(j,[])}static updateCellMetadata(j,oe){const ke=new c(new ei(j,j),[]);return ke.newCellMetadata=oe,ke}static updateNotebookMetadata(j){const oe=new c(new ei(0,0),[]);return oe.newNotebookMetadata=j,oe}constructor(j,oe){this.range=j,this.newCells=oe}};e.$cL=ve,e.$cL=ve=c=Je([D],ve);class ee{static isSnippetTextEdit(j){return j instanceof ee?!0:j?W.isRange(j.range)&&x.isSnippetString(j.snippet):!1}static replace(j,oe){return new ee(j,oe)}static insert(j,oe){return ee.replace(new W(j,j),oe)}constructor(j,oe){this.range=j,this.snippet=oe}}e.$dL=ee;var De;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(De||(e.FileEditType=De={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,oe,ke,Ge){this.c.push({_type:1,from:j,to:oe,options:ke,metadata:Ge})}createFile(j,oe,ke){this.c.push({_type:1,from:void 0,to:j,options:oe,metadata:ke})}deleteFile(j,oe,ke){this.c.push({_type:1,from:j,to:void 0,options:oe,metadata:ke})}e(j,oe,ke){this.c.push({_type:3,metadata:ke,uri:j,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(j,oe,ke,Ge){const xe=oe.start,ut=oe.end;(xe!==ut||ke.length>0)&&this.c.push({_type:5,uri:j,index:xe,count:ut-xe,cells:ke,metadata:Ge})}g(j,oe,ke,Ge){this.c.push({_type:3,metadata:Ge,uri:j,edit:{editType:3,index:oe,metadata:ke}})}replace(j,oe,ke,Ge){this.c.push({_type:2,uri:j,edit:new he(oe,ke),metadata:Ge})}insert(j,oe,ke,Ge){this.replace(j,new W(oe,oe),ke,Ge)}delete(j,oe,ke){this.replace(j,oe,"",ke)}has(j){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===j.toString())}set(j,oe){if(oe)for(const ke of oe){if(!ke)continue;let Ge,xe;Array.isArray(ke)?(Ge=ke[0],xe=ke[1]):Ge=ke,ve.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(j,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(j,Ge.newNotebookMetadata,xe):this.f(j,Ge.range,Ge.newCells,xe):ee.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:j,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:j,edit:Ge,metadata:xe})}else{for(let ke=0;ke<this.c.length;ke++){const Ge=this.c[ke];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===j.toString()&&(this.c[ke]=void 0);break}}(0,E.$Ib)(this.c)}}get(j){const oe=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===j.toString()&&oe.push(ke.edit);return oe}entries(){const j=new M.$Ac;for(const oe of this.c)if(oe._type===2){let ke=j.get(oe.uri);ke||(ke=[oe.uri,[]],j.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$eL=se,e.$eL=se=Je([D],se);let x=h=class{static isSnippetString(j){return j instanceof h?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=h.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,oe=this.e++){if(typeof j=="function"){const ke=new h;ke.e=this.e,j(ke),this.e=ke.e,j=ke.value}else j=h.c(j);return this.value+="${",this.value+=oe,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,oe=this.e++){const ke=j.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(j,oe){if(typeof oe=="function"){const ke=new h;ke.e=this.e,oe(ke),this.e=ke.e,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$fL=x,e.$fL=x=h=Je([D],x);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ie=i=class{static isLocation(j){return j instanceof i?!0:j?W.isRange(j.range)&&b.URI.isUri(j.uri):!1}constructor(j,oe){if(this.uri=j,oe)if(W.isRange(oe))this.range=W.of(oe);else if(U.isPosition(oe))this.range=new W(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$gL=Ie,e.$gL=Ie=i=Je([D],Ie);let Me=class{static is(j){return j?typeof j.message=="string"&&j.location&&W.isRange(j.location.range)&&b.URI.isUri(j.location.uri):!1}constructor(j,oe){this.location=j,this.message=oe}static isEqual(j,oe){return j===oe?!0:!j||!oe?!1:j.message===oe.message&&j.location.range.isEqual(oe.location.range)&&j.location.uri.toString()===oe.location.uri.toString()}};e.$hL=Me,e.$hL=Me=Je([D],Me);let Ce=class{constructor(j,oe,ke=ne.Error){if(!W.isRange(j))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=j,this.message=oe,this.severity=ke}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,oe){return j===oe?!0:!j||!oe?!1:j.message===oe.message&&j.severity===oe.severity&&j.code===oe.code&&j.severity===oe.severity&&j.source===oe.source&&j.range.isEqual(oe.range)&&(0,E.$ub)(j.tags,oe.tags)&&(0,E.$ub)(j.relatedInformation,oe.relatedInformation,Me.isEqual)}};e.$iL=Ce,e.$iL=Ce=Je([D],Ce);let ce=class{constructor(j,oe){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=oe}};e.$jL=ce,e.$jL=ce=Je([D],ce);var ie;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let Q=class{constructor(j,oe=ie.Text){this.range=j,this.kind=oe}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$kL=Q,e.$kL=Q=Je([D],Q);let te=class{constructor(j,oe){this.uri=j,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$lL=te,e.$lL=te=Je([D],te);var me;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var pe;(function(B){B[B.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Ae=s=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,oe,ke,Ge,xe){this.name=j,this.kind=oe,this.containerName=xe,typeof ke=="string"&&(this.containerName=ke),Ge instanceof Ie?this.location=Ge:ke instanceof W&&(this.location=new Ie(Ge,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$mL=Ae,e.$mL=Ae=s=Je([D],Ae);let le=u=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(u.validate)}constructor(j,oe,ke,Ge,xe){this.name=j,this.detail=oe,this.kind=ke,this.range=Ge,this.selectionRange=xe,this.children=[],u.validate(this)}};e.$nL=le,e.$nL=le=u=Je([D],le);var be;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(be||(e.CodeActionTriggerKind=be={}));let F=class{constructor(j,oe){this.title=j,this.kind=oe}};e.$oL=F,e.$oL=F=Je([D],F);let q=class{static{d=this}static{this.c="."}constructor(j){this.value=j}append(j){return new d(this.value?this.value+d.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+d.c)}};e.$pL=q,e.$pL=q=d=Je([D],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let K=class{constructor(j,oe){if(this.range=j,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$qL=K,e.$qL=K=Je([D],K);class z{constructor(j,oe,ke,Ge,xe,ut){this.kind=j,this.name=oe,this.detail=ke,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$rL=z;class X{constructor(j,oe){this.fromRanges=oe,this.from=j}}e.$sL=X;class Y{constructor(j,oe){this.fromRanges=oe,this.to=j}}e.$tL=Y;var Ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ee||(e.LanguageStatusSeverity=Ee={}));let Te=class{constructor(j,oe){this.range=j,this.command=oe}get isResolved(){return!!this.command}};e.$uL=Te,e.$uL=Te=Je([D],Te);let We=m=class{#e;static isMarkdownString(j){return j instanceof m?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,oe=!1){this.#e=new I.$gk(j,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,oe){return this.#e.appendCodeblock(oe??"",j),this}};e.$vL=We,e.$vL=We=m=Je([D],We);let Ke=class{constructor(j,oe){this.label=j,this.documentation=oe}};e.$wL=Ke,e.$wL=Ke=Je([D],Ke);let Ze=class{constructor(j,oe){this.label=j,this.documentation=oe,this.parameters=[]}};e.$xL=Ze,e.$xL=Ze=Je([D],Ze);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$yL=st,e.$yL=st=Je([D],st);var nt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let at=class{constructor(j){this.value=j}};e.$zL=at,e.$zL=at=Je([D],at);let ct=class{constructor(j,oe,ke){this.position=j,this.label=oe,this.kind=ke}};e.$AL=ct,e.$AL=ct=Je([D],ct);var je;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var vt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var Z;(function(B){B[B.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let _=class{constructor(j,oe){this.label=j,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$BL=_,e.$BL=_=Je([D],_);let $e=class{constructor(j=[],oe=!1){this.items=j,this.isIncomplete=oe}};e.$CL=$e,e.$CL=$e=Je([D],$e);let Be=class{constructor(j,oe,ke){this.insertText=j,this.range=oe,this.command=ke}};e.$DL=Be,e.$DL=Be=Je([D],Be);let Qe=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$EL=Qe,e.$EL=Qe=Je([D],Qe);var it;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var rt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function Ne(B,j){return`${k.$km.toKey(B)}.${j}`}e.$FL=Ne;var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Tt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Kt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var Bt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var yt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var Ht;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(B){function j(oe){switch(oe){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=j}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Nt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Nt||(e.SyntaxTokenType=Nt={})),function(B){function j(oe){switch(oe){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=j}(Nt||(e.SyntaxTokenType=Nt={}));let Xt=class{constructor(j,oe){if(oe&&!b.URI.isUri(oe))throw(0,T.$7)("target");if(!W.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.target=oe}};e.$GL=Xt,e.$GL=Xt=Je([D],Xt);let Ut=class{constructor(j,oe,ke,Ge){this.red=j,this.green=oe,this.blue=ke,this.alpha=Ge}};e.$HL=Ut,e.$HL=Ut=Je([D],Ut);let Rt=class{constructor(j,oe){if(oe&&!(oe instanceof Ut))throw(0,T.$7)("color");if(!W.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.color=oe}};e.$IL=Rt,e.$IL=Rt=Je([D],Rt);let Ye=class{constructor(j){if(!j||typeof j!="string")throw(0,T.$7)("label");this.label=j}};e.$JL=Ye,e.$JL=Ye=Je([D],Ye);var Gt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var lt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class $t{constructor(j,oe,ke){if(this.startIndex=j,this.length=oe,this.tooltip=ke,typeof j!="number"||j<0)throw(0,T.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,T.$7)("length");if(ke!==void 0&&typeof ke!="string")throw(0,T.$7)("tooltip")}}e.$KL=$t;class jt{constructor(j){this.uri=j}}e.$LL=jt;class Wt{constructor(j){this.terminalCommand=j}}e.$ML=Wt;var Dt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class dt{constructor(j){if(this.options=j,typeof j!="object")throw(0,T.$7)("options")}}e.$NL=dt;var Ct;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var xt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let kt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(j){switch(j){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(j,oe){if(this.label=oe,typeof j!="string"||typeof oe!="string")throw(0,T.$7)("name");this.c=j}get id(){return this.c}};e.$OL=kt,e.$OL=kt=f=Je([D],kt);function qe(B){let j="";for(let oe=0;oe<B.length;oe++)j+=B[oe].replace(/,/g,",,")+",";return j}let Mt=class{constructor(j,oe,ke){if(typeof j!="string")throw(0,T.$7)("process");this.e=[],this.c=j,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=ke):this.f=oe)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,T.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)j.push(oe);return qe(j)}};e.$PL=Mt,e.$PL=Mt=Je([D],Mt);let Vt=class{constructor(j,oe,ke){if(this.f=[],Array.isArray(oe)){if(!j)throw(0,T.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j,this.f=oe,this.g=ke}else{if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j,this.g=oe}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)j.push(typeof oe=="string"?oe:oe.value);return qe(j)}};e.$QL=Vt,e.$QL=Vt=Je([D],Vt);var Qt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Ft{constructor(j){this.c=j}computeId(){return"customExecution"+(0,A.$pg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$RL=Ft;let Se=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,oe,ke,Ge,xe,ut){this.k=!1,this.l=this.definition=j;let gt;typeof oe=="string"?(this.n=this.name=oe,this.u=this.source=ke,this.execution=Ge,gt=xe,this.k=!0):oe===ft.Global||oe===ft.Workspace?(this.target=oe,this.n=this.name=ke,this.u=this.source=Ge,this.execution=xe,gt=ut):(this.target=oe,this.n=this.name=ke,this.u=this.source=Ge,this.execution=xe,gt=ut),typeof gt=="string"?(this.q=[gt],this.r=!0):Array.isArray(gt)?(this.q=gt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Mt?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Vt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Ft?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,A.$pg)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=j}get scope(){return this.m}set target(j){this.A(),this.m=j}get name(){return this.n}set name(j){if(typeof j!="string")throw(0,T.$7)("name");this.A(),this.n=j}get execution(){return this.o}set execution(j){j===null&&(j=void 0),this.A(),this.o=j;const oe=this.l.type;(S.g===oe||S.e===oe||S.f===oe||S.c===oe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(j){if(Array.isArray(j))this.A(),this.q=j,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.A(),this.t=j}get source(){return this.u}set source(j){if(typeof j!="string"||j.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=j}get group(){return this.w}set group(j){j===null&&(j=void 0),this.A(),this.w=j}get detail(){return this.z}set detail(j){j===null&&(j=void 0),this.z=j}get presentationOptions(){return this.x}set presentationOptions(j){j==null&&(j=Object.create(null)),this.A(),this.x=j}get runOptions(){return this.y}set runOptions(j){j==null&&(j=Object.create(null)),this.A(),this.y=j}};e.$SL=Se,e.$SL=Se=S=Je([D],Se);var Fe;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var de;(function(B){function j(oe){const ke=oe;return(0,g.$Lf)(ke.value)?ke.tooltip&&!(0,g.$Hf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}B.isViewBadge=j})(de||(e.ViewBadge=de={}));let G=L=class{static isTreeItem(j,oe){const ke=j;if(ke.checkboxState!==void 0){const Ge=(0,g.$Lf)(ke.checkboxState)?ke.checkboxState:(0,g.$Jf)(ke.checkboxState)&&(0,g.$Lf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,xe=!(0,g.$Lf)(ke.checkboxState)&&(0,g.$Jf)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==ze.Checked&&Ge!==ze.Unchecked||xe!==void 0&&!(0,g.$Hf)(xe))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(j instanceof L)return!0;if(ke.label!==void 0&&!(0,g.$Hf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,g.$Hf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,g.$Hf)(ke.iconPath)&&!b.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,g.$Hf)(ke.iconPath.id))){const Ge=ke.iconPath;if(!Ge||!(0,g.$Hf)(Ge.light)&&!b.URI.isUri(Ge.light)&&!(0,g.$Hf)(Ge.dark)&&!b.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,g.$Hf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!b.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,g.$Hf)(ke.tooltip)&&!(ke.tooltip instanceof We)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Le.None&&ke.collapsibleState>Le.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,g.$Hf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(j,oe=Le.None){this.collapsibleState=oe,b.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$TL=G,e.$TL=G=L=Je([D],G);var Le;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Le||(e.TreeItemCollapsibleState=Le={}));var ze;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(ze||(e.TreeItemCheckboxState=ze={}));let Xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$UL=Xe,e.$UL=Xe=Je([D],Xe);class Ve extends Xe{}e.$VL=Ve;class _e extends Ve{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$WL=_e;class mt{constructor(j,oe,ke,Ge){this.name=j,this.uri=oe,this._itemId=ke,this.c=Ge}data(){return this.c()}}e.$XL=mt;let zt=class{#e=new Map;constructor(j){for(const[oe,ke]of j??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(ke):this.#e.set(this.#t(oe),[ke])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,oe){this.#e.set(this.#t(j),[oe])}forEach(j,oe){for(const[ke,Ge]of this.#e)for(const xe of Ge)j.call(oe,xe,ke,this)}*[Symbol.iterator](){for(const[j,oe]of this.#e)for(const ke of oe)yield[j,ke]}#t(j){return j.toLowerCase()}};e.$YL=zt,e.$YL=zt=Je([D],zt);let Et=class{constructor(j){this.insertText=j}};e.$ZL=Et,e.$ZL=Et=Je([D],Et);let St=class{constructor(j,oe){this.label=oe,this.insertText=j}};e.$1L=St,e.$1L=St=Je([D],St);let bt=class{constructor(j,oe){this.id=j,this.color=oe}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$2L=bt,e.$2L=bt=Je([D],bt),bt.File=new bt("file"),bt.Folder=new bt("folder");let gi=class{constructor(j){this.id=j}};e.$3L=gi,e.$3L=gi=Je([D],gi);var At;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Si=class{get base(){return this.c}set base(j){this.c=j,this.e=b.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,oe){if(typeof j!="string"&&(!j||!b.URI.isUri(j)&&!b.URI.isUri(j.uri)))throw(0,T.$7)("base");if(typeof oe!="string")throw(0,T.$7)("pattern");typeof j=="string"?this.baseUri=b.URI.file(j):b.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$4L=Si,e.$4L=Si=Je([D],Si);const Gi=new WeakMap;function It(B,j){Gi.set(B,j)}e.$5L=It;let ri=class{constructor(j,oe,ke,Ge){this.enabled=typeof j=="boolean"?j:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Gi.get(this)??(0,A.$pg)()),this.c}};e.$6L=ri,e.$6L=ri=Je([D],ri);let mi=class extends ri{constructor(j,oe,ke,Ge,xe){if(super(oe,ke,Ge,xe),j===null)throw(0,T.$7)("location");this.location=j}};e.$7L=mi,e.$7L=mi=Je([D],mi);let ci=class extends ri{constructor(j,oe,ke,Ge,xe){super(oe,ke,Ge,xe),this.functionName=j}};e.$8L=ci,e.$8L=ci=Je([D],ci);let Ii=class extends ri{constructor(j,oe,ke,Ge,xe,ut,gt){if(super(Ge,xe,ut,gt),!oe)throw(0,T.$7)("dataId");this.label=j,this.dataId=oe,this.canPersist=ke}};e.$9L=Ii,e.$9L=Ii=Je([D],Ii);let Ci=class{constructor(j,oe,ke){this.command=j,this.args=oe||[],this.options=ke}};e.$0L=Ci,e.$0L=Ci=Je([D],Ci);let Ot=class{constructor(j,oe){this.port=j,this.host=oe}};e.$$L=Ot,e.$$L=Ot=Je([D],Ot);let $i=class{constructor(j){this.path=j}};e.$_L=$i,e.$_L=$i=Je([D],$i);let Pi=class{constructor(j){this.implementation=j}};e.$aM=Pi,e.$aM=Pi=Je([D],Pi);let ui=class{constructor(j,oe,ke){this.session=j,this.threadId=oe,this.frameId=ke}};e.$bM=ui,e.$bM=ui=Je([D],ui);let li=class{constructor(j,oe){this.session=j,this.threadId=oe}};e.$cM=li,e.$cM=li=Je([D],li);let ht=class{constructor(j,oe){this.range=j,this.expression=oe}};e.$dM=ht,e.$dM=ht=Je([D],ht);var Ji;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let _t=class{constructor(j,oe){this.range=j,this.text=oe}};e.$eM=_t,e.$eM=_t=Je([D],_t);let si=class{constructor(j,oe,ke=!0){this.range=j,this.variableName=oe,this.caseSensitiveLookup=ke}};e.$fM=si,e.$fM=si=Je([D],si);let pi=class{constructor(j,oe){this.range=j,this.expression=oe}};e.$gM=pi,e.$gM=pi=Je([D],pi);let Ri=class{constructor(j,oe){this.frameId=j,this.stoppedLocation=oe}};e.$hM=Ri,e.$hM=Ri=Je([D],Ri);var Qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ai=v=class extends Error{static FileExists(j){return new v(j,l.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(j){return new v(j,l.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(j){return new v(j,l.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(j){return new v(j,l.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(j){return new v(j,l.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(j){return new v(j,l.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(j,oe=l.FileSystemProviderErrorCode.Unknown,ke){super(b.URI.isUri(j)?j.toString(!0):j),this.code=ke?.name??"Unknown",(0,l.$Ek)(this,oe),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$iM=Ai,e.$iM=Ai=v=Je([D],Ai);let vi=class{constructor(j,oe,ke){this.start=j,this.end=oe,this.kind=ke}};e.$jM=vi,e.$jM=vi=Je([D],vi);var Xi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Li;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Zi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var wi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Mi{constructor(j,oe=[]){this.tokenTypes=j,this.tokenModifiers=oe}}e.$kM=Mi;function un(B){return typeof B>"u"||(0,g.$If)(B)}class Fi{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let oe=0,ke=j.tokenTypes.length;oe<ke;oe++)this.k.set(j.tokenTypes[oe],oe);for(let oe=0,ke=j.tokenModifiers.length;oe<ke;oe++)this.l.set(j.tokenModifiers[oe],oe)}}push(j,oe,ke,Ge,xe){if(typeof j=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(j,oe,ke,Ge,xe);if(W.isRange(j)&&typeof oe=="string"&&un(ke))return this.n(j,oe,ke);throw(0,T.$7)()}n(j,oe,ke){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=j.start.line,xe=j.start.character,ut=j.end.character-j.start.character,gt=this.k.get(oe);let qt=0;if(ke)for(const Yt of ke){if(!this.l.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Yt);qt|=1<<ii>>>0}this.o(Ge,xe,ut,gt,qt)}o(j,oe,ke,Ge,xe){if(this.f&&(j<this.c||j===this.c&&oe<this.e)){this.f=!1;const qt=this.g.length/5|0;let Yt=0,ii=0;for(let ni=0;ni<qt;ni++){let ai=this.g[5*ni],Hi=this.g[5*ni+1];ai===0?(ai=Yt,Hi+=ii):ai+=Yt,this.g[5*ni]=ai,this.g[5*ni+1]=Hi,Yt=ai,ii=Hi}}let ut=j,gt=oe;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=ke,this.g[this.j++]=Ge,this.g[this.j++]=xe,this.c=j,this.e=oe}static q(j){const oe=[],ke=j.length/5|0;for(let gt=0;gt<ke;gt++)oe[gt]=gt;oe.sort((gt,qt)=>{const Yt=j[5*gt],ii=j[5*qt];if(Yt===ii){const ni=j[5*gt+1],ai=j[5*qt+1];return ni-ai}return Yt-ii});const Ge=new Uint32Array(j.length);let xe=0,ut=0;for(let gt=0;gt<ke;gt++){const qt=5*oe[gt],Yt=j[qt+0],ii=j[qt+1],ni=j[qt+2],ai=j[qt+3],Hi=j[qt+4],In=Yt-xe,Un=In===0?ii-ut:ii,Ki=5*gt;Ge[Ki+0]=In,Ge[Ki+1]=Un,Ge[Ki+2]=ni,Ge[Ki+3]=ai,Ge[Ki+4]=Hi,xe=Yt,ut=ii}return Ge}build(j){return this.f?new oi(new Uint32Array(this.g),j):new oi(Fi.q(this.g),j)}}e.$lM=Fi;class oi{constructor(j,oe){this.resultId=oe,this.data=j}}e.$mM=oi;class ln{constructor(j,oe,ke){this.start=j,this.deleteCount=oe,this.data=ke}}e.$nM=ln;class hn{constructor(j,oe){this.resultId=oe,this.edits=j}}e.$oM=hn;var Yi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let di=class{static{this.Back={iconPath:new bt("arrow-left")}}constructor(){}};e.$pM=di,e.$pM=di=Je([D],di);var xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var _i;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var bi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(bi||(e.ExtensionKind=bi={}));class en{static validate(j){if(typeof j.badge=="string"){let oe=(0,$.$if)(j.badge,0);if(oe<j.badge.length&&(oe+=(0,$.$if)(j.badge,oe)),j.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!bt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,oe,ke){this.badge=j,this.tooltip=oe,this.color=ke}}e.$qM=en;let Ti=class{constructor(j){this.kind=j}};e.$rM=Ti,e.$rM=Ti=Je([D],Ti);var Ni;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class ei{static isNotebookRange(j){return j instanceof ei?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,oe){if(j<0)throw(0,T.$7)("start must be positive");if(oe<0)throw(0,T.$7)("end must be positive");j<=oe?(this.c=j,this.e=oe):(this.c=oe,this.e=j)}with(j){let oe=this.c,ke=this.e;return j.start!==void 0&&(oe=j.start),j.end!==void 0&&(ke=j.end),oe===this.c&&ke===this.e?this:new ei(oe,ke)}}e.$sM=ei;class yi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(oe=>yi.isNotebookCellData(oe))}static isNotebookCellData(j){return!0}constructor(j,oe,ke,Ge,xe,ut,gt){this.kind=j,this.value=oe,this.languageId=ke,this.mime=Ge,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,yi.validate(this)}}e.$tM=yi;class dn{constructor(j){this.cells=j}}e.$uM=dn;class Zt{static isNotebookCellOutputItem(j){return j instanceof Zt?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const oe={name:j.name,message:j.message,stack:j.stack};return Zt.json(oe,"application/vnd.code.notebook.error")}static stdout(j){return Zt.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return Zt.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,oe="application/octet-stream"){return new Zt(j,oe)}static#e=new TextEncoder;static text(j,oe=R.$es.text){const ke=Zt.#e.encode(String(j));return new Zt(ke,oe)}static json(j,oe="text/x-json"){const ke=JSON.stringify(j,void 0,"	");return Zt.text(ke,oe)}constructor(j,oe){this.data=j,this.mime=oe;const ke=(0,R.$is)(oe,!0);if(!ke)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$vM=Zt;class Ei{static isNotebookCellOutput(j){return j instanceof Ei?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,oe=!1){const ke=new Set,Ge=new Set;for(let xe=0;xe<j.length;xe++){const ut=j[xe],gt=(0,R.$is)(ut.mime);if(!ke.has(gt)||(0,w.$9I)(gt)){ke.add(gt);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?j:j.filter((xe,ut)=>!Ge.has(ut))}constructor(j,oe,ke){this.items=Ei.ensureUniqueMimeTypes(j,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,A.$pg)(),this.metadata=oe??ke)}}e.$wM=Ei;var Di;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Di||(e.NotebookCellKind=Di={}));var Oi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Ue;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ue||(e.NotebookCellStatusBarAlignment=Ue={}));var ti;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class tn{constructor(j,oe){this.text=j,this.alignment=oe}}e.$xM=tn;var et;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(et||(e.NotebookControllerAffinity=et={}));var pt;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(pt||(e.NotebookControllerAffinity2=pt={}));class fn{constructor(j,oe=[]){this.uri=j,this.provides=(0,E.$3b)(oe)}}e.$yM=fn;class gn{constructor(j){this.label=j}}e.$zM=gn;var Ui;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(Ui||(e.NotebookVariablesRequestKind=Ui={}));let ji=class{constructor(j,oe){this.label=j,this.timestamp=oe}};e.$AM=ji,e.$AM=ji=Je([D],ji);var fi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var nn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class mn{constructor(j,oe){this.ranges=j,this.wordPattern=oe}}e.$BM=mn;class sn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$CM=sn;var on;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let zi=class{constructor(j=void 0,oe=void 0,ke=void 0,Ge=!1){this.include=j,this.exclude=oe,this.profile=ke,this.continuous=Ge}};e.$DM=zi,e.$DM=zi=Je([D],zi);let Bi=y=class{static diff(j,oe,ke){const Ge=new y(j);return Ge.expectedOutput=oe,Ge.actualOutput=ke,Ge}constructor(j){this.message=j}};e.$EM=Bi,e.$EM=Bi=y=Je([D],Bi);let Wi=class{constructor(j){this.id=j}};e.$FM=Wi,e.$FM=Wi=Je([D],Wi);class ki{constructor(j,oe){this.covered=j,this.total=oe}}e.$GM=ki;const Vi=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class qi{static fromDetails(j,oe){const ke=new ki(0,0),Ge=new ki(0,0),xe=new ki(0,0);for(const gt of oe)if("branches"in gt){ke.total+=1,ke.covered+=gt.executionCount>0?1:0;for(const qt of gt.branches)Ge.total+=1,Ge.covered+=qt.executionCount>0?1:0}else xe.total+=1,xe.covered+=gt.executionCount>0?1:0;const ut=new qi(j,ke,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=oe,ut}constructor(j,oe,ke,Ge){this.uri=j,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Ge,Vi(oe),Vi(ke),Vi(Ge)}}e.$HM=qi;class $n{constructor(j,oe,ke=[]){this.executionCount=j,this.location=oe,this.branches=ke}}e.$IM=$n;class pn{constructor(j,oe){this.executionCount=j,this.location=oe}}e.$JM=pn;class re{constructor(j,oe,ke){this.name=j,this.executionCount=oe,this.location=ke}}e.$KM=re;var ue;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(ue||(e.ExternalUriOpenerPriority=ue={}));var Oe;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Oe||(e.WorkspaceTrustState=Oe={}));var ot;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(ot||(e.PortAutoForwardAction=ot={}));class wt{constructor(j,oe,ke,Ge,xe,ut){this.kind=j,this.name=oe,this.detail=ke,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$LM=wt;class Lt{constructor(j){this.uri=j}}e.$MM=Lt;class cn{constructor(j,oe){this.original=j,this.modified=oe}}e.$NM=cn;class Cn{constructor(j,oe,ke,Ge){this.base=j,this.input1=oe,this.input2=ke,this.result=Ge}}e.$OM=Cn;class Pn{constructor(j,oe){this.uri=j,this.viewType=oe}}e.$PM=Pn;class Rn{constructor(j){this.viewType=j}}e.$QM=Rn;class An{constructor(j,oe){this.uri=j,this.notebookType=oe}}e.$RM=An;class Ln{constructor(j,oe,ke){this.original=j,this.modified=oe,this.notebookType=ke}}e.$SM=Ln;class Mn{constructor(){}}e.$TM=Mn;class Fn{constructor(j,oe){this.uri=j,this.inputBoxUri=oe}}e.$UM=Fn;class Tn{constructor(j){this.providerId=j}}e.$VM=Tn;var vn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var wn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(wn||(e.ChatAgentCopyKind=wn={}));var bn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Nn{constructor(j,oe){this.label=j,this.values=oe}}e.$WM=Nn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class On{constructor(j,oe){this.role=j,this.content=oe}}e.$XM=On;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Dn||(e.ChatAgentResultFeedbackKind=Dn={}));var kn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Pe[103],Re([1,0,53,12,11,294,147,7,18]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=e.$_M=e.$$M=void 0;const b=new Map;function A(w,r){r?b.set(w,r):b.delete(w)}e.$$M=A;function k(w){return b.get(w)}class l extends M.$kv{constructor(r,o,t,n,a,c,h,i){super(o,t,n,a),this.c=r,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,g.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===T.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,t){return r.y(o,t)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,E.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,E.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const t=this.g,n=o.start.line,a=o.end.line,c=[];c.push(this.f[n].substring(o.start.character));for(let h=n+1;h<a;h++)c.push(this.f[h]);return c.push(this.f[a].substring(0,o.end.character)),c.join(t)}t(r){let o;if(r instanceof $.$8K?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new p(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),t=this.f[o.index].length;return new $.$8K(o.index,Math.min(o.remainder,t))}w(r){if(!(r instanceof $.$9K))throw new Error("Invalid argument");const o=this.x(r.start),t=this.x(r.end);return o===r.start&&t===r.end?r:new $.$9K(o.line,o.character,t.line,t.character)}x(r){if(!(r instanceof $.$8K))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:t}=r,n=!1;if(o<0)o=0,t=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,t=this.f[o].length,n=!0;else{const a=this.f[o].length;t<0?(t=0,n=!0):t>a&&(t=a,n=!0)}return n?new $.$8K(o,t):r}y(r,o){const t=this.x(r);if(!o)o=k(this.m);else if((0,I.$Xe)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.$ws)(t.character+1,(0,R.$us)(o),this.f[t.line],0);if(n)return new $.$9K(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$_M=l;class p{constructor(r,o,t){this.a=r,this.b=o,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$9K(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$9K(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$aN=p}),define(Pe[209],Re([1,0,7,17,5]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;let M=class{constructor($){this.a=new E.$rM(E.ColorThemeKind.Dark),this.b=new I.$Ud}get activeColorTheme(){return this.a}$onColorThemeChange($){let g;switch($){case"light":g=E.ColorThemeKind.Light;break;case"hcDark":g=E.ColorThemeKind.HighContrast;break;case"hcLight":g=E.ColorThemeKind.HighContrastLight;break;default:g=E.ColorThemeKind.Dark}this.a=new E.$rM(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Phc=M,e.$Phc=M=Je([He(0,T.$9M)],M)}),define(Pe[210],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.CellExecutionUpdateType=void 0;var T;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$aJ=(0,E.$5h)("INotebookExecutionService")}),define(Pe[211],Re([1,0,6,29,144,94]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQb=void 0;class R extends E.$Tc{constructor(g,b,A){super(),this._source=g,this.b=b,this.c=A,this.a=void 0}f(g){const b=g.getLineCount();return new T.$Ts(1,1,b,this.g(g,b))}g(g,b){if(b<1||b>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(b)+1}get inputTextBuffer(){if(!this.b){const g=new I.$bC;g.acceptChunk(this._source);const b=g.finish(!0),{textBuffer:A,disposable:k}=b.create(1);this.b=A,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const b=new I.$bC;b.acceptChunk(g);const A=b.finish(!0),{textBuffer:k,disposable:l}=A.create(1);return this.B(l),k})),this.a}findInInputs(g){const A=new M.$2B(g,!1,!1,null).parseSearchRequest();if(!A)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,A,!0,5e3)}findInOutputs(g){const A=new M.$2B(g,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),A,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$yQb=R}),define(Pe[48],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class I{static fromExtHostTestItem(R,$,g=R.parent){if(R._isRoot)return new I([$]);const b=[R.id];for(let A=g;A&&A.id!==$;A=A.parent)b.push(A.id);return b.push($),new I(b.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new I(R.split("\0"))}static join(R,$){return new I([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:I.isChild(R,$)?2:I.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new I(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$WJ=I}),define(Pe[58],Re([1,0,2,92,29,48]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$4J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$3J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$2J=e.$1J=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$ZJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$YJ=e.$XJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var $;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})($||(e.ExtTestRunProfileKind=$={}));var g;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$XJ=[2,4,8,16,32,64];const b=P=>"runId"in P;e.$YJ=b;var A;(function(P){P.serialize=C=>({range:C.range.toJSON(),uri:C.uri.toJSON()}),P.deserialize=(C,J)=>({range:I.$Ts.lift(J.range),uri:C.asCanonicalUri(E.URI.revive(J.uri))})})(A||(e.IRichLocation=A={}));var k;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(P){P.serialize=C=>({message:C.message,type:0,expected:C.expected,actual:C.actual,contextValue:C.contextValue,location:C.location&&A.serialize(C.location)}),P.deserialize=(C,J)=>({message:J.message,type:0,expected:J.expected,actual:J.actual,contextValue:J.contextValue,location:J.location&&A.deserialize(C,J.location)})})(l||(e.ITestErrorMessage=l={}));const p=(P,C)=>`${C?"s":"e"}${P}`;e.$ZJ=p;var w;(function(P){P.serialize=C=>({message:C.message,type:1,offset:C.offset,length:C.length,location:C.location&&A.serialize(C.location)}),P.deserialize=(C,J)=>({message:J.message,type:1,offset:J.offset,length:J.length,location:J.location&&A.deserialize(C,J.location)})})(w||(e.ITestOutputMessage=w={}));var r;(function(P){P.serialize=C=>C.type===0?l.serialize(C):w.serialize(C),P.deserialize=(C,J)=>J.type===0?l.deserialize(C,J):w.deserialize(C,J)})(r||(e.ITestMessage=r={}));var o;(function(P){P.serializeWithoutMessages=C=>({state:C.state,duration:C.duration,messages:[]}),P.serialize=C=>({state:C.state,duration:C.duration,messages:C.messages.map(r.serialize)}),P.deserialize=(C,J)=>({state:J.state,duration:J.duration,messages:J.messages.map(ae=>r.deserialize(C,ae))})})(o||(e.ITestTaskState=o={}));const t="\0",n=(P,C)=>P+t+C;e.$1J=n;const a=P=>{const C=P.indexOf(t);return{ctrlId:P.slice(0,C),tagId:P.slice(C+1)}};e.$2J=a;var c;(function(P){P.serialize=C=>({extId:C.extId,label:C.label,tags:C.tags,busy:C.busy,children:void 0,uri:C.uri?.toJSON(),range:C.range?.toJSON()||null,description:C.description,error:C.error,sortText:C.sortText}),P.deserialize=(C,J)=>({extId:J.extId,label:J.label,tags:J.tags,busy:J.busy,children:void 0,uri:J.uri?C.asCanonicalUri(E.URI.revive(J.uri)):void 0,range:J.range?I.$Ts.lift(J.range):null,description:J.description,error:J.error,sortText:J.sortText})})(c||(e.ITestItem=c={}));var h;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(P){P.serialize=C=>({expand:C.expand,item:c.serialize(C.item)}),P.deserialize=(C,J)=>({controllerId:M.$WJ.root(J.item.extId),expand:J.expand,item:c.deserialize(C,J.item)})})(i||(e.InternalTestItem=i={}));var s;(function(P){P.serialize=C=>{let J;return C.item&&(J={},C.item.label!==void 0&&(J.label=C.item.label),C.item.tags!==void 0&&(J.tags=C.item.tags),C.item.busy!==void 0&&(J.busy=C.item.busy),C.item.uri!==void 0&&(J.uri=C.item.uri?.toJSON()),C.item.range!==void 0&&(J.range=C.item.range?.toJSON()),C.item.description!==void 0&&(J.description=C.item.description),C.item.error!==void 0&&(J.error=C.item.error),C.item.sortText!==void 0&&(J.sortText=C.item.sortText)),{extId:C.extId,expand:C.expand,item:J}},P.deserialize=C=>{let J;return C.item&&(J={},C.item.label!==void 0&&(J.label=C.item.label),C.item.tags!==void 0&&(J.tags=C.item.tags),C.item.busy!==void 0&&(J.busy=C.item.busy),C.item.range!==void 0&&(J.range=C.item.range?I.$Ts.lift(C.item.range):null),C.item.description!==void 0&&(J.description=C.item.description),C.item.error!==void 0&&(J.error=C.item.error),C.item.sortText!==void 0&&(J.sortText=C.item.sortText)),{extId:C.extId,expand:C.expand,item:J}}})(s||(e.ITestItemUpdate=s={}));const u=(P,C)=>{C.expand!==void 0&&(P.expand=C.expand),C.item!==void 0&&(P.item=P.item?Object.assign(P.item,C.item):C.item)};e.$3J=u;var d;(function(P){P.serializeWithoutMessages=C=>({...i.serialize(C),ownComputedState:C.ownComputedState,computedState:C.computedState,tasks:C.tasks.map(o.serializeWithoutMessages)}),P.serialize=C=>({...i.serialize(C),ownComputedState:C.ownComputedState,computedState:C.computedState,tasks:C.tasks.map(o.serialize)}),P.deserialize=(C,J)=>({...i.deserialize(C,J),ownComputedState:J.ownComputedState,computedState:J.computedState,tasks:J.tasks.map(ae=>o.deserialize(C,ae)),retired:!0})})(d||(e.TestResultItem=d={}));var m;(function(P){P.empty=()=>({covered:0,total:0}),P.sum=(C,J)=>{C.covered+=J.covered,C.total+=J.total}})(m||(e.ICoveredCount=m={}));var f;(function(P){P.serialize=C=>({statement:C.statement,branch:C.branch,function:C.function,details:C.details?.map(y.serialize),uri:C.uri.toJSON()}),P.deserialize=(C,J)=>({statement:J.statement,branch:J.branch,function:J.function,details:J.details?.map(y.deserialize),uri:C.asCanonicalUri(E.URI.revive(J.uri))})})(f||(e.IFileCoverage=f={}));function S(P){return{...P,location:P.location?.toJSON()}}function L(P){return P.location=P.location?T.$Ss.isIPosition(P.location)?T.$Ss.lift(P.location):I.$Ts.lift(P.location):void 0,P}e.$4J=3;var v;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(v||(e.DetailType=v={}));var y;(function(P){P.serialize=C=>C.type===0?N.serialize(C):O.serialize(C),P.deserialize=C=>C.type===0?N.deserialize(C):O.deserialize(C)})(y||(e.CoverageDetails=y={}));var D;(function(P){P.serialize=S,P.deserialize=L})(D||(e.IBranchCoverage=D={}));var N;(function(P){P.serialize=S,P.deserialize=L})(N||(e.IFunctionCoverage=N={}));var O;(function(P){P.serialize=C=>({...S(C),branches:C.branches?.map(D.serialize)}),P.deserialize=C=>({...L(C),branches:C.branches?.map(D.deserialize)})})(O||(e.IStatementCoverage=O={}));var H;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(H||(e.TestDiffOpType=H={}));var U;(function(P){P.deserialize=(C,J)=>J.op===0?{op:J.op,item:i.deserialize(C,J.item)}:J.op===1?{op:J.op,item:s.deserialize(J.item)}:J.op===2?{op:J.op,uri:C.asCanonicalUri(E.URI.revive(J.uri)),docv:J.docv}:J,P.serialize=C=>C.op===0?{op:C.op,item:i.serialize(C.item)}:C.op===1?{op:C.op,item:s.serialize(C.item)}:C})(U||(e.TestsDiffOp=U={}));class W{constructor(C){this.k=C,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(C){const J=this.v();for(const ae of C)switch(ae.op){case 0:this.l(i.deserialize(this.k,ae.item),J);break;case 1:this.o(s.deserialize(ae.item),J);break;case 3:this.p(ae.itemId,J);break;case 5:this.q(ae.itemId);break;case 4:this.updatePendingRoots(ae.amount);break;case 6:this.c.set(ae.tag.id,ae.tag);break;case 7:this.c.delete(ae.id);break}J.complete?.()}l(C,J){const ae=M.$WJ.parentId(C.item.extId)?.toString();let fe;if(!ae)fe=this.w(C),this.g.add(fe),this.f.set(C.item.extId,fe);else if(this.f.has(ae)){const we=this.f.get(ae);we.children.add(C.item.extId),fe=this.w(C,we),this.f.set(C.item.extId,fe)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(C)}`);return}return J.add?.(fe),C.expand===2&&this.h++,fe}o(C,J){const ae=this.f.get(C.extId);if(ae)return C.expand!==void 0&&(ae.expand===2&&this.h--,C.expand===2&&this.h++),(0,e.$3J)(ae,C),J.update?.(ae),ae}p(C,J){const ae=this.f.get(C);if(!ae)return;const fe=M.$WJ.parentId(ae.item.extId)?.toString();fe?this.f.get(fe).children.delete(ae.item.extId):this.g.delete(ae);const we=[[C]];for(;we.length;)for(const ye of we.pop()){const he=this.f.get(ye);he&&(we.push(he.children),this.f.delete(ye),J.remove?.(he,he!==ae),he.expand===2&&this.h--)}}q(C){}updatePendingRoots(C){this.j+=C}v(){return{}}}e.$5J=W}),define(Pe[77],Re([1,0,13,5,6,53,58,48]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.TestItemEventOp=void 0;var g;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const b=(n,a)=>n===a,k=Object.entries({range:(n,a)=>n===a?!0:!n||!a?!1:n.equalsRange(a),busy:b,label:b,description:b,error:b,sortText:b,tags:(n,a)=>!(n.length!==a.length||n.some(c=>!a.includes(c)))}),l=(n,a)=>{let c;for(const[h,i]of k)i(n[h],a[h])||(c?c[h]=a[h]:c={[h]:a[h]});return c};class p extends I.$Tc{get root(){return this.s.root}constructor(a){super(),this.s=a,this.f=this.B(new E.$eh(()=>this.flushDiff(),200)),this.g=this.B(new T.$Ud),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(a){this.h=a;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const a=this.m;return this.m=[],a}pushDiff(a){switch(a.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===a.uri){c.docv=a.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===a.item.extId){(0,R.$3J)(c.item,a.item);return}if(c.op===0&&c.item.item.extId===a.item.extId){(0,R.$3J)(c.item,a.item);return}}break}}this.m.push(a),this.f.isScheduled()||this.f.schedule()}expand(a,c){const h=this.tree.get(a);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const a of this.tree.values())this.s.getApiFor(a.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(a,c){switch(c.op){case 3:this.O($.$WJ.joinToString(a.fullId,c.id));break;case 0:this.z(c.item,a);break;case 5:for(const h of c.ops)this.w(a,h);break;case 1:this.C(c.new,c.old,a.fullId.toString());break;case 2:this.J(a);break;case 4:this.pushDiff({op:1,item:{extId:a.fullId.toString(),item:c.update}});break;case 6:this.y(a.actual.uri);break;default:(0,M.$6c)(c)}}y(a){a&&this.pushDiff({op:2,uri:a,docv:this.s.getDocumentVersion(a)})}z(a,c){const h=$.$WJ.fromExtHostTestItem(a,this.root.id,c?.actual),i=this.s.getApiFor(a);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(a.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:a,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},a.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(a,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(a)}}),this.I(a,s,c);return}if(s.actual===a){this.H(a,s,c);return}if(s.actual.uri?.toString()!==a.uri?.toString())return this.O(h.toString()),this.z(a,c);const u=this.s.getChildren(s.actual),d=s.actual,m=l(this.s.toITestItem(d),this.s.toITestItem(a));this.s.getApiFor(d).listener=void 0,s.actual=a,s.expand=0,m&&(m.hasOwnProperty("tags")&&(this.C(a.tags,d.tags,h.toString()),delete m.tags),this.w(s,{op:4,update:m})),this.I(a,s,c);for(const[f,S]of u)this.s.getChildren(a).get(S.id)||this.O($.$WJ.joinToString(h,S.id));this.y(s.actual.uri)}C(a,c,h){const i=new Set(c.map(s=>s.id));for(const s of a)i.delete(s.id)||this.D(s);this.pushDiff({op:1,item:{extId:h,item:{tags:a.map(s=>(0,R.$1J)(this.s.controllerId,s.id))}}}),i.forEach(this.F,this)}D(a){const c=this.j.get(a.id);c?c.refCount++:(this.j.set(a.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$1J)(this.s.controllerId,a.id)}}))}F(a){const c=this.j.get(a);c&&!--c.refCount&&(this.j.delete(a),this.pushDiff({op:7,id:(0,R.$1J)(this.s.controllerId,a)}))}G(a,c){this.s.getApiFor(a).parent=c&&c.actual!==this.root?c.actual:void 0}H(a,c,h){this.G(a,h);const i=this.s.getApiFor(a);i.parent=h?.actual,i.listener=s=>this.w(c,s),this.J(c)}I(a,c,h){this.H(a,c,h);for(const[i,s]of this.s.getChildren(a))this.z(s,c)}J(a){let c;this.h?a.resolveBarrier?c=a.resolveBarrier.isOpen()?3:2:c=a.actual.canResolveChildren?1:0:c=0,c!==a.expand&&(a.expand=c,this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:c}}),c===1&&a.expandLevels!==void 0&&this.M(a))}L(a,c){if(c<0)return;const h=[];for(const[i,s]of this.s.getChildren(a.actual)){const u=this.expand($.$WJ.joinToString(a.fullId,s.id),c);(0,E.$Rg)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}M(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this.h){const s=new E.$4g;return s.open(),s}a.expand=2,this.N(a);const c=a.resolveBarrier=new E.$4g,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let i;try{i=this.h(a.actual===this.root?void 0:a.actual)}catch(s){h(s)}return(0,E.$Rg)(i)?i.catch(h).then(()=>{c.open(),this.J(a)}):(c.open(),this.J(a)),a.resolveBarrier}N(a){this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:a.expand}})}O(a){const c=this.tree.get(a);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:a});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.F(s.id);this.tree.delete(i.fullId.toString());for(const[s,u]of this.s.getChildren(i.actual))h.push(this.tree.get($.$WJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.g.fire(a)}}e.$YM=p;class w extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.$ZM=w;class r extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$1M=r;class o extends Error{constructor(a,c,h){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$2M=o;const t=(n,a,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,s){for(const u of h.values())i.call(s,u,this)},[Symbol.iterator](){return h.entries()},replace(i){const s=new Map,u=new Set(h.keys()),d={op:5,ops:[]};for(const m of i){if(!(m instanceof c))throw new r(m.id);const f=a(m).controllerId;if(f!==n.controllerId)throw new o(m.id,f,n.controllerId);if(s.has(m.id))throw new w(m.id);s.set(m.id,m),u.delete(m.id),d.ops.push({op:0,item:m})}for(const m of u.keys())d.ops.push({op:3,id:m});n.listener?.(d),h=s},add(i){if(!(i instanceof c))throw new r(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$3M=t}),define(Pe[104],Re([1,0,77]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=e.$4M=void 0;const T=new WeakMap,I=(R,$)=>{const g={controllerId:$};return T.set(R,g),g};e.$4M=I;const M=R=>{const $=T.get(R);if(!$)throw new E.$1M(R?.id||"<unknown>");return $};e.$5M=M}),define(Pe[78],Re([1,0,12,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rvb=e.$qvb=e.$pvb=e.$ovb=e.$nvb=void 0,e.$nvb="vscode-cdn.net",e.$ovb=`vscode-resource.${e.$nvb}`,e.$pvb=`'self' https://*.${e.$nvb}`;function I($,g){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(g&&g.authority&&g.isRemote&&$.scheme===E.Schemas.file&&($=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:g.authority,path:$.path})),T.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$ovb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$qvb=I;function M($){return $.replace(/./g,g=>{const b=g.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?g:"-"+b.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(g,b)=>String.fromCharCode(parseInt(b,16)))}e.$rvb=R}),define(Pe[212],Re([1,0,5,6,78]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class M{constructor($,g,b){this.d=$,this.e=g,this.f=b,this.a=0,this.b=new T.$Sc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const A=g.getVisibleTextEditors();for(const k of this.c.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,g,b,A,k){let l;for(const a of this.e.getVisibleTextEditors(!0))if(a.value===$){l=a;break}if(!l)throw new Error("not a visible editor");const p=this,w=this.a++,r=new E.$Ud,o=new E.$Ud,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(a){return(0,I.$qvb)(a,p.f)}get cspSource(){return I.$pvb}set options(a){this.b=a,p.d.$setOptions(w,a)}get options(){return this.b}set html(a){this.a=a,p.d.$setHtml(w,a)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(a){return p.d.$postMessage(w,a)}},n=new class{constructor(){this.editor=$,this.line=g,this.height=b,this.webview=t,this.onDidDispose=o.event}dispose(){p.c.has(w)&&(p.c.delete(w),p.d.$disposeEditorInset(w),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(w,l.id,l.value.document.uri,g+1,b,A||{},k.identifier,k.extensionLocation),this.c.set(w,{editor:$,inset:n,onDidReceiveMessage:r}),n}$onDidDispose($){const g=this.c.get($);g&&g.inset.dispose()}$onDidReceiveMessage($,g){this.c.get($)?.onDidReceiveMessage.fire(g)}}e.$_fc=M}),define(Pe[213],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=e.VariableKind=e.$UN=void 0,e.$UN=(0,E.$5h)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator",M.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class I extends Error{constructor(R,$){super($),this.variable=R}}e.$VN=I}),define(Pe[214],Re([1,0,19,74,16,26,21,95,176,213,11]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,w,r,o){this.h=new Map,this.a=p,this.b=w,this.g=r,o&&(this.c=o.then(t=>this.i(t)))}i(p){if(R.$i){const w=Object.create(null);return Object.keys(p).forEach(r=>{w[r.toLowerCase()]=p[r]}),w}return p}resolveWithEnvironment(p,w,r){return this.l({env:this.i(p),userHome:void 0},w?w.uri:void 0,r)}async resolveAsync(p,w){const r={env:await this.c,userHome:await this.g};return this.l(r,p?p.uri:void 0,w)}async j(p,w,r,o){const t=M.$un(w);R.$i&&t.windows?Object.keys(t.windows).forEach(a=>t[a]=t.windows[a]):R.$j&&t.osx?Object.keys(t.osx).forEach(a=>t[a]=t.osx[a]):R.$k&&t.linux&&Object.keys(t.linux).forEach(a=>t[a]=t.linux[a]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,t,r,o)}async resolveAnyAsync(p,w,r){return this.j(p,w,r)}async resolveAnyMap(p,w,r){const o=new Map;return{newConfig:await this.j(p,w,r,o),resolvedVariables:o}}resolveWithInteractionReplace(p,w,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,w,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,w){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,w)}async l(p,w,r,o,t){if(I.$Hf(r))return this.m(p,w,r,o,t);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(p,w,n,o,t)));if(I.$Jf(r)){const n=Object.create(null),a=await Promise.all(Object.keys(r).map(async c=>[await this.m(p,w,c,o,t),await this.l(p,w,r[c],o,t)]));for(const[c,h]of a)n[c]=h;return n}return r}m(p,w,r,o,t){return(0,A.$3e)(r,k.VARIABLE_REGEXP,async(n,a)=>{if(a.includes(k.VARIABLE_LHS))return n;let c=await this.o(p,n,a,w,o);return t?.set(a,c),c!==n&&I.$Hf(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.m(p,w,c,o,t)),c})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,w,r,o,t){let n;const a=r.split(":");a.length>1&&(r=a[0],n=a[1]);const c=s=>{const u=this.a.getFilePath();if(u)return(0,$.$Vv)(u);throw new b.$VN(s,(0,g.localize)(0,null,w))},h=s=>{const u=c(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,$.$Vv)(d)}throw new b.$VN(s,(0,g.localize)(1,null,w,E.$nc(u)))},i=s=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new b.$VN(s,(0,g.localize)(2,null,w,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new b.$VN(s,(0,g.localize)(3,null,w)):new b.$VN(s,(0,g.localize)(4,null,w))};switch(r){case"env":if(n){if(p.env){const s=p.env[R.$i?n.toLowerCase():n];if(I.$Hf(s))return s}return""}throw new b.$VN(b.VariableKind.Env,(0,g.localize)(5,null,w));case"config":if(n){const s=this.a.getConfigurationValue(o,n);if(I.$Qf(s))throw new b.$VN(b.VariableKind.Config,(0,g.localize)(6,null,w,n));if(I.$Jf(s))throw new b.$VN(b.VariableKind.Config,(0,g.localize)(7,null,w,n));return s}throw new b.$VN(b.VariableKind.Config,(0,g.localize)(8,null,w));case"command":return this.p(b.VariableKind.Command,w,n,t,"command");case"input":return this.p(b.VariableKind.Input,w,n,t,"input");case"extensionInstallFolder":if(n){const s=await this.a.getExtension(n);if(!s)throw new b.$VN(b.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,w,n));return this.n(s.extensionLocation)}throw new b.$VN(b.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,w));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,$.$Vv)(this.n(i(b.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,$.$Vv)(this.n(i(b.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Vv)(E.$nc(this.n(i(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new b.$VN(b.VariableKind.UserHome,(0,g.localize)(11,null,w))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new b.$VN(b.VariableKind.LineNumber,(0,g.localize)(12,null,w))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new b.$VN(b.VariableKind.SelectedText,(0,g.localize)(13,null,w))}case"file":return c(b.VariableKind.File);case"fileWorkspaceFolder":return h(b.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(h(b.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?E.$lc(this.n(i(b.VariableKind.RelativeFile)),c(b.VariableKind.RelativeFile)):c(b.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$mc(c(b.VariableKind.RelativeFileDirname));if(o||n){const u=E.$lc(this.n(i(b.VariableKind.RelativeFileDirname)),s);return u.length===0?".":u}return s}case"fileDirname":return E.$mc(c(b.VariableKind.FileDirname));case"fileExtname":return E.$oc(c(b.VariableKind.FileExtname));case"fileBasename":return E.$nc(c(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$nc(c(b.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$oc(s).length)}case"fileDirnameBasename":return E.$nc(E.$mc(c(b.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||w}case"execInstallFolder":{const s=this.a.getAppRoot();return s||w}case"pathSeparator":case"/":return E.sep;default:try{const s=n?`${r}:${n}`:r;return this.p(b.VariableKind.Unknown,w,s,t,void 0)}catch{return w}}}}p(p,w,r,o,t){if(r&&o){const n=t===void 0?o[r]:o[t+":"+r];if(typeof n=="string")return n;throw new b.$VN(p,(0,g.localize)(14,null,w))}return w}}e.$0N=k}),define(Pe[105],Re([1,0,4,102]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.$0C=e.OpenEditorContext=e.GroupsOrder=e.$9C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$8C=void 0,e.$8C=(0,E.$5h)("editorGroupsService");var I;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var M;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var g;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function b(w){const r=w;return(0,T.$RE)(r?.editor)&&(0,T.$RE)(r?.replacement)}e.$9C=b;var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(w){const r=w;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.$0C=l;function p(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$$C=p}),define(Pe[215],Re([1,0,4,105]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=void 0,e.$_C=(0,E.$5h)("editorService"),e.$aD=-1,e.$bD=-2,e.$cD=-3;function I(M){const R=M;return typeof M=="number"||(0,T.$0C)(R)}e.$dD=I}),define(Pe[216],Re([1,0,4,183]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=void 0,e.$pK=(0,E.$6h)(T.$_h)}),define(Pe[106],Re([1,0,22,5,19,6]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$77b=e.$67b=e.$57b=e.$47b=e.$37b=void 0;class R{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$37b=R;class ${static isHostExtension(t,n,a){if(n.getExtensionDescription(t))return!1;const c=a.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,n){this.j=t,this.c=new T.$Ud,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(w),this.f=new E.$mm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const a of n)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=r(this.e,n),this.e=this.e.concat(t);const a=$.l(this.e);return this.e=r(this.e,a.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,a)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,u){this.addNode(s),this.addNode(u),this.c.has(s)?this.c.get(s).push(u):this.c.set(s,[u])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,u){const d=n.getArcs(s);for(let m=0;m<d.length;m++)if(!u.has(d[m]))return!1;return!0}getNodes(){return this.e}},a=new E.$mm;for(const s of t)if(a.set(s.identifier,s),s.extensionDependencies)for(const u of s.extensionDependencies)n.addArc(E.$km.toKey(s.identifier),E.$km.toKey(u));const c=new Set;n.getNodes().filter(s=>n.getArcs(s).length===0).forEach(s=>c.add(s));const h=n.getNodes().filter(s=>!c.has(s));let i;do{i=!1;for(let s=0;s<h.length;s++){const u=h[s];n.hasOnlyGoodArcs(u,c)&&(h.splice(s,1),s--,c.add(u),i=!0)}}while(i);return h.map(s=>a.get(s))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$47b=$;class g{constructor(t,n){this.versionId=t,this.extensions=n}}e.$57b=g;class b{constructor(t){this.d=new l,this.c=new $(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new A(this,n)}deltaExtensions(t,n,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,a)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$67b=b;class A extends M.$Tc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$77b=A;class k{constructor(t){this.name=t,this.promise=new Promise((n,a)=>{this.c=n})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new k(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const a=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(a),n=!1,this.d=!1,this.e())};t.resolve((0,M.$Rc)(c))}}var p;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(p||(p={}));function w(o,t){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==a)return n-a;const c=I.$gc.basename(o.extensionLocation.path),h=I.$gc.basename(t.extensionLocation.path);return c<h?-1:c>h?1:0}function r(o,t){const n=new E.$lm(t);return o.filter(a=>!n.has(a.identifier))}}),define(Pe[79],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$tm=e.$sm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(T||(e.UIKind=T={}));var I;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var M;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(b){const A=E.$ie.alloc(1);switch(b){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$sm=R;function $(b,A){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$tm=$;var g;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Pe[59],Re([1,0,4,5,14,27,79,55,56,26,2,6,164]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.$nN=void 0;let p=class extends k.$Tc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new T.$Ud),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Ud),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:g.$Oo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(a=>{(0,I.$oj)(a)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,a){const c=this.getTelemetryDetails(),h=new w(n,a,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,n,a){this.f=t,this.g=n,this.c=a??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$al)((0,g.$Vo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((a,c)=>{const h=a.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(a=>{for(const c of a)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$nN=p,e.$nN=p=Je([He(0,M.$mN),He(1,I.$nj)],p);class w{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,a,c,h,i,s){this.g=a,this.h=c,this.i=h,this.j=i,this.a=new T.$Ud,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,g.$Yo)(n,[]),this.c&&(n=(0,b.$xn)(n,this.c)),this.b||(n=(0,b.$xn)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const a={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,g.$Yo)(a,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$oN=w;function r(o){const t=Date.now()-new Date(o).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$pN=r,e.$qN=(0,E.$5h)("IExtHostTelemetry")}),define(Pe[23],Re([1,0,5,2,192,101,22,4]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.ActivationKind=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.ExtensionHostStartup=e.$zF=e.$yF=e.$xF=e.$wF=void 0,e.$wF=Object.freeze({identifier:new R.$km("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$xF="extensions.webWorker",e.$yF=(0,$.$5h)("extensionService");class g{constructor(h){this.dependency=h}}e.$zF=g;var b;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,s){this.c=h,this.d=i.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$hF.createActivationEventsMap(this.d)}}set(h,i,s){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],d=[],m=[],f=[],S=k(this.d),L=k(i),v=(H,U)=>H.extensionLocation.toString()===U.extensionLocation.toString()||H.isBuiltin===U.isBuiltin||H.isUserBuiltin===U.isUserBuiltin||H.isUnderDevelopment===U.isUnderDevelopment;for(const H of this.d){const U=L.get(H.identifier);if(!U){u.push(H.identifier),S.delete(H.identifier);continue}if(!v(H,U)){u.push(H.identifier),S.delete(H.identifier);continue}}for(const H of i){const U=S.get(H.identifier);if(!U){d.push(H);continue}if(!v(U,H)){u.push(U.identifier),S.delete(U.identifier);continue}}const y=new R.$lm(this.e),D=new R.$lm(s);for(const H of this.e)D.has(H)||m.push(H);for(const H of s)y.has(H)||f.push(H);const N=M.$hF.createActivationEventsMap(d),O={versionId:h,toRemove:u,toAdd:d,addActivationEvents:N,myToRemove:m,myToAdd:f};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:u,myToAdd:d}=h,m=new R.$lm(i),f=new R.$lm(u);for(let S=0;S<this.d.length;S++)m.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)f.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of d)this.e.push(S);return this.f=null,h}containsExtension(h){for(const i of this.e)if(R.$km.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const s=M.$hF.readActivationEvents(i);for(const u of s)h.add(u)}return h}}e.$AF=A;function k(c){const h=new R.$mm;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$BF=l;function p(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$CF=p;class w{constructor(h,i,s,u){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=u}}e.$DF=w;class r{constructor(h,i){this.description=h,this.value=i}}e.$EF=r;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,I.$5o)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$FF=t;function n(c,h){return{identifier:new R.$km((0,I.$3o)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$GF=n;class a{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$HF=a}),define(Pe[217],Re([1,0,15,106,22,23,14,13]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=e.$zgc=e.$ygc=e.$xgc=e.$wgc=e.$vgc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(t,n,a,c){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=a,this.activateResolvedTime=c}}e.$vgc=g;class b{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$wgc=b;class A{constructor(t,n,a,c,h,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=a,this.module=c,this.exports=h,this.subscriptions=i}}e.$xgc=A;class k extends A{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ygc=k;class l extends A{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$zgc=l;class p extends A{constructor(t){super(!0,t,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(t,n,a,c){this.g=c,this.a=t,this.b=n,this.c=a,this.d=new I.$mm,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,a]of this.d)t.push(a.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const a=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(a.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const a=this.a.getExtensionDescription(t);if(!a)throw new Error(`Extension '${t}' is not known`);return this.h([{id:a.identifier,reason:n}])}async h(t){const n=t.filter(a=>!this.isActivated(a.id)).map(a=>this.j(a));await Promise.all(n.map(a=>a.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new p(h));return this.c.onExtensionActivationError(t.id,h,new M.$zF(t.id.value)),i}const a=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){a.push(i);continue}if(this.l(h)){a.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const s=this.a.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;a.push(this.j({id:s.identifier,reason:t.reason}));continue}const u=n.displayName||n.identifier.value,d=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),m=this.k(t,n.displayName,[],new p(d));return this.c.onExtensionActivationError(n.identifier,d,new M.$zF(h)),m}return this.k(t,n.displayName,a,null)}k(t,n,a,c){const h=new r(t.id,n,t.reason,a,c,this.c,this.g);return this.d.set(t.id,h),h}l(t){return T.$47b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$Agc=w,e.$Agc=w=Je([He(3,R.$mj)],w);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,a,c,h,i,s){this.c=t,this.d=n,this.f=a,this.g=c,this.h=h,this.j=i,this.k=s,this.a=new $.$4g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);a.detail=n.value.activationFailedError,this.h=new p(a),this.j.onExtensionActivationError(this.c,a,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new p(n),this.b&&E.$4(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};r=Je([He(6,R.$mj)],r)}),define(Pe[8],Re([1,0,18,24,127,218,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,215,7,23]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c,h,i,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$8M=e.$7M=e.MarkdownString=e.$6M=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Se){function Fe(G){const{selectionStartLineNumber:Le,selectionStartColumn:ze,positionLineNumber:Xe,positionColumn:Ve}=G,_e=new s.$8K(Le-1,ze-1),mt=new s.$8K(Xe-1,Ve-1);return new s.$0K(_e,mt)}Se.to=Fe;function de(G){const{anchor:Le,active:ze}=G;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Se.from=de})(d||(e.Selection=d={}));var m;(function(Se){function Fe(G){if(!G)return;const{start:Le,end:ze}=G;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Se.from=Fe;function de(G){if(!G)return;const{startLineNumber:Le,startColumn:ze,endLineNumber:Xe,endColumn:Ve}=G;return new s.$9K(Le-1,ze-1,Xe-1,Ve-1)}Se.to=de})(m||(e.Range=m={}));var f;(function(Se){function Fe(de){switch(de){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Se.to=Fe})(f||(e.TokenType=f={}));var S;(function(Se){function Fe(G){return new s.$8K(G.lineNumber-1,G.column-1)}Se.to=Fe;function de(G){return{lineNumber:G.line+1,column:G.character+1}}Se.from=de})(S||(e.Position=S={}));var L;(function(Se){function Fe(Le,ze,Xe){return(0,E.$Hb)((0,E.$3b)(Le).map(Ve=>de(Ve,ze,Xe)))}Se.from=Fe;function de(Le,ze,Xe){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Xe?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:G(Le.scheme,ze),pattern:Z.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Xe?.isBuiltin}}function G(Le,ze){return ze&&typeof Le=="string"?ze.transformOutgoingScheme(Le):Le}})(L||(e.DocumentSelector=L={}));var v;(function(Se){function Fe(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Se.from=Fe;function de(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Se.to=de})(v||(e.DiagnosticTag=v={}));var y;(function(Se){function Fe(G){let Le;return G.code&&((0,l.$Hf)(G.code)||(0,l.$Lf)(G.code)?Le=String(G.code):Le={value:String(G.code.value),target:G.code.target}),{...m.from(G.range),message:G.message,source:G.source,code:Le,severity:N.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(D.from),tags:Array.isArray(G.tags)?(0,E.$Hb)(G.tags.map(v.from)):void 0}}Se.from=Fe;function de(G){const Le=new s.$iL(m.to(G),G.message,N.to(G.severity));return Le.source=G.source,Le.code=(0,l.$Hf)(G.code)?G.code:G.code?.value,Le.relatedInformation=G.relatedInformation&&G.relatedInformation.map(D.to),Le.tags=G.tags&&(0,E.$Hb)(G.tags.map(v.to)),Le}Se.to=de})(y||(e.Diagnostic=y={}));var D;(function(Se){function Fe(G){return{...m.from(G.location.range),message:G.message,resource:G.location.uri}}Se.from=Fe;function de(G){return new s.$hL(new s.$gL(G.resource,m.to(G)),G.message)}Se.to=de})(D||(e.DiagnosticRelatedInformation=D={}));var N;(function(Se){function Fe(G){switch(G){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Se.from=Fe;function de(G){switch(G){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Se.to=de})(N||(e.DiagnosticSeverity=N={}));var O;(function(Se){function Fe(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?i.$bD:i.$aD}Se.from=Fe;function de(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=de})(O||(e.ViewColumn=O={}));function H(Se){return typeof Se.range<"u"}function U(Se){return Se.length===0?!0:!!H(Se[0])}e.$6M=U;var W;(function(Se){function Fe(Ve){return Ve.map(Se.from)}Se.fromMany=Fe;function de(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let _e;if(de(Ve)){const{language:St,value:bt}=Ve;_e={value:"```"+St+`
`+bt+"\n```\n"}}else s.$vL.isMarkdownString(Ve)?_e={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?_e={value:Ve}:_e={value:""};const mt=Object.create(null);_e.uris=mt;const zt=St=>{try{let bt=p.URI.parse(St,!0);bt=bt.with({query:Le(bt.query,mt)}),mt[St]=bt}catch{}return""},Et=new g.marked.Renderer;return Et.link=zt,Et.image=St=>typeof St=="string"?zt(R.$ok(St).href):"",(0,g.marked)(_e.value,{renderer:Et}),_e}Se.from=G;function Le(Ve,_e){if(!Ve)return Ve;let mt;try{mt=(0,b.$Ah)(Ve)}catch{}if(!mt)return Ve;let zt=!1;return mt=(0,k.$wn)(mt,Et=>{if(p.URI.isUri(Et)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[St]=Et,zt=!0,St}else return}),zt?JSON.stringify(mt):Ve}function ze(Ve){const _e=new s.$vL(Ve.value,Ve.supportThemeIcons);return _e.isTrusted=Ve.isTrusted,_e.supportHtml=Ve.supportHtml,_e.baseUri=Ve.baseUri?p.URI.from(Ve.baseUri):void 0,_e}Se.to=ze;function Xe(Ve){if(Ve)return typeof Ve=="string"?Ve:Se.from(Ve)}Se.fromStrict=Xe})(W||(e.MarkdownString=W={}));function P(Se){return U(Se)?Se.map(Fe=>({range:m.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?W.fromMany(Fe.hoverMessage):Fe.hoverMessage?W.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Se.map(Fe=>({range:m.from(Fe)}))}e.$7M=P;function C(Se){return typeof Se>"u"?Se:typeof Se=="string"?p.URI.file(Se):Se}e.$8M=C;var J;(function(Se){function Fe(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?C(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Se.from=Fe})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var ae;(function(Se){function Fe(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?C(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?J.from(de.before):void 0,after:de.after?J.from(de.after):void 0}}Se.from=Fe})(ae||(e.ThemableDecorationRenderOptions=ae={}));var fe;(function(Se){function Fe(de){if(typeof de>"u")return de;switch(de){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Fe})(fe||(e.DecorationRangeBehavior=fe={}));var we;(function(Se){function Fe(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?fe.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?ae.from(de.light):void 0,dark:de.dark?ae.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?C(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?J.from(de.before):void 0,after:de.after?J.from(de.after):void 0}}Se.from=Fe})(we||(e.DecorationRenderOptions=we={}));var ye;(function(Se){function Fe(G){return{text:G.newText,eol:G.newEol&&tt.from(G.newEol),range:m.from(G.range)}}Se.from=Fe;function de(G){const Le=new s.$bL(m.to(G.range),G.text);return Le.newEol=typeof G.eol>"u"?void 0:tt.to(G.eol),Le}Se.to=de})(ye||(e.TextEdit=ye={}));var he;(function(Se){function Fe(G,Le){const ze={edits:[]};if(G instanceof s.$eL){const Xe=new $.$Bc;for(const Ve of G._allEntries())Ve._type===1&&p.URI.isUri(Ve.to)&&Ve.from===void 0&&Xe.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===1){let _e;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?_e={type:"base64",value:(0,T.$Ce)(T.$ie.wrap(Ve.options.contents))}:_e={type:"dataTransferItem",id:Ve.options.contents._itemId}),ze.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:_e},metadata:Ve.metadata})}else Ve._type===2?ze.edits.push({resource:Ve.uri,textEdit:ye.from(Ve.edit),versionId:Xe.has(Ve.uri)?void 0:Le?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?ze.edits.push({resource:Ve.uri,textEdit:{range:m.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ve.uri)?void 0:Le?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Pt.from)}})}return ze}Se.from=Fe;function de(G){const Le=new s.$eL,ze=new $.$Ac;for(const Xe of G.edits)if(Xe.textEdit){const Ve=Xe,_e=p.URI.revive(Ve.resource),mt=m.to(Ve.textEdit.range),zt=Ve.textEdit.text,Et=Ve.textEdit.insertAsSnippet;let St;Et?St=s.$dL.replace(mt,new s.$fL(zt)):St=s.$bL.replace(mt,zt);const bt=ze.get(_e);bt?bt.push(St):ze.set(_e,[St])}else Le.renameFile(p.URI.revive(Xe.oldResource),p.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Ve]of ze)Le.set(Xe,Ve);return Le}Se.to=de})(he||(e.WorkspaceEdit=he={}));var ve;(function(Se){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function de(Le){return typeof Fe[Le]=="number"?Fe[Le]:6}Se.from=de;function G(Le){for(const ze in Fe)if(Fe[ze]===Le)return Number(ze);return s.SymbolKind.Property}Se.to=G})(ve||(e.SymbolKind=ve={}));var ee;(function(Se){function Fe(G){switch(G){case s.SymbolTag.Deprecated:return 1}}Se.from=Fe;function de(G){switch(G){case 1:return s.SymbolTag.Deprecated}}Se.to=de})(ee||(e.SymbolTag=ee={}));var De;(function(Se){function Fe(G){return{name:G.name,kind:ve.from(G.kind),tags:G.tags&&G.tags.map(ee.from),containerName:G.containerName,location:Ie.from(G.location)}}Se.from=Fe;function de(G){const Le=new s.$mL(G.name,ve.to(G.kind),G.containerName,Ie.to(G.location));return Le.tags=G.tags&&G.tags.map(ee.to),Le}Se.to=de})(De||(e.WorkspaceSymbol=De={}));var se;(function(Se){function Fe(G){const Le={name:G.name||"!!MISSING: name!!",detail:G.detail,range:m.from(G.range),selectionRange:m.from(G.selectionRange),kind:ve.from(G.kind),tags:G.tags?.map(ee.from)??[]};return G.children&&(Le.children=G.children.map(Fe)),Le}Se.from=Fe;function de(G){const Le=new s.$nL(G.name,G.detail,ve.to(G.kind),m.to(G.range),m.to(G.selectionRange));return(0,E.$Lb)(G.tags)&&(Le.tags=G.tags.map(ee.to)),G.children&&(Le.children=G.children.map(de)),Le}Se.to=de})(se||(e.DocumentSymbol=se={}));var x;(function(Se){function Fe(G){const Le=new s.$rL(ve.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),m.to(G.range),m.to(G.selectionRange));return Le._sessionId=G._sessionId,Le._itemId=G._itemId,Le}Se.to=Fe;function de(G,Le,ze){if(Le=Le??G._sessionId,ze=ze??G._itemId,Le===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:ze,name:G.name,detail:G.detail,kind:ve.from(G.kind),uri:G.uri,range:m.from(G.range),selectionRange:m.from(G.selectionRange),tags:G.tags?.map(ee.from)}}Se.from=de})(x||(e.CallHierarchyItem=x={}));var V;(function(Se){function Fe(de){return new s.$sL(x.to(de.from),de.fromRanges.map(G=>m.to(G)))}Se.to=Fe})(V||(e.CallHierarchyIncomingCall=V={}));var ne;(function(Se){function Fe(de){return new s.$tL(x.to(de.to),de.fromRanges.map(G=>m.to(G)))}Se.to=Fe})(ne||(e.CallHierarchyOutgoingCall=ne={}));var Ie;(function(Se){function Fe(G){return{range:G.range&&m.from(G.range),uri:G.uri}}Se.from=Fe;function de(G){return new s.$gL(p.URI.revive(G.uri),m.to(G.range))}Se.to=de})(Ie||(e.location=Ie={}));var Me;(function(Se){function Fe(G){const Le=G,ze=G;return{originSelectionRange:Le.originSelectionRange?m.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:ze.uri,range:m.from(Le.targetRange?Le.targetRange:ze.range),targetSelectionRange:Le.targetSelectionRange?m.from(Le.targetSelectionRange):void 0}}Se.from=Fe;function de(G){return{targetUri:p.URI.revive(G.uri),targetRange:m.to(G.range),targetSelectionRange:G.targetSelectionRange?m.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?m.to(G.originSelectionRange):void 0}}Se.to=de})(Me||(e.DefinitionLink=Me={}));var Ce;(function(Se){function Fe(G){return{range:m.from(G.range),contents:W.fromMany(G.contents)}}Se.from=Fe;function de(G){return new s.$jL(G.contents.map(W.to),m.to(G.range))}Se.to=de})(Ce||(e.Hover=Ce={}));var ce;(function(Se){function Fe(G){return{range:m.from(G.range),expression:G.expression}}Se.from=Fe;function de(G){return new s.$dM(m.to(G.range),G.expression)}Se.to=de})(ce||(e.EvaluatableExpression=ce={}));var ie;(function(Se){function Fe(G){if(G instanceof s.$eM)return{type:"text",range:m.from(G.range),text:G.text};if(G instanceof s.$fM)return{type:"variable",range:m.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.$gM)return{type:"expression",range:m.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Fe;function de(G){switch(G.type){case"text":return{range:m.to(G.range),text:G.text};case"variable":return{range:m.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:m.to(G.range),expression:G.expression}}}Se.to=de})(ie||(e.InlineValue=ie={}));var Q;(function(Se){function Fe(G){return{frameId:G.frameId,stoppedLocation:m.from(G.stoppedLocation)}}Se.from=Fe;function de(G){return new s.$hM(G.frameId,m.to(G.stoppedLocation))}Se.to=de})(Q||(e.InlineValueContext=Q={}));var te;(function(Se){function Fe(G){return{range:m.from(G.range),kind:G.kind}}Se.from=Fe;function de(G){return new s.$kL(m.to(G.range),G.kind)}Se.to=de})(te||(e.DocumentHighlight=te={}));var me;(function(Se){function Fe(G){return{uri:G.uri,highlights:G.highlights.map(te.from)}}Se.from=Fe;function de(G){return new s.$lL(p.URI.revive(G.uri),G.highlights.map(te.to))}Se.to=de})(me||(e.MultiDocumentHighlight=me={}));var pe;(function(Se){function Fe(de){switch(de){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Se.to=Fe})(pe||(e.CompletionTriggerKind=pe={}));var Ae;(function(Se){function Fe(de){return{triggerKind:pe.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Se.to=Fe})(Ae||(e.CompletionContext=Ae={}));var le;(function(Se){function Fe(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}Se.from=Fe;function de(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}Se.to=de})(le||(e.CompletionItemTag=le={}));var be;(function(Se){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function de(ze){return Fe.get(ze)??9}Se.from=de;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(ze){return G.get(ze)??s.CompletionItemKind.Property}Se.to=Le})(be||(e.CompletionItemKind=be={}));var F;(function(Se){function Fe(de,G){const Le=new s.$BL(de.label);return Le.insertText=de.insertText,Le.kind=be.to(de.kind),Le.tags=de.tags?.map(le.to),Le.detail=de.detail,Le.documentation=R.$ik(de.documentation)?W.to(de.documentation):de.documentation,Le.sortText=de.sortText,Le.filterText=de.filterText,Le.preselect=de.preselect,Le.commitCharacters=de.commitCharacters,w.$Ts.isIRange(de.range)?Le.range=m.to(de.range):typeof de.range=="object"&&(Le.range={inserting:m.to(de.range.insert),replacing:m.to(de.range.replace)}),Le.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Le.insertText=new s.$fL(de.insertText):(Le.insertText=de.insertText,Le.textEdit=Le.range instanceof s.$9K?new s.$bL(Le.range,Le.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Le.additionalTextEdits=de.additionalTextEdits.map(ze=>ye.to(ze))),Le.command=G&&de.command?G.fromInternal(de.command):void 0,Le}Se.to=Fe})(F||(e.CompletionItem=F={}));var q;(function(Se){function Fe(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:W.fromStrict(G.documentation)}}Se.from=Fe;function de(G){return{label:G.label,documentation:R.$ik(G.documentation)?W.to(G.documentation):G.documentation}}Se.to=de})(q||(e.ParameterInformation=q={}));var K;(function(Se){function Fe(G){return{label:G.label,documentation:W.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(q.from):[],activeParameter:G.activeParameter}}Se.from=Fe;function de(G){return{label:G.label,documentation:R.$ik(G.documentation)?W.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(q.to):[],activeParameter:G.activeParameter}}Se.to=de})(K||(e.SignatureInformation=K={}));var z;(function(Se){function Fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(K.from):[]}}Se.from=Fe;function de(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(K.to):[]}}Se.to=de})(z||(e.SignatureHelp=z={}));var X;(function(Se){function Fe(de,G){const Le=new s.$AL(S.to(G.position),typeof G.label=="string"?G.label:G.label.map(Y.to.bind(void 0,de)),G.kind&&Ee.to(G.kind));return Le.textEdits=G.textEdits&&G.textEdits.map(ye.to),Le.tooltip=R.$ik(G.tooltip)?W.to(G.tooltip):G.tooltip,Le.paddingLeft=G.paddingLeft,Le.paddingRight=G.paddingRight,Le}Se.to=Fe})(X||(e.InlayHint=X={}));var Y;(function(Se){function Fe(de,G){const Le=new s.$zL(G.label);return Le.tooltip=R.$ik(G.tooltip)?W.to(G.tooltip):G.tooltip,r.Command.is(G.command)&&(Le.command=de.fromInternal(G.command)),G.location&&(Le.location=Ie.to(G.location)),Le}Se.to=Fe})(Y||(e.InlayHintLabelPart=Y={}));var Ee;(function(Se){function Fe(G){return G}Se.from=Fe;function de(G){return G}Se.to=de})(Ee||(e.InlayHintKind=Ee={}));var Te;(function(Se){function Fe(G){return{range:m.from(G.range),url:G.target,tooltip:G.tooltip}}Se.from=Fe;function de(G){let Le;if(G.url)try{Le=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new s.$GL(m.to(G.range),Le)}Se.to=de})(Te||(e.DocumentLink=Te={}));var We;(function(Se){function Fe(G){const Le=new s.$JL(G.label);return G.textEdit&&(Le.textEdit=ye.to(G.textEdit)),G.additionalTextEdits&&(Le.additionalTextEdits=G.additionalTextEdits.map(ze=>ye.to(ze))),Le}Se.to=Fe;function de(G){return{label:G.label,textEdit:G.textEdit?ye.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Le=>ye.from(Le)):void 0}}Se.from=de})(We||(e.ColorPresentation=We={}));var Ke;(function(Se){function Fe(G){return new s.$HL(G[0],G[1],G[2],G[3])}Se.to=Fe;function de(G){return[G.red,G.green,G.blue,G.alpha]}Se.from=de})(Ke||(e.Color=Ke={}));var Ze;(function(Se){function Fe(G){return{range:m.from(G.range)}}Se.from=Fe;function de(G){return new s.$qL(m.to(G.range))}Se.to=de})(Ze||(e.SelectionRange=Ze={}));var st;(function(Se){function Fe(de){switch(de){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Se.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var nt;(function(Se){function Fe(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Fe;function de(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Se.to=de})(nt||(e.TextEditorLineNumbersStyle=nt={}));var tt;(function(Se){function Fe(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}Se.from=Fe;function de(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}Se.to=de})(tt||(e.EndOfLine=tt={}));var at;(function(Se){function Fe(de){if(typeof de=="object")return de.viewId;switch(de){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Fe})(at||(e.ProgressLocation=at={}));var ct;(function(Se){function Fe(G){const Le={start:G.start+1,end:G.end+1};return G.kind&&(Le.kind=je.from(G.kind)),Le}Se.from=Fe;function de(G){const Le={start:G.start-1,end:G.end-1};return G.kind&&(Le.kind=je.to(G.kind)),Le}Se.to=de})(ct||(e.FoldingRange=ct={}));var je;(function(Se){function Fe(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return r.$Jt.Comment;case s.FoldingRangeKind.Imports:return r.$Jt.Imports;case s.FoldingRangeKind.Region:return r.$Jt.Region}}Se.from=Fe;function de(G){if(G)switch(G.value){case r.$Jt.Comment.value:return s.FoldingRangeKind.Comment;case r.$Jt.Imports.value:return s.FoldingRangeKind.Imports;case r.$Jt.Region.value:return s.FoldingRangeKind.Region}}Se.to=de})(je||(e.FoldingRangeKind=je={}));var vt;(function(Se){function Fe(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?m.from(de.selection):void 0,override:typeof de.override=="boolean"?n.$DE.id:void 0}}Se.from=Fe})(vt||(e.TextEditorOpenOptions=vt={}));var Z;(function(Se){function Fe(ze){return ze instanceof s.$4L?ze.toJSON():typeof ze=="string"?ze:de(ze)||G(ze)?new s.$4L(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Se.from=Fe;function de(ze){const Xe=ze;return Xe?p.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function G(ze){const Xe=ze;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Le(ze){return typeof ze=="string"?ze:new s.$4L(p.URI.revive(ze.baseUri),ze.pattern)}Se.to=Le})(Z||(e.GlobPattern=Z={}));var _;(function(Se){function Fe(de){if(de){if(Array.isArray(de))return de.map(Fe);if(typeof de=="string")return de;{const G=de;return{language:G.language,scheme:G.scheme,pattern:Z.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Se.from=Fe})(_||(e.LanguageSelector=_={}));var $e;(function(Se){function Fe(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Le=>Array.isArray(Le)&&Le.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&p.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(Xe=>Xe instanceof s.$9K)))}Se.is=Fe;function de(G){return{documents:G.documents.map(Le=>Le.map(ze=>({uri:p.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(Xe=>m.from(Xe))})))}}Se.from=de})($e||(e.MappedEditsContext=$e={}));var Be;(function(Se){function Fe(G){return{start:G.start,end:G.end}}Se.from=Fe;function de(G){return new s.$sM(G.start,G.end)}Se.to=de})(Be||(e.NotebookRange=Be={}));var Qe;(function(Se){function Fe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Se.to=Fe;function de(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Se.from=de})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var it;(function(Se){function Fe(de){if(de===a.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(de===a.NotebookCellExecutionState.Pending)return;if(de===a.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Se.to=Fe})(it||(e.NotebookCellExecutionState=it={}));var rt;(function(Se){function Fe(G){switch(G){case s.NotebookCellKind.Markup:return a.CellKind.Markup;case s.NotebookCellKind.Code:default:return a.CellKind.Code}}Se.from=Fe;function de(G){switch(G){case a.CellKind.Markup:return s.NotebookCellKind.Markup;case a.CellKind.Code:default:return s.NotebookCellKind.Code}}Se.to=de})(rt||(e.NotebookCellKind=rt={}));var Ne;(function(Se){function Fe(G){const Le={metadata:G.metadata??Object.create(null),cells:[]};for(const ze of G.cells)s.$tM.validate(ze),Le.cells.push(Pt.from(ze));return Le}Se.from=Fe;function de(G){const Le=new s.$uM(G.cells.map(Pt.to));return(0,l.$Uf)(G.metadata)||(Le.metadata=G.metadata),Le}Se.to=de})(Ne||(e.NotebookData=Ne={}));var Pt;(function(Se){function Fe(G){return{cellKind:rt.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Qe.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Kt.from):[]}}Se.from=Fe;function de(G){return new s.$tM(rt.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Kt.to):void 0,G.metadata,G.internalMetadata?Qe.to(G.internalMetadata):void 0)}Se.to=de})(Pt||(e.NotebookCellData=Pt={}));var Tt;(function(Se){function Fe(G){return{mime:G.mime,valueBytes:T.$ie.wrap(G.data)}}Se.from=Fe;function de(G){return new s.$vM(G.valueBytes.buffer,G.mime)}Se.to=de})(Tt||(e.NotebookCellOutputItem=Tt={}));var Kt;(function(Se){function Fe(G){return{outputId:G.id,items:G.items.map(Tt.from),metadata:G.metadata}}Se.from=Fe;function de(G){const Le=G.items.map(Tt.to);return new s.$wM(Le,G.outputId,G.metadata)}Se.to=de})(Kt||(e.NotebookCellOutput=Kt={}));var Bt;(function(Se){function Fe(Le){return G(Le)?{include:Z.from(Le.include)??void 0,exclude:Z.from(Le.exclude)??void 0}:Z.from(Le)??void 0}Se.from=Fe;function de(Le){return G(Le)?{include:Z.to(Le.include),exclude:Z.to(Le.exclude)}:Z.to(Le)}Se.to=de;function G(Le){const ze=Le;return ze?!(0,l.$Qf)(ze.include)&&!(0,l.$Qf)(ze.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var yt;(function(Se){function Fe(de,G,Le){const ze=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(ze,Le),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Se.from=Fe})(yt||(e.NotebookStatusBarItem=yt={}));var Ht;(function(Se){function Fe(de,G,Le){const ze=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:G.toInternal(ze,Le),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}Se.from=Fe})(Ht||(e.NotebookKernelSourceAction=Ht={}));var Nt;(function(Se){function Fe(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Se.from=Fe})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Xt;(function(Se){function Fe(G){return{uri:G.uri,provides:G.provides}}Se.from=Fe;function de(G){return new s.$yM(p.URI.revive(G.uri),G.provides)}Se.to=de})(Xt||(e.NotebookRendererScript=Xt={}));var Ut;(function(Se){function Fe(G){return{message:W.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:m.from(G.location.range),uri:G.location.uri}}}Se.from=Fe;function de(G){const Le=new s.$EM(typeof G.message=="string"?G.message:W.to(G.message));return Le.actualOutput=G.actual,Le.expectedOutput=G.expected,Le.contextValue=G.contextValue,Le.location=G.location?Ie.to(G.location):void 0,Le}Se.to=de})(Ut||(e.TestMessage=Ut={}));var Rt;(function(Se){Se.namespace=h.$1J,Se.denamespace=h.$2J})(Rt||(e.TestTag=Rt={}));var Ye;(function(Se){function Fe(G){const Le=(0,t.$5M)(G).controllerId;return{extId:c.$WJ.fromExtHostTestItem(G,Le).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(ze=>Rt.namespace(Le,ze.id)),range:w.$Ts.lift(m.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&W.fromStrict(G.error)||null}}Se.from=Fe;function de(G){return{parent:void 0,error:void 0,id:c.$WJ.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Le=>{const{tagId:ze}=Rt.denamespace(Le);return new s.$FM(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:m.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Se.toPlain=de})(Ye||(e.TestItem=Ye={})),function(Se){function Fe(G){return{id:G.id}}Se.from=Fe;function de(G){return new s.$FM(G.id)}Se.to=de}(Rt||(e.TestTag=Rt={}));var Gt;(function(Se){const Fe=(G,Le)=>{const ze=[];for(const[Ve,_e]of Le)c.$WJ.compare(_e.item.extId,Ve)===2&&(Le.delete(Ve),ze.push(_e));const Xe={...Ye.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(_e=>_e.type===0).map(Ut.to)})),children:ze.map(Ve=>Fe(Ve,Le))};for(const Ve of Xe.children)Ve.parent=Xe;return Xe};function de(G){const Le=[],ze=new Map;for(const Xe of G.items){ze.set(Xe.item.extId,Xe);const Ve=c.$WJ.root(Xe.item.extId);G.request.targets.some(_e=>_e.controllerId===Ve&&_e.testIds.includes(Xe.item.extId))&&Le.push(Xe)}return{completedAt:G.completedAt,results:Le.map(Xe=>Fe(Xe,ze))}}Se.to=de})(Gt||(e.TestResults=Gt={}));var Jt;(function(Se){function Fe(ze){return{covered:ze.covered,total:ze.total}}function de(ze){return"line"in ze?S.from(ze):m.from(ze)}function G(ze){return"branches"in ze?{count:ze.executionCount,location:de(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&de(Xe.location)})):void 0}:{type:0,name:ze.name,count:ze.executionCount,location:de(ze.location)}}Se.fromDetailed=G;function Le(ze){return{uri:ze.uri,statement:Fe(ze.statementCoverage),branch:ze.branchCoverage&&Fe(ze.branchCoverage),function:ze.functionCoverage&&Fe(ze.functionCoverage),details:ze.detailedCoverage?.map(G)}}Se.fromFile=Le})(Jt||(e.TestCoverage=Jt={}));var lt;(function(Se){function Fe(de){switch(de){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Se.to=Fe})(lt||(e.CodeActionTriggerKind=lt={}));var $t;(function(Se){function Fe(G){const Le=new s.$LM(ve.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),m.to(G.range),m.to(G.selectionRange));return Le._sessionId=G._sessionId,Le._itemId=G._itemId,Le}Se.to=Fe;function de(G,Le,ze){if(Le=Le??G._sessionId,ze=ze??G._itemId,Le===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:ze,kind:ve.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:m.from(G.range),selectionRange:m.from(G.selectionRange),tags:G.tags?.map(ee.from)}}Se.from=de})($t||(e.TypeHierarchyItem=$t={}));var jt;(function(Se){function Fe(de){if(de)return{value:de.value,tooltip:de.tooltip}}Se.from=Fe})(jt||(e.ViewBadge=jt={}));var Wt;(function(Se){function Fe(ze,Xe,Ve){const _e=Xe.fileData;return _e?new s.$WL(new s.$XL(_e.name,p.URI.revive(_e.uri),_e.id,(0,M.$db)(()=>Ve(_e.id)))):ze===A.$es.uriList&&Xe.uriListData?new s.$VL(Le(Xe.uriListData)):new s.$VL(Xe.asString)}Se.to=Fe;async function de(ze,Xe){const Ve=await Xe.asString();if(ze===A.$es.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const _e=Xe.asFile();return{asString:Ve,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Se.from=de;function G(ze){return I.$qt.split(ze).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return p.URI.parse(Xe)}catch{}return Xe})}function Le(ze){return I.$qt.create(ze.map(Xe=>typeof Xe=="string"?Xe:p.URI.revive(Xe)))}})(Wt||(e.DataTransferItem=Wt={}));var Dt;(function(Se){function Fe(G,Le){const ze=G.items.map(([Xe,Ve])=>[Xe,Wt.to(Xe,Ve,Le)]);return new s.$YL(ze)}Se.toDataTransfer=Fe;async function de(G){const Le={items:[]},ze=[];for(const[Xe,Ve]of G)ze.push((async()=>{Le.items.push([Xe,await Wt.from(Xe,Ve)])})());return await Promise.all(ze),Le}Se.from=de})(Dt||(e.DataTransfer=Dt={}));var dt;(function(Se){function Fe(de){return{kind:"reply",message:de.message,title:de.title,tooltip:de.tooltip}}Se.from=Fe})(dt||(e.ChatReplyFollowup=dt={}));var Ct;(function(Se){function Fe(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",when:de.when??"",args:de.args}:dt.from(de)}Se.from=Fe})(Ct||(e.ChatFollowup=Ct={}));var xt;(function(Se){function Fe(G){const Le=new s.$XM(kt.to(G.role),G.content);return Le.name=G.name,Le}Se.to=Fe;function de(G){return{role:kt.from(G.role),content:G.content,name:G.name}}Se.from=de})(xt||(e.ChatMessage=xt={}));var kt;(function(Se){function Fe(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Se.to=Fe;function de(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Se.from=de})(kt||(e.ChatMessageRole=kt={}));var qe;(function(Se){function Fe(Le){const ze={};for(const Xe of Object.keys(Le))ze[Xe]=Le[Xe].map(Se.to);return ze}Se.objectTo=Fe;function de(Le){return{level:Mt.to(Le.level),kind:Le.kind,value:(0,b.$Bh)(Le.value),description:Le.description}}Se.to=de;function G(Le){return{level:Mt.from(Le.level),kind:Le.kind,value:Le.value,description:Le.description}}Se.from=G})(qe||(e.ChatVariable=qe={}));var Mt;(function(Se){function Fe(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Se.to=Fe;function de(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Se.from=de})(Mt||(e.ChatVariableLevel=Mt={}));var Vt;(function(Se){function Fe(de){switch(de){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Se.to=Fe})(Vt||(e.InteractiveEditorResponseFeedbackKind=Vt={}));var Qt;(function(Se){function Fe(de,G){return"placeholder"in G&&"resolvedContent"in G?{content:G.placeholder,kind:"asyncContent"}:"markdownContent"in G?((0,u.$CF)(de,"chatAgents2Additions"),{content:W.from(G.markdownContent),kind:"markdownContent"}):"content"in G?"vulnerabilities"in G&&G.vulnerabilities?((0,u.$CF)(de,"chatAgents2Additions"),{content:G.content,vulnerabilities:G.vulnerabilities,kind:"vulnerability"}):typeof G.content=="string"?{content:G.content,kind:"content"}:((0,u.$CF)(de,"chatAgents2Additions"),{content:W.from(G.content),kind:"markdownContent"}):"documents"in G?{documents:G.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(ze=>m.from(ze))})),kind:"usedContext"}:"reference"in G?{reference:"uri"in G.reference?{uri:G.reference.uri,range:m.from(G.reference.range)}:G.reference,kind:"reference"}:"inlineReference"in G?{inlineReference:"uri"in G.inlineReference?{uri:G.inlineReference.uri,range:m.from(G.inlineReference.range)}:G.inlineReference,name:G.title,kind:"inlineReference"}:"agentName"in G?((0,u.$CF)(de,"chatAgents2Additions"),{agentName:G.agentName,command:G.command,kind:"agentDetection"}):"treeData"in G?{treeData:G.treeData,kind:"treeData"}:"message"in G?{content:G.message,kind:"progressMessage"}:void 0}Se.from=Fe})(Qt||(e.ChatResponseProgress=Qt={}));var ft;(function(Se){function Fe(de){return{label:de.label,values:de.values.map(qe.from),insertText:de.insertText,detail:de.detail,documentation:de.documentation}}Se.from=Fe})(ft||(e.ChatAgentCompletionItem=ft={}));var Ft;(function(Se){function Fe(de,G,Le){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:G.toInternal(de,Le)}Se.from=Fe})(Ft||(e.TerminalQuickFix=Ft={}))}),define(Pe[219],Re([1,0,2,15,7,8,185]),function(ge,e,E,T,I,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class ${constructor(b,A,k,l={timeout:1500,errors:3}){this.c=b,this.d=A,this.f=k,this.g=l,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(b){return(A,k,l)=>{const w={dispose:this.a.push([A,k,b])};return Array.isArray(l)&&l.push(w),w}}async $participateInSave(b,A){const k=E.URI.revive(b);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),w=[];try{for(const r of[...this.a]){if(l)break;const o=this.d.getDocument(k),t=await this.h(r,{document:o,reason:M.TextDocumentSaveReason.to(A)});w.push(t)}}finally{clearTimeout(p)}return w}h([b,A,k],l){const p=this.b.get(b);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(k,b,A,l).then(()=>!0,w=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const r=this.b.get(b);this.b.set(b,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(b,A,k,l){const p=[],w=Date.now(),{document:r,reason:o}=l,{version:t}=r,n=Object.freeze({document:r,reason:o,waitUntil(a){if(Object.isFrozen(p))throw(0,T.$8)("waitUntil can not be called async");p.push(Promise.resolve(a))}});try{A.apply(k,[n])}catch(a){return Promise.reject(a)}return Object.freeze(p),new Promise((a,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(p).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(h),a(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(a=>{const c={edits:[]};for(const h of a)if(Array.isArray(h)&&h.every(i=>i instanceof I.$bL))for(const{newText:i,newEol:s,range:u}of h)c.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:u&&M.Range.from(u),text:i,eol:s&&M.EndOfLine.from(s)}});if(c.edits.length!==0)return t===r.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$7gc=$}),define(Pe[220],Re([1,0,12,2,8,7,76]),function(ge,e,E,T,I,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=e.$_gc=void 0;class ${constructor(k,l,p,w){this.start=k,this.deletedCount=l,this.deletedItems=p,this.items=w}asApiEvent(){return{range:new M.$sM(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(k,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,l,p){this.notebook=k,this.h=l,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(I.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(w){k.g=w},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(p)}return this.f}setOutputs(k){this.a=k.map(I.NotebookCellOutput.to)}setOutputItems(k,l,p){const w=p.map(I.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===k);if(r&&(l||(r.items.length=0),r.items.push(...w),r.items.length>1&&r.items.every(o=>R.$9I(o.mime)))){const o=new Map,t=[];r.items.forEach(n=>{let a;o.has(n.mime)?a=o.get(n.mime):(a=[],o.set(n.mime,a),t.push(n.mime)),a.push(n.data)}),r.items.length=0,t.forEach(n=>{const a=R.$0I(o.get(n));r.items.push({mime:n,data:a.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$_gc=g;class b{static{this.a=0}constructor(k,l,p,w,r){this.k=k,this.l=l,this.m=p,this.uri=w,this.handle=b.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===E.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(p){return p=k.n(p),k.b[p].apiCell},getCells(p){return(p?k.p(p):k.b).map(r=>r.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,p){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const w={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},r=[];for(const t of k.rawEvents)t.kind===R.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,w.contentChanges):t.kind===R.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,w.contentChanges):t.kind===R.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),r.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),r.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),r.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),r.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),r.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const o=new Map;for(let t=0;t<r.length;t++){const n=r[t],a=o.get(n.cell);if(a===void 0){const c=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,c-1)}else w.cellChanges[a]={...w.cellChanges[a],...n}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,p=k.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),k.with({start:l,end:p})}p(k){k=this.o(k);const l=[];for(let p=k.start;p<k.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,p){if(this.j)return;const w=[],r=[],o=[];if(k.reverse().forEach(t=>{const a=t[2].map(i=>{const s=new g(this,this.l,i);return l||r.push(g.asModelAddData(this.apiNotebook,i)),s}),c=new $(t[0],t[1],[],a),h=this.b.splice(t[0],t[1],...a);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);w.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),p)for(const t of w)p.push(t.asApiEvent())}s(k,l,p,w){const r=this.b.splice(k,l);this.b.splice(p,0,...r);const o=[new $(k,l,r.map(t=>t.apiCell),[]),new $(p,0,[],r)];for(const t of o)w.push(t.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,p,w){this.b[k].setOutputItems(l,p,w)}v(k,l){const p=this.b[k];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(k,l){const p=this.b[k];p.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$ahc=b}),define(Pe[221],Re([1,0,5,2,8,7]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class R{constructor(g,b,A,k={timeout:1500,errors:3}){this.b=g,this.c=b,this.d=A,this.f=k,this.a=new E.$Wd}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(b,A,k)=>{const l=function(w){b.call(A,w)};return l.extension=g,this.a.event(l,void 0,k)}}async $participateInSave(g,b,A){const k=T.URI.revive(g),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(b)},A,async(r,o)=>{const t=Date.now(),n=await await Promise.resolve(r);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof M.$eL?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const w={edits:[]};for(const r of p){const{edits:o}=I.WorkspaceEdit.from(r);w.edits=w.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(w)}}e.$qhc=R}),define(Pe[107],Re([1,0,15,8,7]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,g,b,A,k,l){this.id=$,this.f=g,this.notebookData=b,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=A,this.c=l}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(g){this.selections=[g]},get selections(){return $.a},set selections(g){if(!Array.isArray(g)||!g.every(I.$sM.isNotebookRange))throw(0,E.$7)("selections");$.a=g,$.g(g)},get visibleRanges(){return $.b},revealRange(g,b){$.f.$tryRevealRange($.id,T.NotebookRange.from(g),b??I.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$bhc=M}),define(Pe[222],Re([1,0,5,14,8]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;let M=class{constructor($,g){this.c=$,this.d=g,this.a=new E.$Ud,this.b=new E.$Ud,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,g);const b=this.d.getEditorById($);g.visibleRanges&&b._acceptVisibleRanges(g.visibleRanges.ranges.map(I.NotebookRange.to)),g.selections&&b._acceptSelections(g.selections.selections.map(I.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns($){for(const g in $)this.d.getEditorById(g)._acceptViewColumn(I.ViewColumn.to($[g]))}};e.$shc=M,e.$shc=M=Je([He(0,T.$mj)],M)}),define(Pe[223],Re([1,0,8,72,20,66,15]),function(ge,e,E,T,I,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class ${constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,l,p){const w=this.b++,{title:r,location:o,cancellable:t}=l,n={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(w,{location:E.ProgressLocation.from(o),title:r,source:n,cancellable:t},k.isUnderDevelopment?void 0:k.identifier.value).catch(R.$2),this.d(w,p,!!t)}d(k,l,p){let w;p&&(w=new I.$5d,this.c.set(k,w));const r=t=>{this.a.$progressEnd(t),this.c.delete(t),w?.dispose()};let o;try{o=l(new b(this.a,k),p&&w?w.token:I.CancellationToken.None)}catch(t){throw r(k),t}return o.then(t=>r(k),t=>r(k)),o}$acceptProgressCanceled(k){const l=this.c.get(k);l&&(l.cancel(),this.c.delete(k))}}e.$zhc=$;function g(A,k){return A.message=k.message,typeof k.increment=="number"&&(typeof A.increment=="number"?A.increment+=k.increment:A.increment=k.increment),A}class b extends T.$uv{constructor(k,l){super(p=>this.throttledReport(p)),this.c=k,this.d=l}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,M.$yh)(100,(A,k)=>g(A,k),()=>Object.create(null))],b.prototype,"throttledReport",null)}),define(Pe[108],Re([1,0,29,104,48,77,58,8,2]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=e.$kN=e.$jN=e.$iN=void 0;const b=(a,c,h,i)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(u){if(!h(s,u)){const d=s;s=u,a.listener?.(i(u,d))}}}},A=(a,c)=>a===c,k={range:(a,c)=>a===c?!0:!a||!c?!1:a.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(a,c)=>!(a.length!==c.length||a.some(h=>!c.find(i=>h.id===i.id)))},l=a=>c=>({op:4,update:a(c)}),p=(a,c)=>({range:(()=>{let h;const i=l(s=>({range:E.$Ts.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){a.listener?.({op:6}),k.range(h,s)||(h=s,a.listener?.(i(s)))}}})(),label:b(a,c,k.label,l(h=>({label:h}))),description:b(a,void 0,k.description,l(h=>({description:h}))),sortText:b(a,void 0,k.sortText,l(h=>({sortText:h}))),canResolveChildren:b(a,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:b(a,!1,k.busy,l(h=>({busy:h}))),error:b(a,void 0,k.error,l(h=>({error:$.MarkdownString.fromStrict(h)||null}))),tags:b(a,[],k.tags,(h,i)=>({op:1,new:h.map($.TestTag.from),old:i.map($.TestTag.from)}))}),w=a=>{const c=I.$WJ.fromString(a.extId),h=new o(c.controllerId,c.localId,a.label,g.URI.revive(a.uri)||void 0);return h.range=$.Range.to(a.range||void 0),h.description=a.description||void 0,h.sortText=a.sortText||void 0,h.tags=a.tags.map(i=>$.TestTag.to({id:(0,R.$2J)(i).tagId})),h},r=a=>{let c;for(const h of a.tests){const i=w(h.item);(0,T.$5M)(i).parent=c,c=i}return c};e.$iN=r;class o{constructor(c,h,i,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,T.$4M)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,M.$3M)(u,T.$5M,o),enumerable:!0,writable:!1},...p(u,i)})}}e.$jN=o;class t extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$kN=t;class n extends M.$YM{constructor(c,h,i){super({controllerId:c,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:T.$5M,getChildren:s=>s.children,root:new t(c,h),toITestItem:$.TestItem.from})}}e.$lN=n}),define(Pe[109],Re([1,0,53,15,89,8,7]),function(ge,e,E,T,I,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=void 0;class ${static{this.c=new I.$bN("TextEditorDecorationType")}constructor(l,p,w){const r=$.c.nextId();l.$registerTextEditorDecorationType(p.identifier,r,M.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$dN=$;class g{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let w=null;if(l instanceof R.$8K)w=new R.$9K(l,l);else if(l instanceof R.$9K)w=l;else throw new Error("Unrecognized location");this.l(w,p,!1)}insert(l,p){this.k(),this.l(new R.$9K(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof R.$9K)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,w){const r=this.c.validateRange(l);this.g.push({range:r,text:p,forceMoveMarkers:w})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=l}}class b{constructor(l,p,w,r){this.c=l,this.d=p,this._accept(w),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(t){o.n(t)},get indentSize(){return o.g},set indentSize(t){o.p(t)},get insertSpaces(){return o.j},set insertSpaces(t){o.s(t)},get cursorStyle(){return o.k},set cursorStyle(t){o.t(t)},get lineNumbers(){return o.l},set lineNumbers(t){o.u(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=M.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}n(l){const p=this.m(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}p(l){const p=this.o(l);if(p!==null){if(typeof p=="number"){if(this.h===p)return;this.g=p,this.h=p}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const p=this.q(l);if(typeof p=="boolean"){if(this.j===p)return;this.j=p}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let w=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(w=!0,p.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,w=!0,p.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(w=!0,p.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,w=!0,p.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(w=!0,p.insertSpaces=r):this.j!==r&&(this.j=r,w=!0,p.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,w=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,w=!0,p.lineNumbers=M.TextEditorLineNumbersStyle.from(l.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,p))}v(l,p){p.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(w)})}}e.$eN=b;class A{constructor(l,p,w,r,o,t,n,a){this.id=l,this.j=p,this.k=w,this.g=!1,this.h=new Set,this.c=o,this.d=new b(this.j,this.id,t,w),this.e=n,this.f=a;const c=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof R.$0K))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof R.$0K)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new g(r.value,i);return h(s),c.m(s)},insertSnippet(h,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(d=>M.Range.from(d));else if(i instanceof R.$8K){const{lineNumber:d,column:m}=M.Position.from(i);u=[{startLineNumber:d,startColumn:m,endLineNumber:d,endColumn:m}]}else if(i instanceof R.$9K)u=[M.Range.from(i)];else{u=[];for(const d of i)if(d instanceof R.$9K)u.push(M.Range.from(d));else{const{lineNumber:m,column:f}=M.Position.from(d);u.push({startLineNumber:m,startColumn:f,endLineNumber:m,endColumn:f})}}return p.$tryInsertSnippet(l,r.value.version,h.value,u,s)},setDecorations(h,i){const s=i.length===0;s&&!c.h.has(h.key)||(s?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(M.$6M(i))return p.$trySetDecorations(l,h.key,M.$7M(i));{const u=new Array(4*i.length);for(let d=0,m=i.length;d<m;d++){const f=i[d];u[4*d]=f.start.line+1,u[4*d+1]=f.start.character+1,u[4*d+2]=f.end.line+1,u[4*d+3]=f.end.character+1}return p.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,i){c.n(()=>p.$tryRevealRange(l,M.Range.from(h),i||R.TextEditorRevealType.Default))},show(h){p.$tryShowEditor(l,M.ViewColumn.from(h))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const w=p.edits.map(o=>o.range);w.sort((o,t)=>o.end.line===t.end.line?o.end.character===t.end.character?o.start.line===t.start.line?o.start.character-t.start.character:o.start.line-t.start.line:o.end.character-t.end.character:o.end.line-t.end.line);for(let o=0,t=w.length-1;o<t;o++){const n=w[o].end;if(w[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=p.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,r,{setEndOfLine:typeof p.setEndOfLine=="number"?M.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$fN=A}),define(Pe[224],Re([1,0,166,25,2,5,6,204,13,7,16,18,8,52,20,132,23]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;function t(c,h){if((0,A.$Hf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends R.$Tc{constructor(h,i,s){super(),this.f=h,this.g=i,this.h=s,this.a=new Map,this.b=new r.$f8;function u(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:d=>u(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(m=>u(m)?this.r(m):m):d})}registerTreeDataProvider(h,i,s){const u=this.createTreeView(h,{treeDataProvider:i},s);return{dispose:()=>u.dispose()}}createTreeView(h,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],d=i.dragAndDropController?.dragMimeTypes??[],m=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,S=this.m(h,i,s),L={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:d,hasHandleDrag:m,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(h,L),y={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,o.$CF)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,o.$CF)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(D){(0,p.$ik)(D)&&(0,o.$CF)(s,"treeViewMarkdownMessage"),S.message=D},get title(){return S.title},set title(D){S.title=D},get description(){return S.description},set description(D){S.description=D},get badge(){return S.badge},set badge(D){D!==void 0&&b.ViewBadge.isViewBadge(D)?S.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(S.badge=void 0)},reveal:(D,N)=>S.reveal(D,N),dispose:async()=>{await v,this.a.delete(h),S.dispose()}};return this.B(y),y}$getChildren(h,i){const s=this.a.get(h);return s?s.getChildren(i):Promise.reject(new $.$aF(h))}async $handleDrop(h,i,s,u,d,m,f,S){const L=this.a.get(h);if(!L)return Promise.reject(new $.$aF(h));const v=l.DataTransfer.toDataTransfer(s,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return f===h&&S&&await this.j(v,L,S,d,m),L.onDrop(v,u,d)}async j(h,i,s,u,d){const m=this.b.removeDragOperationTransfer(d);if(m)(await m)?.forEach((f,S)=>{f&&h.set(S,f)});else if(d&&i.handleDrag){const f=i.handleDrag(s,h,u);this.b.addDragOperationTransfer(d,f),await f}return h}async $handleDrag(h,i,s,u){const d=this.a.get(h);if(!d)return Promise.reject(new $.$aF(h));const m=await this.j(new b.$YL,d,i,u,s);if(!(!m||u.isCancellationRequested))return l.DataTransfer.from(m)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new $.$aF(h);return i.hasResolve}$resolve(h,i,s){const u=this.a.get(h);if(!u)throw new $.$aF(h);return u.resolveTreeItem(i,s)}$setExpanded(h,i,s){const u=this.a.get(h);if(!u)throw new $.$aF(h);u.setExpanded(i,s)}$setSelectionAndFocus(h,i,s){const u=this.a.get(h);if(!u)throw new $.$aF(h);u.setSelectionAndFocus(i,s)}$setVisible(h,i){const s=this.a.get(h);if(!s){if(!i)return;throw new $.$aF(h)}s.setVisible(i)}$changeCheckboxState(h,i){const s=this.a.get(h);if(!s)throw new $.$aF(h);s.setCheckboxState(i)}m(h,i,s){const u=this.B(new a(h,i,this.f,this.g.converter,this.h,s));return this.a.set(h,u),u}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$Shc=n;class a extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$Qf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,s,u,d,m){if(super(),this.I=h,this.J=s,this.L=u,this.M=d,this.N=m,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Ud),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Ud),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Ud),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Ud),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Ud),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Ud),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Ud),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$5d,m.contributes&&m.contributes.views)for(const v in m.contributes.views)for(const y of m.contributes.views[v])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let f,S;const L=M.Event.debounce(this.F.event,(v,y)=>(v||(v={message:!1,elements:[]}),y.element!==!1&&(f||(f=new Promise(D=>S=D),this.G=this.G.then(()=>f)),Array.isArray(y.element)?v.elements.push(...y.element):v.elements.push(y.element)),y.message&&(v.message=!0),v),200,!0);this.B(L(({message:v,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const D=S;return f=null,this.$(y).then(()=>D())})),v&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.X(h);return s||(s=await this.Y(i)),s?s.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const s=(0,A.$Qf)(i.select)?!0:i.select,u=(0,A.$Qf)(i.focus)?!1:i.focus,d=(0,A.$Qf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(m=>this.W(h,m[m.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:m.map(S=>S.item)},{select:s,focus:u,expand:d})),m=>this.M.error(m)):this.J.$reveal(this.I,void 0,{select:s,focus:u,expand:d})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const s=this.getExtensionElement(h);s&&(i?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(h,i){const s=!(0,k.$ub)(this.s,h);this.s=h;const u=this.t!==i;this.t=i,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async s=>{const u=this.getExtensionElement(s.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:s.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,i,s){const u=[];for(const d of h){const m=this.getExtensionElement(d);m&&u.push(m)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,s){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,g.$Xg)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const s=this.j.get(h);if(s){const u=this.m.get(s);if(u){const d=await this.f.resolveTreeItem(u.extensionItem,s,i)??u.extensionItem;return this.hb(d),u.item.tooltip=this.eb(d.tooltip),u.item.command=this.fb(u.disposableStore,d.command),u.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(s=>this.W(i,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$Xg)(()=>this.f.getParent(h))}W(h,i){const s=this.m.get(h);return s?Promise.resolve(s):(0,g.$Xg)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const d=this.getExtensionElement(u);if(d){const m=this.m.get(d);if(m)return Promise.resolve(m)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const s=this.getExtensionElement(h);i=s?this.m.get(s):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new w.$5d(this.Z.token);try{const s=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const d=(0,k.$Hb)(u||[]),m=await Promise.all((0,k.$Hb)(d).map(S=>this.f.getTreeItem(S)));if(i.token.isCancellationRequested)return;const f=m.map((S,L)=>S?this.db(d[L],S,s):null);return(0,k.$Hb)(f)}finally{i.dispose()}}$(h){if(h.some(s=>!s))return this.Z.dispose(!0),this.Z=new w.$5d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(h);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(h){const i=new Set,s=h.map(d=>this.m.get(d));for(const d of s)if(d&&!i.has(d.item.handle)){let m=d;for(;m&&m.parent&&s.findIndex(f=>m&&m.parent&&f&&f.item.handle===m.parent.item.handle)===-1;){const f=this.j.get(m.parent.item.handle);m=f?this.m.get(f):void 0}m&&!m.parent&&i.add(d.item.handle)}const u=[];return i.forEach(d=>{const m=this.j.get(d);if(m){const f=this.m.get(m);f&&(!f.parent||!i.has(f.parent.item.handle))&&u.push(d)}}),u}bb(h){const i={};return Promise.all(h.map(s=>this.cb(s).then(u=>{u&&(i[s]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const s=this.m.get(i);if(s)return this.rb(i),(0,g.$Xg)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const d=this.ib(i,u,s.parent);return this.pb(i,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(h,i,s){const u=this.ib(h,i,s);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(h,u),this.qb(u,s),u}eb(h){return b.$vL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,s,u;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,s=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:i===b.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:u}}hb(h){if(!b.$TL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,s){this.hb(i);const u=this.B(new R.$Sc),d=this.kb(h,i,s),m=this.lb(i);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:m,iconDark:this.mb(i)||m,themeIcon:this.jb(i),collapsibleState:(0,A.$Qf)(i.collapsibleState)?b.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof b.$2L?h.iconPath:void 0}kb(h,{id:i,label:s,resourceUri:u},d,m){if(i)return`${a.b}/${i}`;const f=t(s,this.N),S=d?d.item.handle:a.a;let L=f?f.label:u?(0,T.$Dg)(u):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const v=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(d)||[];let D,N=0;do{if(D=`${S}/${N}:${L}`,m||!this.j.has(D)||v===D)break;N++}while(N<=y.length);return D}lb(h){if(h.iconPath&&!(h.iconPath instanceof b.$2L))return typeof h.iconPath=="string"||I.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof b.$2L)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return I.URI.isUri(h)?h:I.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,s,u){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(h,i);const d=this.X(u)||[],m=d.filter(f=>f.item.handle===s.item.handle)[0];m&&d.splice(d.indexOf(m),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[225],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[226],Re([1,0,178,15,31,97,73,30,22,225,188,101]),function(ge,e,E,T,I,M,R,$,g,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=void 0;const l=$.$Gn.as(R.$Hn.JSONContribution);class p{constructor(h,i,s){this.a=h,this.b=i,this.c=s}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(I.default.Error,h)}warn(h){this.d(I.default.Warning,h)}info(h){this.d(I.default.Info,h)}}e.$qF=p;class w{static a(h){const i=new g.$lm;for(let s=0,u=h.length;s<u;s++)i.add(h[s].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new w(i,[]);if(!i||!i.length)return new w([],h);const s=this.a(h),u=this.a(i),d=i.filter(f=>!s.has(f.description.identifier)),m=h.filter(f=>!u.has(f.description.identifier));return new w(d,m)}constructor(h,i){this.added=h,this.removed=i}}e.$rF=w;class r{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=w.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$sF=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$tF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$jm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$lo}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$lo}},extensionKind:{description:E.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&k.$hF.register(h.extensionPoint,h.activationEventsGenerator),e.$tF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(t,e.$tF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$uF=n;const a={ExtensionsRegistry:"ExtensionsRegistry"};$.$Gn.add(a.ExtensionsRegistry,new n),e.$vF=$.$Gn.as(a.ExtensionsRegistry),l.registerSchema(t,e.$tF),l.registerSchema(A.$Fj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(Pe[227],Re([1,0,174,16,26,226,35,5]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var b;(function(l){function p(w,r,o){if(!w)return;const t=T.$Hf(w.type)?w.type:void 0;if(!t||t.length===0){o.error(E.localize(3,null));return}const n=[];if(Array.isArray(w.required))for(const a of w.required)T.$Hf(a)&&n.push(a);return{extensionId:r.value,taskType:t,required:n,properties:w.properties?I.$un(w.properties):{},when:w.when?R.$3i.deserialize(w.when):void 0}}l.from=p})(b||(b={}));const A=M.$vF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const w of l)w.type&&p.push(`onTaskType:${w.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:g}});class k{constructor(){this.d=new $.$Ud,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,w)=>{A.setHandler((r,o)=>{this.c=void 0;try{for(const t of o.removed){const n=t.value;for(const a of n)this.a&&a.type&&this.a[a.type]&&delete this.a[a.type]}for(const t of o.added){const n=t.value;for(const a of n){const c=b.from(a,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const w of this.all()){const r={type:"object",additionalProperties:!1};w.required.length>0&&(r.required=w.required.slice(0)),w.properties!==void 0?r.properties=I.$un(w.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[w.taskType]},p.push(r)}this.c={oneOf:p}}return this.c}}e.$xG=new k}),define(Pe[228],Re([1,0,175,16,25,26,35,227]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HG=e.JsonSchemaVersion=e.ExecutionEngine=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BG=e.ShellQuoting=e.$AG=e.$zG=e.$yG=void 0,e.$yG="settings",e.$zG=new R.$jj("taskRunning",!1,E.localize(0,null)),e.$AG={value:E.localize(1,null),original:"Tasks"};var g;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$BG="$customized",function(P){function C(J){if(!J)return P.Strong;switch(J.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=C}(g||(e.ShellQuoting=g={}));var b;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var A;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(A||(e.RevealKind=A={})),function(P){function C(J){switch(J.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=C}(A||(e.RevealKind=A={}));var k;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(P){function C(J){switch(J.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=C}(k||(e.RevealProblemKind=k={}));var l;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(l||(e.PanelKind=l={})),function(P){function C(J){switch(J.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=C}(l||(e.PanelKind=l={}));var p;(function(P){P.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var w;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(w||(e.RuntimeType=w={})),function(P){function C(ae){switch(ae.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=C;function J(ae){switch(ae){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=J}(w||(e.RuntimeType=w={}));var r;(function(P){function C(J){return T.$Hf(J)?J:J.value}P.value=C})(r||(e.CommandString=r={}));var o;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function C(ae){return ae===P.Clean._id||ae===P.Build._id||ae===P.Rebuild._id||ae===P.Test._id}P.is=C;function J(ae){if(ae!==void 0)return T.$Hf(ae)?C(ae)?{_id:ae,isDefault:!1}:void 0:ae}P.from=J})(o||(e.TaskGroup=o={}));var t;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function C(J){switch(J){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=C})(n||(e.TaskSourceKind=n={}));var a;(function(P){P.parallel="parallel",P.sequence="sequence"})(a||(e.DependsOrder=a={}));var c;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(C,J,ae,fe,we,ye){this._label="",this._id=C,J&&(this._label=J),ae&&(this.type=ae),this.runOptions=fe,this.configurationProperties=we,this._source=ye}getDefinition(C){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const C={folder:this.d(),id:this._id};return JSON.stringify(C)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(C,J=!1){if(C===void 0)return!1;if(T.$Hf(C))return C===this._label||C===this.configurationProperties.identifier||J&&C===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===C._key}getQualifiedLabel(){const C=this.getWorkspaceFolder();return C?`${this._label} (${C.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(C){this.c===void 0&&(this.c=[]),C&&(this.c=this.c.concat(C))}get taskLoadMessages(){return this.c}}e.$CG=i;class s extends i{constructor(C,J,ae,fe,we,ye,he,ve){super(C,ae,void 0,he,ve,J),this.command={},this._source=J,this.hasDefinedMatchers=ye,we&&(this.command=we)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(C=!1){if(C&&this._source.customizes!==void 0)return this._source.customizes;{let J;switch(this.command?this.command.runtime:void 0){case w.Shell:J="shell";break;case w.Process:J="process";break;case w.CustomExecution:J="customExecution";break;case void 0:J="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:J,_key:this._id,id:this._id}}}static is(C){return C instanceof s}getMapKey(){const C=this._source.config.workspaceFolder;return C?`${C.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const C=this.d();if(!C)return;let J=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(J+=this._source.kind);const ae={type:e.$BG,folder:C,id:J};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Dg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(C){return new s(C._id,C._source,C._label,C.type,C.command,C.hasDefinedMatchers,C.runOptions,C.configurationProperties)}}e.$DG=s;class u extends i{constructor(C,J,ae,fe,we,ye,he){super(C,ae,fe,ye,he,J),this._source=J,this.configures=we}static is(C){return C instanceof u}f(C){return C}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Dg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const C=this.d();if(!C)return;let J=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(J+=this._source.kind);const ae={type:e.$BG,folder:C,id:J};return JSON.stringify(ae)}}e.$EG=u;class d extends i{constructor(C,J,ae,fe,we,ye,he,ve,ee){super(C,ae,fe,ve,ee,J),this.defines=we,this.hasDefinedMatchers=he,this.command=ye,this.icon=ee.icon,this.hide=ee.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(C){return C instanceof d}getMapKey(){const C=this._source.workspaceFolder;return C?`${this._source.scope.toString()}|${C.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const C={type:"contributed",scope:this._source.scope,id:this._id};return C.folder=this.d(),JSON.stringify(C)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(C){return new d(C._id,C._source,C._label,C.type,C.defines,C.command,C.hasDefinedMatchers,C.runOptions,C.configurationProperties)}}e.$FG=d;class m extends i{constructor(C,J,ae,fe,we,ye){super(C,ae,fe,we,ye,J),this._source=J}clone(){return new m(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(C){return C instanceof m}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(C){return new m(C._id,C._source,C._label,C.type,C.runOptions,C.configurationProperties)}}e.$GG=m;var f;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(P){P._default=P.Terminal}(f||(e.ExecutionEngine=f={}));var S;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class L{constructor(C){this.c=new Map;for(let J=0;J<C.length;J++)this.c.set(C[J].uri.toString(),J)}compare(C,J){const ae=C.getWorkspaceFolder(),fe=J.getWorkspaceFolder();if(ae&&fe){let we=this.c.get(ae.uri.toString());we=we===void 0?0:we+1;let ye=this.c.get(fe.uri.toString());return ye=ye===void 0?0:ye+1,we===ye?C._label.localeCompare(J._label):we-ye}else return!ae&&fe?-1:ae&&!fe?1:0}}e.$HG=L;var v;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(v||(e.TaskEventKind=v={}));var y;(function(P){P.SingleRun="singleRun",P.Background="background"})(y||(e.TaskRunType=y={}));var D;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var N;(function(P){function C(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function J(ve,ee,De){return{...C(ve),kind:"start",terminalId:ee,resolvedVariables:De}}P.start=J;function ae(ve,ee,De){return{...C(ve),kind:"processStarted",terminalId:ee,processId:De}}P.processStarted=ae;function fe(ve,ee,De){return{...C(ve),kind:"processEnded",terminalId:ee,exitCode:De}}P.processEnded=fe;function we(ve,ee,De){return{...C(ve),kind:"terminated",exitReason:De,terminalId:ee}}P.terminated=we;function ye(ve,ee,De){return{...C(ee),kind:ve,terminalId:De}}P.general=ye;function he(){return{kind:"changed"}}P.changed=he})(N||(e.TaskEvent=N={}));var O;(function(P){function C(ae){const fe=Object.keys(ae).sort();let we="";for(const ye of fe){let he=ae[ye];he instanceof Object?he=C(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),we+=ye+","+he+","}return we}function J(ae){const we={_key:C(ae),type:ae.taskType};return Object.assign(we,ae),we}P.create=J})(O||(e.KeyedTaskIdentifier=O={}));var H;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection",P.VerboseLogging="task.verboseLogging"})(H||(e.TaskSettingId=H={}));var U;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var W;(function(P){function C(J,ae){const fe=$.$xG.get(J.type);if(fe===void 0){const ve=M.$un(J);return delete ve._key,O.create(ve)}const we=Object.create(null);we.type=fe.taskType;const ye=new Set;fe.required.forEach(ve=>ye.add(ve));const he=fe.properties;for(const ve of Object.keys(he)){const ee=J[ve];if(ee!=null)we[ve]=ee;else if(ye.has(ve)){const De=he[ve];if(De.default!==void 0)we[ve]=M.$un(De.default);else switch(De.type){case"boolean":we[ve]=!1;break;case"number":case"integer":we[ve]=0;break;case"string":we[ve]="";break;default:ae.error(E.localize(2,null,JSON.stringify(J,void 0,0),ve));return}}}return O.create(we)}P.createTaskIdentifier=C})(W||(e.TaskDefinition=W={}))}),define(Pe[229],Re([1,0,15]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97b=e.$87b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$1)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$87b=T;class I extends T{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$97b=I}),define(Pe[49],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sv=e.$Rv=e.$Qv=e.$Pv=void 0;class E{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++E.count}}e.$Pv=E;const T=[];function I($){const g=new E($);return T[g.nid]=g,g}e.$Qv=I;function M($){return T[$].sid}e.$Rv=M;class R{constructor(g){this.value=g}}e.$Sv=R}),define(Pe[3],Re([1,0,49]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6K=e.$5K=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$4K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var M;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var g;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var b;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var A;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static{this.a=0}static mixin(o){return o._id=k.a++,o}}e.$4K=k;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var w;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$5K={MainThreadAuthentication:(0,E.$Qv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Qv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Qv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Qv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Qv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Qv)("MainThreadClipboard"),MainThreadCommands:(0,E.$Qv)("MainThreadCommands"),MainThreadComments:(0,E.$Qv)("MainThreadComments"),MainThreadConfiguration:(0,E.$Qv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Qv)("MainThreadConsole"),MainThreadDebugService:(0,E.$Qv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Qv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Qv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Qv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Qv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Qv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Qv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Qv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Qv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Qv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Qv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Qv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Qv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Qv)("MainThreadLanguages"),MainThreadLogger:(0,E.$Qv)("MainThreadLogger"),MainThreadMessageService:(0,E.$Qv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Qv)("MainThreadOutputService"),MainThreadProgress:(0,E.$Qv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Qv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Qv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Qv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Qv)("MainThreadSecretState"),MainThreadStorage:(0,E.$Qv)("MainThreadStorage"),MainThreadSpeech:(0,E.$Qv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Qv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Qv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Qv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Qv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Qv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Qv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Qv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Qv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Qv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Qv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Qv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Qv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Qv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Qv)("MainThreadSCM"),MainThreadSearch:(0,E.$Qv)("MainThreadSearch"),MainThreadShare:(0,E.$Qv)("MainThreadShare"),MainThreadTask:(0,E.$Qv)("MainThreadTask"),MainThreadWindow:(0,E.$Qv)("MainThreadWindow"),MainThreadLabelService:(0,E.$Qv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Qv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Qv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Qv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Qv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Qv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Qv)("MainThreadInteractive"),MainThreadChat:(0,E.$Qv)("MainThreadChat"),MainThreadInlineChat:(0,E.$Qv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Qv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Qv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Qv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Qv)("MainThreadTimeline"),MainThreadTesting:(0,E.$Qv)("MainThreadTesting"),MainThreadLocalization:(0,E.$Qv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Qv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Qv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Qv)("MainThreadIssueReporter")},e.$6K={ExtHostCommands:(0,E.$Qv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Qv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Qv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Qv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Qv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Qv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Qv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Qv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Qv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Qv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Qv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Qv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Qv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Qv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Qv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Qv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Qv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Qv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Qv)("ExtHostStatusBar"),ExtHostShare:(0,E.$Qv)("ExtHostShare"),ExtHostExtensionService:(0,E.$Qv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Qv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Qv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Qv)("ExtHostSCM"),ExtHostSearch:(0,E.$Qv)("ExtHostSearch"),ExtHostTask:(0,E.$Qv)("ExtHostTask"),ExtHostWorkspace:(0,E.$Qv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Qv)("ExtHostWindow"),ExtHostWebviews:(0,E.$Qv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Qv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Qv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Qv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Qv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Qv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Qv)("ExtHostProgress"),ExtHostComments:(0,E.$Qv)("ExtHostComments"),ExtHostSecretState:(0,E.$Qv)("ExtHostSecretState"),ExtHostStorage:(0,E.$Qv)("ExtHostStorage"),ExtHostUrls:(0,E.$Qv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Qv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Qv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Qv)("ExtHostOutputService"),ExtHostLabelService:(0,E.$Qv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Qv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Qv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Qv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Qv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Qv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Qv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Qv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Qv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Qv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Qv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Qv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Qv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Qv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Qv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Qv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Qv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Qv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Qv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Qv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Qv)("ExtHostTimeline"),ExtHostTesting:(0,E.$Qv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Qv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Qv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Qv)("ExtHostIssueReporter")}}),define(Pe[230],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$5K.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,g){if(this.a.size===0)throw new Error("No related information providers registered");const b=this.a.get(R);if(!b)throw new Error("related information provider not found");return await b.provideRelatedInformation($,g)??[]}getRelatedInformation(R,$,g){return this.c.$getAiRelatedInformation($,g)}registerRelatedInformationProvider(R,$,g){const b=this.b;return this.b++,this.a.set(b,g),this.c.$registerAiRelatedInformationProvider(b,$),new T.$7K(()=>{this.c.$unregisterAiRelatedInformationProvider(b),this.a.delete(b)})}}e.$Sfc=I}),define(Pe[81],Re([1,0,4,14,3,17]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=e.$Yfc=void 0,e.$Yfc=(0,E.$5h)("IExtHostApiDeprecationService");let R=class{constructor(g,b){this.c=b,this.a=new Set,this.b=g.getProxy(I.$5K.MainThreadTelemetry)}report(g,b,A){const k=this.d(g,b);this.a.has(k)||(this.a.add(k),b.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:g}))}d(g,b){return`${g}-${b.identifier.value}`}};e.$Zfc=R,e.$Zfc=R=Je([He(0,M.$9M),He(1,T.$mj)],R),e.$1fc=Object.freeze(new class{report($,g,b){}})}),define(Pe[231],Re([1,0,5,3,7,22]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class R{constructor(b){this.b=new Map,this.c=new E.$Ud,this.onDidChangeSessions=this.c.event,this.d=new $,this.f=new $,this.a=b.getProxy(T.$5K.MainThreadAuthentication)}async getSession(b,A,k,l={}){const p=M.$km.toKey(b.identifier),w=[...k].sort().join(" ");return await this.d.getOrCreate(`${p} ${A} ${w}`,async()=>{await this.a.$ensureProvider(A);const r=b.displayName||b.name;return this.a.$getSession(A,k,p,r,l)})}async getSessions(b,A,k){const l=M.$km.toKey(b.identifier),p=[...k].sort().join(" ");return await this.f.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(A);const w=b.displayName||b.name;return this.a.$getSessions(A,k,l,w)})}async removeSession(b,A){const k=this.b.get(b);return k?k.provider.removeSession(A):this.a.$removeSession(b,A)}registerAuthenticationProvider(b,A,k,l){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:A,provider:k,options:l??{supportsMultipleAccounts:!1}});const p=k.onDidChangeSessions(w=>this.a.$sendDidChangeSessions(b,w));return this.a.$registerAuthenticationProvider(b,A,l?.supportsMultipleAccounts??!1),new I.$7K(()=>{p.dispose(),this.b.delete(b),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,A,k){const l=this.b.get(b);if(l)return Promise.resolve(l.provider.createSession(A,k));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,A){const k=this.b.get(b);if(k)return Promise.resolve(k.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,A){const k=this.b.get(b);if(k)return Promise.resolve(k.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,A){return this.c.fire({provider:{id:b,label:A}}),Promise.resolve()}}e.$4fc=R;class ${constructor(){this.a=new Map}getOrCreate(b,A){const k=this.a.get(b);if(k)return k;const l=A().finally(()=>this.a.delete(b));return this.a.set(b,l),l}}}),define(Pe[232],Re([1,0,3,17,8]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;let M=class{constructor($,g){this.a=$.getProxy(E.$5K.MainThreadBulkEdits),this.b={getTextDocumentVersion:b=>g.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,g,b){const A=I.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,b?.isRefactoring??!1)}};e.$5fc=M,e.$5fc=M=Je([He(0,T.$9M)],M)}),define(Pe[233],Re([1,0,67,6,3,8]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;class R{static{this.a=0}constructor(b,A){this.extension=b,this.provider=A,this.handle=R.a++}}class ${static{this.a=0}constructor(b){this.b=new Map,this.c=new Map,this.d=b.getProxy(I.$5K.MainThreadChat)}registerChatProvider(b,A,k){const l=new R(b,k);return this.b.set(l.handle,l),this.d.$registerChatProvider(l.handle,A),(0,T.$Rc)(()=>{this.d.$unregisterChatProvider(l.handle),this.b.delete(l.handle)})}transferChatSession(b,A){const k=E.Iterable.find(this.c.keys(),l=>this.c.get(l)===b)??0;typeof k=="number"&&this.d.$transferChatSession(k,A)}sendInteractiveRequestToProvider(b,A){this.d.$sendRequestToProvider(b,A)}async $prepareChat(b,A){const k=this.b.get(b);if(!k)return;const l=await k.provider.prepareSession(A);if(!l)return;const p=$.a++;return this.c.set(p,l),{id:p,requesterUsername:l.requester?.name,requesterAvatarIconUri:l.requester?.icon,responderUsername:l.responder?.name,responderAvatarIconUri:l.responder?.icon,inputPlaceholder:l.inputPlaceholder}}async $provideWelcomeMessage(b,A){const k=this.b.get(b);if(!k||!k.provider.provideWelcomeMessage)return;const l=await k.provider.provideWelcomeMessage(A);if(l)return l.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(w=>M.ChatReplyFollowup.from(w)):M.MarkdownString.from(p))}async $provideSampleQuestions(b,A){const k=this.b.get(b);if(!k||!k.provider.provideSampleQuestions)return;const l=await k.provider.provideSampleQuestions(A);if(l)return l?.map(p=>M.ChatReplyFollowup.from(p))}$releaseSession(b){this.c.delete(b)}}e.$6fc=$}),define(Pe[234],Re([1,0,13,20,40,5,60,16,2,157,72,3,8,7,205,23]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;class o{static{this.a=0}constructor(a,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=a.getProxy(k.$5K.MainThreadChatAgents2)}createChatAgent(a,c,h){const i=o.a++,s=new t(a,c,this.d,i,h);return this.b.set(i,s),this.d.$registerAgent(i,c,{}),s.apiAgent}async $invokeAgent(a,c,h,i,s,u){this.g.delete(c);const d=this.b.get(a);if(!d)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let m=!1;function f(){if(m)throw new Error("Only valid while executing the command")}const S=new E.$ph;u.onCancellationRequested(()=>S.complete()),this.i.allowListExtensionWhile(d.extension.identifier,S.p);const L=i.command?await d.validateSlashCommand(i.command):void 0,v=R.$Qd.create(!1);let y;try{const D=d.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:L},{history:s.history.map(l.ChatMessage.to)},new A.$uv(N=>{f(),typeof y>"u"&&"content"in N&&(y=v.elapsed());const O=l.ChatResponseProgress.from(d.extension,N);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(N));return}if("placeholder"in N&&"resolvedContent"in N){const H=Promise.all([this.d.$handleProgressChunk(h,O),N.resolvedContent]);(0,E.$Tg)(H,u).then(U=>{if(!U)return;const[W,P]=U,C=l.ChatResponseProgress.from(d.extension,P);if(!C){this.j.error("Unknown progress type: "+JSON.stringify(P));return}this.d.$handleProgressChunk(h,C,W??void 0)})}else this.d.$handleProgressChunk(h,O)}),u);return await(0,E.$Tg)(Promise.resolve(D).then(N=>{if(N){this.g.set(c,N);let O=this.h.get(c);O||(O=new Map,this.h.set(c,O)),O.set(h,N);const H={firstProgress:y,totalElapsed:v.elapsed()};return{errorDetails:N.errorDetails,timings:H}}else this.g.delete(c)}),u)}catch(D){return this.j.error(D,d.extension),{errorDetails:{message:(0,b.localize)(0,null,(0,I.$Pi)(D)),responseIsIncomplete:!0}}}finally{m=!0,S.complete()}}$releaseSession(a){this.g.delete(a),this.h.delete(a)}async $provideSlashCommands(a,c){const h=this.b.get(a);return h?h.provideSlashCommand(c):[]}$provideFollowups(a,c,h){const i=this.b.get(a);if(!i)return Promise.resolve([]);const s=this.g.get(c);return s?i.provideFollowups(s,h):Promise.resolve([])}$acceptFeedback(a,c,h,i,s){const u=this.b.get(a);if(!u)return;const d=this.h.get(c)?.get(h);if(!d)return;let m;switch(i){case w.InteractiveSessionVoteDirection.Down:m=p.ChatAgentResultFeedbackKind.Unhelpful;break;case w.InteractiveSessionVoteDirection.Up:m=p.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(s?{result:d,kind:m,reportIssue:s}:{result:d,kind:m}))}$acceptAction(a,c,h,i){const s=this.b.get(a);if(!s)return;const u=this.h.get(c)?.get(h);u&&i.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:i.action,result:u}))}async $invokeCompletionProvider(a,c,h){const i=this.b.get(a);return i?(await i.invokeCompletionProvider(c,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$8fc=o;class t{constructor(a,c,h,i,s){this.extension=a,this.t=c,this.u=h,this.w=i,this.x=s,this.o=new M.$Ud,this.q=new M.$Ud}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.q.fire(a)}async invokeCompletionProvider(a,c){return this.s?await this.s.provider.provideCompletionItems(a,c)??[]:[]}async validateSlashCommand(a){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$Rf)(this.b));const c=this.b.find(h=>h.name===a);if(!c)throw new Error(`Unknown slashCommand: ${a}`);return c}async provideSlashCommand(a){if(!this.a)return[];const c=await this.a.provideSlashCommands(a);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(a,c){if(!this.d)return[];const h=await this.d.provideFollowups(a,c);return h?h.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let a=!1,c=!1;const h=()=>{a||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$2L?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.t},get description(){return i.g??""},set description(s){i.g=s,h()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(s){i.h=s,h()},get iconPath(){return i.i},set iconPath(s){i.i=s,h()},get slashCommandProvider(){return i.a},set slashCommandProvider(s){i.a=s,h()},get followupProvider(){return i.d},set followupProvider(s){i.d=s,h()},get isDefault(){return(0,r.$CF)(i.extension,"defaultChatAgent"),i.j},set isDefault(s){(0,r.$CF)(i.extension,"defaultChatAgent"),i.j=s,h()},get helpTextPrefix(){return(0,r.$CF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(s){if((0,r.$CF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=s,h()},get helpTextPostfix(){return(0,r.$CF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(s){if((0,r.$CF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=s,h()},get isSecondary(){return(0,r.$CF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(s){(0,r.$CF)(i.extension,"defaultChatAgent"),i.n=s,h()},get sampleRequest(){return i.m},set sampleRequest(s){i.m=s,h()},get supportIssueReporting(){return(0,r.$CF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(s){(0,r.$CF)(i.extension,"chatAgents2Additions"),i.r=s,h()},get onDidReceiveFeedback(){return i.o.event},set agentVariableProvider(s){if(i.s=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");i.u.$registerAgentCompletionsProvider(i.w,s.triggerCharacters)}else i.u.$unregisterAgentCompletionsProvider(i.w)},get agentVariableProvider(){return i.s},onDidPerformAction:(0,r.$BF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){a=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.u.$unregisterAgent(i.w)}}}invoke(a,c,h,i){return this.x(a,c,h,i)}}}),define(Pe[235],Re([1,0,20,6,3,8,72,22,13,5]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class A{constructor(w,r){this.stream=new g.$vh,this.stream=r??new g.$vh;const o=this;this.apiObj={option:w,response:o.stream.asyncIterable}}}class k{constructor(w,r){this.a=new b.$Ud,this.b=new Map,this.c=new g.$vh,this.d=!1;const o=this;this.apiObject={result:w,response:o.c.asyncIterable,onDidStartResponseStream:o.a.event,cancel(){r.cancel()}},w.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(w){if(this.d)return;let r=this.b.get(w.index);r||(this.b.size===0?r=new A(w.index,this.c):r=new A(w.index),this.b.set(w.index,r),this.a.fire(r.apiObj)),r.stream.emitOne(w.part)}}class l{static{this.a=1}constructor(w,r){this.d=r,this.c=new Map,this.e=new Map,this.f=new $.$mm,this.b=w.getProxy(I.$5K.MainThreadChatProvider)}registerProvider(w,r,o,t){const n=l.a++;return this.c.set(n,{extension:w,provider:o}),this.b.$registerProvider(n,r,{extension:w,model:t.name??""}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(w,r,o,t,n){const a=this.c.get(w);if(!a)return;const c=new R.$uv(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${a.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:h.index,part:h.part})});return a.provider.provideChatResponse(o.map(M.ChatMessage.to),t,c,n)}allowListExtensionWhile(w,r){this.f.set(w,r),r.finally(()=>this.f.delete(w))}async requestChatResponseProvider(w,r){if(!this.f.has(w))throw new Error("Extension is NOT allowed to make chat requests");const o=await this.b.$prepareChatAccess(r);if(!o)throw new Error(`ChatAccess '${r}' NOT found`);const t=this;return{get model(){return o.model},get isRevoked(){return!t.f.has(w)},makeRequest(n,a,c){if(!t.f.has(w))throw new Error("Access to chat has been revoked");const h=new E.$5d(c),i=Math.random()*1e6|0,s=t.b.$fetchResponse(w,r,i,n.map(M.ChatMessage.from),a??{},h.token),u=new k(s,h);return t.e.set(i,{res:u}),s.finally(()=>{t.e.delete(i)}),u.apiObject}}}async $handleResponseFragment(w,r){const o=this.e.get(w);o&&o.res.handleFragment(r)}}e.$7fc=l}),define(Pe[236],Re([1,0,6,3,15,8]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;class R{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(T.$5K.MainThreadChatVariables)}async $resolveVariable(g,b,A){const k=this.b.get(g);if(k)try{const l=await k.resolver.resolve(k.data.name,{message:b},A);if(l)return l.map(M.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(g,b,A,k){const l=R.a++;return this.b.set(l,{extension:g.identifier,data:{name:b,description:A},resolver:k}),this.c.$registerVariable(l,{name:b,description:A}),(0,E.$Rc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$9fc=R}),define(Pe[237],Re([1,0,3]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class T{constructor(M){const R=M.getProxy(E.$5K.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$0fc=T}),define(Pe[32],Re([1,0,16,7,8,26,3,18,14,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=void 0;let u=class{#e;#t;#i;constructor(v,y,D){this.b=new Map,this.c=new Map,this.#e=v.getProxy(R.$5K.MainThreadCommands),this.d=y,this.#i=D,this.#t=v.getProxy(R.$5K.MainThreadTelemetry),this.converter=new d(this,N=>{const O=this.c.get(N);return O?.result===f.Void?O:void 0},y),this.f=[{processArgument(N){return(0,b.$Bh)(N)}},{processArgument(N){return(0,M.$wn)(N,function(O){if(A.$Ts.isIRange(O))return I.Range.to(O);if(k.$Ss.isIPosition(O))return I.Position.to(O);if(A.$Ts.isIRange(O.range)&&l.URI.isUri(O.uri))return I.location.to(O);if(O instanceof t.$ie)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const y=this.registerCommand(!1,v.id,async(...D)=>{const N=v.args.map((H,U)=>{if(!H.validate(D[U]))throw new Error(`Invalid argument '${H.name}' when running '${v.id}', received: ${typeof D[U]=="object"?JSON.stringify(D[U],null,"	"):D[U]} `);return H.convert(D[U])}),O=await this.executeCommand(v.internalId,...N);return v.result.convert(O,D,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new T.$7K(()=>{y.dispose(),this.c.delete(v.id)})}registerCommand(v,y,D,N,O,H){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:D,thisArg:N,metadata:O,extension:H}),v&&this.#e.$registerCommand(y),new T.$7K(()=>{this.b.delete(y)&&v&&this.#e.$unregisterCommand(y)})}executeCommand(v,...y){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,y,!0)}async g(v,y,D){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,y,!1);{let N=!1;const O=(0,M.$wn)(y,function(H){if(H instanceof T.$8K)return I.Position.from(H);if(H instanceof T.$9K)return I.Range.from(H);if(H instanceof T.$gL)return I.location.from(H);if(T.$sM.isNotebookRange(H))return I.NotebookRange.from(H);if(H instanceof ArrayBuffer)return N=!0,t.$ie.wrap(new Uint8Array(H));if(H instanceof Uint8Array)return N=!0,t.$ie.wrap(H);if(H instanceof t.$ie)return N=!0,H;if(!Array.isArray(H))return H});try{const H=await this.#e.$executeCommand(v,N?new n.$Sv(O):O,D);return(0,b.$Bh)(H)}catch(H){if(H instanceof Error&&H.message==="$executeCommand:retry")return this.g(v,y,!1);throw H}}}async h(v,y,D){const N=this.b.get(v);if(!N)throw new Error("Unknown command");const{callback:O,thisArg:H,metadata:U}=N;if(U?.args)for(let P=0;P<U.args.length;P++)try{(0,E.$Yf)(y[P],U.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${U.args[P].name}' - ${U.args[P].description}`)}const W=c.$Qd.create();try{return await O.apply(H,y)}catch(P){if(v===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...y);C&&(v=C.command)}if(this.d.error(P,v,N.extension?.identifier),!D)throw P;if(N.extension?.identifier){const C=this.#i.onExtensionError(N.extension.identifier,P);this.d.trace("forwarded error to extension?",C,N.extension?.identifier)}throw new class extends Error{constructor(){super((0,a.$Pi)(P)),this.id=v,this.source=N.extension?.displayName??N.extension?.name}}}finally{this.j(N,v,W.elapsed())}}j(v,y,D){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new h.$Jo(y),duration:D})}$executeContributedCommand(v,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const D=this.b.get(v);return D?(y=y.map(N=>this.f.reduce((O,H)=>H.processArgument(O,D.extension?.identifier),N)),this.h(v,y,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(y=>(v&&(y=y.filter(D=>D[0]!=="_")),y))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[y,D]of this.b){const{metadata:N}=D;N&&(v[y]=N)}return Promise.resolve(v)}};e.$rN=u,e.$rN=u=Je([He(0,r.$9M),He(1,g.$mj),He(2,i.$qN)],u),e.$sN=(0,w.$5h)("IExtHostCommands");class d{constructor(v,y,D){this.d=v,this.f=y,this.g=D,this.delegatingCommandId=`__vsc${(0,s.$pg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,y){if(!v)return;const D={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return D;const N=this.f(v.command);if(N)D.id=N.internalId,D.arguments=N.args.map((O,H)=>O.convert(v.arguments&&v.arguments[H]));else if((0,$.$Lb)(v.arguments)){const O=`${v.command} /${++this.c}`;this.b.set(O,v),y.add((0,p.$Rc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),D.$ident=O,D.id=this.delegatingCommandId,D.arguments=[O],this.g.trace("CommandsConverter#CREATE",v.command,O)}return D}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const y=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$tN=d;class m{static{this.Uri=new m("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v)}static{this.Position=new m("position","A position in a text document",v=>T.$8K.isPosition(v),I.Position.from)}static{this.Range=new m("range","A range in a text document",v=>T.$9K.isRange(v),I.Range.from)}static{this.Selection=new m("selection","A selection in a text document",v=>T.$0K.isSelection(v),I.Selection.from)}static{this.Number=new m("number","",v=>typeof v=="number",v=>v)}static{this.String=new m("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=m.Arr(m.String)}static Arr(v){return new m(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,y=>Array.isArray(y)&&y.every(D=>v.validate(D)),y=>y.map(D=>v.convert(D)))}static{this.CallHierarchyItem=new m("item","A call hierarchy item",v=>v instanceof T.$rL,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new m("item","A type hierarchy item",v=>v instanceof T.$LM,I.TypeHierarchyItem.from)}static{this.TestItem=new m("testItem","A VS Code TestItem",v=>v instanceof o.$jN,I.TestItem.from)}constructor(v,y,D,N){this.name=v,this.description=y,this.validate=D,this.convert=N}optional(){return new m(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,y){return new m(v??this.name,y??this.description,this.validate,this.convert)}}e.$uN=m;class f{static{this.Void=new f("no result",v=>v)}constructor(v,y){this.description=v,this.convert=y}}e.$vN=f;class S{constructor(v,y,D,N,O){this.id=v,this.internalId=y,this.description=D,this.args=N,this.result=O}}e.$wN=S}),define(Pe[238],Re([1,0,18,12,2,80,96,35,32,8,7]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;const k=[new g.$wN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$uN.Uri,g.$uN.Position],new g.$vN("A promise that resolves to an array of DocumentHighlight-instances.",p(b.DocumentHighlight.to))),new g.$wN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$uN.Uri],new g.$vN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,E.$Kb)(r))return;class t extends A.$mL{static to(a){const c=new t(a.name,b.SymbolKind.to(a.kind),a.containerName||"",new A.$gL(o[0],b.Range.to(a.range)));return c.detail=a.detail,c.range=c.location.range,c.selectionRange=b.Range.to(a.selectionRange),c.children=a.children?a.children.map(t.to):[],c}}return r.map(t.to)})),new g.$wN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$uN.Uri,new g.$uN("options","Formatting options",r=>!0,r=>r)],new g.$vN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new g.$wN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$uN.Uri,g.$uN.Range,new g.$uN("options","Formatting options",r=>!0,r=>r)],new g.$vN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new g.$wN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$uN.Uri,g.$uN.Position,new g.$uN("ch","Trigger character",r=>typeof r=="string",r=>r),new g.$uN("options","Formatting options",r=>!0,r=>r)],new g.$vN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new g.$wN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$uN.Uri,g.$uN.Position],new g.$vN("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$wN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$uN.Uri,g.$uN.Position],new g.$vN("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$wN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$uN.Uri,g.$uN.Position],new g.$vN("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$wN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$uN.Uri,g.$uN.Position],new g.$vN("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$wN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$uN.Uri,g.$uN.Position],new g.$vN("A promise that resolves to an array of Location-instances.",p(b.location.to))),new g.$wN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$uN.Uri,g.$uN.Position],new g.$vN("A promise that resolves to an array of Hover-instances.",p(b.Hover.to))),new g.$wN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$uN.Uri,new g.$uN("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>A.$8K.isPosition(o)),r=>r.map(b.Position.from))],new g.$vN("A promise that resolves to an array of ranges.",r=>r.map(o=>{let t;for(const n of o.reverse())t=new A.$qL(b.Range.to(n),t);return t}))),new g.$wN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$uN.String.with("query","Search string")],new g.$vN("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(b.WorkspaceSymbol.to))),new g.$wN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$uN.Uri,g.$uN.Position],new g.$vN("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(b.CallHierarchyItem.to))),new g.$wN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$uN.CallHierarchyItem],new g.$vN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(b.CallHierarchyIncomingCall.to))),new g.$wN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$uN.CallHierarchyItem],new g.$vN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(b.CallHierarchyOutgoingCall.to))),new g.$wN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$uN.Uri,g.$uN.Position],new g.$vN("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:b.Range.to(r.range),placeholder:r.text}})),new g.$wN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$uN.Uri,g.$uN.Position,g.$uN.String.with("newName","The new symbol name")],new g.$vN("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return b.WorkspaceEdit.to(r)}})),new g.$wN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$uN.Uri,g.$uN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$vN("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(b.DocumentLink.to))),new g.$wN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$uN.Uri],new g.$vN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$kM(r.tokenTypes,r.tokenModifiers)})),new g.$wN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$uN.Uri],new g.$vN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$p$)(r);if(o.type==="full")return new A.$mM(o.data,void 0)})),new g.$wN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$uN.Uri,g.$uN.Range.optional()],new g.$vN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$kM(r.tokenTypes,r.tokenModifiers)})),new g.$wN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$uN.Uri,g.$uN.Range],new g.$vN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$p$)(r);if(o.type==="full")return new A.$mM(o.data,void 0)})),new g.$wN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$uN.Uri,g.$uN.Position,g.$uN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$uN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$vN("A promise that resolves to a CompletionList-instance.",(r,o,t)=>{if(!r)return new A.$CL([]);const n=r.suggestions.map(a=>b.CompletionItem.to(a,t));return new A.$CL(n,r.incomplete)})),new g.$wN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$uN.Uri,g.$uN.Position,g.$uN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$vN("A promise that resolves to SignatureHelp.",r=>{if(r)return b.SignatureHelp.to(r)})),new g.$wN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$uN.Uri,g.$uN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$vN("A promise that resolves to an array of CodeLens-instances.",(r,o,t)=>p(n=>new A.$uL(b.Range.to(n.range),n.command&&t.fromInternal(n.command)))(r))),new g.$wN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$uN.Uri,new g.$uN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.$9K.isRange(r),r=>A.$0K.isSelection(r)?b.Selection.from(r):b.Range.from(r)),g.$uN.String.with("kind","Code action kind to return code actions for").optional(),g.$uN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$vN("A promise that resolves to an array of Command-instances.",(r,o,t)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const a=new A.$oL(n.title,n.kind?new A.$pL(n.kind):void 0);return n.edit&&(a.edit=b.WorkspaceEdit.to(n.edit)),n.command&&(a.command=t.fromInternal(n.command)),a.isPreferred=n.isPreferred,a}})(r))),new g.$wN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$uN.Uri],new g.$vN("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new A.$IL(b.Range.to(o.range),b.Color.to(o.color))):[])),new g.$wN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$uN("color","The color to show and insert",r=>r instanceof A.$HL,b.Color.from),new g.$uN("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:b.Range.from(r.range)}))],new g.$vN("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(b.ColorPresentation.to):[])),new g.$wN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$uN.Uri,g.$uN.Range],new g.$vN("A promise that resolves to an array of Inlay objects",(r,o,t)=>r.map(b.InlayHint.to.bind(void 0,t)))),new g.$wN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$uN.Uri],new g.$vN("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(b.FoldingRange.to)})),new g.$wN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$vN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>b.NotebookExclusiveDocumentPattern.to(o))})))),new g.$wN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$uN.Uri,g.$uN.Range,new g.$uN("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof A.$9K,r=>b.InlineValueContext.from(r))],new g.$vN("A promise that resolves to an array of InlineValue objects",r=>r.map(b.InlineValue.to))),new g.$wN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$uN("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,T.$eg)(r,T.Schemas.http,T.Schemas.https),r=>r),new g.$uN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[b.ViewColumn.from(r),void 0]:[b.ViewColumn.from(r.viewColumn),b.TextEditorOpenOptions.from(r)])).optional(),g.$uN.String.with("label","").optional()],g.$vN.Void),new g.$wN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$uN.Uri.with("resource","Resource to open"),g.$uN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$uN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[b.ViewColumn.from(r),void 0]:[b.ViewColumn.from(r.viewColumn),b.TextEditorOpenOptions.from(r)])).optional()],g.$vN.Void),new g.$wN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$uN.Uri.with("left","Left-hand side resource of the diff editor"),g.$uN.Uri.with("right","Right-hand side resource of the diff editor"),g.$uN.String.with("title","Human readable title for the diff editor").optional(),new g.$uN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[b.ViewColumn.from(r.viewColumn),b.TextEditorOpenOptions.from(r)]).optional()],g.$vN.Void),new g.$wN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$uN.String.with("title","Human readable title for the changes editor"),new g.$uN("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[t,n,a]=o;if(!I.URI.isUri(t)||!I.URI.isUri(n)&&n!==void 0&&n!==null||!I.URI.isUri(a)&&a!==void 0&&a!==null)return!1}return!0},r=>r)],g.$vN.Void),new g.$wN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$uN.Uri,g.$uN.Position],new g.$vN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(b.TypeHierarchyItem.to))),new g.$wN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$uN.TypeHierarchyItem],new g.$vN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(b.TypeHierarchyItem.to))),new g.$wN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$uN.TypeHierarchyItem],new g.$vN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(b.TypeHierarchyItem.to))),new g.$wN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$uN.TestItem],g.$vN.Void),new g.$wN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$uN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$vN.Void),new g.$wN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$uN.String.with("name","The context key name"),new g.$uN("value","The context key value",()=>!0,r=>r)],g.$vN.Void),new g.$wN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$uN.Uri,g.$uN.StringArray,new g.$uN("MappedEditsContext","Mapped Edits Context",r=>b.MappedEditsContext.is(r),r=>b.MappedEditsContext.from(r))],new g.$vN("A promise that resolves to a workspace edit or null",r=>r?b.WorkspaceEdit.to(r):null))];class l{static register(o){k.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",$.$4i)}}e.$3fc=l;function p(r){return o=>{if(Array.isArray(o))return o.map(r)}}function w(r){if(!Array.isArray(r))return;const o=[];for(const t of r)M.$Ft(t)?o.push(b.DefinitionLink.to(t)):o.push(b.location.to(t));return o}}),define(Pe[239],Re([1,0,13,66,5,6,2,80,22,8,7,3,23]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;function p(w,r,o){const t=w.getProxy(k.$5K.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$mm,r.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const S=this.b.get(f.handle);return S?S.value:f}else if(f&&f.$mid===7){const S=this.b.get(f.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.commentThreadHandle);return L?L.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);return L?f.$mid===8?L.value:{thread:L.value,text:f.text}:f}else if(f&&f.$mid===10){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const v=f.commentUniqueId,y=L.getCommentByUniqueId(v);return y||f}else if(f&&f.$mid===11){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const v=f.text,y=f.commentUniqueId,D=L.getCommentByUniqueId(y);return D?(typeof D.body=="string"?D.body=v:D.body=new A.$vL(v),D):f}return f}})}createCommentController(f,S,L){const v=n.a++,y=new c(f,v,S,L);this.b.set(y.handle,y);const D=this.c.get(f.identifier)||[];return D.push(y),this.c.set(f.identifier,D),y.value}async $createCommentThreadTemplate(f,S,L){const v=this.b.get(f);v&&v.$createCommentThreadTemplate(S,L)}async $updateCommentThreadTemplate(f,S,L){const v=this.b.get(f);v&&v.$updateCommentThreadTemplate(S,L)}$deleteCommentThread(f,S){this.b.get(f)?.$deleteCommentThread(S)}$provideCommentingRanges(f,S,L){const v=this.b.get(f);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const y=o.getDocument(R.URI.revive(S));return(0,E.$Xg)(async()=>{const D=await v.commentingRangeProvider.provideCommentingRanges(y,L);let N;return Array.isArray(D)?N={ranges:D,fileComments:!1}:D?N={ranges:D.ranges||[],fileComments:D.fileComments||!1}:N=D??void 0,N}).then(D=>{let N;return D&&(N={ranges:D.ranges.map(O=>b.Range.from(O)),fileComments:D.fileComments}),N})}$toggleReaction(f,S,L,v,y){const D=this.b.get(f);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,E.$Xg)(()=>{const N=D.getCommentThread(S);if(N){const O=N.getCommentByUniqueId(v.uniqueIdInThread);if(D!==void 0&&O&&D.reactionHandler)return D.reactionHandler(O,s(y))}return Promise.resolve(void 0)})}}class a{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,S,L,v,y,D,N,O){this.m=S,this.n=L,this.o=v,this.p=y,this.q=D,this.extensionDescription=N,this.r=O,this.handle=a.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Ud,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Uc,this.l.value=new M.$Sc,this.n===void 0&&(this.n=`${f}.${this.handle}`),t.$createCommentThread(S,this.handle,this.n,this.o,b.Range.from(this.p),N.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{t.$deleteCommentThread(S,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(U){H.range=U},get comments(){return H.comments},set comments(U){H.comments=U},get collapsibleState(){return H.collapsibleState},set collapsibleState(U){H.collapsibleState=U},get canReply(){return H.canReply},set canReply(U){H.canReply=U},get contextValue(){return H.contextValue},set contextValue(U){H.contextValue=U},get label(){return H.label},set label(U){H.label=U},get state(){return H.state},set state(U){H.state=U},dispose:()=>{H.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Sc);const f=L=>Object.prototype.hasOwnProperty.call(this.b,L),S={};f("range")&&(S.range=b.Range.from(this.p)),f("label")&&(S.label=this.label),f("contextValue")&&(S.contextValue=this.contextValue??null),f("comments")&&(S.comments=this.q.map(L=>h(this,L,this.k,this.extensionDescription))),f("collapsibleState")&&(S.collapseState=u(this.g)),f("canReply")&&(S.canReply=this.canReply),f("state")&&(S.state=d(this.h)),f("isTemplate")&&(S.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(f){for(const S of this.k){const L=S[0],v=S[1];if(f===v)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Je([(0,T.$xh)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,S,L,v){this.f=f,this.g=S,this.h=L,this.i=v,this.a=new Map,t.$registerCommentController(this.handle,L,v,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(D){y.options=D},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(D){y.commentingRangeProvider=D},get reactionHandler(){return y.reactionHandler},set reactionHandler(D){y.reactionHandler=D},createCommentThread(D,N,O){return y.createCommentThread(D,N,O).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,S,L){S===void 0&&(0,l.$CF)(this.f,"fileComments");const v=new a(this.id,this.handle,void 0,f,S,L,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(f,S){const L=new a(this.id,this.handle,void 0,R.URI.revive(f),b.Range.to(S),[],this.f,!0);return L.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(f,S){const L=this.a.get(f);L&&(L.range=b.Range.to(S))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function h(m,f,S,L){let v=S.get(f);return v||(v=++m.commentHandle,S.set(f,v)),f.state!==void 0&&(0,l.$CF)(L,"commentsDraftState"),f.reactions?.some(y=>y.reactors!==void 0)&&(0,l.$CF)(L,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:v,body:typeof f.body=="string"?f.body:b.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>i(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(m){return{label:m.label,iconPath:m.iconPath?b.$8M(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted,reactors:m.reactors&&m.reactors.length>0&&typeof m.reactors[0]!="string"?m.reactors.map(f=>f.name):m.reactors}}function s(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?R.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1,reactors:m.reactors?.map(f=>({name:f}))}}function u(m){if(m!==void 0)switch(m){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function d(m){if(m!==void 0)switch(m){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$agc=p}),define(Pe[240],Re([1,0,26,3,27,17]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;let R=class{constructor(A,k){this.a=A.getProxy(T.$5K.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,k){const l=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,k,p,arguments)}})}e(A,k,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:g(p,this.b)}),this.c&&this.f(A,l,p)}};e.$1hc=R,e.$1hc=R=Je([He(0,M.$9M),He(1,I.$mN)],R);const $=1e5;function g(b,A){const k=[];if(b.length)for(let l=0;l<b.length;l++){let p=b[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const w=p;w.stack?p=w.stack:p=w.toString()}k.push(p)}if(A){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$zn)(k);return l.length>$?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[110],Re([1,0,2,3,7,4,17,14,18,11,19,23]),function(ge,e,E,T,I,M,R,$,g,b,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=void 0;let p=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(T.$5K.MainThreadDecorations)}registerFileDecorationProvider(r,o){const t=l.c++;this.f.set(t,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(t,o.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(t,null);return}const c=(0,g.$3b)(a);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,b.$Oe)(u.path,"/")})),i=(0,g.$zb)(h,(u,d)=>u.rank-d.rank||(0,b.$4e)(u.uri.path,d.uri.path)),s=[];e:for(const u of i){let d;for(const m of u){const f=(0,A.$mc)(m.uri.path);if(d!==f&&(d=f,s.push(m.uri)>=l.d))break e}}this.g.$onDidChange(t,s)});return new I.$7K(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(r,o,t){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:a,extensionDescription:c}=this.f.get(r);return await Promise.all(o.map(async h=>{try{const{uri:i,id:s}=h,u=await Promise.resolve(a.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{I.$qM.validate(u),u.badge&&typeof u.badge!="string"&&(0,k.$CF)(c,"codiconDecoration"),n[s]=[u.propagate,u.tooltip,u.badge,u.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(i){this.h.error(i)}})),n}};e.$3gc=p,e.$3gc=p=l=Je([He(0,R.$9M),He(1,$.$mj)],p),e.$4gc=(0,M.$5h)("IExtHostDecorations")}),define(Pe[241],Re([1,0,158,99,2,3,7,8,5,14,28,43]),function(ge,e,E,T,I,M,R,$,g,b,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0;class p{#e;#t;#i;constructor(o,t,n,a,c,h,i,s){this.d=o,this.e=t,this.f=n,this.g=a,this.h=c,this.c=!1,this.f=Math.max(a,n),this.#i=new A.$Ac(u=>h.getComparisonKey(u)),this.#e=i,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,t){if(!o){this.clear();return}this.j();let n=[];if(I.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(p.k);for(const i of o){const[s,u]=i;if((!h||s.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=s,n.push(s),this.#i.set(s,[])),u)this.#i.get(s)?.push(...u);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(n),!this.#e)return;const a=[];let c=0;for(const h of n){let i=[];const s=this.#i.get(h);if(s)if(s.length>this.g){i=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const m of s)if(m.severity===u[d]&&i.push({...$.Diagnostic.from(m),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=s.map(u=>({...$.Diagnostic.from(u),modelVersionId:this.h(h)}));if(a.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,a)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,t){this.j();for(const[n,a]of this)o.call(t,n,a,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.$Wfc=p;let w=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const t=new A.$Ac;for(const n of o)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,n,a){this.j=t,this.k=n,this.l=a,this.g=new Map,this.h=new g.$Yd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=o.getProxy(M.$5K.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{g:n,f:a,h:c,j:h,k:i,l:s}=this,u=new class{$changeMany(f,S){a.$changeMany(f,S),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,f,S.length===0?"CLEARING":S)}$clear(f){a.$clear(f),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,f)}dispose(){a.dispose()}};let d;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,d=t;else if(!n.has(t))d=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do d=t+l.c++;while(n.has(d))}return new class extends p{constructor(){super(t,d,l.e,l.d,f=>s.getDocument(f)?.version,i.extUri,u,c),n.set(d,this)}dispose(){super.dispose(),n.delete(d)}}}getDiagnostics(o){if(o)return this.m(o);{const t=new Map,n=[];for(const a of this.g.values())a.forEach((c,h)=>{let i=t.get(c.toString());typeof i>"u"&&(i=n.length,t.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(o){let t=[];for(const n of this.g.values())n.has(o)&&(t=t.concat(n.get(o)));return t}$acceptMarkersChange(o){if(!this.n){const t="_generated_mirror",n=new p(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of o)this.n.set(I.URI.revive(t),n.map($.Diagnostic.to))}};e.$Xfc=w,e.$Xfc=w=l=Je([He(1,b.$mj),He(2,k.$Vfc)],w)}),define(Pe[242],Re([1,0,2,3,23]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;class M{constructor($){this.a=$.getProxy(T.$5K.MainThreadDialogs)}showOpenDialog($,g){return g?.allowUIResources&&(0,I.$CF)($,"showLocal"),this.a.$showOpenDialog(g).then(b=>b?b.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(g=>g?E.URI.revive(g):void 0)}}e.$5gc=M}),define(Pe[243],Re([1,0,15,2,7,3,12,20,11]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;class b{static{this.a=0}constructor(k,l,p){this.d=l,this.e=p,this.b=new Map,this.c=k.getProxy(M.$5K.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const p=b.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,k);let w;if(typeof l.onDidChange=="function"){let r;w=l.onDidChange(async o=>{if(o.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const t=this.$provideTextDocumentContent(p,o).then(async n=>{if(!n&&typeof n!="string")return;const a=this.d.getDocument(o);if(!a)return;const c=(0,g.$Ye)(n);if(!a.equalLines(c))return this.c.$onVirtualDocumentChange(o,n)}).catch(E.$1).finally(()=>{r===t&&(r=void 0)});r=t})}return new I.$7K(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(k,l){const p=this.b.get(k);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(l),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$6gc=b}),define(Pe[244],Re([1,0,5,6,2,3,103,8,16,26,7]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=void 0;class k{constructor(p,w){this.a=new E.$Ud,this.b=new E.$Ud,this.c=new E.$Ud,this.d=new E.$Ud,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Sc,this.h=new Map,this.f=p.getProxy(M.$5K.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const w=this.g.getDocument(p);if(w)return w}getDocument(p){const w=this.getDocumentData(p);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return w.document}ensureDocumentData(p){const w=this.g.getDocument(p);if(w)return Promise.resolve(w);let r=this.h.get(p.toString());return r||(r=this.f.$tryOpenDocument(p).then(o=>{this.h.delete(p.toString());const t=I.URI.revive(o);return(0,g.$Sf)(this.g.getDocument(t))},o=>(this.h.delete(p.toString()),Promise.reject(o))),this.h.set(p.toString(),r)),r}createDocumentData(p){return this.f.$tryCreateDocument(p).then(w=>I.URI.revive(w))}$acceptModelLanguageChanged(p,w){const r=I.URI.revive(p),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(w),this.a.fire(o.document)}$acceptModelSaved(p){const w=I.URI.revive(p),r=this.g.getDocument(w);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(p,w){const r=I.URI.revive(p),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(w),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,w,r){const o=I.URI.revive(p),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");t._acceptIsDirty(r),t.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,b.$vn)({document:t.document,contentChanges:w.changes.map(a=>({range:$.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:n}))}setWordDefinitionFor(p,w){(0,R.$$M)(p,w)}}e.$Tfc=k}),define(Pe[61],Re([1,0,53,5,6,2,4,3,103,17,109,8,14,28,12,67,39]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new T.$Ud,this.e=new T.$Ud,this.f=new T.$Ud,this.g=new T.$Ud,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],s=[];if(c.removedDocuments)for(const u of c.removedDocuments){const d=M.URI.revive(u),m=this.c.get(d);m?.unref()&&(this.c.delete(d),h.push(m.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const d=M.URI.revive(u.uri);let m=this.c.get(d);if(m&&d.scheme!==w.Schemas.vscodeNotebookCell&&d.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);m||(m=new t(new g.$_M(this.h.getProxy($.$5K.MainThreadDocuments),d,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(d,m),i.push(m.value)),m.ref()}if(c.removedEditors)for(const u of c.removedEditors){const d=this.b.get(u);this.b.delete(u),d&&s.push(d)}if(c.addedEditors)for(const u of c.addedEditors){const d=M.URI.revive(u.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const m=this.c.get(d).value,f=new A.$fN(u.id,this.h.getProxy($.$5K.MainThreadTextEditors),this.i,new o.$V(()=>m.document),u.selections.map(k.Selection.to),u.options,u.visibleRanges.map(S=>k.Range.to(S)),typeof u.editorPosition=="number"?k.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,I.$Oc)(h),(0,I.$Oc)(s),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$gN=n,e.$gN=n=Je([He(0,b.$9M),He(1,l.$mj)],n),e.$hN=(0,R.$5h)("IExtHostDocumentsAndEditors")}),define(Pe[62],Re([1,0,245,5,16,2,4,3,17,8,7]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=e.$tgc=void 0,e.$tgc=(0,R.$5h)("IExtHostEditorTabs");class k{constructor(o,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$MM(M.URI.revive(this.b.input.uri));case 2:return new A.$NM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$OM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$PM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$QM(this.b.input.viewType);case 4:return new A.$RM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$SM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$TM;case 9:return new A.$UM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$VM(this.b.input.providerId);default:return}}}class l{constructor(o,t){this.c=[],this.d="",this.b=o,this.e=t;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new k(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return b.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new k(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const t=this.c.find(n=>n.tabId===o.tabDto.id);if(!t)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(o.tabDto),t}activeTabId(){return this.d}}let p=class{constructor(o){this.b=new T.$Ud,this.c=new T.$Ud,this.e=[],this.a=o.getProxy($.$5K.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,t={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,I.$Sf)(o.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,a)=>{const c=Array.isArray(n)?n:[n];return c.length?w(c[0])?this.j(c,a):this.i(c,a):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(o){const t=new Set(this.e.map(u=>u.groupId)),n=new Set(o.map(u=>u.groupId)),a=(0,E.$L)(t,n),c=this.e.filter(u=>a.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],i=[];this.e=o.map(u=>{const d=new l(u,()=>this.d);return a.added.includes(d.groupId)?h.push(d.apiObject):i.push(d.apiObject),d});const s=(0,I.$Sf)(o.find(u=>u.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const t=this.e.find(n=>n.groupId===o.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const t=this.e.find(a=>a.groupId===o.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(t=>t.apiObject===o)}async i(o,t){const n=[];for(const a of o){const c=this.g(a);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,t)}async j(o,t){const n=[];for(const a of o){const c=this.h(a);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,t)}};e.$ugc=p,e.$ugc=p=Je([He(0,g.$9M)],p);function w(r){return r.tabs!==void 0}}),define(Pe[246],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$5K.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const b=this.a.get(R);if(!b)throw new Error("Embedding vector provider not found");const A=await b.provideEmbeddingVector($,g);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,g){const b=this.b;return this.b++,this.a.set(b,g),this.c.$registerAiEmbeddingVectorProvider($,b),new T.$7K(()=>{this.c.$unregisterAiEmbeddingVectorProvider(b),this.a.delete(b)})}}e.$8gc=I}),define(Pe[247],Re([1,0,2,3,6,7,8,295,11,24,23,52]),function(ge,e,E,T,I,M,R,$,g,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let t,n,a=14,c=14;for(const h of r){let i=t?(0,g.$af)(t,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(a=c,c=9):c+=1,o.push([n,h.toUpperCase().charCodeAt(i),c]),o.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;t=h,c=a}o.push([9,58,10]),o.push([10,47,12]),this.b=new $.$sZ(o)}}provideDocumentLinks(r){this.c();const o=[],t=$.$tZ.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of t){const a=R.DocumentLink.to(n);a.target&&o.push(a)}return o}}class p{constructor(r,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(T.$5K.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,t,n={}){if(p.j(t),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const a=this.h++;this.b.add(o),this.d.add(o),this.c.set(a,t);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,A.$CF)(r,"fsChunks"),c+=4);let h;n.isReadonly&&(0,k.$ik)(n.isReadonly)&&((0,A.$CF)(r,"readonlyMessage"),h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(a,o,c,h).catch(s=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(s)});const i=t.onDidChangeFile(s=>{const u=[];for(const d of s){const{uri:m,type:f}=d;if(m.scheme!==o)continue;let S;switch(f){case M.FileChangeType.Changed:S=0;break;case M.FileChangeType.Created:S=1;break;case M.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:m,type:S})}this.a.$onFileSystemChange(a,u)});return(0,I.$Rc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(a),this.a.$unregisterProvider(a)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:t,mtime:n,size:a,permissions:c}=r;return{type:o,ctime:t,mtime:n,size:a,permissions:c}}$stat(r,o){return Promise.resolve(this.l(r).stat(E.URI.revive(o))).then(t=>p.k(t))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(E.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(E.URI.revive(o))).then(t=>b.$ie.wrap(t))}$writeFile(r,o,t,n){return Promise.resolve(this.l(r).writeFile(E.URI.revive(o),t.buffer,n))}$delete(r,o,t){return Promise.resolve(this.l(r).delete(E.URI.revive(o),t))}$rename(r,o,t,n){return Promise.resolve(this.l(r).rename(E.URI.revive(o),E.URI.revive(t),n))}$copy(r,o,t,n){const a=this.l(r);if(!a.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(a.copy(E.URI.revive(o),E.URI.revive(t),n))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(E.URI.revive(o)))}$watch(r,o,t,n){const a=this.l(r).watch(E.URI.revive(t),n);this.f.set(o,a)}$unwatch(r,o){const t=this.f.get(o);t&&(t.dispose(),this.f.delete(o))}$open(r,o,t){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(o),t))}$close(r,o){const t=this.l(r);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(o))}$read(r,o,t,n){const a=this.l(r);if(!a.read)throw new Error('FileSystemProvider does not implement "read"');const c=b.$ie.alloc(n);return Promise.resolve(a.read(o,t,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(r,o,t,n){const a=this.l(r);if(!a.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(a.write(o,t,n.buffer,0,n.byteLength))}l(r){const o=this.c.get(r);if(!o){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return o}}e.$9gc=p}),define(Pe[63],Re([1,0,3,42,7,24,4,17,43,6,13,25,12]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=void 0;let w=p=class{constructor(o,t){this.b=new Map,this.c=new A.$bh,this.a=o.getProxy(E.$5K.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(a){try{let c;const h=n.b.get(a.scheme);return h?(await n.a.$ensureActivation(a.scheme),c=await h.impl.stat(a)):c=await n.a.$stat(a),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){p.e(c)}},async readDirectory(a){try{const c=n.b.get(a.scheme);return c?(await n.a.$ensureActivation(a.scheme),(await c.impl.readDirectory(a)).slice()):await n.a.$readdir(a)}catch(c){return p.e(c)}},async createDirectory(a){try{const c=n.b.get(a.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(a.scheme),await n.d(c.impl,c.extUri,a)):await n.a.$mkdir(a)}catch(c){return p.e(c)}},async readFile(a){try{const c=n.b.get(a.scheme);return c?(await n.a.$ensureActivation(a.scheme),(await c.impl.readFile(a)).slice()):(await n.a.$readFile(a)).buffer}catch(c){return p.e(c)}},async writeFile(a,c){try{const h=n.b.get(a.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(a.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(a)),await n.c.queueFor(a).queue(()=>Promise.resolve(h.impl.writeFile(a,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(a,M.$ie.wrap(c))}catch(h){return p.e(h)}},async delete(a,c){try{const h=n.b.get(a.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(a.scheme),await h.impl.delete(a,{recursive:!1,...c})):await n.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return p.e(h)}},async rename(a,c,h){try{return await n.a.$rename(a,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},async copy(a,c,h){try{return await n.a.$copy(a,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},isWritableFileSystem(a){const c=t.getCapabilities(a);if(typeof c=="number")return!(c&2048)}})}async d(o,t,n){const a=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&T.FileType.Directory))throw I.$iM.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$Fk(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;a.push(t.basename(n)),n=t.dirname(n)}for(let c=a.length-1;c>=0;c--){n=t.joinPath(n,a[c]);try{await o.createDirectory(n)}catch(h){if(T.$Fk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof I.$iM)throw o;if(o instanceof T.$Bk)switch(o.code){case T.FileSystemProviderErrorCode.FileExists:throw I.$iM.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.$iM.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.$iM.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.$iM.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.$iM.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.$iM.Unavailable(o.message);default:throw new I.$iM(o.message,o.name)}if(!(o instanceof Error))throw new I.$iM(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.$iM.Unavailable(o.message);switch(o.name){case T.FileSystemProviderErrorCode.FileExists:throw I.$iM.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.$iM.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.$iM.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.$iM.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.$iM.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.$iM.Unavailable(o.message);default:throw new I.$iM(o.message,o.name)}}addFileSystemProvider(o,t,n){return this.b.set(o,{impl:t,extUri:n?.isCaseSensitive?k.$wg:k.$yg,isReadonly:!!n?.isReadonly}),(0,b.$Rc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??k.$wg}};e.$igc=w,e.$igc=w=p=Je([He(0,$.$9M),He(1,g.$Vfc)],w),e.$jgc=(0,R.$5h)("IExtHostConsumerFileSystem")}),define(Pe[248],Re([1,0,5,34,2,3,8,7,39]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;class b{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,w,r,o,t,n){this.a=Math.random(),this.b=new E.$Ud,this.c=new E.$Ud,this.d=new E.$Ud,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const a=(0,T.$Lj)(t),c=typeof t=="string",h=n?.correlate,i=o(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(h&&typeof s.session>"u")){if(!n?.ignoreCreateEvents)for(const u of s.created){const d=I.URI.revive(u);a(d.fsPath)&&(!c||w.getWorkspaceFolder(d))&&this.b.fire(d)}if(!n?.ignoreChangeEvents)for(const u of s.changed){const d=I.URI.revive(u);a(d.fsPath)&&(!c||w.getWorkspaceFolder(d))&&this.c.fire(d)}if(!n?.ignoreDeleteEvents)for(const u of s.deleted){const d=I.URI.revive(u);a(d.fsPath)&&(!c||w.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=$.$7K.from(this.i(p,r,t,n,n?.correlate),this.b,this.c,this.d,i)}i(p,w,r,o,t){const n=$.$7K.from();if(typeof r=="string")return n;const a=p.getProxy(M.$5K.MainThreadFileSystemEventService);let c=!1;return(r.pattern.includes(T.$Hj)||r.pattern.includes(T.$Ij))&&(c=!0),a.$watch(w.identifier.value,this.a,r.baseUri,{recursive:c,excludes:o?.excludes??[]},!!t),$.$7K.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(p){this.a=p,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(I.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(p,w,r){this.j=p,this.k=w,this.l=r,this.a=new E.$Ud,this.b=new E.$Ud,this.c=new E.$Ud,this.d=new E.$Ud,this.g=new E.$Wd,this.h=new E.$Wd,this.i=new E.$Wd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,w,r,o){return new b(this.j,p,w,this.a.event,R.GlobPattern.from(r),o)}$onFileEvent(p){this.a.fire(new A(p))}$onDidRunFileOperation(p,w){switch(p){case 2:this.b.fire(Object.freeze({files:w.map(r=>({oldUri:I.URI.revive(r.source),newUri:I.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(r=>I.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(r=>I.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,w){return(r,o,t)=>{const n=function(c){r.call(o,c)};return n.extension=p,w.event(n,void 0,t)}}async $onWillRunFileOperation(p,w,r,o){switch(p){case 2:return await this.n(this.g,{files:w.map(t=>({oldUri:I.URI.revive(t.source),newUri:I.URI.revive(t.target)}))},r,o);case 1:return await this.n(this.i,{files:w.map(t=>I.URI.revive(t.target))},r,o);case 0:case 3:return await this.n(this.h,{files:w.map(t=>I.URI.revive(t.target))},r,o)}}async n(p,w,r,o){const t=new Set,n=[];if(await p.fireAsync(w,o,async(c,h)=>{const i=Date.now(),s=await Promise.resolve(c);s instanceof $.$eL&&(n.push([h.extension,s]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const a={edits:[]};for(const[,c]of n){const{edits:h}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(h)}return{edit:a,extensionNames:Array.from(t)}}}e.$0gc=k}),define(Pe[249],Re([1,0,6,2,3,8,7,32,13]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;class b{static{this.a=0}constructor(p,w){this.extension=p,this.provider=w,this.handle=b.a++}}class A{constructor(p){this.session=p,this.responses=[]}}class k{static{this.a=0}constructor(p,w,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=p.getProxy(I.$5K.MainThreadInlineChat),w.registerApiCommand(new $.$wN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$uN("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?M.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?M.Position.from(t.position):void 0}})],$.$vN.Void))}registerProvider(p,w,r){const o=new b(p,w);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??p.displayName??p.name,p.identifier.value,typeof w.handleInteractiveEditorResponseFeedback=="function",typeof w.provideFollowups=="function",r?.supportReportIssue??!1),(0,E.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(p,w,r,o){const t=this.b.get(p);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(T.URI.revive(w)),a=M.Selection.to(r),c=await t.provider.prepareInteractiveEditorSession({document:n,selection:a},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new A(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:M.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,w,r,o){const t=this.b.get(p);if(!t)return;const n=this.d.get(w.id);if(!n)return;const a={prompt:r.prompt,selection:M.Selection.to(r.selection),wholeRange:M.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,withIntentDetection:r.withIntentDetection};let c=!1;const h={report:async L=>{if(!r.live&&L.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:L.message,edits:L.edits?.map(M.TextEdit.from),editsShouldBeInstant:L.editsShouldBeInstant,slashCommand:L.slashCommand?.command,markdownFragment:R.$vL.isMarkdownString(L.content)?L.content.value:L.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,a,h,o));let s;try{s=await(0,g.$Tg)(i,o)}finally{c=!0}if(!s)return;const u=n.responses.push(s)-1,d={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(!k.h(s))return{...d,id:u,type:"editorEdit",message:M.MarkdownString.from(s.contents),edits:[]};const{edits:m,contents:f}=s,S=f!==void 0?M.MarkdownString.from(f):void 0;return m instanceof R.$eL?{...d,id:u,type:"bulkEdit",edits:M.WorkspaceEdit.from(m),message:S}:{...d,id:u,type:"editorEdit",edits:m.map(M.TextEdit.from),message:S}}async $provideFollowups(p,w,r,o){const t=this.b.get(p),n=this.d.get(w),a=n?.responses[r];if(t&&a&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(n.session,a,o));return(await(0,g.$Tg)(c,o))?.map(M.ChatReplyFollowup.from)}}$handleFeedback(p,w,r,o){const t=this.b.get(p),n=this.d.get(w),a=n?.responses[r];if(t&&a){const c=M.InteractiveEditorResponseFeedbackKind.to(o);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,a,c)}}$releaseSession(p,w){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$$gc=k}),define(Pe[250],Re([1,0,2,32]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;class I{constructor(R,$,g,b,A){this.a=$,this.b=g,this.c=b;const k=new T.$wN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$uN("showOptions","Show Options",l=>!0,l=>l),new T.$uN("resource","Interactive resource Uri",l=>!0,l=>l),new T.$uN("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$uN("title","Interactive editor title",l=>!0,l=>l)],new T.$vN("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,$,g,b){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:g,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$lhc=I}),define(Pe[251],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;class I{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$5K.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(R);if(!g)throw new Error("Issue request handler not found");const b=await g.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const b=await g.provideIssueData($);if(!b)throw new Error("Issue data provider returned no result");return b}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const b=await g.provideIssueTemplate($);if(!b)throw new Error("Issue template provider returned no result");return b}registerIssueUriRequestHandler(R,$){const g=R.identifier.value;return this.a.set(g,$),this.c.$registerIssueUriRequestHandler(g),new T.$7K(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(R,$){const g=R.identifier.value;return this.b.set(g,$),this.c.$registerIssueDataProvider(g),new T.$7K(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$mhc=I}),define(Pe[252],Re([1,0,6,3]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class I{constructor(R){this.b=0,this.a=R.getProxy(T.$5K.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$nhc=I}),define(Pe[253],Re([1,0,2,26,8,7,80,3,11,29,18,16,296,20,22,6,96,89,75,60,15,13,23,160]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;class u{constructor(F,q){this.d=F,this.e=q}async provideDocumentSymbols(F,q){const K=this.d.getDocument(F),z=await this.e.provideDocumentSymbols(K,q);if(!(0,A.$Kb)(z))return z[0]instanceof M.$nL?z.map(I.DocumentSymbol.from):u.f(z)}static f(F){F=F.slice(0).sort((z,X)=>{let Y=z.location.range.start.compareTo(X.location.range.start);return Y===0&&(Y=X.location.range.end.compareTo(z.location.range.end)),Y});const q=[],K=[];for(const z of F){const X={name:z.name||"!!MISSING: name!!",kind:I.SymbolKind.from(z.kind),tags:z.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:z.containerName,range:I.Range.from(z.location.range),selectionRange:I.Range.from(z.location.range),children:[]};for(;;){if(K.length===0){K.push(X),q.push(X);break}const Y=K[K.length-1];if(b.$Ts.containsRange(Y.range,X.range)&&!b.$Ts.equalsRange(Y.range,X.range)){Y.children?.push(X),K.push(X);break}K.pop()}}return q}}class d{constructor(F,q,K,z,X,Y){this.f=F,this.g=q,this.h=K,this.j=z,this.k=X,this.l=Y,this.d=new n.$Rfc("CodeLens"),this.e=new Map}async provideCodeLenses(F,q){const K=this.f.getDocument(F),z=await this.h.provideCodeLenses(K,q);if(!z||q.isCancellationRequested)return;const X=this.d.add(z),Y=new r.$Sc;this.e.set(X,Y);const Ee={cacheId:X,lenses:[]};for(let Te=0;Te<z.length;Te++)Ee.lenses.push({cacheId:[X,Te],range:I.Range.from(z[Te].range),command:this.g.toInternal(z[Te].command,Y)});return Ee}async resolveCodeLens(F,q){const K=F.cacheId&&this.d.get(...F.cacheId);if(!K)return;let z;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?z=K:z=await this.h.resolveCodeLens(K,q),z||(z=K),q.isCancellationRequested)return;const X=F.cacheId&&this.e.get(F.cacheId[0]);if(X){if(!z.command){const Y=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,Y),this.l.error(Y);return}return F.command=this.g.toInternal(z.command,X),F}}releaseCodeLenses(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}}function m(be){return Array.isArray(be)?be.map(I.DefinitionLink.from):be?[I.DefinitionLink.from(be)]:[]}class f{constructor(F,q){this.d=F,this.e=q}async provideDefinition(F,q,K){const z=this.d.getDocument(F),X=I.Position.to(q),Y=await this.e.provideDefinition(z,X,K);return m(Y)}}class S{constructor(F,q){this.d=F,this.e=q}async provideDeclaration(F,q,K){const z=this.d.getDocument(F),X=I.Position.to(q),Y=await this.e.provideDeclaration(z,X,K);return m(Y)}}class L{constructor(F,q){this.d=F,this.e=q}async provideImplementation(F,q,K){const z=this.d.getDocument(F),X=I.Position.to(q),Y=await this.e.provideImplementation(z,X,K);return m(Y)}}class v{constructor(F,q){this.d=F,this.e=q}async provideTypeDefinition(F,q,K){const z=this.d.getDocument(F),X=I.Position.to(q),Y=await this.e.provideTypeDefinition(z,X,K);return m(Y)}}class y{constructor(F,q){this.d=F,this.e=q}async provideHover(F,q,K){const z=this.d.getDocument(F),X=I.Position.to(q),Y=await this.e.provideHover(z,X,K);if(!(!Y||(0,A.$Kb)(Y.contents)))return Y.range||(Y.range=z.getWordRangeAtPosition(X)),Y.range||(Y.range=new M.$9K(X,X)),I.Hover.from(Y)}}class D{constructor(F,q){this.d=F,this.e=q}async provideEvaluatableExpression(F,q,K){const z=this.d.getDocument(F),X=I.Position.to(q),Y=await this.e.provideEvaluatableExpression(z,X,K);if(Y)return I.EvaluatableExpression.from(Y)}}class N{constructor(F,q){this.d=F,this.e=q}async provideInlineValues(F,q,K,z){const X=this.d.getDocument(F),Y=await this.e.provideInlineValues(X,I.Range.to(q),I.InlineValueContext.to(K),z);if(Array.isArray(Y))return Y.map(Ee=>I.InlineValue.from(Ee))}}class O{constructor(F,q){this.d=F,this.e=q}async provideDocumentHighlights(F,q,K){const z=this.d.getDocument(F),X=I.Position.to(q),Y=await this.e.provideDocumentHighlights(z,X,K);if(Array.isArray(Y))return Y.map(I.DocumentHighlight.from)}}class H{constructor(F,q){this.d=F,this.e=q}async provideMultiDocumentHighlights(F,q,K,z){const X=this.d.getDocument(F),Y=K.map(We=>this.d.getDocument(We)),Ee=I.Position.to(q),Te=await this.e.provideMultiDocumentHighlights(X,Ee,Y,z);if(Array.isArray(Te))return Te.map(I.MultiDocumentHighlight.from)}}class U{constructor(F,q){this.d=F,this.e=q}async provideLinkedEditingRanges(F,q,K){const z=this.d.getDocument(F),X=I.Position.to(q),Y=await this.e.provideLinkedEditingRanges(z,X,K);if(Y&&Array.isArray(Y.ranges))return{ranges:(0,A.$Hb)(Y.ranges.map(I.Range.from)),wordPattern:Y.wordPattern}}}class W{constructor(F,q){this.d=F,this.e=q}async provideReferences(F,q,K,z){const X=this.d.getDocument(F),Y=I.Position.to(q),Ee=await this.e.provideReferences(X,Y,K,z);if(Array.isArray(Ee))return Ee.map(I.location.from)}}class P{static{this.d=1e3}constructor(F,q,K,z,X,Y,Ee){this.g=F,this.h=q,this.j=K,this.k=z,this.l=X,this.m=Y,this.n=Ee,this.e=new n.$Rfc("CodeAction"),this.f=new Map}async provideCodeActions(F,q,K,z){const X=this.g.getDocument(F),Y=l.$Vs.isISelection(q)?I.Selection.to(q):I.Range.to(q),Ee=[];for(const nt of this.j.getDiagnostics(F))if(Y.intersection(nt.range)&&Ee.push(nt)>P.d)break;const Te={diagnostics:Ee,only:K.only?new M.$pL(K.only):void 0,triggerKind:I.CodeActionTriggerKind.to(K.trigger)},We=await this.k.provideCodeActions(X,Y,Te,z);if(!(0,A.$Lb)(We)||z.isCancellationRequested)return;const Ke=this.e.add(We),Ze=new r.$Sc;this.f.set(Ke,Ze);const st=[];for(let nt=0;nt<We.length;nt++){const tt=We[nt];tt&&(P.o(tt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,Ze)})):(Te.only&&(tt.kind?Te.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[Ke,nt],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,Ze),diagnostics:tt.diagnostics&&tt.diagnostics.map(I.Diagnostic.from),edit:tt.edit&&I.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,i.$BF)(this.m,"codeActionAI")?tt.isAI:!1,disabled:tt.disabled?.reason})))}return{cacheId:Ke,actions:st}}async resolveCodeAction(F,q){const[K,z]=F,X=this.e.get(K,z);if(!X||P.o(X))return{};if(!this.k.resolveCodeAction)return{};const Y=await this.k.resolveCodeAction(X,q)??X;let Ee;Y.edit&&(Ee=I.WorkspaceEdit.from(Y.edit,void 0));let Te;if(Y.command){const We=this.f.get(K);We&&(Te=this.h.toInternal(Y.command,We))}return{edit:Ee,command:Te}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class C{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,K,z,X){this.d=F,this.e=q,this.f=K,this.g=z,this.h=X}async prepareDocumentPaste(F,q,K,z){if(!this.f.prepareDocumentPaste)return;const X=this.e.getDocument(F),Y=q.map(We=>I.Range.to(We)),Ee=I.DataTransfer.toDataTransfer(K,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(X,Y,Ee,z),z.isCancellationRequested)return;const Te=Array.from(Ee).filter(([,We])=>!(We instanceof M.$VL));return I.DataTransfer.from(Te)}async providePasteEdits(F,q,K,z,X){if(!this.f.provideDocumentPasteEdits)return;const Y=this.e.getDocument(q),Ee=K.map(Ke=>I.Range.to(Ke)),Te=I.DataTransfer.toDataTransfer(z,async Ke=>(await this.d.$resolvePasteFileData(this.g,F,Ke)).buffer),We=await this.f.provideDocumentPasteEdits(Y,Ee,Te,X);if(We)return{label:We.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:C.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class J{constructor(F,q){this.d=F,this.e=q}async provideDocumentFormattingEdits(F,q,K){const z=this.d.getDocument(F),X=await this.e.provideDocumentFormattingEdits(z,q,K);if(Array.isArray(X))return X.map(I.TextEdit.from)}}class ae{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeFormattingEdits(F,q,K,z){const X=this.d.getDocument(F),Y=I.Range.to(q),Ee=await this.e.provideDocumentRangeFormattingEdits(X,Y,K,z);if(Array.isArray(Ee))return Ee.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,q,K,z){(0,k.$Rf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const X=this.d.getDocument(F),Y=q.map(I.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(X,Y,K,z);if(Array.isArray(Ee))return Ee.map(I.TextEdit.from)}}class fe{constructor(F,q){this.d=F,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,q,K,z,X){const Y=this.d.getDocument(F),Ee=I.Position.to(q),Te=await this.e.provideOnTypeFormattingEdits(Y,Ee,K,z,X);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class we{constructor(F,q){this.e=F,this.f=q,this.d=new n.$Rfc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,q){const K=await this.e.provideWorkspaceSymbols(F,q);if(!(0,A.$Lb)(K))return{symbols:[]};const z=this.d.add(K),X={cacheId:z,symbols:[]};for(let Y=0;Y<K.length;Y++){const Ee=K[Y];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}X.symbols.push({...I.WorkspaceSymbol.from(Ee),cacheId:[z,Y]})}return X}async resolveWorkspaceSymbol(F,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const K=this.d.get(...F.cacheId);if(K){const z=await this.e.resolveWorkspaceSymbol(K,q);return z&&(0,T.$xn)(F,I.WorkspaceSymbol.from(z),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class ye{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,q,K){this.d=F,this.e=q,this.f=K}async provideRenameEdits(F,q,K,z){const X=this.d.getDocument(F),Y=I.Position.to(q);try{const Ee=await this.e.provideRenameEdits(X,Y,K,z);return Ee?I.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Te=ye.g(Ee);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(F,q,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const z=this.d.getDocument(F),X=I.Position.to(q);try{const Y=await this.e.prepareRename(z,X,K);let Ee,Te;if(M.$9K.isRange(Y)?(Ee=Y,Te=z.getText(Y)):(0,k.$Jf)(Y)&&(Ee=Y.range,Te=Y.placeholder),!Ee||!Te)return;if(Ee.start.line>X.line||Ee.end.line<X.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Ee),text:Te}}catch(Y){const Ee=ye.g(Y);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(Y)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class he{constructor(F,q){this.resultId=F,this.tokens=q}}class ve{constructor(F,q){this.f=F,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,q,K){const z=this.f.getDocument(F),X=q!==0?this.d.get(q):null;let Y=typeof X?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(z,X.resultId,K):await this.g.provideDocumentSemanticTokens(z,K);return X&&this.d.delete(q),Y?(Y=ve.h(Y),this.o(ve.n(X,Y),Y)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return ve.j(F)?ve.k(F)?F:new M.$mM(new Uint32Array(F.data),F.resultId):ve.l(F)?ve.m(F)?F:new M.$oM(F.edits.map(q=>new M.$nM(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const q of F.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(F,q){if(!ve.j(q)||!F||!F.tokens)return q;const K=F.tokens,z=K.length,X=q.data,Y=X.length;let Ee=0;const Te=Math.min(z,Y);for(;Ee<Te&&K[Ee]===X[Ee];)Ee++;if(Ee===z&&Ee===Y)return new M.$oM([],q.resultId);let We=0;const Ke=Te-Ee;for(;We<Ke&&K[z-We-1]===X[Y-We-1];)We++;return new M.$oM([{start:Ee,deleteCount:z-Ee-We,data:X.subarray(Ee,Y-We)}],q.resultId)}o(F,q){if(ve.j(F)){const K=this.e++;return this.d.set(K,new he(F.resultId,F.data)),(0,o.$o$)({id:K,type:"full",data:F.data})}if(ve.l(F)){const K=this.e++;return ve.j(q)?this.d.set(K,new he(q.resultId,q.data)):this.d.set(K,new he(F.resultId)),(0,o.$o$)({id:K,type:"delta",deltas:(F.edits||[]).map(z=>({start:z.start,deleteCount:z.deleteCount,data:z.data}))})}return null}}class ee{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeSemanticTokens(F,q,K){const z=this.d.getDocument(F),X=await this.e.provideDocumentRangeSemanticTokens(z,I.Range.to(q),K);return X?this.f(X):null}f(F){return(0,o.$o$)({id:0,type:"full",data:F.data})}}class De{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,q,K,z,X){this.f=F,this.g=q,this.h=K,this.j=z,this.k=X,this.d=new n.$Rfc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,q,K,z){const X=this.f.getDocument(F),Y=I.Position.to(q),Ee=X.getWordRangeAtPosition(Y)||new M.$9K(Y,Y),Te=Ee.with({end:Y}),We=new a.$Qd,Ke=await this.h.provideCompletionItems(X,Y,z,I.CompletionContext.to(K));if(!Ke||z.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new M.$CL(Ke):Ke,st=De.supportsResolving(this.h)?this.d.add(Ze.items):this.d.add([]),nt=new r.$Sc;this.e.set(st,nt);const tt=[],at={x:st,b:tt,a:{replace:I.Range.from(Ee),insert:I.Range.from(Te)},c:Ze.isIncomplete||void 0,d:We.elapsed()};for(let ct=0;ct<Ze.items.length;ct++){const je=Ze.items[ct],vt=this.l(je,[st,ct],Te,Ee);tt.push(vt)}return at}async resolveCompletionItem(F,q){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...F);if(!K)return;const z=this.l(K,F),X=await this.h.resolveCompletionItem(K,q);if(!X)return;const Y=this.l(X,F);return(z.h!==Y.h||z.i!==Y.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(z.n!==Y.n||z.o!==Y.o||!(0,T.$yn)(z.p,Y.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...z,d:Y.d,c:Y.c,l:Y.l,h:Y.h,i:Y.i,n:Y.n,o:Y.o,p:Y.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q,K,z){const X=this.e.get(q[0]);if(!X)throw Error("DisposableStore is missing...");const Y=this.g.toInternal(F.command,X),Ee={x:q,a:F.label,b:F.kind!==void 0?I.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(I.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:I.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(I.TextEdit.from),n:Y?.$ident,o:Y?.id,p:Y?.$ident?void 0:Y?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=F.textEdit.newText):typeof F.insertText=="string"?Ee.h=F.insertText:F.insertText instanceof M.$fL&&(Ee.h=F.insertText.value,Ee.i|=4);let Te;return F.textEdit?Te=F.textEdit.range:F.range&&(Te=F.range),M.$9K.isRange(Te)?Ee.j=I.Range.from(Te):Te&&(!K?.isEqual(Te.inserting)||!z?.isEqual(Te.replacing))&&(Ee.j={insert:I.Range.from(Te.inserting),replace:I.Range.from(Te.replacing)}),Ee}}class se{async provideInlineCompletions(F,q,K,z){}disposeCompletions(F){}handleDidShowCompletionItem(F,q,K){}handlePartialAccept(F,q,K){}}class x extends se{constructor(F,q,K,z){super(),this.f=F,this.g=q,this.h=K,this.j=z,this.d=new V,this.e=(0,i.$BF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$BF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,q,K,z){const X=this.g.getDocument(F),Y=I.Position.to(q),Ee=await this.h.provideInlineCompletionItems(X,Y,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:I.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},z);if(!Ee||z.isCancellationRequested)return;const Te=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],Ke=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Ze;return{pid:this.d.createReferenceId({dispose(){Ze?.dispose()},items:Te}),items:Te.map((nt,tt)=>{let at;nt.command&&(Ze||(Ze=new r.$Sc),at=this.j.toInternal(nt.command,Ze));const ct=nt.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:nt.filterText,range:nt.range?I.Range.from(nt.range):void 0,command:at,idx:tt,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:We.map(nt=>(Ze||(Ze=new r.$Sc),this.j.toInternal(nt,Ze))),suppressSuggestions:!1,enableForwardStability:Ke}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,q,K){const z=this.d.get(F)?.items[q];z&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(z,K)}handlePartialAccept(F,q,K){const z=this.d.get(F)?.items[q];z&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(z,K)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const q=this.e++;return this.d.set(q,F),q}disposeReferenceId(F){const q=this.d.get(F);return this.d.delete(F),q}get(F){return this.d.get(F)}}class ne{constructor(F,q){this.e=F,this.f=q,this.d=new n.$Rfc("SignatureHelp")}async provideSignatureHelp(F,q,K,z){const X=this.e.getDocument(F),Y=I.Position.to(q),Ee=this.g(K),Te=await this.f.provideSignatureHelp(X,Y,z,Ee);if(Te){const We=this.d.add([Te]);return{...I.SignatureHelp.from(Te),id:We}}}g(F){let q;if(F.activeSignatureHelp){const K=I.SignatureHelp.to(F.activeSignatureHelp),z=this.d.get(F.activeSignatureHelp.id,0);z?(q=z,q.activeSignature=K.activeSignature,q.activeParameter=K.activeParameter):q=K}return{...F,activeSignatureHelp:q}}releaseSignatureHelp(F){this.d.delete(F)}}class Ie{constructor(F,q,K,z,X){this.f=F,this.g=q,this.h=K,this.j=z,this.k=X,this.d=new n.$Rfc("InlayHints"),this.e=new Map}async provideInlayHints(F,q,K){const z=this.f.getDocument(F),X=I.Range.to(q),Y=await this.h.provideInlayHints(z,X,K);if(!Array.isArray(Y)||Y.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(K.isCancellationRequested)return;const Ee=this.d.add(Y);this.e.set(Ee,new r.$Sc);const Te={hints:[],cacheId:Ee};for(let We=0;We<Y.length;We++)this.l(Y[We],X)&&Te.hints.push(this.m(Y[We],[Ee,We]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Te}async resolveInlayHint(F,q){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...F);if(!K)return;const z=await this.h.resolveInlayHint(K,q);if(z&&this.l(z))return this.m(z,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q){return F.label.length===0||Array.isArray(F.label)&&F.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(q&&!q.contains(F.position))}m(F,q){const K=this.e.get(q[0]);if(!K)throw Error("DisposableStore is missing...");const z={label:"",cacheId:q,tooltip:I.MarkdownString.fromStrict(F.tooltip),position:I.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(I.TextEdit.from),kind:F.kind&&I.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};if(typeof F.label=="string")z.label=F.label;else{const X=[];z.label=X;for(const Y of F.label){if(!Y.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:Y.value,tooltip:I.MarkdownString.fromStrict(Y.tooltip)};M.$gL.isLocation(Y.location)&&(Ee.location=I.location.from(Y.location)),Y.command&&(Ee.command=this.g.toInternal(Y.command,K)),X.push(Ee)}}return z}}class Me{constructor(F,q){this.e=F,this.f=q,this.d=new n.$Rfc("DocumentLink")}async provideLinks(F,q){const K=this.e.getDocument(F),z=await this.f.provideDocumentLinks(K,q);if(!(!Array.isArray(z)||z.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:z.filter(Me.g).map(I.DocumentLink.from)};{const X=this.d.add(z),Y={links:[],cacheId:X};for(let Ee=0;Ee<z.length;Ee++){if(!Me.g(z[Ee]))continue;const Te=I.DocumentLink.from(z[Ee]);Te.cacheId=[X,Ee],Y.links.push(Te)}return Y}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,q){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...F);if(!K)return;const z=await this.f.resolveDocumentLink(K,q);if(!(!z||!Me.g(z)))return I.DocumentLink.from(z)}releaseLinks(F){this.d.delete(F)}}class Ce{constructor(F,q){this.d=F,this.e=q}async provideColors(F,q){const K=this.d.getDocument(F),z=await this.e.provideDocumentColors(K,q);return Array.isArray(z)?z.map(Y=>({color:I.Color.from(Y.color),range:I.Range.from(Y.range)})):[]}async provideColorPresentations(F,q,K){const z=this.d.getDocument(F),X=I.Range.to(q.range),Y=I.Color.to(q.color),Ee=await this.e.provideColorPresentations(Y,{document:z,range:X},K);if(Array.isArray(Ee))return Ee.map(I.ColorPresentation.from)}}class ce{constructor(F,q){this.d=F,this.e=q}async provideFoldingRanges(F,q,K){const z=this.d.getDocument(F),X=await this.e.provideFoldingRanges(z,q,K);if(Array.isArray(X))return X.map(I.FoldingRange.from)}}class ie{constructor(F,q,K){this.d=F,this.e=q,this.f=K}async provideSelectionRanges(F,q,K){const z=this.d.getDocument(F),X=q.map(I.Position.to),Y=await this.e.provideSelectionRanges(z,X,K);if(!(0,A.$Lb)(Y))return[];if(Y.length!==X.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Te=0;Te<X.length;Te++){const We=[];Ee.push(We);let Ke=X[Te],Ze=Y[Te];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(We.push(I.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return Ee}}class Q{constructor(F,q){this.f=F,this.g=q,this.d=new t.$bN(""),this.e=new Map}async prepareSession(F,q,K){const z=this.f.getDocument(F),X=I.Position.to(q),Y=await this.g.prepareCallHierarchy(z,X,K);if(!Y)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(Y)?Y.map(Te=>this.h(Ee,Te)):[this.h(Ee,Y)]}async provideCallsTo(F,q,K){const z=this.j(F,q);if(!z)throw new Error("missing call hierarchy item");const X=await this.g.provideCallHierarchyIncomingCalls(z,K);if(X)return X.map(Y=>({from:this.h(F,Y.from),fromRanges:Y.fromRanges.map(Ee=>I.Range.from(Ee))}))}async provideCallsFrom(F,q,K){const z=this.j(F,q);if(!z)throw new Error("missing call hierarchy item");const X=await this.g.provideCallHierarchyOutgoingCalls(z,K);if(X)return X.map(Y=>({to:this.h(F,Y.to),fromRanges:Y.fromRanges.map(Ee=>I.Range.from(Ee))}))}releaseSession(F){this.e.delete(F)}h(F,q){const K=this.e.get(F),z=I.CallHierarchyItem.from(q,F,K.size.toString(36));return K.set(z._itemId,q),z}j(F,q){return this.e.get(F)?.get(q)}}class te{constructor(F,q){this.f=F,this.g=q,this.d=new t.$bN(""),this.e=new Map}async prepareSession(F,q,K){const z=this.f.getDocument(F),X=I.Position.to(q),Y=await this.g.prepareTypeHierarchy(z,X,K);if(!Y)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(Y)?Y.map(Te=>this.h(Ee,Te)):[this.h(Ee,Y)]}async provideSupertypes(F,q,K){const z=this.j(F,q);if(!z)throw new Error("missing type hierarchy item");const X=await this.g.provideTypeHierarchySupertypes(z,K);if(X)return X.map(Y=>this.h(F,Y))}async provideSubtypes(F,q,K){const z=this.j(F,q);if(!z)throw new Error("missing type hierarchy item");const X=await this.g.provideTypeHierarchySubtypes(z,K);if(X)return X.map(Y=>this.h(F,Y))}releaseSession(F){this.e.delete(F)}h(F,q){const K=this.e.get(F),z=I.TypeHierarchyItem.from(q,F,K.size.toString(36));return K.set(z._itemId,q),z}j(F,q){return this.e.get(F)?.get(q)}}class me{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,K,z,X){this.d=F,this.e=q,this.f=K,this.g=z,this.h=X}async provideDocumentOnDropEdits(F,q,K,z,X){const Y=this.e.getDocument(q),Ee=I.Position.to(K),Te=I.DataTransfer.toDataTransfer(z,async Ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Ke)).buffer),We=await this.f.provideDocumentDropEdits(Y,Ee,Te,X);if(We)return{label:We.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:me.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class pe{constructor(F,q){this.d=F,this.e=q}async provideMappedEdits(F,q,K,z){const X=E.URI.revive(F),Y=this.d.getDocument(X),Ee=K.documents.map(Ke=>Ke.map(Ze=>({uri:E.URI.revive(Ze.uri),version:Ze.version,ranges:Ze.ranges.map(st=>I.Range.to(st))}))),Te={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(Y,q,Te,z);return We?I.WorkspaceEdit.from(We):null}}class Ae{constructor(F,q){this.adapter=F,this.extension=q}}class le{static{this.d=0}constructor(F,q,K,z,X,Y,Ee,Te){this.g=q,this.h=K,this.j=z,this.k=X,this.l=Y,this.m=Ee,this.n=Te,this.f=new Map,this.e=F.getProxy($.$5K.MainThreadLanguageFeatures)}o(F,q){return I.DocumentSelector.from(F,this.g,q)}p(F){return new M.$7K(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return le.d++}async s(F,q,K,z,X,Y=!1){const Ee=this.f.get(F);if(!Ee||!(Ee.adapter instanceof q))return z;const Te=Date.now();Y||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const We=K(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(Ke=>{(0,c.$4)(Ke)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(Ke),this.n.onExtensionError(Ee.extension.identifier,Ke))}).finally(()=>{Y||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),p.CancellationToken.isCancellationToken(X)?(0,h.$Ug)(We,X):We}t(F,q){const K=this.q();return this.f.set(K,new Ae(F,q)),K}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,q,K,z){const X=this.t(new u(this.h,K),F),Y=z&&z.label||le.u(F);return this.e.$registerDocumentSymbolProvider(X,this.o(q,F),Y),this.p(X)}$provideDocumentSymbols(F,q,K){return this.s(F,u,z=>z.provideDocumentSymbols(E.URI.revive(q),K),void 0,K)}registerCodeLensProvider(F,q,K){const z=this.q(),X=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(z,new Ae(new d(this.h,this.j.converter,K,F,this.n,this.l),F)),this.e.$registerCodeLensSupport(z,this.o(q,F),X);let Y=this.p(z);if(X!==void 0){const Ee=K.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(X));Y=M.$7K.from(Y,Ee)}return Y}$provideCodeLenses(F,q,K){return this.s(F,d,z=>z.provideCodeLenses(E.URI.revive(q),K),void 0,K)}$resolveCodeLens(F,q,K){return this.s(F,d,z=>z.resolveCodeLens(q,K),void 0,void 0)}$releaseCodeLenses(F,q){this.s(F,d,K=>Promise.resolve(K.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(F,q,K){const z=this.t(new f(this.h,K),F);return this.e.$registerDefinitionSupport(z,this.o(q,F)),this.p(z)}$provideDefinition(F,q,K,z){return this.s(F,f,X=>X.provideDefinition(E.URI.revive(q),K,z),[],z)}registerDeclarationProvider(F,q,K){const z=this.t(new S(this.h,K),F);return this.e.$registerDeclarationSupport(z,this.o(q,F)),this.p(z)}$provideDeclaration(F,q,K,z){return this.s(F,S,X=>X.provideDeclaration(E.URI.revive(q),K,z),[],z)}registerImplementationProvider(F,q,K){const z=this.t(new L(this.h,K),F);return this.e.$registerImplementationSupport(z,this.o(q,F)),this.p(z)}$provideImplementation(F,q,K,z){return this.s(F,L,X=>X.provideImplementation(E.URI.revive(q),K,z),[],z)}registerTypeDefinitionProvider(F,q,K){const z=this.t(new v(this.h,K),F);return this.e.$registerTypeDefinitionSupport(z,this.o(q,F)),this.p(z)}$provideTypeDefinition(F,q,K,z){return this.s(F,v,X=>X.provideTypeDefinition(E.URI.revive(q),K,z),[],z)}registerHoverProvider(F,q,K,z){const X=this.t(new y(this.h,K),F);return this.e.$registerHoverProvider(X,this.o(q,F)),this.p(X)}$provideHover(F,q,K,z){return this.s(F,y,X=>X.provideHover(E.URI.revive(q),K,z),void 0,z)}registerEvaluatableExpressionProvider(F,q,K,z){const X=this.t(new D(this.h,K),F);return this.e.$registerEvaluatableExpressionProvider(X,this.o(q,F)),this.p(X)}$provideEvaluatableExpression(F,q,K,z){return this.s(F,D,X=>X.provideEvaluatableExpression(E.URI.revive(q),K,z),void 0,z)}registerInlineValuesProvider(F,q,K,z){const X=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,Y=this.t(new N(this.h,K),F);this.e.$registerInlineValuesProvider(Y,this.o(q,F),X);let Ee=this.p(Y);if(X!==void 0){const Te=K.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(X));Ee=M.$7K.from(Ee,Te)}return Ee}$provideInlineValues(F,q,K,z,X){return this.s(F,N,Y=>Y.provideInlineValues(E.URI.revive(q),K,z,X),void 0,X)}registerDocumentHighlightProvider(F,q,K){const z=this.t(new O(this.h,K),F);return this.e.$registerDocumentHighlightProvider(z,this.o(q,F)),this.p(z)}registerMultiDocumentHighlightProvider(F,q,K){const z=this.t(new H(this.h,K),F);return this.e.$registerMultiDocumentHighlightProvider(z,this.o(q,F)),this.p(z)}$provideDocumentHighlights(F,q,K,z){return this.s(F,O,X=>X.provideDocumentHighlights(E.URI.revive(q),K,z),void 0,z)}$provideMultiDocumentHighlights(F,q,K,z,X){return this.s(F,H,Y=>Y.provideMultiDocumentHighlights(E.URI.revive(q),K,z.map(Ee=>E.URI.revive(Ee)),X),void 0,X)}registerLinkedEditingRangeProvider(F,q,K){const z=this.t(new U(this.h,K),F);return this.e.$registerLinkedEditingRangeProvider(z,this.o(q,F)),this.p(z)}$provideLinkedEditingRanges(F,q,K,z){return this.s(F,U,async X=>{const Y=await X.provideLinkedEditingRanges(E.URI.revive(q),K,z);if(Y)return{ranges:Y.ranges,wordPattern:Y.wordPattern?le.w(Y.wordPattern):void 0}},void 0,z)}registerReferenceProvider(F,q,K){const z=this.t(new W(this.h,K),F);return this.e.$registerReferenceSupport(z,this.o(q,F)),this.p(z)}$provideReferences(F,q,K,z,X){return this.s(F,W,Y=>Y.provideReferences(E.URI.revive(q),K,z,X),void 0,X)}registerCodeActionProvider(F,q,K,z){const X=new r.$Sc,Y=this.t(new P(this.h,this.j.converter,this.k,K,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(Y,this.o(q,F),{providedKinds:z?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:z?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,X)}))},le.u(F),!!K.resolveCodeAction),X.add(this.p(Y)),X}$provideCodeActions(F,q,K,z,X){return this.s(F,P,Y=>Y.provideCodeActions(E.URI.revive(q),K,z,X),void 0,X)}$resolveCodeAction(F,q,K){return this.s(F,P,z=>z.resolveCodeAction(q,K),{},void 0)}$releaseCodeActions(F,q){this.s(F,P,K=>Promise.resolve(K.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(F,q,K){const z=this.t(new J(this.h,K),F);return this.e.$registerDocumentFormattingSupport(z,this.o(q,F),F.identifier,F.displayName||F.name),this.p(z)}$provideDocumentFormattingEdits(F,q,K,z){return this.s(F,J,X=>X.provideDocumentFormattingEdits(E.URI.revive(q),K,z),void 0,z)}registerDocumentRangeFormattingEditProvider(F,q,K){const z=typeof K.provideDocumentRangesFormattingEdits=="function",X=this.t(new ae(this.h,K),F);return this.e.$registerRangeFormattingSupport(X,this.o(q,F),F.identifier,F.displayName||F.name,z),this.p(X)}$provideDocumentRangeFormattingEdits(F,q,K,z,X){return this.s(F,ae,Y=>Y.provideDocumentRangeFormattingEdits(E.URI.revive(q),K,z,X),void 0,X)}$provideDocumentRangesFormattingEdits(F,q,K,z,X){return this.s(F,ae,Y=>Y.provideDocumentRangesFormattingEdits(E.URI.revive(q),K,z,X),void 0,X)}registerOnTypeFormattingEditProvider(F,q,K,z){const X=this.t(new fe(this.h,K),F);return this.e.$registerOnTypeFormattingSupport(X,this.o(q,F),z,F.identifier),this.p(X)}$provideOnTypeFormattingEdits(F,q,K,z,X,Y){return this.s(F,fe,Ee=>Ee.provideOnTypeFormattingEdits(E.URI.revive(q),K,z,X,Y),void 0,Y)}registerWorkspaceSymbolProvider(F,q){const K=this.t(new we(q,this.l),F);return this.e.$registerNavigateTypeSupport(K,typeof q.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(F,q,K){return this.s(F,we,z=>z.provideWorkspaceSymbols(q,K),{symbols:[]},K)}$resolveWorkspaceSymbol(F,q,K){return this.s(F,we,z=>z.resolveWorkspaceSymbol(q,K),void 0,void 0)}$releaseWorkspaceSymbols(F,q){this.s(F,we,K=>K.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(F,q,K){const z=this.t(new ye(this.h,K,this.l),F);return this.e.$registerRenameSupport(z,this.o(q,F),ye.supportsResolving(K)),this.p(z)}$provideRenameEdits(F,q,K,z,X){return this.s(F,ye,Y=>Y.provideRenameEdits(E.URI.revive(q),K,z,X),void 0,X)}$resolveRenameLocation(F,q,K,z){return this.s(F,ye,X=>X.resolveRenameLocation(E.URI.revive(q),K,z),void 0,z)}registerDocumentSemanticTokensProvider(F,q,K,z){const X=this.t(new ve(this.h,K),F),Y=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(X,this.o(q,F),z,Y);let Ee=this.p(X);if(Y){const Te=K.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(Y));Ee=M.$7K.from(Ee,Te)}return Ee}$provideDocumentSemanticTokens(F,q,K,z){return this.s(F,ve,X=>X.provideDocumentSemanticTokens(E.URI.revive(q),K,z),null,z)}$releaseDocumentSemanticTokens(F,q){this.s(F,ve,K=>K.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,q,K,z){const X=this.t(new ee(this.h,K),F);return this.e.$registerDocumentRangeSemanticTokensProvider(X,this.o(q,F),z),this.p(X)}$provideDocumentRangeSemanticTokens(F,q,K,z){return this.s(F,ee,X=>X.provideDocumentRangeSemanticTokens(E.URI.revive(q),K,z),null,z)}registerCompletionItemProvider(F,q,K,z){const X=this.t(new De(this.h,this.j.converter,K,this.m,F),F);return this.e.$registerCompletionsProvider(X,this.o(q,F),z,De.supportsResolving(K),F.identifier),this.p(X)}$provideCompletionItems(F,q,K,z,X){return this.s(F,De,Y=>Y.provideCompletionItems(E.URI.revive(q),K,z,X),void 0,X)}$resolveCompletionItem(F,q,K){return this.s(F,De,z=>z.resolveCompletionItem(q,K),void 0,K)}$releaseCompletionItems(F,q){this.s(F,De,K=>K.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(F,q,K,z){const X=new x(F,this.h,K,this.j.converter),Y=this.t(X,F);return this.e.$registerInlineCompletionsSupport(Y,this.o(q,F),X.supportsHandleEvents,w.$km.toKey(F.identifier.value),z?.yieldTo?.map(Ee=>w.$km.toKey(Ee))||[]),this.p(Y)}$provideInlineCompletions(F,q,K,z,X){return this.s(F,se,Y=>Y.provideInlineCompletions(E.URI.revive(q),K,z,X),void 0,X)}$handleInlineCompletionDidShow(F,q,K,z){this.s(F,se,async X=>{X.handleDidShowCompletionItem(q,K,z)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,q,K,z){this.s(F,se,async X=>{X.handlePartialAccept(q,K,z)},void 0,void 0)}$freeInlineCompletionsList(F,q){this.s(F,se,async K=>{K.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(F,q,K,z){const X=Array.isArray(z)?{triggerCharacters:z,retriggerCharacters:[]}:z,Y=this.t(new ne(this.h,K),F);return this.e.$registerSignatureHelpProvider(Y,this.o(q,F),X),this.p(Y)}$provideSignatureHelp(F,q,K,z,X){return this.s(F,ne,Y=>Y.provideSignatureHelp(E.URI.revive(q),K,z,X),void 0,X)}$releaseSignatureHelp(F,q){this.s(F,ne,K=>K.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(F,q,K){const z=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,X=this.t(new Ie(this.h,this.j.converter,K,this.l,F),F);this.e.$registerInlayHintsProvider(X,this.o(q,F),typeof K.resolveInlayHint=="function",z,le.u(F));let Y=this.p(X);if(z!==void 0){const Ee=K.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(z));Y=M.$7K.from(Y,Ee)}return Y}$provideInlayHints(F,q,K,z){return this.s(F,Ie,X=>X.provideInlayHints(E.URI.revive(q),K,z),void 0,z)}$resolveInlayHint(F,q,K){return this.s(F,Ie,z=>z.resolveInlayHint(q,K),void 0,K)}$releaseInlayHints(F,q){this.s(F,Ie,K=>K.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(F,q,K){const z=this.t(new Me(this.h,K),F);return this.e.$registerDocumentLinkProvider(z,this.o(q,F),typeof K.resolveDocumentLink=="function"),this.p(z)}$provideDocumentLinks(F,q,K){return this.s(F,Me,z=>z.provideLinks(E.URI.revive(q),K),void 0,K,q.scheme==="output")}$resolveDocumentLink(F,q,K){return this.s(F,Me,z=>z.resolveLink(q,K),void 0,void 0,!0)}$releaseDocumentLinks(F,q){this.s(F,Me,K=>K.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(F,q,K){const z=this.t(new Ce(this.h,K),F);return this.e.$registerDocumentColorProvider(z,this.o(q,F)),this.p(z)}$provideDocumentColors(F,q,K){return this.s(F,Ce,z=>z.provideColors(E.URI.revive(q),K),[],K)}$provideColorPresentations(F,q,K,z){return this.s(F,Ce,X=>X.provideColorPresentations(E.URI.revive(q),K,z),void 0,z)}registerFoldingRangeProvider(F,q,K){const z=this.q(),X=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(z,new Ae(new ce(this.h,K),F)),this.e.$registerFoldingRangeProvider(z,this.o(q,F),F.identifier,X);let Y=this.p(z);if(X!==void 0){const Ee=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(X));Y=M.$7K.from(Y,Ee)}return Y}$provideFoldingRanges(F,q,K,z){return this.s(F,ce,X=>X.provideFoldingRanges(E.URI.revive(q),K,z),void 0,z)}registerSelectionRangeProvider(F,q,K){const z=this.t(new ie(this.h,K,this.l),F);return this.e.$registerSelectionRangeProvider(z,this.o(q,F)),this.p(z)}$provideSelectionRanges(F,q,K,z){return this.s(F,ie,X=>X.provideSelectionRanges(E.URI.revive(q),K,z),[],z)}registerCallHierarchyProvider(F,q,K){const z=this.t(new Q(this.h,K),F);return this.e.$registerCallHierarchyProvider(z,this.o(q,F)),this.p(z)}$prepareCallHierarchy(F,q,K,z){return this.s(F,Q,X=>Promise.resolve(X.prepareSession(E.URI.revive(q),K,z)),void 0,z)}$provideCallHierarchyIncomingCalls(F,q,K,z){return this.s(F,Q,X=>X.provideCallsTo(q,K,z),void 0,z)}$provideCallHierarchyOutgoingCalls(F,q,K,z){return this.s(F,Q,X=>X.provideCallsFrom(q,K,z),void 0,z)}$releaseCallHierarchy(F,q){this.s(F,Q,K=>Promise.resolve(K.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(F,q,K){const z=this.t(new te(this.h,K),F);return this.e.$registerTypeHierarchyProvider(z,this.o(q,F)),this.p(z)}$prepareTypeHierarchy(F,q,K,z){return this.s(F,te,X=>Promise.resolve(X.prepareSession(E.URI.revive(q),K,z)),void 0,z)}$provideTypeHierarchySupertypes(F,q,K,z){return this.s(F,te,X=>X.provideSupertypes(q,K,z),void 0,z)}$provideTypeHierarchySubtypes(F,q,K,z){return this.s(F,te,X=>X.provideSubtypes(q,K,z),void 0,z)}$releaseTypeHierarchy(F,q){this.s(F,te,K=>Promise.resolve(K.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(F,q,K,z){const X=this.q();this.f.set(X,new Ae(new me(this.e,this.h,K,X,F),F));const Y=(0,i.$BF)(F,"dropMetadata")&&z?me.toInternalProviderId(F.identifier.value,z.id):void 0;return this.e.$registerDocumentOnDropEditProvider(X,this.o(q,F),Y,(0,i.$BF)(F,"dropMetadata")?z:void 0),this.p(X)}$provideDocumentOnDropEdits(F,q,K,z,X,Y){return this.s(F,me,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(q,E.URI.revive(K),z,X,Y)),void 0,void 0)}registerMappedEditsProvider(F,q,K){const z=this.t(new pe(this.h,K),F);return this.e.$registerMappedEditsProvider(z,this.o(q,F)),this.p(z)}$provideMappedEdits(F,q,K,z,X){return this.s(F,pe,Y=>Promise.resolve(Y.provideMappedEdits(q,K,z,X)),null,X)}registerDocumentPasteEditProvider(F,q,K,z){const X=this.q();this.f.set(X,new Ae(new C(this.e,this.h,K,X,F),F));const Y=C.toInternalProviderId(F.identifier.value,z.id);return this.e.$registerPasteEditProvider(X,this.o(q,F),Y,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:z.copyMimeTypes,pasteMimeTypes:z.pasteMimeTypes}),this.p(X)}$prepareDocumentPaste(F,q,K,z,X){return this.s(F,C,Y=>Y.prepareDocumentPaste(E.URI.revive(q),K,z,X),void 0,X)}$providePasteEdits(F,q,K,z,X,Y){return this.s(F,C,Ee=>Ee.providePasteEdits(q,E.URI.revive(K),z,X,Y),void 0,Y)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:le.w(F.decreaseIndentPattern),increaseIndentPattern:le.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?le.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?le.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:le.w(F.beforeText),afterText:F.afterText?le.w(F.afterText):void 0,previousLineText:F.previousLineText?le.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(le.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(q=>M.SyntaxTokenType.toString(q)):void 0}}static D(F){return F.map(le.C)}setLanguageConfiguration(F,q,K){const{wordPattern:z}=K;if(z&&(0,g.$Xe)(z))throw new Error(`Invalid language configuration: wordPattern '${z}' is not allowed to match the empty string.`);z?this.h.setWordDefinitionFor(q,z):this.h.setWordDefinitionFor(q,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const X=this.q(),Y={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?le.w(K.wordPattern):void 0,indentationRules:K.indentationRules?le.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?le.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?le.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(X,q,Y),this.p(X)}$setWordDefinitions(F){for(const q of F)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$2fc=le}),define(Pe[254],Re([1,0,3,8,7,31,13,6,23]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class b{constructor(k,l,p,w){this.c=l,this.d=p,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(E.$5K.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const p=this.c.getDocumentData(k);if(!p)throw new Error(`document '${k.toString()}' NOT found`);return p.document}async tokenAtPosition(k,l){const p=k.version,w=T.Position.from(l),r=await this.a.$tokensAtPosition(k.uri,w),o={type:I.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new I.$9K(l.line,l.character,l.line,l.character)};if(!r)return o;const t={range:T.Range.to(r.range),type:T.TokenType.to(r.type)};return!t.range.contains(l)||p!==k.version?o:t}createLanguageStatusItem(k,l,p){const w=this.f++,r=this.a,o=this.g,t=`${k.identifier.value}/${l}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(t);const n={selector:p,id:l,name:k.displayName??k.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const c=new $.$Sc,h=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,R.$7g)(()=>{c.clear(),this.a.$setLanguageStatus(w,{id:t,name:n.name??k.displayName??k.name,source:k.displayName??k.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===I.LanguageStatusSeverity.Error?M.default.Error:n.severity===I.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),a?.dispose(),r.$removeLanguageStatus(w),o.delete(t)},get id(){return n.id},get name(){return n.name},set name(s){n.name=s,h()},get selector(){return n.selector},set selector(s){n.selector=s,h()},get text(){return n.text},set text(s){n.text=s,h()},set text2(s){(0,g.$CF)(k,"languageStatusText"),n.text=s,h()},get text2(){return(0,g.$CF)(k,"languageStatusText"),n.text},get detail(){return n.detail},set detail(s){n.detail=s,h()},get severity(){return n.severity},set severity(s){n.severity=s,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(s){n.accessibilityInformation=s,h()},get command(){return n.command},set command(s){n.command=s,h()},get busy(){return n.busy},set busy(s){n.busy=s,h()}};return h(),i}}e.$ohc=b}),define(Pe[82],Re([1,0,21,11,2,4,14,3,27,17]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=void 0;let A=class{constructor(l,p,w){this.f=w,this.d=new Map,this.a=p.getProxy($.$5K.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,p){const{message:w,args:r,comment:o}=p;if(this.c)return(0,T.$Ke)(w,r??{});let t=w;o&&o.length>0&&(t+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(l)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$Ke)(n??w,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const w=await this.g(l);if(!w){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(w),o=JSON.parse(r);p=l.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${w}: ${r.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:w})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive(p)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Mgc=A,e.$Mgc=A=Je([He(0,g.$mN),He(1,b.$9M),He(2,R.$mj)],A),e.$Ngc=(0,M.$5h)("IExtHostLocalizationService")}),define(Pe[255],Re([1,0,14,3,27,17,2,51]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;let g=class extends E.$xj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,$.$Bh)(p))),this.r=k.getProxy(T.$5K.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(R.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,p){return new b(this.r,k,l,p)}};e.$Zhc=g,e.$Zhc=g=Je([He(0,M.$9M),He(1,I.$mN)],g);class b extends E.$sj{constructor(k,l,p,w){super(w?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,w).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const p=[[k,l]];this.m?this.u(p):this.n.push(...p)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Re([1,0,3,4,6,17,24]),function(ge,e,E,T,I,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=void 0,e.$Ogc=(0,T.$5h)("IExtHostManagedSockets");let $=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(E.$5K.MainThreadManagedSockets)}setFactory(k,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,p=await this.c.makeConnection(),w=new I.$Sc;return this.d.set(l,new b(l,p,w)),w.add((0,I.$Rc)(()=>this.d.delete(l))),w.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),w.dispose()})),w.add(p.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),w.dispose()})),w.add(p.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,R.$ie.wrap(r)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Pgc=$,e.$Pgc=$=Je([He(0,M.$9M)],$);class g{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class b extends I.$Tc{constructor(k,l,p){super(),this.socketId=k,this.actual=l,this.B(p)}}}),define(Pe[256],Re([1,0,3,14,23]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;function M($){return $&&$.title}let R=class{constructor(g,b){this.b=b,this.a=g.getProxy(E.$5K.MainThreadMessageService)}showMessage(g,b,A,k,l){const p={source:{identifier:g.identifier,label:g.displayName||g.name}};let w;typeof k=="string"||M(k)?w=[k,...l]:(p.modal=k?.modal,p.useCustom=k?.useCustom,p.detail=k?.detail,w=l),p.useCustom&&(0,I.$CF)(g,"resolvers");const r=[];let o=!1;for(let t=0;t<w.length;t++){const n=w[t];if(typeof n=="string")r.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:a,isCloseAffordance:c}=n;r.push({title:a,isCloseAffordance:!!c,handle:t}),c&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,n)}return this.a.$showMessage(b,A,p,r).then(t=>{if(typeof t=="number")return w[t]})}};e.$phc=R,e.$phc=R=Je([He(1,T.$mj)],R)}),define(Pe[257],Re([1,0,18,13,20,5,6,28,2,22,14,3,32,8,7,78,210,23,49]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=e.$thc=void 0;let a=class{constructor(f,S,L,v,y){this.m=S,this.n=L,this.o=v,this.q=y,this.b=new $.$Ac,this.c=new $.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$Ud,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(k.$5K.MainThreadNotebookKernels);const D=new l.$wN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$uN("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],l.$vN.Void);this.o.registerApiCommand(D)}createNotebookController(f,S,L,v,y,D){for(const ee of this.j.values())if(ee.controller.id===S&&b.$km.equals(f.identifier,ee.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const N=this.k++,O=this;this.q.trace(`NotebookController[${N}], CREATED by ${f.identifier.value}, ${S}`);const H=()=>console.warn(`NO execute handler from notebook controller '${C.id}' of extension: '${f.identifier}'`);let U=!1;const W=new M.$Ud,P=new M.$Ud,C={id:d(f.identifier,S),notebookType:L,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:v||f.identifier.value,preloads:D?D.map(p.NotebookRendererScript.from):[]};let J=y??H,ae,fe;this.a.$addKernel(N,C).catch(ee=>{console.log(ee),U=!0});let we=0;const ye=()=>{if(U)return;const ee=++we;Promise.resolve().then(()=>{ee===we&&this.a.$updateKernel(N,C)})},he=new $.$Ac,ve={get id(){return S},get notebookType(){return C.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return C.label},set label(ee){C.label=ee??f.displayName??f.name,ye()},get detail(){return C.detail??""},set detail(ee){C.detail=ee,ye()},get description(){return C.description??""},set description(ee){C.description=ee,ye()},get supportedLanguages(){return C.supportedLanguages},set supportedLanguages(ee){C.supportedLanguages=ee,ye()},get supportsExecutionOrder(){return C.supportsExecutionOrder??!1},set supportsExecutionOrder(ee){C.supportsExecutionOrder=ee,ye()},get rendererScripts(){return C.preloads?C.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(ee){J=ee??H},get interruptHandler(){return ae},set interruptHandler(ee){ae=ee,C.supportsInterrupt=!!ee,ye()},set variableProvider(ee){(0,t.$CF)(f,"notebookVariableProvider"),fe=ee,C.hasVariableProvider=!!ee,ee?.onDidChangeVariables(De=>O.a.$variablesUpdated(De.uri)),ye()},get variableProvider(){return fe},createNotebookCellExecution(ee){if(U)throw new Error("notebook controller is DISPOSED");if(!he.has(ee.notebook.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.notebook.uri.toString()}`);return O._createNotebookCellExecution(ee,d(f.identifier,this.id))},createNotebookExecution(ee){if((0,t.$CF)(f,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!he.has(ee.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.uri.toString()}`);return O._createNotebookExecution(ee,d(f.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${N}], DISPOSED`),U=!0,this.j.delete(N),W.dispose(),P.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ee,De){De===w.NotebookControllerAffinity2.Hidden&&(0,t.$CF)(f,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(N,ee.uri,De)},onDidReceiveMessage:P.event,postMessage(ee,De){return(0,t.$CF)(f,"notebookMessaging"),O.a.$postMessage(N,De&&O.n.getIdByEditor(De),ee)},asWebviewUri(ee){return(0,t.$CF)(f,"notebookMessaging"),(0,r.$qvb)(ee,O.m.remote)}};return this.j.set(N,{extensionId:f.identifier,controller:ve,onDidReceiveMessage:P,onDidChangeSelection:W,associatedNotebooks:he}),ve}getIdByController(f){for(const[S,L]of this.j)if(L.controller===f)return d(L.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,S){const L=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(L,S);const y={dispose:()=>{this.f.delete(L),v.a.$removeKernelDetectionTask(L)}};return this.f.set(L,y),y}registerKernelSourceActionProvider(f,S,L){const v=this.i++,y=typeof L.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,D=this;this.h.set(v,L),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,S);let N;return y!==void 0&&(N=L.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(v),D.a.$removeKernelSourceActionProvider(v,v),N?.dispose()}}}async $provideKernelSourceActions(f,S){const L=this.h.get(f);if(L){const v=new R.$Sc;return(await L.provideNotebookKernelSourceActions(S)??[]).map(D=>p.NotebookKernelSourceAction.from(D,this.o.converter,v))}return[]}$acceptNotebookAssociation(f,S,L){const v=this.j.get(f);if(v){const y=this.n.getNotebookDocument(g.URI.revive(S));L?v.associatedNotebooks.set(y.uri,!0):v.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),L),v.onDidChangeSelection.fire({selected:L,notebook:y.apiNotebook})}}async $executeCells(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument(g.URI.revive(S)),D=[];for(const N of L){const O=y.getCell(N);O&&D.push(O.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),D.length),await v.controller.executeHandler.call(v.controller,D,y.apiNotebook,v.controller)}catch(N){this.q.error(`NotebookController[${f}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument(g.URI.revive(S));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,y.apiNotebook);else for(const D of L){const N=y.getCell(D);N&&this.b.get(N.uri)?.cancel()}if(v.controller.interruptHandler){const D=this.c.get(y.uri);L.length&&Array.isArray(D)&&D.length&&D.forEach(N=>N.dispose())}}async $provideVariables(f,S,L,v,y,D,N){const O=this.j.get(f);if(!O)return;const H=this.n.getNotebookDocument(g.URI.revive(L)),U=O.controller.variableProvider;if(!U)return;let W;if(v){if(W=this.s[v],!W)return}else this.s={};const P=y==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,C=U.provideVariables(H.apiNotebook,W,P,D,N);for await(const J of C){if(N.isCancellationRequested)return;const ae={id:this.r++,name:J.variable.name,value:J.variable.value,hasNamedChildren:J.hasNamedChildren,indexedChildrenCount:J.indexedChildrenCount};this.s[ae.id]=J.variable,this.a.$receiveVariable(S,ae)}}$acceptKernelMessageFromRenderer(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getEditorById(S);v.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:L}))}$cellExecutionChanged(f,S,L){const y=this.n.getNotebookDocument(g.URI.revive(f)).getCell(S);if(y){const D=L?p.NotebookCellExecutionState.to(L):w.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:y.apiCell,state:D})}}_createNotebookCellExecution(f,S){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const y=new h(S,v,this.a);this.b.set(v.uri,y);const D=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),D.dispose(),this.b.delete(v.uri))});return y.asApiObject()}_createNotebookExecution(f,S){const L=this.n.getNotebookDocument(f.uri),v=f.getCells().find(N=>{const O=L.getCellFromApiCell(N);return O&&this.b.has(O.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const y=new s(S,L,this.a),D=y.onDidChangeState(()=>{y.state===i.Resolved&&(y.dispose(),D.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[y,D]),y.asApiObject()}};e.$thc=a,e.$thc=a=Je([He(4,A.$mj)],a);var c;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(c||(c={}));class h extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(f,S,L){super(),this.m=S,this.n=L,this.b=h.a++,this.c=new M.$Ud,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new I.$5d),this.h=new u(10,v=>this.s(v)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const S=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$Sv(S))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let S=this.m;if(f&&(S=this.m.notebook.getCellFromApiCell(f)),!S)throw new Error("INVALID cell");return S.handle}y(f){return f.map(S=>{const L=w.$wM.ensureUniqueMimeTypes(S.items,!0);return L===S.items?p.NotebookCellOutput.from(S):p.NotebookCellOutput.from({items:L,id:S.id,metadata:S.metadata})})}async z(f,S,L){const v=this.w(S),y=this.y((0,E.$3b)(f));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:v,append:L,outputs:y})}async C(f,S,L){return f=w.$wM.ensureUniqueMimeTypes((0,E.$3b)(f),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:f.map(p.NotebookCellOutputItem.from),outputId:S.id,append:L})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(L){f.j=L,f.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(L){if(f.f===c.Resolved||f.f===c.Started)throw new Error("Cannot call start again");f.f=c.Started,f.c.fire(),f.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,v){if(f.f===c.Resolved)throw new Error("Cannot call resolve twice");f.f=c.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new n.$Sv({runEndTime:v,lastRunSuccess:L}))},clearOutput(L){return f.t(),f.z([],L,!1)},appendOutput(L,v){return f.t(),f.z(L,v,!0)},replaceOutput(L,v){return f.t(),f.z(L,v,!1)},appendOutputItems(L,v){return f.t(),f.C(L,v,!0)},replaceOutputItems(L,v){return f.t(),f.C(L,v,!1)}})}}var i;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(i||(i={}));class s extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(f,S,L){super(),this.h=S,this.j=L,this.b=s.a++,this.c=new M.$Ud,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new I.$5d),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(f,S){this.f=f,this.g=S,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new T.$ph,this.b=Date.now(),(0,T.$6g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>f.complete())}}function d(m,f){return`${m.value}/${f}`}e.$uhc=d}),define(Pe[258],Re([1,0,5,3,107]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;class M{constructor($,g){this.c=g,this.a=new Map,this.b=$.getProxy(T.$5K.MainThreadNotebookRenderers)}$postRendererMessage($,g,b){const A=this.c.getEditorById($);this.a.get(g)?.fire({editor:A.apiEditor,message:b})}createRendererMessaging($,g){if(!$.contributes?.notebookRenderer?.some(A=>A.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(A,k,l)=>this.d(g).event(A,k,l),postMessage:(A,k)=>{I.$bhc.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const l=k&&I.$bhc.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,g,A)}}}d($){let g=this.a.get($);return g||(g=new E.$Ud({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete($)}}),this.a.set($,g),g)}}e.$vhc=M}),define(Pe[259],Re([1,0,6,16,2,23,3]),function(ge,e,E,T,I,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class ${constructor(b){this.b=new Map,this.a=b.getProxy(R.$5K.MainThreadProfileContentHandlers)}registerProfileContentHandler(b,A,k){if((0,M.$CF)(b,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,k),this.a.$registerProfileContentHandler(A,k.name,k.description,b.identifier.value),(0,E.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(b,A,k,l){const p=this.b.get(b);if(!p)throw new Error(`Unknown handler with id: ${b}`);return p.saveProfile(A,k,l)}async $readProfile(b,A,k){const l=this.b.get(b);if(!l)throw new Error(`Unknown handler with id: ${b}`);return l.readProfile((0,T.$Hf)(A)?A:I.URI.revive(A),k)}}e.$yhc=$}),define(Pe[260],Re([1,0,2,3,13,8]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class R{static{this.a=0}constructor(g,b){this.d=b,this.c=new Map,this.b=g.getProxy(T.$5K.MainThreadQuickDiff)}$provideOriginalResource(g,b,A){const k=E.URI.revive(b),l=this.c.get(g);return l?(0,I.$Xg)(()=>l.provideOriginalResource(k,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(g,b,A,k){const l=R.a++;return this.c.set(l,b),this.b.$registerQuickDiffProvider(l,M.DocumentSelector.from(g,this.d),A,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Ahc=R}),define(Pe[261],Re([1,0,20,5,6,3,2,7,15,18,31,45,23,8]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;function w(r,o,t){const n=r.getProxy(M.$5K.MainThreadQuickOpen);class a{constructor(S,L){this.e=new Map,this.f=0,this.a=S,this.b=L}showQuickPick(S,L,v,y=E.CancellationToken.None){this.c=void 0;const D=Promise.resolve(L),N=++this.f,O=n.$show(N,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},y),H={},U=O.then(()=>H);return Promise.race([U,D]).then(W=>{if(W===H)return;const P=(0,l.$BF)(S,"quickPickItemTooltip");return D.then(C=>{const J=[];for(let ae=0;ae<C.length;ae++){const fe=C[ae];if(typeof fe=="string")J.push({label:fe,handle:ae});else if(fe.kind===$.QuickPickItemKind.Separator)J.push({type:"separator",label:fe.label});else{fe.tooltip&&!P&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const we=fe.iconPath?u(fe.iconPath):void 0;J.push({label:fe.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:P?p.MarkdownString.fromStrict(fe.tooltip):void 0,handle:ae})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=ae=>{v.onDidSelectItem(C[ae])}),n.$setItems(N,J),O.then(ae=>{if(typeof ae=="number")return C[ae];if(Array.isArray(ae))return ae.map(fe=>C[fe])})})}).then(void 0,W=>{if(!(0,g.$4)(W))return n.$setError(N,W),Promise.reject(W)})}$onItemSelected(S){this.c?.(S)}showInput(S,L=E.CancellationToken.None){return this.d=S?.validateInput,n.$input(S,typeof this.d=="function",L).then(void 0,v=>{if(!(0,g.$4)(v))return Promise.reject(v)})}async $validateInput(S){if(!this.d)return;const L=await this.d(S);if(!L||typeof L=="string")return L;let v;switch(L.severity){case $.InputBoxValidationSeverity.Info:v=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:v=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:v=A.default.Error;break;default:v=L.message?A.default.Error:A.default.Ignore;break}return{content:L.message,severity:v}}async showWorkspaceFolderPick(S,L=E.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!v)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(D=>D.uri.toString()===v.uri.toString())}createQuickPick(S){const L=new d(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(S){const L=new m(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(S,L){this.e.get(S)?._fireDidChangeValue(L)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,L){const v=this.e.get(S);v instanceof d&&v._fireDidChangeActive(L)}$onDidChangeSelection(S,L){const v=this.e.get(S);v instanceof d&&v._fireDidChangeSelection(L)}$onDidTriggerButton(S,L){this.e.get(S)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(S,L,v){const y=this.e.get(S);y instanceof d&&y._fireDidTriggerItemButton(L,v)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class c{static{this.a=1}constructor(S,L){this.x=S,this.y=L,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Ud,this.q=new T.$Ud,this.r=new T.$Ud,this.s=new T.$Ud,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((L,v)=>{const y=L===$.$pM.Back?-1:v;this.o.set(y,L)}),this.z({buttons:S.map((L,v)=>({...u(L.iconPath),tooltip:L.tooltip,handle:L===$.$pM.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const L=this.o.get(S);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(S){if(!this.v){for(const L of Object.keys(S)){const v=S[L];this.u[L]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(f){if(f instanceof $.$2L)return{id:f.id};const S=s(f),L=i(f);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof L=="string"?R.URI.file(L):L}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function s(f){return typeof f=="object"&&"dark"in f?f.dark:f}function u(f){const S=h(f);let L,v;return"id"in S?v=k.ThemeIcon.asClassName(S):L=S,{iconPath:L,iconClass:v}}class d extends c{constructor(S,L){super(S.identifier,L),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Ud,this.L=[],this.M=new T.$Ud,this.N=new T.$Ud,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((y,D)=>{this.C.set(D,y),this.D.set(y,D)});const L=(0,l.$BF)(this.O,"quickPickItemTooltip"),v=[];for(let y=0;y<S.length;y++){const D=S[y];if(D.kind===$.QuickPickItemKind.Separator)v.push({type:"separator",label:D.label});else{D.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const N=D.iconPath?u(D.iconPath):void 0;v.push({handle:y,label:D.label,iconPath:N?.iconPath,iconClass:N?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:L?p.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((O,H)=>({...u(O.iconPath),tooltip:O.tooltip,handle:H}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(S){const L=(0,b.$Hb)(S.map(v=>this.C.get(v)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(S){const L=(0,b.$Hb)(S.map(v=>this.C.get(v)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(S,L){const v=this.C.get(S);if(!v||!v.buttons||!v.buttons.length)return;const y=v.buttons[L];y&&this.N.fire({button:y,item:v})}}class m extends c{constructor(S,L){super(S.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:A.default.Error}):this.z({validationMessage:S.message,severity:S.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new a(o,t)}e.$Bhc=w}),define(Pe[262],Re([1,0,2,5,66,6,13,3,18,138,14,22,45,8,23,12,21]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=e.$Chc=void 0;function n(N){return N instanceof E.URI}function a(N,O){return N.scheme===r.Schemas.file&&O.scheme===r.Schemas.file&&o.$k?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function c(N){if(N)return typeof N.iconPath=="string"?E.URI.file(N.iconPath):E.URI.isUri(N.iconPath)||l.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function h(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if(l.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const O=N.icon;return{light:O.light,dark:O.dark}}}else return}function i(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const H=typeof N.iconPath=="string"?N.iconPath:E.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,U=typeof O.iconPath=="string"?O.iconPath:E.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,b.$Rq)(H,U)}function s(N,O){let H=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(H=i(N,O),H!==0)return H;if(N.light&&O.light)H=i(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(H!==0)return H;if(N.dark&&O.dark)H=i(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return H}function u(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let H=0;H<N.arguments.length;H++){const U=N.arguments[H],W=O.arguments[H];if(U!==W&&!(n(U)&&n(W)&&a(U,W)))return U<W?-1:1}return 0}function d(N,O){let H=(0,b.$Rq)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(H!==0)return H;if(N.command&&O.command)H=u(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(H!==0)return H;if(N.decorations&&O.decorations)H=s(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)H=(0,b.$Rq)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)H=(0,b.$Rq)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return H}function m(N,O){for(let H=0;H<N.length;H++)if(N[H]!==O[H])return!1;return!0}function f(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?m(N.arguments,O.arguments):N.arguments===O.arguments)}function S(N,O){return(0,g.$ub)(N,O,f)}class L{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,w.$CF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,w.$CF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,w.$CF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,H,U,W,P){this.k=O,this.l=W,this.m=P,this.d="",this.e=new T.$Ud,this.f="",this.h=!0,this.j=!0,this.#t=H,this.#e=U}showValidationMessage(O,H){(0,w.$CF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,H)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Chc=L;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,H,U,W,P,C,J){this.q=O,this.s=H,this.t=U,this.u=W,this.v=P,this.multiDiffEditorEnableViewChanges=C,this.w=J,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Ud,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Ud,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,H){const U=this.h.get(O);return U?(0,R.$Xg)(()=>this.s.executeCommand(U.command,...U.arguments||[],H)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(d),U=(0,g.$Db)(this.o,O,d).map(C=>{const J=C.toInsert.map(ae=>{const fe=this.e++;this.g.set(fe,ae);const we=ae.resourceUri;let ye;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const ie=new M.$Sc;ye=this.s.converter.toInternal(ae.command,ie),this.j.set(fe,ie)}else this.h.set(fe,ae.command);const he=(0,w.$BF)(this.w,"scmMultiDiffEditor"),ve=he?ae.multiDiffEditorOriginalUri:void 0,ee=he?ae.multiFileDiffEditorModifiedUri:void 0,De=c(ae.decorations),se=ae.decorations&&c(ae.decorations.light)||De,x=ae.decorations&&c(ae.decorations.dark)||De,V=[se,x],ne=ae.decorations&&ae.decorations.tooltip||"",Ie=ae.decorations&&!!ae.decorations.strikeThrough,Me=ae.decorations&&!!ae.decorations.faded,Ce=ae.contextValue||"";return{rawResource:[fe,we,V,ne,Ie,Me,Ce,ye,ve,ee],handle:fe}});return{start:C.start,deleteCount:C.deleteCount,toInsert:J}}),W=U.map(({start:C,deleteCount:J,toInsert:ae})=>[C,J,ae.map(fe=>fe.rawResource)]),P=U.reverse();for(const{start:C,deleteCount:J,toInsert:ae}of P){const fe=ae.map(ye=>ye.handle),we=this.n.splice(C,J,...fe);for(const ye of we)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=O,W}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let H;(0,w.$BF)(this.x,"quickDiffProvider")&&(H=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:H})}get historyProvider(){return(0,w.$CF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,w.$CF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new M.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new M.$Sc,this.o=O;const H=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:H})}get actionButton(){return(0,w.$CF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,w.$CF)(this.x,"scmActionButton"),this.p.value=new M.$Sc,this.q=O;const H=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(U=>U.map(W=>this.y.converter.toInternal(W,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:H??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&S(this.t,O))return;this.s.value=new M.$Sc,this.t=O;const H=(O||[]).map(U=>this.y.converter.toInternal(U,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:H})}get selected(){return this.u}constructor(O,H,U,W,P,C,J){this.x=O,this.y=W,this.z=P,this.A=C,this.B=J,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Uc,this.m=void 0,this.n=new M.$Uc,this.o=void 0,this.p=new M.$Uc,this.s=new M.$Uc,this.t=void 0,this.u=!1,this.v=new T.$Ud,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=U;const ae=E.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${P}/scm${this.w}/input`,query:J?`rootUri=${encodeURIComponent(J.toString())}`:void 0});this.f=new L(O,H,this.#e,this.w,ae),this.#e.$registerSourceControl(this.w,P,C,J,ae)}createResourceGroup(O,H,U){const W=(0,w.$BF)(this.x,"scmMultiDiffEditor")&&U?.multiDiffEditorEnableViewChanges===!0,P=new v(this.#e,this.y,this.w,O,H,W,this.x),C=T.Event.once(P.onDidDispose)(()=>this.C.delete(P));return this.C.set(P,C),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const O=[],H=[];for(const[U,W]of this.C){W.dispose();const P=U.onDidUpdateResourceStates(()=>{this.D.add(U),this.eventuallyUpdateResourceStates()});T.Event.once(U.onDidDispose)(()=>{this.D.delete(U),P.dispose(),this.e.delete(U.handle),this.#e.$unregisterGroup(this.w,U.handle)}),O.push([U.handle,U.id,U.label,U.features,U.multiDiffEditorEnableViewChanges]);const C=U._takeResourceStateSnapshot();C.length>0&&H.push([U.handle,C]),this.e.set(U.handle,U)}this.#e.$registerGroups(this.w,O,H),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(H=>{const U=H._takeResourceStateSnapshot();U.length!==0&&O.push([H.handle,U])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,I.$xh)(100)],y.prototype,"eventuallyAddResourceGroups",null),Je([(0,I.$xh)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,H,U,W){this.l=H,this.m=U,this.n=W,this.g=new Map,this.h=new k.$mm,this.j=new T.$Ud,this.e=O.getProxy($.$5K.MainThreadSCM),this.f=O.getProxy($.$5K.MainThreadTelemetry),H.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const C=this.g.get(P.sourceControlHandle);if(!C)return P;const J=C.getResourceGroup(P.groupHandle);return J?J.getResourceState(P.handle):P}else if(P&&P.$mid===4){const C=this.g.get(P.sourceControlHandle);return C?C.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const C=this.g.get(P.handle);return C||P}return P}})}createSourceControl(O,H,U,W){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,H,U,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const P=t.d++,C=new y(O,this.m,this.e,this.l,H,U,W);this.g.set(P,C);const J=this.h.get(O.identifier)||[];return J.push(C),this.h.set(O.identifier,J),C}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const H=this.h.get(O.identifier),U=H&&H[H.length-1];return U&&U.inputBox}$provideOriginalResource(O,H,U){const W=E.URI.revive(H);this.n.trace("ExtHostSCM#$provideOriginalResource",O,W.toString());const P=this.g.get(O);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Xg)(()=>P.quickDiffProvider.provideOriginalResource(W,U)).then(C=>C||null)}$onInputBoxValueChange(O,H){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const U=this.g.get(O);return U&&U.inputBox.$onInputBoxValueChange(H),Promise.resolve(void 0)}$executeResourceCommand(O,H,U,W){this.n.trace("ExtHostSCM#$executeResourceCommand",O,H,U);const P=this.g.get(O);if(!P)return Promise.resolve(void 0);const C=P.getResourceGroup(H);return C?C.$executeResourceCommand(U,W):Promise.resolve(void 0)}$validateInput(O,H,U){this.n.trace("ExtHostSCM#$validateInput",O);const W=this.g.get(O);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Xg)(()=>W.inputBox.validateInput(H,U)).then(P=>{if(!P)return Promise.resolve(void 0);const C=p.MarkdownString.fromStrict(P.message);return C?Promise.resolve([C,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(O,H,U){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupBase(H,U)??void 0}async $resolveHistoryItemGroupCommonAncestor(O,H,U,W){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(H,U,W)??void 0}async $provideHistoryItems(O,H,U,W){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(H,U,W))?.map(J=>({...J,icon:h(J)}))??void 0}async $provideHistoryItemChanges(O,H,U,W){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(H,U,W)??void 0}};e.$Dhc=D,e.$Dhc=D=t=Je([He(3,A.$mj)],D)}),define(Pe[84],Re([1,0,3,5,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=void 0;class M{constructor($){this.b=new T.$Ud,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$5K.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,g){return this.a.$getPassword($,g)}store($,g,b){return this.a.$setPassword($,g,b)}delete($,g){return this.a.$deletePassword($,g)}}e.$Jgc=M,e.$Kgc=(0,I.$5h)("IExtHostSecretState")}),define(Pe[263],Re([1,0,3,8,2]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;class M{static{this.a=0}constructor($,g){this.d=g,this.c=new Map,this.b=$.getProxy(E.$5K.MainThreadShare)}async $provideShare($,g,b){return await this.c.get($)?.provideShare({selection:T.Range.to(g.selection),resourceUri:I.URI.revive(g.resourceUri)},b)??void 0}registerShareProvider($,g){const b=M.a++;return this.c.set(b,g),this.b.$registerShareProvider(b,T.DocumentSelector.from($,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(b),this.c.delete(b)}}}}e.$Ehc=M}),define(Pe[264],Re([1,0,20,6,3]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(I.$5K.MainThreadSpeech)}async $createSpeechToTextSession($,g){const b=this.c.get($);if(!b)return;const A=new T.$Sc,k=new E.$5d;this.d.set(g,k);const l=A.add(b.provideSpeechToTextSession(k.token));A.add(l.onDidChange(p=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,p)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,g,b){const A=M.a++;return this.c.set(A,b),this.b.$registerProvider(A,g,{extension:$,displayName:$.value}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Fhc=M}),define(Pe[265],Re([1,0,7,3,163,6,8,16]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$3L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$3L("statusBarItem.warningForeground")]])}#e;#t;constructor(l,p,w,r,o,t=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Sc,this.#e=l,this.#t=p,o&&r){this.c=(0,E.$FL)(r.identifier,o);const a=w.get(this.c);a&&(t=a.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(g.a++);this.e=r,this.f=o,this.g=t,this.h=this.u(n)}u(l){if((0,$.$Lf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new M.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let p;this.m?p=this.m:p=(0,I.localize)(0,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=g.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,p,this.k,r,this.r?.internal,w,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Ghc=g;class b{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const p={message:l};return this.b.unshift(p),this.c(),new E.$7K(()=>{const w=this.b.indexOf(p);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,p){this.e=new Map,this.a=l.getProxy(T.$5K.MainThreadStatusBar),this.b=p,this.c=new b(this)}$acceptStaticEntries(l){for(const p of l)this.e.set(p.entryId,p)}createStatusBarEntry(l,p,w,r){return new g(this.a,this.b,this.e,l,p,w,r)}setStatusBarMessage(l,p){const w=this.c.setMessage(l);let r;return typeof p=="number"?r=setTimeout(()=>w.dispose(),p):typeof p<"u"&&p.then(()=>w.dispose(),()=>w.dispose()),new E.$7K(()=>{w.dispose(),clearTimeout(r)})}}e.$Hhc=A}),define(Pe[85],Re([1,0,3,5,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=void 0;class M{constructor($,g){this.c=g,this.b=new T.$Ud,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$5K.MainThreadStorage)}registerExtensionStorageKeysToSync($,g){this.a.$registerExtensionStorageKeysToSync($,g)}async initializeExtensionStorage($,g,b){const A=await this.a.$initializeExtensionStorage($,g);let k;return A&&(k=this.d($,g,A)),k||b}setValue($,g,b){return this.a.$setValue($,g,b)}$acceptValue($,g,b){const A=this.d($,g,b);A&&this.b.fire({shared:$,key:g,value:A})}d($,g,b){try{return JSON.parse(b)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${$}): ${A}`)}}}e.$Bgc=M,e.$Cgc=(0,I.$5h)("IExtHostStorage")}),define(Pe[86],Re([1,0,4,27,14,63,2]),function(ge,e,E,T,I,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=e.$kgc=void 0,e.$kgc=(0,E.$5h)("IExtensionStoragePaths");let $=class{constructor(b,A,k){this.d=A,this.f=k,this.a=b.workspace??void 0,this.b=b.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(b){return R.URI.joinPath(this.b.workspaceStorageHome,b)}async h(){if(!this.a)return Promise.resolve(void 0);const b=this.a.id,A=await this.g(b);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(b){if(this.c)return R.URI.joinPath(this.c,b.identifier.value)}globalValue(b){return R.URI.joinPath(this.b.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$lgc=$,e.$lgc=$=Je([He(0,T.$mN),He(1,I.$mj),He(2,M.$jgc)],$)}),define(Pe[64],Re([1,0,5,3,4,2,17,6,7,165,15,193,20,33,194,45,13,8,32]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=e.$Hgc=e.$Ggc=e.$Fgc=void 0,e.$Fgc=(0,I.$5h)("IExtHostTerminalService");class a{constructor(v,y,D,N){this.l=v,this._id=y,this.m=D,this.n=N,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(H=>this.f=H);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(H,U=!0){O.q(),O.l.$sendText(O._id,H,U)},show(H){O.q(),O.l.$show(O._id,H)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(v,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??y?.cwd??void 0,env:v.env??void 0,icon:m(v.iconPath)??void 0,color:r.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(v.location,y?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,y,D,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:N,color:r.ThemeColor.isThemeColor(O)?O.id:void 0,location:y?.location||this.o(v,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,y){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in v?{viewColumn:t.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,y){this.h=Object.freeze({code:v,reason:y})}setDimensions(v,y){return v===this.d&&y===this.g||v===0||y===0?!1:(this.d=v,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(y=>{y!==v&&(this.b=Promise.resolve(v))})}}e.$Ggc=a;class c{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new E.$Ud,this.onProcessData=this.a.event,this.b=new E.$Ud,this.d=new E.$Ud,this.onDidChangeProperty=this.d.event,this.f=new E.$Ud,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,y){this.g.setDimensions?.({columns:v,rows:y})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends $.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,y,D){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Ud,this.onDidCloseTerminal=this.H.event,this.I=new E.$Ud,this.onDidOpenTerminal=this.I.event,this.J=new E.$Ud,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Ud,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Ud,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Ud,this.onDidChangeShell=this.N.event,this.O=new E.$Ud({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Ud({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(T.$5K.MainThreadTerminalService),this.y=new w.$Erb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:N=>{const O=H=>{const U=H;return this.W(U.instanceId)?.value};switch(N?.$mid){case 15:return O(N);default:{if(Array.isArray(N))for(let H=0;H<N.length&&N[H].$mid===15;H++)N[H]=O(N[H]);return N}}}}),this.B({dispose:()=>{for(const[N,O]of this.g)O.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,y){const D=new a(this.a,(0,p.$pg)(),v,v.name),N=new c(v.pty);return D.createExtensionTerminal(v.location,y,this.R(v,y).resolvedExtHostIdentifier,m(v.iconPath),f(v.color)).then(O=>{const H=this.S(O,N);this.h[O]=H}),this.f.push(D),D.value}R(v,y){if(y=y||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const D=v.location.parentTerminal;if(D){const N=this.f.find(O=>O.value===D);N&&(y.resolvedExtHostIdentifier=N._id)}}else v.location&&typeof v.location!="object"?y.location=v.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(v,y){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const N=new c(y),O=this.S(v,N);this.h[v]=O}async $acceptActiveTerminalChanged(v){const y=this.b;if(v===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const D=this.W(v);D&&(this.b=D,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,y){const D=this.W(v);D&&this.O.fire({terminal:D.value,data:y})}async $acceptTerminalDimensions(v,y,D){const N=this.W(v);N&&N.setDimensions(y,D)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(v,y){const D=this.W(v);D&&this.P.fire({terminal:D.value,...y})}async $acceptTerminalMaximumDimensions(v,y,D){this.g.get(v)?.resize(y,D)}async $acceptTerminalTitleChange(v,y){const D=this.W(v);D&&(D.name=y)}async $acceptTerminalClosed(v,y,D){const N=this.Y(this.f,v);if(N!==null){const O=this.f.splice(N,1)[0];O.setExitStatus(y,D),this.H.fire(O.value)}}$acceptTerminalOpened(v,y,D,N){if(y){const U=this.Y(this.f,y);if(U!==null){this.f[U]._id=v,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:M.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},H=new a(this.a,v,O,D);this.f.push(H),this.I.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(v,y){this.W(v)?._setProcessId(y)}async $startExtensionTerminal(v,y){const D=this.W(v);if(!D)return{message:(0,b.localize)(0,null,v)};D.isOpen||await new Promise(O=>{const H=this.onDidOpenTerminal(async U=>{U===D.value&&(H.dispose(),O())})});const N=this.g.get(v);N?N.startSendingEvents(y):this.j[v]={initialDimensions:y}}S(v,y){const D=new $.$Sc;D.add(y.onProcessReady(O=>this.a.$sendProcessReady(v,O.pid,O.cwd,O.windowsPty))),D.add(y.onDidChangeProperty(O=>this.a.$sendProcessProperty(v,O))),this.y.startBuffering(v,y.onProcessData),D.add(y.onProcessExit(O=>this.U(v,O))),this.g.set(v,y);const N=this.j[v];return N&&y instanceof c&&(y.startSendingEvents(N.initialDimensions),delete this.j[v]),D}$acceptProcessAckDataEvent(v,y){this.g.get(v)?.acknowledgeDataEvent(y)}$acceptProcessInput(v,y){this.g.get(v)?.input(y)}$acceptTerminalInteraction(v){const y=this.W(v);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(v,y){this.W(v)?.setSelection(y)}$acceptProcessResize(v,y,D){try{this.g.get(v)?.resize(y,D)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(v,y){this.g.get(v)?.shutdown(y)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(y=>this.a.$sendProcessProperty(v,{type:"cwd",value:y}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new g.$7K(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,y,D){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,D),this.a.$registerProfileProvider(y,v.identifier.value),new g.$7K(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(v,y,D){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,D),this.a.$registerQuickFixProvider(v,y),new g.$7K(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,y){const D=new l.$5d().token;if(D.isCancellationRequested)return;const N=this.D.get(v);if(!N)return;const O=await N.provideTerminalQuickFixes(y,D);if(O===null||Array.isArray(O)&&O.length===0)return;const H=new $.$Sc;if(this.w.value=H,!Array.isArray(O))return O?t.TerminalQuickFix.from(O,this.Q.converter,H):void 0;const U=[];for(const W of O){const P=t.TerminalQuickFix.from(W,this.Q.converter,H);P&&U.push(P)}return U}async $createContributedProfileTerminal(v,y){const D=new l.$5d().token;let N=await this.C.get(v)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,y);return}this.createTerminalFromOptions(N.options,y)}}async $provideLinks(v,y){const D=this.W(v);if(!D)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const O=new l.$5d;this.G.set(v,O);const H=[],U={terminal:D.value,line:y},W=[];for(const J of this.z)W.push(o.Promises.withAsyncBody(async ae=>{O.token.onCancellationRequested(()=>ae({provider:J,links:[]}));const fe=await J.provideTerminalLinks(U,O.token)||[];O.token.isCancellationRequested||ae({provider:J,links:fe})}));const P=await Promise.all(W);if(O.token.isCancellationRequested)return[];const C=new Map;for(const J of P)J&&J.links.length>0&&H.push(...J.links.map(ae=>{const fe={id:h++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return C.set(fe.id,{provider:J.provider,link:ae}),fe}));return this.F.set(v,C),H}$activateLink(v,y){const D=this.F.get(v)?.get(y);D&&D.provider.handleTerminalLink(D.link)}U(v,y){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const D=this.h[v];D&&(D.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,y)}W(v){return this.X(this.f,v)}X(v,y){const D=this.Y(v,y);return D!==null?v[D]:null}Y(v,y){const D=v.findIndex(N=>N._id===y);return D===-1?null:D}getEnvironmentVariableCollection(v){let y=this.n.get(v.identifier.value);return y||(y=new s,this.$(v.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(v,y){const D=(0,k.$Lr)(y.map),N=(0,k.$Mr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(v,y.persistent,D.length===0?void 0:D,N)}$initEnvironmentVariableCollections(v){v.forEach(y=>{const D=y[0],N=new s(y[1]);this.$(D,N)})}$acceptDefaultProfile(v,y){const D=this.s;this.s=v,this.u=y,D?.path!==v.path&&this.N.fire(v.path)}$(v,y){this.n.set(v,y),y.onDidChangeCollection(()=>{this.Z(v,y)})}};e.$Hgc=i,e.$Hgc=i=Je([He(1,n.$sN),He(2,R.$9M)],i);class s{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Ud,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const y=this.h(v);let D=this.a.get(y);return D||(D=new u(this,v),this.a.set(y,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(v,y,D,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:N})}append(v,y,D,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:N})}prepend(v,y,D,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:N})}f(v,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(v,y.scope),N=this.map.get(D),O=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==y.value||N.type!==y.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const H=this.g(v,y.scope),U={variable:v,...y,options:O};this.map.set(H,U),this.d.fire()}}get(v,y){const D=this.g(v,y),N=this.map.get(D);return N?S(N):void 0}g(v,y){const D=this.h(y);return D.length?`${v}:::${D}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const y=new Map;for(const[D,N]of this.map)this.h(N.scope)===this.h(v)&&y.set(N.variable,S(N));return y}delete(v,y){const D=this.g(v,y);this.map.delete(D),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[y,D]of this.map)D.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(y);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,y){const D=this.h(y),N=this.descriptionMap.get(D);if(!N||N.description!==v){let O;typeof v=="string"?O=v:O=v?.value.split(`

`)[0];const H={description:O,scope:y};this.descriptionMap.set(D,H),this.d.fire()}}getDescription(v){const y=this.h(v);return this.descriptionMap.get(y)?.description}k(v){const y=this.h(v);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,y){this.b=v,this.d=y,this.a=new E.$Ud}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,y,D){this.b.replace(v,y,D,this.d)}append(v,y,D){this.b.append(v,y,D,this.d)}prepend(v,y,D){this.b.prepend(v,y,D,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,y){this.b.getVariableMap(this.d).forEach((D,N)=>v.call(y,N,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends i{constructor(v,y){super(!1,v,y)}createTerminal(v,y,D){throw new A.$_}createTerminalFromOptions(v,y){throw new A.$_}};e.$Igc=d,e.$Igc=d=Je([He(0,n.$sN),He(1,R.$9M)],d);function m(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function f(L){return r.ThemeColor.isThemeColor(L)?L:void 0}function S(L){const v={...L};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Pe[266],Re([1,0,13,24,20,5,218,98,6,26,16,33,14,3,17,108,8,7,48,77,58,23]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=e.$Mhc=e.$Lhc=void 0;let i=class extends g.$Tc{constructor(U,W,P,C){super(),this.w=C,this.f=this.B(new M.$Ud),this.g=new Map,this.s=this.B(new M.$Ud),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(p.$5K.MainThreadTesting),this.m=new D(this.h),this.j=new m(this.h,W),P.registerArgumentProcessor({processArgument:J=>{switch(J?.$mid){case 16:{const ae=J,fe=ae.tests[ae.tests.length-1].item.extId;return this.g.get(n.$WJ.root(fe))?.collection.tree.get(fe)?.actual??(0,r.$iN)(J)}case 18:{const{extId:ae,message:fe}=J;return{test:this.g.get(n.$WJ.root(ae))?.collection.tree.get(ae)?.actual,message:o.TestMessage.to(fe)}}default:return J}}}),P.registerCommand(!1,"testing.getExplorerSelection",async()=>{const J=await P.executeCommand("_testing.getExplorerSelection"),ae=fe=>{const we=this.g.get(n.$WJ.root(fe));if(we)return n.$WJ.isRoot(fe)?we.controller:we.collection.tree.get(fe)?.actual};return{include:J?.include.map(ae).filter(A.$Pf)||[],exclude:J?.exclude.map(ae).filter(A.$Pf)||[]}})}createTestController(U,W,P,C){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const J=new g.$Sc,ae=J.add(new r.$lN(W,P,this.w));ae.root.label=P;const fe=new Map,we=new Set,ye=this.h,he={items:ae.root.children,get label(){return P},set label(ee){P=ee,ae.root.label=ee,ye.$updateController(W,{label:P})},get refreshHandler(){return C},set refreshHandler(ee){C=ee,ye.$updateController(W,{canRefresh:!!ee})},get id(){return W},createRunProfile:(ee,De,se,x,V,ne)=>{let Ie=(0,$.$Si)(ee);for(;fe.has(Ie);)Ie++;return new N(this.h,fe,U,we,this.s.event,W,Ie,ee,De,se,x,V,ne)},createTestItem(ee,De,se){return new r.$jN(W,ee,De,se)},createTestRun:(ee,De,se=!0)=>this.j.createTestRun(U,W,ae,ee,De,se),invalidateTestResults:ee=>{if(ee===void 0)this.h.$markTestRetired(void 0);else{const De=ee instanceof Array?ee:[ee];this.h.$markTestRetired(De.map(se=>n.$WJ.fromExtHostTestItem(se,W).toString()))}},set resolveHandler(ee){ae.resolveHandler=ee},get resolveHandler(){return ae.resolveHandler},dispose:()=>{J.dispose()}};ye.$registerTestController(W,P,!!C),J.add((0,g.$Rc)(()=>ye.$unregisterTestController(W)));const ve={controller:he,collection:ae,profiles:fe,extension:U,activeProfiles:we};return this.g.set(W,ve),J.add((0,g.$Rc)(()=>this.g.delete(W))),J.add(ae.onDidGenerateDiff(ee=>ye.$publishDiff(W,ee.map(c.TestsDiffOp.serialize)))),he}createTestObserver(){return this.m.checkout()}async runTests(U,W=I.CancellationToken.None){const P=f(U);if(!P)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const C=this.g.get(P.controllerId);if(!C)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(J=>n.$WJ.fromExtHostTestItem(J,C.collection.root.id).toString())??[C.collection.root.id],profileGroup:O[P.kind],profileId:P.profileId,controllerId:P.controllerId}],exclude:U.exclude?.map(J=>J.id)},W)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,W,P){return await this.j.getCoverageReport(U,W)?.provideFileCoverage(P)??[]}async $resolveFileCoverage(U,W,P,C){return await this.j.getCoverageReport(U,W)?.resolveFileCoverage(P,C)??[]}$configureRunProfile(U,W){this.g.get(U)?.profiles.get(W)?.configureHandler?.()}$setActiveRunProfiles(U){const W=new Map;for(const[P,C]of Object.entries(U)){const J=this.g.get(P);if(!J)continue;const ae=new Map,fe=C.filter(ye=>!J.activeProfiles.has(ye)),we=[...J.activeProfiles].filter(ye=>!C.includes(ye));for(const ye of fe)ae.set(ye,!0),J.activeProfiles.add(ye);for(const ye of we)ae.set(ye,!1),J.activeProfiles.delete(ye);ae.size&&W.set(P,ae)}this.s.fire(W)}async $refreshTests(U,W){await this.g.get(U)?.controller.refreshHandler?.(W)}$publishTestResults(U){this.results=Object.freeze(U.map(W=>(0,b.$vn)(o.TestResults.to(W))).concat(this.results).sort((W,P)=>P.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,W){const P=this.g.get(n.$WJ.fromString(U).controllerId)?.collection;P&&(await P.expand(U,W<0?1/0:W),P.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(W=>c.TestsDiffOp.deserialize({asCanonicalUri:P=>P},W)))}async $runControllerTests(U,W){return Promise.all(U.map(P=>this.y(P,!1,W)))}async $startContinuousRun(U,W){const P=new I.$5d(W),C=await Promise.all(U.map(J=>this.y(J,!0,P.token)));return!W.isCancellationRequested&&!C.some(J=>J.error)&&await new Promise(J=>W.onCancellationRequested(J)),P.dispose(!0),C}async y(U,W,P){const C=this.g.get(U.controllerId);if(!C)return{};const{collection:J,profiles:ae,extension:fe}=C,we=ae.get(U.profileId);if(!we)return{};const ye=U.testIds.map(De=>J.tree.get(De)).filter(A.$Pf),he=U.excludeExtIds.map(De=>C.collection.tree.get(De)).filter(A.$Pf).filter(De=>ye.some(se=>se.fullId.compare(De.fullId)===2));if(!ye.length)return{};const ve=new t.$DM(ye.some(De=>De.actual instanceof r.$kN)?void 0:ye.map(De=>De.actual),he.map(De=>De.actual),we,W),ee=(0,c.$YJ)(U)&&this.j.prepareForMainThreadTestRun(ve,S.fromInternal(U,C.collection),fe,P);try{return await we.runHandler(ve,P),{}}catch(De){return{error:String(De)}}finally{ee&&(ee.hasRunningTasks&&!P.isCancellationRequested&&await M.Event.toPromise(ee.onEnd),ee.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$Lhc=i,e.$Lhc=i=Je([He(0,w.$9M),He(1,l.$mj)],i);const s=1e4;var u;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(u||(u={}));class d extends g.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,W,P,C,J){super(),this.s=U,this.w=W,this.y=P,this.z=C,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new M.$Ud),this.m=this.B(new M.$Ud),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$5d(J));const ae=this.B(new E.$eh(()=>this.C(),s));this.B(this.h.token.onCancellationRequested(()=>ae.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const W=this.s.id,P=this.s.controllerId,C=(0,k.$pg)(),J=this.y,ae=this.m;let fe;const we=ee=>(De,...se)=>{if(he){this.z.warn(`Setting the state of test "${De.id}" is a no-op after the run ends.`);return}this.s.isIncluded(De)&&(this.F(De),ee(De,...se))},ye=(ee,De)=>{const se=De instanceof Array?De.map(o.TestMessage.from):[o.TestMessage.from(De)];if(ee.uri&&ee.range){const x={range:o.Range.from(ee.range),uri:ee.uri};for(const V of se)V.location=V.location||x}this.w.$appendTestMessagesInRun(W,C,n.$WJ.fromExtHostTestItem(ee,P).toString(),se)};let he=!1;const ve={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return fe?.provider},set coverageProvider(ee){(0,h.$CF)(J,"testCoverage"),fe=ee&&new L(ee),ae.fire({taskId:C,runId:W,coverage:fe})},enqueued:we(ee=>{this.w.$updateTestStateInRun(W,C,n.$WJ.fromExtHostTestItem(ee,P).toString(),1)}),skipped:we(ee=>{this.w.$updateTestStateInRun(W,C,n.$WJ.fromExtHostTestItem(ee,P).toString(),5)}),started:we(ee=>{this.w.$updateTestStateInRun(W,C,n.$WJ.fromExtHostTestItem(ee,P).toString(),2)}),errored:we((ee,De,se)=>{ye(ee,De),this.w.$updateTestStateInRun(W,C,n.$WJ.fromExtHostTestItem(ee,P).toString(),6,se)}),failed:we((ee,De,se)=>{ye(ee,De),this.w.$updateTestStateInRun(W,C,n.$WJ.fromExtHostTestItem(ee,P).toString(),4,se)}),passed:we((ee,De)=>{this.w.$updateTestStateInRun(W,C,n.$WJ.fromExtHostTestItem(ee,this.s.controllerId).toString(),3,De)}),appendOutput:(ee,De,se)=>{he||(se&&(this.s.isIncluded(se)?this.F(se):se=void 0),this.w.$appendOutputToRun(W,C,T.$ie.fromString(ee),De&&o.location.from(De),se&&n.$WJ.fromExtHostTestItem(se,P).toString()))},end:()=>{he||(he=!0,this.w.$finishedTestRunTask(W,C),this.f.delete(C),this.f.size||this.D())}};return this.f.set(C,{run:ve}),this.w.$startedTestRunTask(W,{id:C,name:U,running:!0}),ve}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof r.$jN))throw new a.$1M(U.id);if(this.g.has(n.$WJ.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const W=[],P=this.s.colllection.root;for(;;){const C=o.TestItem.from(U);if(W.unshift(C),this.g.has(C.extId)||(this.g.add(C.extId),U===P))break;U=U.parent||P}this.w.$addTestsToRun(this.s.controllerId,this.s.id,W)}dispose(){this.D(),super.dispose()}}class m{get trackers(){return this.c.values()}constructor(U,W){this.g=U,this.h=W,this.c=new Map,this.f=[]}getCoverageReport(U,W){return this.f.find(P=>P.runId===U)?.coverage.get(W)}prepareForMainThreadTestRun(U,W,P,C){return this.j(U,W,P,C)}cancelRunById(U){for(const W of this.c.values())if(W.id===U){W.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,W,P,C,J,ae){const fe=this.c.get(C);if(fe)return fe.createRun(J);const we=S.fromPublic(W,P,C,ae),ye=f(C);this.g.$startedExtensionTestRun({controllerId:W,continuous:!!C.continuous,profile:ye&&{group:O[ye.kind],id:ye.profileId},exclude:C.exclude?.map(ve=>n.$WJ.fromExtHostTestItem(ve,P.root.id).toString())??[],id:we.id,include:C.include?.map(ve=>n.$WJ.fromExtHostTestItem(ve,P.root.id).toString())??[P.root.id],persist:ae});const he=this.j(C,we,U);return M.Event.once(he.onEnd)(()=>{this.g.$finishedExtensionTestRun(we.id),he.dispose()}),he.createRun(J)}j(U,W,P,C){const J=new d(W,this.g,P,this.h,C);this.c.set(U,J);let ae;const fe=J.onDidCoverage(({runId:we,taskId:ye,coverage:he})=>{ae||(ae={runId:we,coverage:new Map},this.f.unshift(ae),this.f.length>c.$4J&&this.f.pop()),ae.coverage.set(ye,he),this.g.$signalCoverageAvailable(we,ye,!!he)});return M.Event.once(J.onEnd)(()=>{this.c.delete(U),fe.dispose()}),J}}e.$Mhc=m;const f=H=>{if(H.profile){if(!(H.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class S{static fromPublic(U,W,P,C){return new S(U,(0,k.$pg)(),P.include?.map(J=>n.$WJ.fromExtHostTestItem(J,U).toString())??[U],P.exclude?.map(J=>n.$WJ.fromExtHostTestItem(J,U).toString())??[],C,W)}static fromInternal(U,W){return new S(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,W)}constructor(U,W,P,C,J,ae){this.controllerId=U,this.id=W,this.isPersisted=J,this.colllection=ae,this.c=P.map(fe=>fe+"\0"),this.f=C.map(fe=>fe+"\0")}isIncluded(U){const W=n.$WJ.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const P of this.f)if(W===P||W.startsWith(P))return!1;for(const P of this.c)if(W===P||W.startsWith(P))return!0;return!1}}e.$Nhc=S;class L{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(o.TestCoverage.fromFile)??[]}catch(W){throw this.c=void 0,W}}async resolveFileCoverage(U,W){const P=await this.c;let C=P?.[U];return!this.provider||!P||!C?[]:(C.detailedCoverage||(C=P[U]=await this.provider.resolveFileCoverage?.(C,W)??C),C.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,o.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const W=n.$WJ.parentId(U.item.extId);if(W&&this.h.has(W.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:W,g:P}=this;return{get added(){return[...U].map(C=>C.revived)},get updated(){return[...W].map(C=>C.revived)},get removed(){return[...P].map(C=>C.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends c.$5J{constructor(){super(...arguments),this.s=new M.$Ud,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,W){return{...U,revived:o.TestItem.toPlain(U.item),depth:W?W.depth+1:0,children:new Set}}v(){return new v(this.s)}}class D{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(W=>W.revived)},dispose:(0,R.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new y({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}class N{#e;#t;#i;#o;#r;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(U){U!==this.h&&(this.h=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.g}set isDefault(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?o.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}get isSelected(){return(0,h.$CF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,h.$CF)(this.#t,"testingActiveProfile"),M.Event.chain(this.#o,U=>U.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(A.$Pf))}constructor(U,W,P,C,J,ae,fe,we,ye,he,ve=!1,ee=void 0,De=!1){this.controllerId=ae,this.profileId=fe,this.f=we,this.kind=ye,this.runHandler=he,this.g=ve,this._tag=ee,this.h=De,this.#e=U,this.#r=W,this.#t=P,this.#i=C,this.#o=J,W.set(fe,this);const se=O[ye];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${ye}`);this.#e.$publishTestRunProfile({profileId:fe,controllerId:ae,tag:ee?o.TestTag.namespace(this.controllerId,ee.id):null,label:we,group:se,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:De})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Ohc=N;const O={[t.TestRunProfileKind.Coverage]:8,[t.TestRunProfileKind.Debug]:4,[t.TestRunProfileKind.Run]:2}}),define(Pe[267],Re([1,0,18,5,3,109,8,7]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;class g{constructor(A,k){this.i=k,this.a=new T.$Ud,this.b=new T.$Ud,this.c=new T.$Ud,this.d=new T.$Ud,this.f=new T.$Ud,this.g=new T.$Ud,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(I.$5K.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const k=this.i.allEditors();return A?k:k.map(l=>l.value)}async showTextDocument(A,k,l){let p;typeof k=="number"?p={position:R.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?p={position:R.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?R.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:p={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(A.uri,p),r=w&&this.i.getEditor(w);if(r)return r.value;throw w?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,k){return new M.$dN(this.h,A,k).value}$acceptEditorPropertiesChanged(A,k){const l=this.i.getEditor(A);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const p=k.selections.selections.map(R.Selection.to);l._acceptSelections(p)}if(k.visibleRanges){const p=E.$Hb(k.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(p)}if(k.options&&this.b.fire({textEditor:l.value,options:{...k.options,lineNumbers:R.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const p=$.TextEditorSelectionChangeKind.fromValue(k.selections.source),w=k.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:w,kind:p})}if(k.visibleRanges){const p=E.$Hb(k.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:p})}}$acceptEditorPositionData(A){for(const k in A){const l=this.i.getEditor(k);if(!l)throw new Error("Unknown text editor");const p=R.ViewColumn.to(A[k]);l.value.viewColumn!==p&&(l._acceptViewColumn(p),this.d.fire({textEditor:l.value,viewColumn:p}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$$fc=g}),define(Pe[268],Re([1,0,2,4,3,6,7,8,22,16]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=e.$Qhc=void 0,e.$Qhc=(0,T.$5h)("IExtHostTimeline");class A{constructor(p,w){this.b=new Map,this.c=new Map,this.a=p.getProxy(I.$5K.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&g.$km.equals(o,this.b.get(r.source)?.extension)){const t=r.uri===void 0?void 0:E.URI.revive(r.uri);return this.c.get(r.source)?.get(k(t))?.get(r.handle)}else return;return r}})}async $getTimeline(p,w,r,o){return this.b.get(p)?.provider.provideTimeline(E.URI.revive(w),r,o)}registerTimelineProvider(p,w,r,o){const t=new M.$Sc,n=this.d(w.id,o,t).bind(this);let a;w.onDidChange&&(a=w.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:w.id}),this));const c=this.c;return this.f({...w,scheme:p,onDidChange:void 0,async provideTimeline(h,i,s){i?.resetCache&&(t.clear(),c.get(w.id)?.clear());const u=await w.provideTimeline(h,i,s);if(u==null)return;const d=n(h,i);return{...u,source:w.id,items:u.items.map(d)}},dispose(){for(const h of c.values())h.get(w.id)?.clear();a?.dispose(),t.dispose()}},r)}d(p,w,r){return(o,t)=>{let n;if(t?.cacheResults){let a=this.c.get(p);a===void 0&&(a=new Map,this.c.set(p,a));const c=k(o);n=a.get(c),n===void 0&&(n=new Map,a.set(c,n))}return a=>{const{iconPath:c,...h}=a,i=`${p}|${a.id??a.timestamp}`;n?.set(i,a);let s,u,d;a.iconPath&&(c instanceof R.$2L?d={id:c.id,color:c.color}:E.URI.isUri(c)?(s=c,u=c):{light:s,dark:u}=c);let m;return R.$vL.isMarkdownString(h.tooltip)?m=$.MarkdownString.from(h.tooltip):(0,b.$Hf)(h.tooltip)?m=h.tooltip:R.$vL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=$.MarkdownString.from(h.detail)):(0,b.$Hf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=h.detail),{...h,id:h.id??void 0,handle:i,source:p,command:a.command?w.toInternal(a.command,r):void 0,icon:s,iconDark:u,themeIcon:d,tooltip:m,accessibilityInformation:a.accessibilityInformation}}}}f(p,w){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:w}),(0,M.$Rc)(()=>{for(const o of this.c.values())o.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$Rhc=A;function k(l){return l?.toString()}}),define(Pe[87],Re([1,0,20,5,6,167,4,14,196,3,27,17,7]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iyb=e.$hyb=e.TunnelDtoConverter=void 0;class p extends g.$Iv{}var w;(function(o){function t(a){return{remoteAddress:a.remoteAddress,localAddress:a.localAddress,public:!!a.public,privacy:a.privacy??(a.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:a.protocol}}o.fromApiTunnel=t;function n(a){return{remoteAddress:{host:a.tunnelRemoteHost,port:a.tunnelRemotePort},localAddress:a.localAddress,public:a.privacy!==g.TunnelPrivacyId.ConstantPrivate&&a.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:a.privacy,protocol:a.protocol}}o.fromServiceTunnel=n})(w||(e.TunnelDtoConverter=w={})),e.$hyb=(0,R.$5h)("IExtHostTunnelService");let r=class extends I.$Tc{constructor(t,n,a){super(),this.s=a,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Ud,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(b.$5K.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const a=await this.a.$openTunnel(n,t.displayName);if(a){const c=new p(a.remoteAddress,a.localAddress,()=>this.a.$closeTunnel(a.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const a=this.u();return this.r.set(a,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,a),new l.$7K(()=>{this.r.delete(a),this.a.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(t,n,a,c,h){const i=[];for(const u of t){const d=this.r.get(u);if(!d)return[];i.push(...await Promise.all(n.map(async m=>{let f;try{f=await d.provider.providePortAttributes({port:m,pid:a,commandLine:c},h)}catch{f=await d.provider.providePortAttributes(m,a,c,h)}return{providedAttributes:f,port:m}})))}const s=i.filter(u=>!!u.providedAttributes);return s.length>0?s.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await t.provideTunnel(c,h,new E.$5d().token)??void 0;const a=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(a),Promise.resolve((0,I.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const a=t.tunnelFactory??(n?this.w(n):void 0);if(a){this.b=a;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,I.$Rc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const a=this.g.get(t.host);a.has(t.port)&&(n&&a.get(t.port).disposeListener.dispose(),await a.get(t.port).tunnel.dispose(),a.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const c=await a;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:h}),w.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(a){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),a instanceof Error)return a.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),a=t.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${a.map(c=>c.port).join(", ")}`),a}};e.$iyb=r,e.$iyb=r=Je([He(0,k.$9M),He(1,A.$mN),He(2,$.$mj)],r)}),define(Pe[269],Re([1,0,6,12,2,3]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(M.$5K.MainThreadUriOpeners)}registerExternalUriOpener(g,b,A,k){if(this.c.has(b))throw new Error(`Opener with id '${b}' already registered`);const l=k.schemes.find(p=>!R.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(b,A),this.b.$registerUriOpener(b,k.schemes,g,k.label),(0,E.$Rc)(()=>{this.c.delete(b),this.b.$unregisterUriOpener(b)})}async $canOpenUri(g,b,A){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener with id: ${g}`);const l=I.URI.revive(b);return k.canOpenExternalUri(l,A)}async $openUri(g,b,A){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener id: '${g}'`);return k.openExternalUri(I.URI.revive(b.resolvedUri),{sourceUri:I.URI.revive(b.sourceUri)},A)}}e.$Thc=R}),define(Pe[270],Re([1,0,3,2,6,15,22]),function(ge,e,E,T,I,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class ${static{this.a=0}constructor(b){this.c=new R.$lm,this.d=new Map,this.b=b.getProxy(E.$5K.MainThreadUrls)}registerUriHandler(b,A){const k=b.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=$.a++;return this.c.add(k),this.d.set(l,A),this.b.$registerUriHandler(l,k,b.displayName||b.name),(0,I.$Rc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(b,A){const k=this.d.get(b);if(!k)return Promise.resolve(void 0);try{k.handleUri(T.URI.revive(A))}catch(l){(0,M.$1)(l)}return Promise.resolve(void 0)}async createAppUri(b){return T.URI.revive(await this.b.$createAppUri(b))}}e.$Uhc=$}),define(Pe[65],Re([1,0,5,6,12,26,2,181,203,78,3]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=e.$pgc=e.$ogc=e.$ngc=e.$mgc=void 0;class k{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(c,h,i,s,u,d,m){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Ud,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Ud,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=s,this.#r=u,this.#n=d,this.#l=l(d),this.#d=p(d),this.#i=m}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,b.$qvb)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===I.Schemas.https||c.scheme===I.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+b.$pvb}return b.$pvb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),M.$yn(this.#s,c)||this.#t.$setOptions(this.#e,o(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$9kb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#n.extensionLocation?.scheme===I.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,m,f,S)=>{const L=R.URI.from({scheme:m||"file",path:decodeURIComponent(f)}),v=(0,b.$qvb)(L,{isRemote:h,authority:i}).toString();return`${u}${v}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,m,f,S)=>{const L=R.URI.from({scheme:m||"file",path:decodeURIComponent(f)}),v=(0,b.$qvb)(L,{isRemote:h,authority:i}).toString();return`${u}${v}${S}`})}}e.$mgc=k;function l(a){try{const c=(0,$.$bp)((0,$.$ap)(a.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$ngc=l;function p(a){try{const c=(0,$.$bp)((0,$.$ap)(a.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class w extends T.$Tc{constructor(c,h,i,s,u){super(),this.c=h,this.f=i,this.g=s,this.h=u,this.b=new Map,this.a=c.getProxy(A.$5K.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const s=this.j(c);if(s){const{message:u}=(0,g.$0kb)(h,i.value);s._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const s=new k(c,this.a,t(h),this.c,this.f,i,this.h);this.b.set(c,s);const u=s._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return s}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$ogc=w;function r(a){return{id:a.identifier,location:a.extensionLocation}}e.$pgc=r;function o(a,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(a,c)}}e.$qgc=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(c=>R.URI.from(c))}}function n(a,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),a.extensionLocation]}}),define(Pe[271],Re([1,0,20,98,6,12,25,2,8,65,75,3,7]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class p{constructor(s,u){this.document=s,this.b=u,this.a=1,this.c=new A.$Rfc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,u){await this.f(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.f(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=h(this.document.uri)+this.a++;return(0,R.$Gg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const u=this.c.get(s,0);if(!u)throw new Error("No edit found");return u}}class w{constructor(){this.a=new Map}get(s,u){return this.a.get(this.b(s,u))}add(s,u,d){const m=this.b(s,u.uri);if(this.a.has(m))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const f=new p(u,d);return this.a.set(m,f),f}delete(s,u){const d=this.b(s,u.uri);this.a.delete(d)}b(s,u){return`${s}@@@${u}`}}var r;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(s,u,d){return this.b(0,s,u,d)}addCustomProvider(s,u,d){return this.b(1,s,u,d)}get(s){return this.a.get(s)}b(s,u,d,m){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:s,extension:d,provider:m}),new l.$7K(()=>this.a.delete(u))}}class t{constructor(s,u,d,m,f){this.d=u,this.f=d,this.g=m,this.h=f,this.b=new o,this.c=new w,this.a=s.getProxy(k.$5K.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,d,m){const f=new I.$Sc;return a(d)?(f.add(this.b.addTextProvider(u,s,d)),this.a.$registerTextEditorProvider((0,b.$pgc)(s),u,m.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,b.$ngc)(s))):(f.add(this.b.addCustomProvider(u,s,d)),n(d)&&f.add(d.onDidChangeCustomDocument(S=>{const L=this.i(u,S.document.uri);if(c(S)){const v=L.addEdit(S);this.a.$onDidEdit(S.document.uri,u,v,S.label)}else this.a.$onContentChange(S.document.uri,u)})),this.a.$registerCustomEditorProvider((0,b.$pgc)(s),u,m.webviewOptions||{},!!m.supportsMultipleEditorsPerDocument,(0,b.$ngc)(s))),l.$7K.from(f,new l.$7K(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,d,m,f){const S=this.b.get(u);if(!S)throw new Error(`No provider found for '${u}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${u}'`);const L=$.URI.revive(s),v=await S.provider.openCustomDocument(L,{backupId:d,untitledDocumentData:m?.buffer},f);let y;return n(S.provider)&&this.f&&(y=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(u,v,y),{editable:n(S.provider)}}async $disposeCustomDocument(s,u){const d=this.b.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${u}'`);const m=$.URI.revive(s),{document:f}=this.i(u,m);this.c.delete(u,f),f.dispose()}async $resolveCustomEditor(s,u,d,m,f,S){const L=this.b.get(d);if(!L)throw new Error(`No provider found for '${d}'`);const v=g.ViewColumn.to(f),y=this.g.createNewWebview(u,m.contentOptions,L.extension),D=this.h.createNewWebviewPanel(u,d,m.title,v,m.options,y,m.active),N=$.URI.revive(s);switch(L.type){case 1:{const{document:O}=this.i(d,N);return L.provider.resolveCustomEditor(O,D,S)}case 0:{const O=this.d.getDocument(N);return L.provider.resolveCustomTextEditor(O,D,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,d){this.i(u,s).disposeEdits(d)}async $onMoveCustomEditor(s,u,d){const m=this.b.get(d);if(!m)throw new Error(`No provider found for '${d}'`);if(!m.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this.h.getWebviewPanel(s);if(!f)throw new Error("No webview found");const S=$.URI.revive(u),L=this.d.getDocument(S);await m.provider.moveCustomTextEditor(L,f,E.CancellationToken.None)}async $undo(s,u,d,m){return this.i(u,s).undo(d,m)}async $redo(s,u,d,m){return this.i(u,s).redo(d,m)}async $revert(s,u,d){const m=this.i(u,s);await this.j(u).revertCustomDocument(m.document,d),m.disposeBackup()}async $onSave(s,u,d){const m=this.i(u,s);await this.j(u).saveCustomDocument(m.document,d),m.disposeBackup()}async $onSaveAs(s,u,d,m){const f=this.i(u,s);return this.j(u).saveCustomDocumentAs(f.document,$.URI.revive(d),m)}async $backup(s,u,d){const m=this.i(u,s),S=await this.j(u).backupCustomDocument(m.document,{destination:m.getNewBackupUri()},d);return m.updateBackup(S),S.id}i(s,u){const d=this.c.get(s,$.URI.revive(u));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!n(d))throw new Error("Custom document is not editable");return d}}e.$sgc=t;function n(i){return!!i.onDidChangeCustomDocument}function a(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const s=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Si)(s)+""}}),define(Pe[272],Re([1,0,5,6,2,33,8,65,3,7]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class A extends T.$Tc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(w,r,o,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Ud),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Ud),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=r,this.#o=o,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(w){this.c(),this.#n!==w&&(this.#n=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,I.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(w){this.#l||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#u=w.active,this.#c=w.visible,this.#s=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:R.ViewColumn.from(w),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends T.$Tc{static c(){return(0,M.$pg)()}constructor(w,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=w.getProxy(g.$5K.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,r,o,t,n={}){const a=typeof t=="object"?t.viewColumn:t,c={viewColumn:R.ViewColumn.from(a),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,$.$ngc)(w),i=k.c();this.f.$createWebviewPanel((0,$.$pgc)(w),i,r,{title:o,panelOptions:l(n),webviewOptions:(0,$.$qgc)(w,this.m,n),serializeBuffersForPostMessage:h},c);const s=this.j.createNewWebview(i,n,w);return this.createNewWebviewPanel(i,r,o,a,n,s,!0)}$onDidChangeWebviewPanelViewStates(w){const r=Object.keys(w);r.sort((o,t)=>{const n=w[o],a=w[t];return n.active?1:a.active?-1:+n.visible-+a.visible});for(const o of r){const t=this.getWebviewPanel(o);if(!t)continue;const n=w[o];t._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:w}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,$.$ngc)(w)}),new b.$7K(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(w,r,o,t){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:a,extension:c}=n,h=this.j.createNewWebview(w,o.webviewOptions,c),i=this.createNewWebviewPanel(w,r,o.title,t,o.panelOptions,h,o.active);await a.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(w,r,o,t,n,a,c){const h=new A(w,this.f,a,{viewType:r,title:o,viewColumn:t,panelOptions:n,active:c});return this.g.set(w,h),h}getWebviewPanel(w){return this.g.get(w)}}e.$rgc=k;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Pe[273],Re([1,0,5,6,65,8,3,7]),function(ge,e,E,T,I,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class g extends T.$Tc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(k,l,p,w,r,o){super(),this.#r=!1,this.#u=this.B(new E.$Ud),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Ud),this.onDidDispose=this.#l.event,this.#i=p,this.#a=w,this.#e=k,this.#t=l,this.#o=r,this.#n=o}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#s}set description(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#r||(this.#n=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#r)throw new Error("Webview is disposed")}}class b{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$5K.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,p,w){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:p,extension:k}),this.a.$registerWebviewViewProvider((0,I.$pgc)(k),l,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$ngc)(k)}),new $.$7K(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,p,w,r){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:n}=o,a=this.d.createNewWebview(k,{},n),c=new g(k,this.a,l,p,a,!0);this.c.set(k,c),await t.resolveWebviewView(c,{state:w},r)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$Vhc=b}),define(Pe[111],Re([1,0,5,3,2,12,11,4,17,23]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=e.$Whc=void 0;let k=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(p){const w=this.d;return{get focused(){return w.focused},get active(){return(0,b.$CF)(p,"windowActivity"),w.active}}}constructor(p){this.c=new E.$Ud,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=p.getProxy(T.$5K.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:r})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,w){w!==this.d[p]&&(this.d={...this.d,[p]:w},this.c.fire(this.d))}openUri(p,w){let r;if(typeof p=="string"){r=p;try{p=I.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,R.$Ie)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,r,w)}async asExternalUri(p,w){if((0,R.$Ie)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(p,w);return I.URI.from(r)}};e.$Whc=k,e.$Whc=k=A=Je([He(0,g.$9M)],k),e.$Xhc=(0,$.$5h)("IExtHostWindow")}),define(Pe[274],Re([1,0,240,27,17]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;let M=class extends E.$1hc{constructor($,g){super($,g)}f($,g,b){g.apply(console,b)}};e.$0jc=M,e.$0jc=M=Je([He(0,I.$9M),He(1,T.$mN)],M)}),define(Pe[275],Re([1,0,13,24,20,15,5,6,139,229,49]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=e.ResponsiveState=e.RequestInitiator=e.$$7b=e.$07b=void 0;function l(D,N){try{return JSON.stringify(D,N)}catch{return"null"}}const p="$$ref$$",w={[p]:-1};class r{constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function o(D,N=null,O=!1){const H=[];return{jsonString:(O?l:JSON.stringify)(D,(W,P)=>{if(typeof P>"u")return w;if(typeof P=="object"){if(P instanceof T.$ie){const C=H.push(P)-1;return{[p]:C}}if(N)return N(W,P)}return P}),referencedBuffers:H}}e.$07b=o;function t(D,N,O){return JSON.parse(D,(H,U)=>{if(U){const W=U[p];if(typeof W=="number")return N[W];if(O&&U.$mid===1)return O.transformIncoming(U)}return U})}e.$$7b=t;function n(D,N){return JSON.stringify(D,N)}function a(D){return D?(N,O)=>O&&O.$mid===1?D.transformOutgoing(O):O:null}var c;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},s=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends $.$Tc{static{k=s}static{this.a=3*1e3}constructor(N,O=null,H=null){super(),this[k]=!0,this.b=this.B(new R.$Ud),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=O,this.g=H,this.h=a(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,W=A.$Pv.count;U<W;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$eh(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const O=this.w[N];delete this.w[N],O.resolveErr(M.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,g.$6m)(N,this.g):N}getProxy(N){const{nid:O,sid:H}=N;return this.s[O]||(this.s[O]=this.J(O,H)),this.s[O]}J(N,O){const H={get:(U,W)=>(typeof W=="string"&&!U[W]&&W.charCodeAt(0)===36&&(U[W]=(...P)=>this.U(N,W,P)),W===u?O:U[W])};return new Proxy(Object.create(null),H)}set(N,O){return this.m[N.nid]=O,O}assertRegistered(N){for(let O=0,H=N.length;O<H;O++){const U=N[O];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(N){if(this.j)return;const O=N.byteLength,H=f.read(N,0),U=H.readUInt8(),W=H.readUInt32();switch(U){case 1:case 2:{let{rpcId:P,method:C,args:J}=L.deserializeRequestJSONArgs(H);this.g&&(J=(0,g.$6m)(J,this.g)),this.M(O,W,P,C,J,U===2);break}case 3:case 4:{let{rpcId:P,method:C,args:J}=L.deserializeRequestMixedArgs(H);this.g&&(J=(0,g.$6m)(J,this.g)),this.M(O,W,P,C,J,U===4);break}case 5:{this.f?.logIncoming(O,W,0,"ack"),this.G(W);break}case 6:{this.N(O,W);break}case 7:{this.O(O,W,void 0);break}case 9:{let P=L.deserializeReplyOKJSON(H);this.g&&(P=(0,g.$6m)(P,this.g)),this.O(O,W,P);break}case 10:{const P=L.deserializeReplyOKJSONWithBuffers(H,this.g);this.O(O,W,P);break}case 8:{const P=L.deserializeReplyOKVSBuffer(H);this.O(O,W,P);break}case 11:{let P=L.deserializeReplyErrError(H);this.g&&(P=(0,g.$6m)(P,this.g)),this.P(O,W,P);break}case 12:{this.P(O,W,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,O,H,U,W,P){this.f?.logIncoming(N,O,1,`receiveRequest ${(0,A.$Rv)(H)}.${U}(`,W);const C=String(O);let J,ae;if(P){const we=new I.$5d;W.push(we.token),J=this.Q(H,U,W),ae=()=>we.cancel()}else J=this.Q(H,U,W),ae=i;this.u[C]=ae;const fe=L.serializeAcknowledged(O);this.f?.logOutgoing(fe.byteLength,O,1,"ack"),this.c.send(fe),J.then(we=>{delete this.u[C];const ye=L.serializeReplyOK(O,we,this.h);this.f?.logOutgoing(ye.byteLength,O,1,"reply:",we),this.c.send(ye)},we=>{delete this.u[C];const ye=L.serializeReplyErr(O,we);this.f?.logOutgoing(ye.byteLength,O,1,"replyErr:",we),this.c.send(ye)})}N(N,O){this.f?.logIncoming(N,O,1,"receiveCancel");const H=String(O);this.u[H]?.()}O(N,O,H){this.f?.logIncoming(N,O,0,"receiveReply:",H);const U=String(O);if(!this.w.hasOwnProperty(U))return;const W=this.w[U];delete this.w[U],W.resolveOk(H)}P(N,O,H){this.f?.logIncoming(N,O,0,"receiveReplyErr:",H);const U=String(O);if(!this.w.hasOwnProperty(U))return;const W=this.w[U];delete this.w[U];let P;H&&(H.$isError?(P=new Error,P.name=H.name,P.message=H.message,P.stack=H.stack):P=H),W.resolveErr(P)}Q(N,O,H){try{return Promise.resolve(this.S(N,O,H))}catch(U){return Promise.reject(U)}}S(N,O,H){const U=this.m[N];if(!U)throw new Error("Unknown actor "+(0,A.$Rv)(N));const W=U[O];if(typeof W!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$Rv)(N));return W.apply(U,H)}U(N,O,H){if(this.j)return new b.$97b;let U=null;if(H.length>0&&I.CancellationToken.isCancellationToken(H[H.length-1])&&(U=H.pop()),U&&U.isCancellationRequested)return Promise.reject(M.$6());const W=L.serializeRequestArguments(H,this.h),P=++this.t,C=String(P),J=new b.$87b,ae=new $.$Sc;U&&ae.add(U.onCancellationRequested(()=>{const we=L.serializeCancel(P);this.f?.logOutgoing(we.byteLength,P,0,"cancel"),this.c.send(L.serializeCancel(P))})),this.w[C]=new m(J,ae),this.F(P);const fe=L.serializeRequest(P,N,O,W,!!U);return this.f?.logOutgoing(fe.byteLength,P,0,`request: ${(0,A.$Rv)(N)}.${O}(`,H),this.c.send(fe),J}}e.$_7b=d;class m{constructor(N,O){this.a=N,this.b=O}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class f{static alloc(N,O,H){const U=new f(T.$ie.alloc(H+1+4),0);return U.writeUInt8(N),U.writeUInt32(O),U}static read(N,O){return new f(N,O)}get buffer(){return this.a}constructor(N,O){this.a=N,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const H=this.a.slice(this.b,this.b+N).toString();return this.b+=N,H}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const H=this.a.slice(this.b,this.b+N).toString();return this.b+=N,H}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+N);return this.b+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let H=0,U=N.length;H<U;H++){const W=N[H];switch(O+=1,W.type){case 1:O+=this.sizeLongString(W.value);break;case 2:O+=this.sizeVSBuffer(W.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(W.value);for(let P=0;P<W.buffers.length;++P)O+=this.sizeVSBuffer(W.buffers[P]);break;case 4:break}}return O}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let O=0,H=N.length;O<H;O++){const U=N[O];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let W=0;W<U.buffers.length;++W)this.writeBuffer(U.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const O=new Array(N);for(let H=0;H<N;H++)switch(this.readUInt8()){case 1:O[H]=this.readLongString();break;case 2:O[H]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),P=this.readLongString(),C=[];for(let J=0;J<W;++J)C.push(this.readVSBuffer());O[H]=new A.$Sv(t(P,C,null));break}case 4:O[H]=void 0;break}return O}}var S;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(S||(S={}));class L{static a(N){for(let O=0,H=N.length;O<H;O++)if(N[O]instanceof T.$ie||N[O]instanceof A.$Sv||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this.a(N)){const H=[];for(let U=0,W=N.length;U<W;U++){const P=N[U];if(P instanceof T.$ie)H[U]={type:2,value:P};else if(typeof P>"u")H[U]={type:4};else if(P instanceof A.$Sv){const{jsonString:C,referencedBuffers:J}=o(P.value,O);H[U]={type:3,value:T.$ie.fromString(C),buffers:J}}else H[U]={type:1,value:T.$ie.fromString(n(P,O))}}return{type:1,args:H}}return{type:0,args:n(N,O)}}static serializeRequest(N,O,H,U,W){switch(U.type){case 0:return this.b(N,O,H,U.args,W);case 1:return this.c(N,O,H,U.args,W)}}static b(N,O,H,U,W){const P=T.$ie.fromString(H),C=T.$ie.fromString(U);let J=0;J+=f.sizeUInt8(),J+=f.sizeShortString(P),J+=f.sizeLongString(C);const ae=f.alloc(W?2:1,N,J);return ae.writeUInt8(O),ae.writeShortString(P),ae.writeLongString(C),ae.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),H=N.readShortString(),U=N.readLongString();return{rpcId:O,method:H,args:JSON.parse(U)}}static c(N,O,H,U,W){const P=T.$ie.fromString(H);let C=0;C+=f.sizeUInt8(),C+=f.sizeShortString(P),C+=f.sizeMixedArray(U);const J=f.alloc(W?4:3,N,C);return J.writeUInt8(O),J.writeShortString(P),J.writeMixedArray(U),J.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),H=N.readShortString(),U=N.readMixedArray(),W=new Array(U.length);for(let P=0,C=U.length;P<C;P++){const J=U[P];typeof J=="string"?W[P]=JSON.parse(J):W[P]=J}return{rpcId:O,method:H,args:W}}static serializeAcknowledged(N){return f.alloc(5,N,0).buffer}static serializeCancel(N){return f.alloc(6,N,0).buffer}static serializeReplyOK(N,O,H){if(typeof O>"u")return this.d(N);if(O instanceof T.$ie)return this.e(N,O);if(O instanceof A.$Sv){const{jsonString:U,referencedBuffers:W}=o(O.value,H,!0);return this.g(N,U,W)}else return this.f(N,l(O,H))}static d(N){return f.alloc(7,N,0).buffer}static e(N,O){let H=0;H+=f.sizeVSBuffer(O);const U=f.alloc(8,N,H);return U.writeVSBuffer(O),U.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,O){const H=T.$ie.fromString(O);let U=0;U+=f.sizeLongString(H);const W=f.alloc(9,N,U);return W.writeLongString(H),W.buffer}static g(N,O,H){const U=T.$ie.fromString(O);let W=0;W+=f.sizeUInt32,W+=f.sizeLongString(U);for(const C of H)W+=f.sizeVSBuffer(C);const P=f.alloc(10,N,W);P.writeUInt32(H.length),P.writeLongString(U);for(const C of H)P.writeBuffer(C);return P.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const H=N.readUInt32(),U=N.readLongString(),W=[];for(let P=0;P<H;++P)W.push(N.readVSBuffer());return new A.$Sv(t(U,W,O))}static serializeReplyErr(N,O){const H=O?l(M.$3(O),null):void 0;if(typeof H!="string")return this.h(N);const U=T.$ie.fromString(H);let W=0;W+=f.sizeLongString(U);const P=f.alloc(11,N,W);return P.writeLongString(U),P.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static h(N){return f.alloc(12,N,0).buffer}}var v;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var y;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(y||(y={}))}),define(Pe[276],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;const E=function(M){const R=$=>{globalThis.removeEventListener("message",R);const g=$.data;Object.defineProperties(globalThis,{postMessage:{value(b,A){g.postMessage(b,A)}},onmessage:{get(){return g.onmessage},set(b){g.onmessage=b}}}),g.addEventListener("message",b=>{globalThis.dispatchEvent(new MessageEvent("message",{data:b.data,ports:b.ports?[...b.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class T extends EventTarget{constructor(M,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${E})('${R}'))`,b=new Blob([g],{type:"application/javascript"}),A=URL.createObjectURL(b),k=new MessageChannel,l=A,p={type:"_newWorker",id:l,port:k.port2,url:A,options:$};M(p,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{M({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(w){k.port1.onmessage=w}},onmessageerror:{get(){return k.port1.onmessageerror},set(w){k.port1.onmessageerror=w}}}),k.port1.addEventListener("messageerror",w=>{const r=new MessageEvent("messageerror",{data:w.data});this.dispatchEvent(r)}),k.port1.addEventListener("message",w=>{const r=new MessageEvent("message",{data:w.data});this.dispatchEvent(r)}),k.port1.start()}}e.$_jc=T}),define(Pe[277],Re([1,0,5,30,35,4]),function(ge,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oK=e.$nK=e.OutputChannelUpdateMode=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=void 0,e.$dK="text/x-code-output",e.$eK="output",e.$fK="Log",e.$gK="text/x-code-log-output",e.$hK="log",e.$iK="workbench.panel.output",e.$jK=new I.$jj("inOutput",!1),e.$kK=new I.$jj("activeLogOutput",!1),e.$lK=new I.$jj("outputView.scrollLock",!1),e.$mK=(0,M.$5h)("outputService");var R;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$nK={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Ud,this.onDidRegisterChannel=this.b.event,this.c=new E.$Ud,this.onDidRemoveChannel=this.c.event}registerChannel(b){this.a.has(b.id)||(this.a.set(b.id,b),this.b.fire(b.id))}getChannels(){const b=[];return this.a.forEach(A=>b.push(A)),b}getChannel(b){return this.a.get(b)}removeChannel(b){this.a.delete(b),this.c.fire(b)}}T.$Gn.add(e.$nK.OutputChannels,new $),e.$oK=new I.$jj("activeOutputChannel","")}),define(Pe[112],Re([1,0,3,4,17,22,14,277,63,27,43,136,24,16,42,5,6]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0;class t extends R.$sj{get disposed(){return this.n}constructor(h,i,s,u,d){super(),this.id=h,this.name=i,this.r=s,this.s=u,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(m=>this.setLevel(m)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$ie.fromString(i).byteLength,(0,R.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(h){this.append(h)}}let a=class{constructor(h,i,s,u,d,m){this.i=i,this.j=s,this.k=u,this.l=d,this.m=m,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(E.$5K.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,k.$vm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(h,i,s){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,d=(0,p.$Hf)(i)?i:void 0;if((0,p.$Hf)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let m;const f=this.i.environment.extensionLogLevel?.find(([L])=>M.$km.equals(s.identifier,L))?.[1];f&&(m=(0,R.$Cj)(f));const S=u?this.o(h,m,s):this.n(h,d,s);return S.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),u?this.r(h,m??this.m.getLevel(),S):this.q(h,S)}async n(h,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,d=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,d,i,s.identifier.value);return new t(f,h,m,this.a,s)}async o(h,i,s){const u=await this.p(s),d=h.replace(/[\\/:\*\?"<>\|]/g,""),m=this.k.extUri.joinPath(u,`${d}.log`),f=`${s.identifier.value}.${d}`,S=this.l.createLogger(m,{id:f,name:h,logLevel:i,extensionId:s.identifier.value});return new n(f,h,S,this.a,s)}p(h){let i=this.d.get(h.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(u){if((0,w.$Fk)(u)!==w.FileSystemProviderErrorCode.FileExists)throw u}return s})())}return i}q(h,i){let s=!1;const u=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return h},append(d){u(),i.then(m=>m.append(d))},appendLine(d){u(),i.then(m=>m.appendLine(d))},clear(){u(),i.then(d=>d.clear())},replace(d){u(),i.then(m=>m.replace(d))},show(d,m){u(),i.then(f=>f.show(d,m))},hide(){u(),i.then(d=>d.hide())},dispose(){s=!0,i.then(d=>d.dispose())}}}r(h,i,s){const u=new o.$Sc,d=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},m=u.add(new r.$Ud);function f(S){i=S,m.fire(S)}return s.then(S=>{u.add(S),S.logLevel!==i&&f(S.logLevel),u.add(S.onDidChangeLogLevel(L=>f(L)))}),{...this.q(h,s),get logLevel(){return i},onDidChangeLogLevel:m.event,trace(S,...L){d(),s.then(v=>v.trace(S,...L))},debug(S,...L){d(),s.then(v=>v.debug(S,...L))},info(S,...L){d(),s.then(v=>v.info(S,...L))},warn(S,...L){d(),s.then(v=>v.warn(S,...L))},error(S,...L){d(),s.then(v=>v.error(S,...L))},dispose(){u.dispose()}}}};e.$whc=a,e.$whc=a=Je([He(0,I.$9M),He(1,b.$mN),He(2,g.$jgc),He(3,A.$Vfc),He(4,R.$nj),He(5,R.$mj)],a),e.$xhc=(0,T.$5h)("IExtHostOutputService")}),define(Pe[113],Re([1,0,4,13]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=void 0,e.$Km=(0,E.$5h)("remoteAgentService"),e.$Lm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const g=await I.getRoundTripTime();if(g===void 0)return;M=Math.min(M,g/2),await(0,T.$6g)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce(($,g)=>$+g,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce(($,g)=>$+g,0)/this.average.length,high:(()=>typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[278],Re([1,0,169,54,30,47,41,6,5,113,21,26]),function(ge,e,E,T,I,M,R,$,g,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=void 0,e.$RH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$SH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$TH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$UH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new g.$Ud,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const p=new l;I.$Gn.add(e.$UH.ConfigurationMigration,p);let w=class extends $.$Tc{constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const c of a.added)await this.f(c,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(a=>this.g(a,t?.uri))])}async g(t,n){const a=this.a.inspect(t.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,i]of c){const s=[];for(const d of a.overrideIdentifiers??[]){const m=await this.h(t,{resource:n,overrideIdentifier:d},h);for(const f of m??[]){let S=s.find(([[L,v]])=>L===f[0]&&(0,k.$yn)(v.value,f[1].value));S||s.push(S=[f,[]]),S[1].push(d)}}const u=await this.h(t,{resource:n},h,a);for(const d of u??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,m],f])=>this.a.updateValue(d,m.value,{resource:n,overrideIdentifiers:f},i)))}}async h(t,n,a,c){const h=d=>i(this.a.inspect(d,n)),i=d=>{const m=d[a];return n.overrideIdentifier?m?.override:m?.value},s=c?i(c):h(t.key);if(s===void 0)return;const u=await t.migrateFn(s,h);return Array.isArray(u)?u:[[t.key,u]]}};e.$VH=w,e.$VH=w=Je([He(0,R.$yi),He(1,M.$bi)],w);let r=class extends $.$Tc{constructor(t){super(),(async()=>{if(!A.$i&&(await t.getEnvironment())?.os!==1)return;I.$Gn.as(T.$Ln.Configuration).registerConfiguration({...e.$TH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$WH=r,e.$WH=r=Je([He(0,b.$Km)],r)}),define(Pe[279],Re([1,0,34,12,19,25,177,278,54,4,30]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adb=e.$_cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$$cb=e.$0cb=void 0,e.$0cb=(0,b.$5h)("editorResolverService"),e.$$cb="workbench.editorAssociations";const k=A.$Gn.as(g.$Ln.Configuration),l={...$.$SH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var p;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(p||(e.RegisteredEditorPriority=p={}));var w;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function r(t){switch(t){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$_cb=r;function o(t,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof t=="string"&&t.indexOf(I.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$Dg)(n);return E.$Kj(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$adb=o}),define(Pe[280],Re([1,0,46,12,19,21,25,2,4,198,47,216,113]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=e.$GK=void 0,e.$GK=(0,g.$5h)("pathService");let w=p=class{constructor(o,t,n,a){this.d=o,this.e=t,this.f=n,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(a=>this.h(o,a,t)):this.h(o,t,n)}h(o,t,n){return o.scheme===T.Schemas.file||o.scheme===T.Schemas.vscodeRemote?(0,E.$5f)(n??(0,R.$Dg)(o),t===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,b.$DK)(t.getWorkspace());if(n)return n;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?I.$fc:I.$gc)}async fileURI(o){let t="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.$HK=w,e.$HK=w=p=Je([He(1,l.$Km),He(2,k.$pK),He(3,A.$bi)],w)}),define(Pe[114],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$jJ=e.$iJ=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$iJ=E;class T{constructor(R,$,g,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(g,b)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$jJ=T;var I;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Pe[44],Re([1,0,18,34,26,46,11,4,19,15,114,13]),function(ge,e,E,T,I,M,R,$,g,b,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.SearchErrorCode=e.$yJ=e.$xJ=e.SearchSortOrder=e.ViewMode=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.SearchCompletionExitCode=e.$sJ=e.$rJ=e.$qJ=e.QueryType=e.SearchProviderType=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$kJ="workbench.view.search",e.$lJ="workbench.panel.search",e.$mJ="workbench.view.search",e.$nJ="search-result",e.$oJ="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",w=(l.length+p.length+5)*2;e.$pJ=(0,$.$5h)("searchService");var r;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(r||(e.SearchProviderType=r={}));var o;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(o||(e.QueryType=o={}));function t(he){return!!he.preview}e.$qJ=t;function n(he){return!!he.resource}e.$rJ=n;function a(he){return!!he.message}e.$sJ=a;var c;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(ve){this.resource=ve,this.results=[]}}e.$tJ=h;class i{constructor(ve,ee,De,se){this.ranges=ee,this.webviewIndex=se;const x=Array.isArray(ee)?ee:[ee];if(De&&De.matchLines===1&&s(x)){ve=(0,R.$Af)(ve,De.matchLines);let V="",ne=0,Ie=0;const Me=Math.floor(De.charsPerLine/5),Ce=[];for(const ce of x){const ie=Math.max(ce.startColumn-Me,0),Q=ce.startColumn+De.charsPerLine;if(ie>Ie+Me+w){const te=l+(ie-Ie)+p;V+=te+ve.slice(ie,Q),ne+=ie-(Ie+te.length)}else V+=ve.slice(Ie,Q);Ce.push(new d(0,ce.startColumn-ne,ce.endColumn-ne)),Ie=Q}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:ve,matches:(0,E.$2b)(ee,ne=>new u(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.$uJ=i;function s(he){const ve=he[0].startLineNumber;for(const ee of he)if(ee.startLineNumber!==ve||ee.endLineNumber!==ve)return!1;return!0}class u{constructor(ve,ee,De,se){this.startLineNumber=ve,this.startColumn=ee,this.endLineNumber=De,this.endColumn=se}}e.$vJ=u;class d extends u{constructor(ve,ee,De){super(ve,ee,ve,De)}}e.$wJ=d;var m;(function(he){he.List="list",he.Tree="tree"})(m||(e.ViewMode=m={}));var f;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function S(he,ve=!0){const ee=he&&he.files&&he.files.exclude,De=ve&&he&&he.search&&he.search.exclude;if(!ee&&!De)return;if(!ee||!De)return ee||De;let se=Object.create(null);return se=I.$xn(se,I.$un(ee)),se=I.$xn(se,I.$un(De),!0),se}e.$xJ=S;function L(he,ve){return he.excludePattern&&T.$Kj(he.excludePattern,ve)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&T.$Kj(he.includePattern,ve)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(ee=>{const De=ee.folder.fsPath;if(M.$7f(ve,De)){const se=g.$lc(De,ve);return!ee.includePattern||!!T.$Kj(ee.includePattern,se)}else return!1}):!1:!0}e.$yJ=L;var v;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class y extends Error{constructor(ve,ee){super(ve),this.code=ee}}e.$zJ=y;function D(he){const ve=he.message;if((0,b.$4)(he))return new y(ve,v.canceled);try{const ee=JSON.parse(ve);return new y(ee.message,ee.code)}catch{return new y(ve,v.other)}}e.$AJ=D;function N(he){const ve={message:he.message,code:he.code};return new Error(JSON.stringify(ve))}e.$BJ=N;function O(he){return he.type==="error"?!0:he.type==="success"}e.$CJ=O;function H(he){return he.type==="success"}e.$DJ=H;function U(he){return!!he.path}e.$EJ=U;function W(he,ve){const ee=he.searchPath?he.searchPath:he.relativePath;return(0,R.$xf)(ee,ve)}e.$FJ=W;class P{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$GJ=P;function C(he,ve){const ee={...he||{},...ve||{}};return Object.keys(ee).filter(De=>{const se=ee[De];return typeof se=="boolean"&&se})}e.$HJ=C;class J{constructor(ve,ee){this.c=null,this.a={...ve.excludePattern||{},...ee.excludePattern||{}},this.b=T.$Lj(this.a);let De=ve.includePattern;ee.includePattern&&(De?De={...De,...ee.includePattern}:De=ee.includePattern),De&&(this.c=T.$Lj(De))}matchesExcludesSync(ve,ee,De){return!!(this.b&&this.b(ve,ee,De))}includedInQuerySync(ve,ee,De){return!(this.b&&this.b(ve,ee,De)||this.c&&!this.c(ve,ee,De))}includedInQuery(ve,ee,De){const se=this.b(ve,ee,De),x=()=>this.c?!!this.c(ve,ee,De):!0;return(0,k.$Rg)(se)?se.then(V=>V?!1:x()):x()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$IJ=J;function ae(he){for(const ve in he)if(typeof he[ve]!="boolean")return!0;return!1}function fe(he){if(!he)return;let ve;return ee=>(ve||(ve=(he()||Promise.resolve([])).then(De=>De?ye(De):{})),ve.then(De=>!!De[ee]))}e.$JJ=fe;function we(he){if(!he)return;let ve;return ee=>{if(!ve){const De=he();ve=De?ye(De):{}}return!!ve[ee]}}e.$KJ=we;function ye(he){const ve={};for(const ee of he)ve[ee]=!0;return ve}}),define(Pe[36],Re([1,0,18,13,20,5,6,50,12,122,25,11,2,168,4,14,187,47,43,27,17,8,7,57,44,3,51]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c,h,i,s,u,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=e.$dgc=void 0;function f(H,U,W){return new A.$vg(P=>y(P,W)).isEqual(H,U)}function S(H,U,W){return f(H.uri,U.uri,W)?0:(0,k.$4e)(H.uri.toString(),U.uri.toString())}function L(H,U,W){return H.index!==U.index?H.index<U.index?-1:1:f(H.uri,U.uri,W)?(0,k.$4e)(H.name,U.name):(0,k.$4e)(H.uri.toString(),U.uri.toString())}function v(H,U,W,P){const C=H.slice(0).sort((ae,fe)=>W(ae,fe,P)),J=U.slice(0).sort((ae,fe)=>W(ae,fe,P));return(0,E.$Eb)(C,J,(ae,fe)=>W(ae,fe,P))}function y(H,U){const W=U.getCapabilities(H.scheme);return!(W&&W&1024)}class D extends t.$li{static toExtHostWorkspace(U,W,P,C){if(!U)return{workspace:null,added:[],removed:[]};const{id:J,name:ae,folders:fe,configuration:we,transient:ye,isUntitled:he}=U,ve=[],ee=W;W?fe.forEach((V,ne)=>{const Ie=l.URI.revive(V.uri),Me=D.o(P||W,Ie,C);Me?(Me.name=V.name,Me.index=V.index,ve.push(Me)):ve.push({uri:Ie,name:V.name,index:ne})}):ve.push(...fe.map(({uri:V,name:ne,index:Ie})=>({uri:l.URI.revive(V),name:ne,index:Ie}))),ve.sort((V,ne)=>V.index<ne.index?-1:1);const De=new D(J,ae,ve,!!ye,we?l.URI.revive(we):null,!!he,V=>y(V,C)),{added:se,removed:x}=v(ee?ee.workspaceFolders:[],De.workspaceFolders,S,C);return{workspace:De,added:se,removed:x}}static o(U,W,P){for(let C=0;C<U.folders.length;C++){const J=U.workspaceFolders[C];if(f(J.uri,W,P))return J}}constructor(U,W,P,C,J,ae,fe){super(U,P.map(we=>new t.$mi(we)),C,J,fe),this.t=W,this.u=ae,this.q=[],this.s=$.$$h.forUris(fe),P.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(U,W){return W&&this.s.get(U)&&(U=(0,A.$Fg)(U)),this.s.findSubstr(U)}resolveWorkspaceFolder(U){return this.s.get(U)}}let N=class{constructor(U,W,P,C,J){this.c=new M.$Ud,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Ud,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Wd,this.B=new Map,this.h=C,this.s=P,this.t=J,this.j=new b.$8l,this.k=new T.$4g,this.o=U.getProxy(d.$5K.MainThreadWorkspace),this.q=U.getProxy(d.$5K.MainThreadMessageService);const ae=W.workspace;this.l=ae?new D(ae.id,ae.name,[],!!ae.transient,ae.configuration?l.URI.revive(ae.configuration):null,!!ae.isUntitled,fe=>y(fe,P)):void 0}$initializeWorkspace(U,W){this.v=W,this.$acceptWorkspaceData(U),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,A.$Dg)((0,A.$Fg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(U,W,P,...C){const J=[];if(Array.isArray(C)&&C.forEach(he=>{l.URI.isUri(he.uri)&&!J.some(ve=>f(ve.uri,he.uri,this.s))&&J.push({uri:he.uri,name:he.name||(0,A.$Cg)(he.uri)})}),this.n||[W,P].some(he=>typeof he!="number"||he<0)||P===0&&J.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(W+P>ae.length)return!1;const fe=ae.slice(0);fe.splice(W,P,...J.map(he=>({uri:he.uri,name:he.name||(0,A.$Cg)(he.uri),index:void 0})));for(let he=0;he<fe.length;he++){const ve=fe[he];if(fe.some((ee,De)=>De!==he&&f(ve.uri,ee.uri,this.s)))return!1}fe.forEach((he,ve)=>he.index=ve);const{added:we,removed:ye}=v(ae,fe,L,this.s);if(we.length===0&&ye.length===0)return!1;if(this.o){const he=U.displayName||U.name;this.o.$updateWorkspaceFolders(he,W,P,J).then(void 0,ve=>{this.n=void 0;const ee={source:{identifier:U.identifier,label:U.displayName||U.name}};this.q.$showMessage(o.Severity.Error,(0,p.localize)(0,null,he,ve.toString()),ee,[])})}return this.y(fe),!0}getWorkspaceFolder(U,W){if(this.x)return this.x.getWorkspaceFolder(U,W)}async getWorkspaceFolder2(U,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(U,W)}async resolveWorkspaceFolder(U){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(U)}getPath(){if(!this.x)return;const{folders:U}=this.x;if(U.length!==0)return U[0].uri.fsPath}getRelativePath(U,W){let P,C="";if(typeof U=="string"?(P=l.URI.file(U),C=U):typeof U<"u"&&(P=U,C=U.fsPath),!P)return C;const J=this.getWorkspaceFolder(P,!0);if(!J)return C;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let ae=(0,A.$Ig)(J.uri,P);return W&&J.name&&(ae=`${J.name}/${ae}`),ae}y(U){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:U,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:W,added:P,removed:C}=D.toExtHostWorkspace(U,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:C}))}findFiles(U,W,P,C,J=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${C.value}, entryPoint: findFiles`);let ae;if(W===null?ae=!1:W&&(typeof W=="string"?ae=W:ae=W.pattern),J&&J.isCancellationRequested)return Promise.resolve([]);const{includePattern:fe,folder:we}=O(h.GlobPattern.from(U));return this.o.$startFileSearch(fe??null,we??null,ae??null,P??null,J).then(ye=>Array.isArray(ye)?ye.map(he=>l.URI.revive(he)):[])}async findTextInFiles(U,W,P,C,J=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${C.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),fe=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:we,folder:ye}=O(h.GlobPattern.from(W.include)),he=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,ve={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:fe,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:we,excludePattern:he},ee=!1;if(this.u[ae]=De=>{if(ee)return;const se=l.URI.revive(De.resource);De.results.forEach(x=>{const V=(0,m.$Bh)(x);(0,u.$qJ)(V)?P({uri:se,preview:{text:V.preview.text,matches:(0,E.$2b)(V.preview.matches,ne=>new i.$9K(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,E.$2b)(V.ranges,ne=>new i.$9K(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):P({uri:se,text:V.text,lineNumber:V.lineNumber})})},J.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(U,ye??null,ve,ae,J);return delete this.u[ae],De||{}}catch(De){throw delete this.u[ae],De}}$handleTextSearchResult(U,W){this.u[W]?.(U)}async save(U){const W=await this.o.$save(U,{saveAs:!1});return l.URI.revive(W)}async saveAs(U){const W=await this.o.$save(U,{saveAs:!0});return l.URI.revive(W)}saveAll(U){return this.o.$saveAll(U)}resolveProxy(U){return this.o.$resolveProxy(U)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(U){return this.o.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(U,W){if(this.w.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.w.set(U,W);const P=this.t.transformOutgoingScheme(U),C=this.z++;return this.o.$registerEditSessionIdentityProvider(C,P),(0,R.$Rc)(()=>{this.w.delete(U),this.o.$unregisterEditSessionIdentityProvider(C)})}async $getEditSessionIdentifier(U,W){this.h.info("Getting edit session identifier for workspaceFolder",U);const P=await this.resolveWorkspaceFolder(l.URI.revive(U));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const C=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!C),!C)return;const J=await C.provideEditSessionIdentity(P,W);if(this.h.info("Provider returned edit session identifier: ",J),!!J)return J}async $provideEditSessionIdentityMatch(U,W,P,C){this.h.info("Getting edit session identifier for workspaceFolder",U);const J=await this.resolveWorkspaceFolder(l.URI.revive(U));if(!J){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",J);const ae=this.w.get(J.uri.scheme);if(this.h.info(`Provider for scheme ${J.uri.scheme} is defined: `,!!ae),!ae)return;const fe=await ae.provideEditSessionIdentityMatch?.(W,P,C);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(U){return(W,P,C)=>{const J=function(fe){W.call(P,fe)};return J.extension=U,this.A.event(J,void 0,C)}}async $onWillCreateEditSessionIdentity(U,W,P){const C=await this.resolveWorkspaceFolder(l.URI.revive(U));if(C===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:C},W,async(J,ae)=>{const fe=Date.now();await Promise.resolve(J),Date.now()-fe>P&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(U,W){if(this.B.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.B.set(U,W);const P=this.t.transformOutgoingScheme(U),C=this.z++;return this.o.$registerCanonicalUriProvider(C,P),(0,R.$Rc)(()=>{this.B.delete(U),this.o.$unregisterCanonicalUriProvider(C)})}async provideCanonicalUri(U,W,P){const C=this.B.get(U.scheme);if(!C)return;const J=await C.provideCanonicalUri?.(l.URI.revive(U),W,P);if(J)return J}async $provideCanonicalUri(U,W,P){return this.provideCanonicalUri(l.URI.revive(U),{targetScheme:W},P)}};e.$dgc=N,e.$dgc=N=Je([He(0,c.$9M),He(1,a.$mN),He(2,n.$Vfc),He(3,r.$mj),He(4,s.$bgc)],N),e.$egc=(0,w.$5h)("IExtHostWorkspace");function O(H){let U,W;return H&&(typeof H=="string"?U=H:(U=H.pattern,W=l.URI.revive(H.baseUri))),{includePattern:U,folder:W}}}),define(Pe[37],Re([1,0,26,5,36,3,7,189,54,16,13,4,17,14,2]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=e.$ggc=e.$fgc=void 0;function r(s,u){if(u){const d=u.split(".");let m=s;for(let f=0;m&&f<d.length;f++)m=m[d[f]];return m}}function o(s){return s instanceof w.URI}function t(s){return s&&s.uri instanceof w.URI&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&s.uri instanceof w.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function c(s){if(o(s))return{resource:s};if(t(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(n(s))return{overrideIdentifier:s.languageId};if(a(s))return{resource:s.uri};if(s===null)return{resource:null}}let h=class{constructor(u,d,m){this.a=u.getProxy(M.$5K.MainThreadConfiguration),this.c=d,this.b=m,this.d=new A.$4g,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,d){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(u,d))}};e.$fgc=h,e.$fgc=h=Je([He(0,l.$9M),He(1,I.$egc),He(2,p.$mj)],h);class i{constructor(u,d,m,f){this.a=new T.$Ud,this.b=u,this.f=f,this.c=d,this.e=$.$5n.parse(m),this.d=this.k(m.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,d){const m={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$5n.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(d,m))}getConfiguration(u,d,m){const f=c(d)||{},S=this.g(u?r(this.e.getValue(void 0,f,this.c.workspace),u):this.e.getValue(void 0,f,this.c.workspace));u&&this.h(u,f,m?.identifier);function L(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(y){return typeof r(S,y)<"u"},get:(y,D)=>{this.h(u?`${u}.${y}`:y,f,m?.identifier);let N=r(S,y);if(typeof N>"u")N=D;else{let O;const H=(U,W)=>{if((0,b.$Jf)(U)){let P;const C=()=>{O=O||(0,E.$un)(S),P=P||r(O,W)};return new Proxy(U,{get:(J,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return C(),()=>P;if(O)return P=P||r(O,W),P[ae];const fe=J[ae];return typeof ae=="string"?H(fe,`${W}.${ae}`):fe},set:(J,ae,fe)=>(C(),P&&(P[ae]=fe),!0),deleteProperty:(J,ae)=>(C(),P&&delete P[ae],!0),defineProperty:(J,ae,fe)=>(C(),P&&Object.defineProperty(P,ae,fe),!0)})}return Array.isArray(U)?(0,E.$un)(U):U};N=H(N,y)}return N},update:(y,D,N,O)=>{y=u?`${u}.${y}`:y;const H=L(N);return D!==void 0?this.b.$updateConfigurationOption(H,y,D,f,O):this.b.$removeConfigurationOption(H,y,f,O)},inspect:y=>{y=u?`${u}.${y}`:y;const D=this.e.inspect(y,f,this.c.workspace);if(D)return{key:y,defaultValue:(0,E.$un)(D.policy?.value??D.default?.value),globalValue:(0,E.$un)(D.user?.value??D.application?.value),workspaceValue:(0,E.$un)(D.workspace?.value),workspaceFolderValue:(0,E.$un)(D.workspaceFolder?.value),defaultLanguageValue:(0,E.$un)(D.default?.override),globalLanguageValue:(0,E.$un)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,E.$un)(D.workspace?.override),workspaceFolderLanguageValue:(0,E.$un)(D.workspaceFolder?.override),languageIds:(0,E.$un)(D.overrideIdentifiers)}}};return typeof S=="object"&&(0,E.$xn)(v,S,!1),Object.freeze(v)}g(u){const d=m=>(0,b.$Jf)(m)?new Proxy(m,{get:(f,S)=>d(f[S]),set:(f,S,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(f,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(f,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return d(u)}h(u,d,m){const f=g.$Vn.test(u)?4:this.d.get(u),S=m?`[${m.value}] `:"";if(f===4){typeof d?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,d){const m=new $.$7n(u,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,S)=>m.affectsConfiguration(f,c(S))})}k(u){return u.reduce((d,m)=>(d.set(m[0],m[1]),d),new Map)}}e.$ggc=i,e.$hgc=(0,k.$5h)("IExtHostConfiguration")}),define(Pe[115],Re([1,0,2,13,5,3,7,36,61,37,20,64,17,27,4,12,21,14,81,228,15]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=e.$Jhc=e.$Ihc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(H){function U(P){if(P!=null)return P}H.from=U;function W(P){if(P!=null)return P}H.to=W})(h||(h={}));var i;(function(H){function U(P){if(P!=null)return P}H.from=U;function W(P){if(P!=null)return P}H.to=W})(i||(i={}));var s;(function(H){function U(P){if(P!=null)return P}H.from=U;function W(P){if(P!=null)return P}H.to=W})(s||(s={}));var u;(function(H){function U(C){if(C){const J=C;return J&&!!J.process}else return!1}H.is=U;function W(C){if(C==null)return;const J={process:C.process,args:C.args};return C.options&&(J.options=s.from(C.options)),J}H.from=W;function P(C){if(C!=null)return new R.$PL(C.process,C.args,C.options)}H.to=P})(u||(u={}));var d;(function(H){function U(P){if(P!=null)return P}H.from=U;function W(P){if(P!=null)return P}H.to=W})(d||(d={}));var m;(function(H){function U(C){if(C){const J=C;return J&&(!!J.commandLine||!!J.command)}else return!1}H.is=U;function W(C){if(C==null)return;const J={};return C.commandLine!==void 0?J.commandLine=C.commandLine:(J.command=C.command,J.args=C.args),C.options&&(J.options=d.from(C.options)),J}H.from=W;function P(C){if(!(C==null||C.command===void 0&&C.commandLine===void 0))return C.commandLine?new R.$QL(C.commandLine,C.options):new R.$QL(C.command,C.args?C.args:[],C.options)}H.to=P})(m||(m={}));var f;(function(H){function U(C){if(C){const J=C;return J&&J.customExecution==="customExecution"}else return!1}H.is=U;function W(C){return{customExecution:"customExecution"}}H.from=W;function P(C,J){return J.get(C)}H.to=P})(f||(e.CustomExecutionDTO=f={}));var S;(function(H){function U(W,P){let C;return W.scope!==void 0&&typeof W.scope!="number"?C=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===R.TaskScope.Workspace&&P&&P.workspaceFile?C=P.workspaceFile:C=a.$yG),{id:W._id,workspaceFolder:C}}H.from=U})(S||(e.TaskHandleDTO=S={}));var L;(function(H){function U(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}H.from=U})(L||(L={}));var v;(function(H){function U(C,J){if(C==null)return[];const ae=[];for(const fe of C){const we=W(fe,J);we&&ae.push(we)}return ae}H.fromMany=U;function W(C,J){if(C==null)return;let ae;C.execution instanceof R.$PL?ae=u.from(C.execution):C.execution instanceof R.$QL?ae=m.from(C.execution):C.execution&&C.execution instanceof R.$RL&&(ae=f.from(C.execution));const fe=h.from(C.definition);let we;return C.scope?typeof C.scope=="number"?we=C.scope:we=C.scope.uri:we=R.TaskScope.Workspace,!fe||!we?void 0:{_id:C._id,definition:fe,name:C.name,source:{extensionId:J.identifier.value,label:C.source,scope:we},execution:ae,isBackground:C.isBackground,group:L.from(C.group),presentationOptions:i.from(C.presentationOptions),problemMatchers:C.problemMatchers,hasDefinedMatchers:C.hasDefinedMatchers,runOptions:C.runOptions?C.runOptions:{reevaluateOnRerun:!0},detail:C.detail}}H.from=W;async function P(C,J,ae){if(C==null)return;let fe;u.is(C.execution)?fe=u.to(C.execution):m.is(C.execution)?fe=m.to(C.execution):f.is(C.execution)&&(fe=f.to(C._id,ae));const we=h.to(C.definition);let ye;if(C.source&&(C.source.scope!==void 0?typeof C.source.scope=="number"?ye=C.source.scope:ye=await J.resolveWorkspaceFolder(E.URI.revive(C.source.scope)):ye=R.TaskScope.Workspace),!we||!ye)return;const he=new R.$SL(we,ye,C.name,C.source.label,fe,C.problemMatchers);return C.isBackground!==void 0&&(he.isBackground=C.isBackground),C.group!==void 0&&(he.group=R.$OL.from(C.group._id),he.group&&C.group.isDefault&&(he.group=new R.$OL(he.group.id,he.group.label),C.group.isDefault===!0&&(he.group.isDefault=C.group.isDefault))),C.presentationOptions&&(he.presentationOptions=i.to(C.presentationOptions)),C._id&&(he._id=C._id),C.detail&&(he.detail=C.detail),he}H.to=P})(v||(e.TaskDTO=v={}));var y;(function(H){function U(P){return P}H.from=U;function W(P){if(P)return Object.assign(Object.create(null),P)}H.to=W})(y||(y={}));class D{#e;constructor(U,W,P){this._id=W,this.a=P,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let N=class{constructor(U,W,P,C,J,ae,fe,we){this.q=new I.$Ud,this.r=new I.$Ud,this.s=new I.$Ud,this.u=new I.$Ud,this.a=U.getProxy(M.$5K.MainThreadTask),this.b=P,this.c=C,this.d=J,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,W,P){if(!P)return new R.$7K(()=>{});const C=this.x();return this.j.set(C,{type:W,provider:P,extension:U}),this.a.$registerTaskProvider(C,W),new R.$7K(()=>{this.j.delete(C),this.a.$unregisterTaskProvider(C)})}registerTaskSystem(U,W){this.a.$registerTaskSystem(U,W)}fetchTasks(U){return this.a.$fetchTasks(y.from(U)).then(async W=>{const P=[];for(const C of W){const J=await v.to(C,this.b,this.m);J&&P.push(J)}return P})}get taskExecutions(){const U=[];return this.k.forEach(W=>U.push(W)),U}terminateTask(U){if(!(U instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,W,P){const C=this.m.get(U.id);C&&(this.o.set(U.id,C),this.e.attachPtyToTerminal(W,await C.callback(P))),this.p=U.id,this.q.fire({execution:await this.z(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){if(!this.l.has(U.id))return;const W=await this.z(U);this.l.delete(U.id),this.k.delete(U.id),this.B(U),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const W=await this.z(U.id);this.s.fire({execution:W,processId:U.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(U){const W=await this.z(U.id);this.u.fire({execution:W,exitCode:U.exitCode})}$provideTasks(U,W){const P=this.j.get(U);if(!P)return Promise.reject(new Error("no handler found"));const C=[],J=(0,T.$Xg)(()=>P.provider.provideTasks(A.CancellationToken.None)).then(ae=>this.v(W,C,P,ae));return new Promise(ae=>{J.then(fe=>{Promise.all(C).then(()=>{ae(fe)})})})}async $resolveTask(U,W){const P=this.j.get(U);if(!P)return Promise.reject(new Error("no handler found"));if(W.definition.type!==P.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${P.type}].`);const C=await v.to(W,this.b,this.m);if(!C)throw new Error("Unexpected: Task cannot be resolved.");const J=await P.provider.resolveTask(C,A.CancellationToken.None);if(!J)return;this.A(J,P);const ae=v.from(J,P.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(J.definition!==C.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ae.execution)&&await this.y(ae,J,!0),await this.w(ae)}x(){return this.h++}async y(U,W,P){const C=await this.a.$createTaskId(U);!P&&!this.m.has(C)&&(this.n.add(C),this.o.set(C,W.execution)),this.m.set(C,W.execution)}async z(U,W){if(typeof U=="string"){const J=this.l.get(U);if(!J)throw new c.$bb("Unexpected: The specified task is missing an execution");return J}const P=this.l.get(U.id);if(P)return P;let C;return W?C=Promise.resolve(new D(this,U.id,W)):C=v.to(U.task,this.b,this.m).then(J=>{if(!J)throw new c.$bb("Unexpected: Task does not exist.");return new D(this,U.id,J)}),this.l.set(U.id,C),C.then(J=>(this.k.set(U.id,J),J))}A(U,W){U._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}B(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const P=this.n.values();let C=P.next();for(;!C.done;)!this.o.has(C.value)&&this.p!==C.value&&(this.m.delete(C.value),this.n.delete(C.value)),C=P.next()}};e.$Ihc=N,e.$Ihc=N=Je([He(0,l.$9M),He(1,p.$mN),He(2,$.$egc),He(3,g.$hN),He(4,b.$hgc),He(5,k.$Fgc),He(6,t.$mj),He(7,n.$Yfc)],N);let O=class extends N{constructor(U,W,P,C,J,ae,fe,we){super(U,W,P,C,J,ae,fe,we),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(U,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const P=v.from(W,U);if(P===void 0)throw new Error("Task is not valid");if(f.is(P.execution))await this.y(P,W,!1);else throw new c.$_;const C=await this.z(await this.a.$getTaskExecution(P),W);return this.a.$executeTask(P).catch(J=>{throw new Error(J)}),C}v(U,W,P,C){const J=[];if(C)for(const ae of C){if(this.A(ae,P),!ae.definition||!U[ae.definition.type]){const we=ae.source?ae.source:"No task source";this.f.warn(`The task [${we}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const fe=v.from(ae,P.extension);fe&&f.is(fe.execution)?(J.push(fe),W.push(this.y(fe,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:J,extension:P.extension}}async w(U){if(f.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,W,P){}};e.$Jhc=O,e.$Jhc=O=Je([He(0,l.$9M),He(1,p.$mN),He(2,$.$egc),He(3,g.$hN),He(4,b.$hgc),He(5,k.$Fgc),He(6,t.$mj),He(7,n.$Yfc)],O),e.$Khc=(0,w.$5h)("IExtHostTask")}),define(Pe[281],Re([1,0,44,29]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SJ=e.$RJ=e.$QJ=void 0;function I(R){return"cellResults"in R}e.$QJ=I,e.$RJ="rawCell#";function M(R,$){let g=-1;const b=[];let A=[];return R.forEach(l=>{l.range.startLineNumber!==g&&A.length>0&&(b.push([...A]),A=[]),A.push(l),g=l.range.endLineNumber}),A.length>0&&b.push([...A]),b.map(l=>{const p=[],w=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let o=w;o<=r;o++)p.push($.getLineContent(o));return new E.$uJ(p.join(`
`)+`
`,l.map(o=>new T.$Ts(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}e.$SJ=M}),define(Pe[282],Re([1,0,162,24,5,6,28,11,16,2,42,75,3,32,8,7,49,220,107,26,12,211,281,279]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,f,S,L,v,y){this.q=S,this.r=L,this.s=v,this.t=y,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new I.$Ud,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Ud,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Ud,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Ud,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Rfc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(l.$5K.MainThreadNotebook),this.c=m.getProxy(l.$5K.MainThreadNotebookDocuments),this.d=m.getProxy(l.$5K.MainThreadNotebookEditors),this.i=f.converter,f.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const N=D.notebookEditor?.notebookUri,O=D.cell.handle,U=this.g.get(N)?.getCell(O);if(U)return U.apiCell}if(D&&D.$mid===14){const N=D.uri,O=this.g.get(N);if(O)return O.apiNotebook}return D}}),u.B(f)}getEditorById(m){const f=this.h.get(m);if(!f)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return f}getIdByEditor(m){for(const[f,S]of this.h)if(S.apiEditor===m)return f}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,f){const S=this.g.get(m);if(!S&&!f)throw new Error(`NO notebook document for '${m}'`);return S}static u(m,f){if(!f)return;const S=f.filenamePattern.map(L=>w.NotebookExclusiveDocumentPattern.from(L)).filter(L=>L!==void 0);if(f.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:f.displayName,filenamePattern:S,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,f,S){const L=u.a++,v=typeof S.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(L,S),this.b.$registerNotebookCellStatusBarItemProvider(L,v,f);let y;return v!==void 0&&(y=S.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(v))),new r.$7K(()=>{this.f.delete(L),this.b.$unregisterNotebookCellStatusBarItemProvider(L,v),y?.dispose()})}async createNotebookDocument(m){const f=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&w.NotebookData.from(m.content)});return b.URI.revive(f)}async openNotebookDocument(m){const f=this.g.get(m);if(f)return f.apiNotebook;const S=await this.c.$tryOpenNotebook(m),L=this.g.get(b.URI.revive(S));return(0,g.$Sf)(L?.apiNotebook)}async showNotebookDocument(m,f){b.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let S;typeof f=="object"?S={position:w.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(w.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:S={preserveFocus:!1};const L=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,S),v=L&&this.h.get(L)?.apiEditor;if(v)return v;throw L?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,f,S,L){const v=this.f.get(m),y=b.URI.revive(f),D=this.g.get(y);if(!D||!v)return;const N=D.getCellFromIndex(S);if(!N)return;const O=await v.provideCellStatusBarItems(N.apiCell,L);if(!O)return;const H=new M.$Sc,U=this.p.add([H]),P=(Array.isArray(O)?O:[O]).map(C=>w.NotebookStatusBarItem.from(C,this.i,H));return{cacheId:U,items:P}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,f,S,L,v){if((0,$.$Ie)(f))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:f,serializer:S,options:L}),this.b.$registerNotebookSerializer(y,{id:m.identifier,location:m.extensionLocation},f,w.NotebookDocumentContentOptions.from(L),u.u(m,v)),(0,M.$Rc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(m,f,S){const L=this.x.get(m);if(!L)throw new Error("NO serializer found");const v=await L.serializer.deserializeNotebook(f.buffer,S);return new o.$Sv(w.NotebookData.from(v))}async $notebookToData(m,f,S){const L=this.x.get(m);if(!L)throw new Error("NO serializer found");const v=await L.serializer.serializeNotebook(w.NotebookData.to(f.value),S);return T.$ie.wrap(v)}async $saveNotebook(m,f,S,L,v){const y=b.URI.revive(f),D=this.x.get(m);if(!D)throw new Error("NO serializer found");const N=this.g.get(y);if(!N)throw new Error("Document NOT found");if(N.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$Kk((0,E.localize)(0,null,this.z(y)),6);await this.y(y,L);const O={metadata:(0,a.$Cn)(N.apiNotebook.metadata,C=>!(D.options?.transientDocumentMetadata??{})[C]),cells:[]};for(const C of N.apiNotebook.getCells()){const J=new r.$tM(C.kind,C.document.getText(),C.document.languageId,C.mime,D.options?.transientOutputs?[]:[...C.outputs],C.metadata,C.executionSummary);J.metadata=(0,a.$Cn)(C.metadata,ae=>!(D.options?.transientCellMetadata??{})[ae]),O.cells.push(J)}const H=await D.serializer.serializeNotebook(O,v);await this.s.value.writeFile(y,H);const U=this.s.getFileSystemProviderExtUri(y.scheme),W=await this.s.value.stat(y);return{name:U.basename(y),isFile:(W.type&A.FileType.File)!==0,isDirectory:(W.type&A.FileType.Directory)!==0,isSymbolicLink:(W.type&A.FileType.SymbolicLink)!==0,mtime:W.mtime,ctime:W.ctime,size:W.size,readonly:!!((W.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((W.permissions??0)&A.FilePermission.Locked),etag:A.$Vk({mtime:W.mtime,size:W.size}),children:void 0}}async $searchInNotebooks(m,f,S,L,v){const y=this.x.get(m)?.serializer;if(!y)return{limitHit:!1,results:[]};const D=new R.$Bc;await(async(W,P,C)=>{await Promise.all(W.map(async J=>await Promise.all(J.filenamePatterns.map(ae=>{const fe={_reason:C._reason,folderQueries:C.folderQueries,includePattern:C.includePattern,excludePattern:C.excludePattern,maxResults:C.maxResults,type:1,filePattern:ae};return this.t.doInternalFileSearchWithCustomCallback(fe,P,we=>{we.forEach(ye=>{D.has(ye)||L.some(ve=>J.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(ee=>(0,s.$adb)(ee,ye)))||D.add(ye)})})}))))})(S,v,f);const O=new R.$Ac;let H=!1;const U=Array.from(D).map(async W=>{const P=[];try{if(v.isCancellationRequested)return;if(f.maxResults&&[...O.values()].reduce((fe,we)=>fe+we.cellResults.length,0)>f.maxResults){H=!0;return}const C=[],J=this.g.get(W);if(J)J.apiNotebook.getCells().forEach(we=>C.push({input:we.document.getText(),outputs:we.outputs.flatMap(ye=>ye.items.map(he=>he.data.toString()))}));else{const fe=await this.s.value.readFile(W),we=T.$ie.fromString(fe.toString()),ye=await y.deserializeNotebook(we.buffer,v);if(v.isCancellationRequested)return;w.NotebookData.from(ye).cells.forEach(ve=>C.push({input:ve.source,outputs:ve.outputs.flatMap(ee=>ee.items.map(De=>De.valueBytes.toString()))}))}if(v.isCancellationRequested)return;C.forEach((fe,we)=>{const ye=f.contentPattern.pattern,he=new h.$yQb(fe.input,void 0,fe.outputs),ve=he.findInInputs(ye),ee=he.findInOutputs(ye),De=ee.flatMap(se=>(0,i.$SJ)(se.matches,se.textBuffer)).map((se,x)=>(se.webviewIndex=x,se));if(ve.length>0||ee.length>0){const se={index:we,contentResults:(0,i.$SJ)(ve,he.inputTextBuffer),webviewResults:De};P.push(se)}});const ae={resource:W,cellResults:P};O.set(W,ae);return}catch{return}});return await Promise.all(U),{limitHit:H,results:[...O.values()]}}async y(m,f){const S=await this.s.value.stat(m);if(typeof f?.mtime=="number"&&typeof f.etag=="string"&&f.etag!==A.$Uk&&typeof S.mtime=="number"&&typeof S.size=="number"&&f.mtime<S.mtime&&f.etag!==A.$Vk({mtime:f.mtime,size:S.size}))throw new A.$Kk((0,E.localize)(1,null),3,f)}z(m){return m.scheme===c.Schemas.file?m.fsPath:m.toString()}A(m,f,S){if(this.h.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const L=new n.$bhc(f,this.d,m,S.visibleRanges.map(w.NotebookRange.to),S.selections.map(w.NotebookRange.to),typeof S.viewColumn=="number"?w.ViewColumn.to(S.viewColumn):void 0);this.h.set(f,L)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const S of m.value.removedDocuments){const L=b.URI.revive(S),v=this.g.get(L);v&&(v.dispose(),this.g.delete(L),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(v.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===L.toString()&&this.h.delete(y.id)}if(m.value.addedDocuments){const S=[];for(const L of m.value.addedDocuments){const v=b.URI.revive(L.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const y=new t.$ahc(this.c,this.q,this.r,v,L);S.push(...L.cells.map(D=>t.$_gc.asModelAddData(y.apiNotebook,D))),this.g.get(v)?.dispose(),this.g.set(v,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(y.apiNotebook)}}if(m.value.addedEditors)for(const S of m.value.addedEditors){if(this.h.has(S.id))return;const L=b.URI.revive(S.documentUri),v=this.g.get(L);v&&this.A(v,S.id,S)}const f=[];if(m.value.removedEditors)for(const S of m.value.removedEditors){const L=this.h.get(S);L&&(this.h.delete(S),this.k?.id===L.id&&(this.k=void 0),f.push(L))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(L=>this.h.get(L)).filter(L=>!!L);const S=new Set;this.l.forEach(L=>S.add(L.id));for(const L of this.h.values()){const v=S.has(L.id);L._acceptVisibility(v)}this.l=[...this.h.values()].map(L=>L).filter(L=>L.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const f=p.$uN.String.with("notebookType","A notebook type"),S=new p.$wN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[f,new p.$uN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>T.$ie.wrap(v))],new p.$vN("Notebook Data",v=>w.NotebookData.to(v.value))),L=new p.$wN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[f,new p.$uN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new o.$Sv(w.NotebookData.from(v)))],new p.$vN("Bytes",v=>v.buffer));m.registerApiCommand(S),m.registerApiCommand(L)}}e.$khc=u}),define(Pe[283],Re([1,0,19,20,40,34,25,60,44]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class b{constructor(l,p,w){this.k=l,this.l=p,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&M.$Lj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&M.$Lj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise((w,r)=>{const o=t=>{this.f++,l(t)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),a=E.$nc(n);this.j&&this.j(n,a)||this.v(o,{base:t,basename:a})}),Promise.all(p.map(t=>this.p(t,o))).then(t=>{w({limitHit:this.e,stats:t[0]||void 0})},t=>{r(new Error((0,I.$Pi)(t)))})})}async p(l,p){const w=new T.$5d,r=this.q(l),o=this.r(),t=new g.$IJ(this.k,l),n=!t.hasSiblingExcludeClauses();let a;try{this.h.add(w),a=$.$Qd.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,w.token),h=a.elapsed(),i=$.$Qd.create();return this.g&&!this.e||(c&&c.forEach(s=>{const u=E.$gc.relative(l.folder.path,s.path);if(n){const d=E.$nc(s.path);this.v(p,{base:l.folder,relativePath:u,basename:d});return}this.s(o,l.folder,u,p)}),this.g&&!this.e)?null:(this.u(o,t,p),{providerTime:h,postProcessTime:i.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(l){const p=(0,g.$HJ)(this.k.includePattern,l.includePattern),w=(0,g.$HJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:w,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,w,r){if(w===this.a){const t=E.$nc(this.a);this.v(r,{base:p,relativePath:this.a,basename:t})}function o(t){const n=E.$nc(t),a=E.$mc(t);let c=l[a];c||(c=l[a]=[],o(a)),c.push({base:p,relativePath:t,basename:n})}o(w)}u({rootEntries:l,pathToEntries:p},w,r){const o=this,t=this.a;function n(a){const c=(0,g.$KJ)(()=>a.map(h=>h.basename));for(let h=0,i=a.length;h<i;h++){const s=a[h],{relativePath:u,basename:d}=s;if(w.matchesExcludesSync(u,d,t!==d?c:void 0))continue;const m=p[u];if(m)n(m);else{if(u===t)continue;o.v(r,s)}if(o.e)break}}n(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,p,w,r){const o=this.c(l.cacheKey),t=new b(l,p,o&&o.token);let n=0;const a=c=>{n+=c.length,w(c.map(h=>this.d(h)))};return this.e(t,A.a,a,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$5d),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Gg(l.base,l.relativePath)}:{resource:l.base}}e(l,p,w,r){const o=r.onCancellationRequested(()=>{l.cancel()}),t=a=>{a&&(n.push(a),p>0&&n.length>=p&&(w(n),n=[]))};let n=[];return l.search(t).then(a=>(n.length&&w(n),o.dispose(),a),a=>(n.length&&w(n),o.dispose(),Promise.reject(a)))}}e.$chc=A}),define(Pe[284],Re([1,0,18,245,34,95,28,12,19,25,11,16,2,94,179,41,14,47,105,280,44]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JK=e.$IK=void 0;let h=class{constructor(y,D,N,O,H){this.a=y,this.b=D,this.c=N,this.d=O,this.e=H}text(y,D,N={}){y=this.f(y,N);const O=this.a.getValue(),H=D&&D.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(D?.map(t.$ni),N),type:2,contentPattern:y,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:O.search.usePCRE2||H||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(y,D){const N=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const O={...y,wordSeparators:N.editor.wordSeparators};return this.j(y,D)&&(O.isCaseSensitive=!0),this.k(y)&&(O.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),O}file(y,D={}){return{...this.h(y,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}g(y,D){return y?(y=Array.isArray(y)?y.map(m):m(y),D?this.parseSearchPaths(y):{pattern:s(...Array.isArray(y)?y:[y])}):{}}h(y=[],D={}){const N=this.g(D.includePattern,D.expandPatterns),O=this.g(D.excludePattern,D.expandPatterns),H=y.length>1,U=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(C=>this.q(C,D,O)):y.map(C=>this.r(C,D,O,H))).filter(C=>!!C),W={_reason:D._reason,folderQueries:U,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:O.pattern,includePattern:N.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const C=E.$Hb(E.$Rb(this.c.groups.map(fe=>fe.editors.map(we=>we.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(C));const J=C.filter(fe=>(0,c.$yJ)(W,fe.fsPath)),ae=this.i(J);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...W,...ae}}const P=D.extraFileResources&&D.extraFileResources.filter(C=>(0,c.$yJ)(W,C.fsPath));return W.extraFileResources=P&&P.length?P:void 0,W}i(y){const D=[],N=new R.$Ac,O={};let H=!1;return y.forEach(U=>{if(U.scheme===$.Schemas.walkThrough)return;if((0,b.$Kg)(U)){const P=this.b.getWorkspaceFolder(U)?.uri??U.with({path:g.$mc(U.fsPath)});let C=N.get(P);C||(H=!0,C={folder:P,includePattern:{}},D.push(C),N.set(P,C));const J=g.$lc(P.fsPath,U.fsPath);(0,k.$Sf)(C.includePattern)[J.replace(/\\/g,"/")]=!0}else U.fsPath&&(H=!0,O[U.fsPath]=!0)}),{folderQueries:D,includePattern:O,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}j(y,D){if(D.isSmartCase){if(y.isRegExp){if(A.$yf(y.pattern,!0))return!0}else if(A.$yf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,p.$3B)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const D=ae=>g.$ic(ae)||/^\.\.?([\/\\]|$)/.test(ae),O=(Array.isArray(y)?y:u(y)).map(ae=>{const fe=this.e.resolvedUserHome;return fe?(0,M.$Xv)(ae,fe.scheme===$.Schemas.file?fe.fsPath:fe.path):ae}),H=T.$K(O,ae=>D(ae)?"searchPaths":"exprSegments"),U=(H.exprSegments||[]).map(ae=>A.$Te(ae,"/")).map(ae=>A.$Te(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),d(ae))),W={},P=this.m(H.searchPaths||[]);P&&P.length&&(W.searchPaths=P);const C=E.$Rb(U),J=s(...C);return J&&(W.pattern=J),W}l(y,D){return D.disregardExcludeSettings?void 0:(0,c.$xJ)(y,!D.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const D=y.flatMap(O=>{let{pathPortion:H,globPortion:U}=i(O);return U&&(U=f(U)),this.n(H).flatMap(P=>this.o(P,U))}),N=new Map;return D.forEach(O=>{const H=O.searchPath.toString(),U=N.get(H);U?O.pattern&&(U.pattern=U.pattern||{},U.pattern[O.pattern]=!0):N.set(H,{searchPath:O.searchPath,pattern:O.pattern?s(O.pattern):void 0})}),Array.from(N.values())}n(y){if(g.$ic(y)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==$.Schemas.file?[{searchPath:D[0].uri.with({path:y})}]:[{searchPath:l.URI.file(g.$hc(y))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(y=m(y),y.startsWith("../")||y===".."){const O=g.$gc.resolve(D.path,y);return[{searchPath:D.with({path:O})}]}const N=f(y);return[{searchPath:D,pattern:N}]}else{if(y==="./"||y===".\\")return[];{const D=y.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(H=>{const U=D.match(new RegExp(`^${A.$Ne(H.name)}(?:/(.*)|$)`));return U?{match:U,folder:H}:null}).filter(k.$Pf);if(O.length)return O.map(H=>{const U=H.match[1];return{searchPath:H.folder.uri,pattern:U&&f(U)}});{const H=y.match(/\.[\/\\](.+)[\/\\]?/),U=H?H[1]:y,W=w.localize(0,null,U);throw new Error(W)}}}}o(y,D){const N=y.pattern&&D?`${y.pattern}/${D}`:y.pattern||D,O=[{searchPath:y.searchPath,pattern:N}];return N&&!N.endsWith("**")&&O.push({searchPath:y.searchPath,pattern:N+"/**"}),O}q(y,D,N){const O=this.r((0,t.$ni)(y.searchPath),D,N,!1);return O?{...O,includePattern:y.pattern}:null}r(y,D,N,O){let H;const U=l.URI.isUri(y)?y:y.uri;if(N.searchPaths){const ae=N.searchPaths.filter(fe=>(0,b.$zg)(fe.searchPath,U))[0];if(ae&&!ae.pattern)return null;ae&&(H=ae.pattern)}const W=this.a.getValue({resource:U}),C={...this.l(W,D)||{},...H||{}},J=l.URI.isUri(y)?(0,b.$Dg)(y):y.name;return{folder:U,folderName:O?J:void 0,excludePattern:Object.keys(C).length>0?C:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!W.search.followSymlinks}}};e.$IK=h,e.$IK=h=Je([He(0,r.$yi),He(1,t.$bi),He(2,n.$8C),He(3,o.$mj),He(4,a.$GK)],h);function i(v){const y=v.match(/[\*\{\}\(\)\[\]\?]/);if(y){const D=y.index,N=v.substr(0,D).match(/[/|\\][^/\\]*$/);if(N){let O=v.substr(0,N.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:v.substr((N.index||0)+1)}}}return{pathPortion:v}}function s(...v){return v.length?v.reduce((y,D)=>(y[D]=!0,y),Object.create(null)):void 0}function u(v){return I.$Jj(v,",").map(y=>y.trim()).filter(y=>!!y.length)}function d(v){return[`**/${v}/**`,`**/${v}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function m(v){return v.replace(/\\/g,"/")}function f(v){return m(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(v){return v.replace(/([?*[\]])/g,"[$1]")}function L(v,y){v=E.$Mb(v,O=>O.toString());const D=[],N=y.getWorkspace();return v&&v.forEach(O=>{let H;if(y.getWorkbenchState()===2)H=(0,b.$Ig)(N.folders[0].uri,O),H&&H!=="."&&(H="./"+H);else{const U=y.getWorkspaceFolder(O);if(U){const W=U.name;if(N.folders.filter(C=>C.name===W).length===1){const C=(0,b.$Ig)(U.uri,O);C===""?H=`./${U.name}`:H=`./${U.name}/${C}`}else H=O.fsPath}}H&&D.push(S(H))}),D}e.$JK=L}),define(Pe[285],Re([1,0,25,2,20,15,4,284,44,47]),function(ge,e,E,T,I,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsb=e.$ksb=void 0;const A=7e3;function k(r,o){const t=o.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],a=[];for(const d of t)if(/^workspaceContains:/.test(d)){const m=d.substr(18);m.indexOf("*")>=0||m.indexOf("?")>=0||r.forceUsingSearch?a.push(m):n.push(m)}if(n.length===0&&a.length===0)return Promise.resolve(void 0);let c;const h=new Promise((d,m)=>{c=d}),i=d=>c({activationEvent:d}),s=Promise.all(n.map(d=>l(r,d,i))).then(()=>{}),u=p(r,o.identifier,a,i);return Promise.all([s,u]).then(()=>{c(void 0)}),h}e.$ksb=k;async function l(r,o,t){for(const n of r.folders)if(await r.exists(E.$Gg(T.URI.revive(n),o))){t(`workspaceContains:${o}`);return}}async function p(r,o,t,n){if(t.length===0)return Promise.resolve(void 0);const a=new I.$5d,c=r.checkExists(r.folders,t,a.token),h=setTimeout(async()=>{a.cancel(),r.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},A);let i=!1;try{i=await c}catch(s){M.$4(s)||M.$1(s)}a.dispose(),clearTimeout(h),i&&n(`workspaceContains:${t.join(",")}`)}function w(r,o,t,n){const a=r.get(R.$4h),c=r.get(g.$pJ),i=a.createInstance($.$IK).file(o.map(s=>(0,b.$ni)(T.URI.revive(s))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,n).then(s=>!!s.limitHit,s=>M.$4(s)?!1:Promise.reject(s))}e.$lsb=w}),define(Pe[38],Re([1,0,159,19,88,25,13,6,50,2,14,3,37,217,85,36,23,106,15,22,24,200,7,100,4,27,86,17,71,87,64,5,285,84,202,12,82,60,21,83]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c,h,i,s,u,d,m,f,S,L,v,y,D,N,O,H,U,W,P,C){"use strict";var J;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=void 0,e.$Qgc=(0,u.$5h)("IHostUtils");let ae=J=class extends $.$Tc{constructor(x,V,ne,Ie,Me,Ce,ce,ie,Q,te,me,pe){super(),this.X=pe,this.a=this.B(new y.$Ud),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ne,this.f=ce,this.j=Ie,this.m=Me,this.s=Ce,this.t=Q,this.u=te,this.w=me,this.y=this.g.getProxy(k.$5K.MainThreadWorkspace),this.z=this.g.getProxy(k.$5K.MainThreadTelemetry),this.C=this.g.getProxy(k.$5K.MainThreadExtensionService),this.D=new R.$4g,this.F=new R.$4g,this.G=new R.$4g,this.H=new R.$4g,this.I=new De(this.f.extensions.activationEvents),this.L=new t.$47b(this.I,this.f.extensions.allExtensions);const Ae=new a.$lm(this.f.extensions.myExtensions);this.J=new t.$47b(this.I,ve(this.L,Ae)),P.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ye(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ye(this.J)}`)),this.M=new w.$Bgc(this.g,this.s),this.N=new N.$Jgc(this.g),this.O=ie,this.h=x.createChild(new S.$3h([w.$Cgc,this.M],[N.$Kgc,this.N])),this.P=this.B(new p.$Agc(this.J,this.L,{onExtensionActivationError:(le,be,F)=>{this.C.$onExtensionActivationError(le,n.$3(be),F)},actualActivateExtension:async(le,be)=>{if(t.$47b.isHostExtension(le,this.J,this.L))return await this.C.$activateExtension(le,be),new p.$zgc;const F=this.J.getExtensionDescription(le);return this.db(F,be)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(x){n.$1(x)}}async Y(){this.O.onWillDeactivateAll();let x=[];try{x=this.J.getAllExtensionDescriptions().map(Me=>Me.identifier).filter(Me=>this.isActivated(Me)).map(Me=>this.cb(Me))}catch{}await Promise.all(x)}terminate(x,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${x}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$6g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(x){return this.G.isOpen()?this.P.isActivated(x):!1}async getExtension(x){const V=await this.C.$getExtension(x);return V&&{...V,identifier:new a.$km(V.identifier.value),extensionLocation:b.URI.revive(V.extensionLocation)}}Z(x,V){return this.P.activateByEvent(x,V)}$(x,V){return this.P.activateById(x,V)}activateByIdWithErrors(x,V){return this.$(x,V).then(()=>{const ne=this.P.getActivatedExtension(x);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(x=>this.J)}getExtensionExports(x){if(this.G.isOpen())return this.P.getActivatedExtension(x).exports;try{return this.P.getActivatedExtension(x).exports}catch{return null}}async ab(x){if(x.scheme===H.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(x.fsPath);return b.URI.file(V)}return x}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(x=>new ee(x))),this.Q}async bb(x){const V=g.$$h.forUris(ne=>M.$xg.ignorePathCasing(ne));return await Promise.all(x.map(async ne=>{if(this.ub(ne)){const Ie=await this.ab(ne.extensionLocation);V.set(Ie,ne)}})),V}cb(x){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(x))return V;const ne=this.P.getActivatedExtension(x);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${x.value}':`),this.s.error(Ie)}try{(0,$.$Oc)(ne.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this.s.error(Ie)}return V}async db(x,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(x.identifier):await this.C.$onWillActivateExtension(x.identifier),this.fb(x,V).then(ne=>{const Ie=ne.activationTimes;return this.C.$onDidActivateExtension(x.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(x,V,"success",Ie),ne},ne=>{throw this.eb(x,V,"failure"),ne})}eb(x,V,ne,Ie){const Me=we(x,V);this.z.$publicLog2("extensionActivationTimes",{...Me,...Ie||{},outcome:ne})}fb(x,V){const ne=we(x,V);this.z.$publicLog2("activatePlugin",ne);const Ie=this.ub(x);if(!Ie)return Promise.resolve(new p.$ygc(p.$vgc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${x.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Me=new p.$wgc(V.startup);return Promise.all([this.vb(x,(0,M.$Gg)(x.extensionLocation,Ie),Me),this.gb(x)]).then(Ce=>(I.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),J.hb(this.s,x.identifier,Ce[0],Ce[1],Me))).then(Ce=>(I.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Ce))}gb(x){const V=new h.$Egc(x,this.M),ne=new h.$Dgc(x.identifier.value,!1,this.M),Ie=new O.$Lgc(x,this.N),Me=x.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ce=this;let ie,Q;const te=(0,o.$BF)(x,"ipc")?this.f.messagePorts?.get(a.$km.toKey(x.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ie,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(me){return T.$jc(x.extensionLocation.fsPath,me)},get storagePath(){return ce.O.workspaceValue(x)?.fsPath},get globalStoragePath(){return ce.O.globalValue(x).fsPath},get logPath(){return T.$jc(ce.f.logsLocation.fsPath,x.identifier.value)},get logUri(){return b.URI.joinPath(ce.f.logsLocation,x.identifier.value)},get storageUri(){return ce.O.workspaceValue(x)},get globalStorageUri(){return ce.O.globalValue(x)},get extensionMode(){return Me},get extension(){return ie===void 0&&(ie=new he(ce,x.identifier,x,Ce,!1)),ie},get extensionRuntime(){return(0,o.$CF)(x,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!Q){if(!te)return;const me=y.Event.buffer(y.Event.fromDOMEventEmitter(te,"message",pe=>pe.data));te.start(),Q={onDidReceiveMessage:me,postMessage:te.postMessage.bind(te)}}return Q}})})}static hb(x,V,ne,Ie,Me){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(x,V,ne,Ie,Me).then(Ce=>new p.$xgc(!1,null,Me.build(),ne,Ce,Ie.subscriptions))}static ib(x,V,ne,Ie,Me){if(typeof ne.activate=="function")try{Me.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Ce=typeof global=="object"?global:self,ce=ne.activate.apply(Ce,[Ie]);return Me.activateCallStop(),Me.activateResolveStart(),Promise.resolve(ce).then(ie=>(Me.activateResolveStop(),ie))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(ne)}jb(x,V){this.$(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:V}).then(void 0,ne=>{this.s.error(ne)})}kb(x,V=0){const Ie=Date.now();(0,P.$B)(()=>{for(let Me=V;Me<x.length;Me+=1){const Ce=x[Me];for(const ce of Ce.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ie>50){this.kb(x,Me);break}else this.jb(Ce,ce)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(x=>{const V=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(V)this.kb(ne);else for(const Ie of ne)if(Ie.activationEvents)for(const Me of Ie.activationEvents)Me==="onStartupFinished"&&this.jb(Ie,Me)})}mb(){const x=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const V=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(V),Ie=this.pb(),Me=Promise.all([Ie,x,ne]).then(()=>{});return Promise.race([Me,(0,R.$6g)(1e4)]).then(()=>{this.lb()}),Me}nb(x){return x.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(x,V))).then(()=>{})}async ob(x,V){if(this.isActivated(V.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:x.map(Ce=>Ce.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,ce,ie)=>this.y.$checkExists(Ce,ce,ie)},Me=await(0,D.$ksb)(Ie,V);if(Me)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Me.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(x){throw console.error(x),x}}async qb(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:V}=this.f.environment;if(!x||!V)throw new Error(E.localize(0,null));const ne=await this.vb(null,V,new p.$wgc(!1));if(!ne||typeof ne.run!="function")throw new Error(E.localize(1,null,V.toString()));return new Promise((Ie,Me)=>{const Ce=(Q,te)=>{Q?(P.$t&&this.s.error("Test runner called back with error",Q),Me(Q)):(P.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof te=="number"&&te>0?1:0))},ce=(0,M.$ug)(V),ie=ne.run(ce,Ce);ie&&ie.then&&ie.then(()=>{P.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(Q=>{P.$t&&this.s.error("Test runner finished with error",Q),Me(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$6g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,V){return this.R[x]=V,(0,$.$Rc)(()=>{delete this.R[x]})}async getRemoteExecServer(x){const{resolver:V}=await this.sb(x);return V?.resolveExecServer?.(x,{resolveAttempt:0})}async sb(x){const V=x.indexOf("+");if(V===-1)throw new i.$aL("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=x.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(x,V){const ne=W.$Qd.create(!1),Ie=()=>`[resolveAuthority(${(0,s.$$k)(x)},${V})][${ne.elapsed()}ms] `,Me=K=>this.s.info(`${Ie()}${K}`),Ce=K=>this.s.warn(`${Ie()}${K}`),ce=(K,z=void 0)=>this.s.error(`${Ie()}${K}`,z),ie=K=>{if(K instanceof i.$aL)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K},Q=async K=>{Me(`activating resolver for ${K}...`);const{resolver:z,authorityPrefix:X}=await this.sb(K);if(!z)throw ce(`no resolver for ${X}`),new i.$aL(`No remote extension installed to resolve ${X}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:z,authorityPrefix:X,remoteAuthority:K}},te=x.split(/@|%40/g).reverse();Me(`activating remote resolvers ${te.join(" -> ")}`);let me;try{me=await Promise.all(te.map(Q)).catch(async K=>{if(!(K instanceof i.$aL)||K._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw K;return Ce(`resolving nested authorities failed: ${K.message}`),[await Q(x)]})}catch(K){return ie(K)}const pe=new R.$dh;pe.cancelAndSet(()=>Me("waiting..."),1e3);let Ae,le;for(const[K,{authorityPrefix:z,resolver:X,remoteAuthority:Y}]of me.entries())try{if(K===me.length-1)Me("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${z}`),Ae=await X.resolve(Y,{resolveAttempt:V,execServer:le}),I.mark(`code/extHost/didResolveAuthorityOK/${z}`),Me("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(X,i.$_K.isManagedResolvedAuthority(Ae)?Ae:void 0));else{if(Me(`invoking resolveExecServer() for ${Y}`),I.mark(`code/extHost/willResolveExecServer/${z}`),le=await X.resolveExecServer?.(Y,{resolveAttempt:V,execServer:le}),!le)throw new i.$aL(`Exec server was not available for ${Y}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${z}`)}}catch(Ee){return I.mark(`code/extHost/didResolveAuthorityError/${z}`),ce("returned an error",Ee),pe.dispose(),ie(Ee)}pe.dispose();const be={environmentTunnels:Ae.environmentTunnels,features:Ae.tunnelFeatures?{elevation:Ae.tunnelFeatures.elevation,privacyOptions:Ae.tunnelFeatures.privacyOptions,protocol:Ae.tunnelFeatures.protocol===void 0?!0:Ae.tunnelFeatures.protocol}:void 0},F={extensionHostEnv:Ae.extensionHostEnv,isTrusted:Ae.isTrusted,authenticationSession:Ae.authenticationSessionForInitializingExtensions?{id:Ae.authenticationSessionForInitializingExtensions.id,providerId:Ae.authenticationSessionForInitializingExtensions.providerId}:void 0};Me(`returned ${i.$_K.isManagedResolvedAuthority(Ae)?"managed authority":`${Ae.host}:${Ae.port}`}`);let q;if(i.$_K.isManagedResolvedAuthority(Ae)){const K=V;this.X.setFactory(K,Ae.makeConnection),q={authority:x,connectTo:new s.$8k(K),connectionToken:Ae.connectionToken}}else q={authority:x,connectTo:new s.$9k(Ae.host,Ae.port),connectionToken:Ae.connectionToken};return{type:"ok",value:{authority:q,options:F,tunnelInformation:be}}}async $getCanonicalURI(x,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$$k)(x)})`);const{resolver:ne}=await this.sb(x);if(!ne)return null;const Ie=b.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ie;const Me=await(0,R.$Xg)(()=>ne.getCanonicalURI(Ie));return Me||Ie}$startExtensionHost(x){x.toAdd.forEach(Ie=>Ie.extensionLocation=b.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ne}=fe(this.I,this.L,this.J,x);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),P.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ye(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ye(this.J)}`)),this.rb()}$activateByEvent(x,V){return V===1?this.D.wait().then(ne=>this.Z(x,!1)):this.G.wait().then(ne=>this.Z(x,!1))}async $activate(x,V){return await this.G.wait(),this.J.getExtensionDescription(x)?(await this.$(x,V),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(Ce=>Ce.extensionLocation=b.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ne}=fe(this.I,this.L,this.J,x),Ie=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),P.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ye(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ye(this.J)}`)),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const V=c.$ie.alloc(x),ne=Math.random()%256;for(let Ie=0;Ie<x;Ie++)V.writeUInt8(ne,Ie);return V}async $updateRemoteConnectionData(x){this.W=x,this.a.fire()}};e.$Rgc=ae,e.$Rgc=ae=J=Je([He(0,u.$4h),He(1,e.$Qgc),He(2,f.$9M),He(3,r.$egc),He(4,l.$hgc),He(5,A.$mj),He(6,d.$mN),He(7,m.$kgc),He(8,L.$hyb),He(9,v.$Fgc),He(10,U.$Ngc),He(11,C.$Ogc)],ae);function fe(se,x,V,ne){se.addActivationEvents(ne.addActivationEvents);const Ie=new t.$47b(se,x.getAllExtensionDescriptions());Ie.deltaExtensions(ne.toAdd,ne.toRemove);const Me=new a.$lm(V.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)Me.delete(ce);for(const ce of ne.myToAdd)Me.add(ce);const Ce=ve(Ie,Me);return{globalRegistry:Ie,myExtensions:Ce}}function we(se,x){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}function ye(se){return se.getAllExtensionDescriptions().map(x=>x.identifier.value).join(",")}e.$Sgc=(0,u.$5h)("IExtHostExtensionService");class he{#e;#t;#i;constructor(x,V,ne,Ie,Me){this.#e=x,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$hc((0,M.$ug)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Me}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Tgc=he;function ve(se,x){return se.getAllExtensionDescriptions().filter(V=>x.has(V.identifier))}class ee{constructor(x){this.a=x}setSearchTree(x){this.a=x}findSubstr(x){return this.a.findSubstr(x)}forEach(x){return this.a.forEach(x)}}e.$Ugc=ee;class De{constructor(x){this.a=new a.$mm,this.addActivationEvents(x)}readActivationEvents(x){return this.a.get(x.identifier)??[]}addActivationEvents(x){for(const V of Object.keys(x))this.a.set(V,x[V])}}}),define(Pe[286],Re([1,0,88,2,3,37,23,22,17,27,4,38,14,11]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;let r=class{constructor(c,h,i,s,u,d,m){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.h=d,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$3hc=r,e.$3hc=r=Je([He(2,A.$4h),He(3,M.$hgc),He(4,k.$Sgc),He(5,b.$mN),He(6,l.$mj)],r);let o=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&w.a.size){const h=(0,p.$Ne)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,s,u]=h,d=w.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),i+d+u}c(c){return c.replace(/\\/g,"/")}};o=w=Je([He(0,b.$mN)],o);class t{constructor(c,h,i,s,u){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.nodeModuleName="vscode",this.a=new $.$mm}load(c,h){const i=this.d.findSubstr(h);if(i){let s=this.a.get(i.identifier);return s||(s=this.c(i,this.e,this.f),this.a.set(i.identifier,s)),s}if(!this.b){let s="";this.d.forEach((u,d)=>s+=`	${d} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$wF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.$5K.MainThreadTelemetry);const s=i.getProxy(I.$5K.MainThreadWindow);this.c=(u,d)=>{const m=T.URI.parse(u);return d?this.g(u,d):m.scheme==="http"||m.scheme==="https"?s.$openUri(m,u,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?s.$openUri(m,u,{}):this.g(u,d)}}load(c,h,i){const s=this.e.findSubstr(h);return s&&(this.a=s.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([He(2,g.$9M)],n)}),define(Pe[116],Re([1,0,39,6,19,74,4,61,62,38,7,36,214,37]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=void 0,e.$Vgc=(0,R.$5h)("IExtHostVariableResolverProvider");class w extends l.$0N{constructor(t,n,a,c,h,i,s){function u(){if(a){const d=a.activeEditor();if(d)return d.document.uri;const m=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(m!==void 0){if(m.input instanceof A.$NM||m.input instanceof A.$SM)return m.input.modified;if(m.input instanceof A.$MM||m.input instanceof A.$RM||m.input instanceof A.$PM)return m.input.uri}}}super({getFolderUri:d=>{const m=i.folders.filter(f=>f.name===d);if(m&&m.length>0)return m[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(d,m)=>h.getConfiguration(void 0,d).get(m),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=u();if(d)return I.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const d=u();if(d){const m=n.getWorkspaceFolder(d);if(m)return I.$hc(m.uri.fsPath)}}},getSelectedText:()=>{if(a){const d=a.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(a){const d=a.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>t.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let r=class extends T.$Tc{constructor(t,n,a,c,h){super(),this.b=t,this.c=n,this.g=a,this.h=c,this.j=h,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$Wgc=r,e.$Wgc=r=Je([He(0,b.$Sgc),He(1,k.$egc),He(2,$.$hN),He(3,p.$hgc),He(4,g.$tgc)],r)}),define(Pe[117],Re([1,0,13,5,2,4,3,62,38,17,7,36,206,208,37,116]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=e.$Zgc=e.$Ygc=e.$Xgc=void 0,e.$Xgc=(0,M.$5h)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,u,d,m,f,S){this.E=u,this.F=d,this.G=m,this.H=f,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Ud,this.n=new T.$Ud,this.o=new T.$Ud,this.u=new T.$Ud,this.k=s.getProxy(R.$5K.MainThreadDebugService),this.y=new T.$Ud,this.A=new T.$Ud,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(v=>{this.J(L)}),this.J(L)})}asDebugSourceUri(s,u){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let m=`debug:${encodeURIComponent(d.path||"")}`,f="?";return u&&(m+=`${f}session=${encodeURIComponent(u.id)}`,f="&"),m+=`${f}ref=${d.sourceReference}`,I.URI.parse(m)}else{if(d.path)return I.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const u=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const m=d.contributes.debuggers;if(m&&m.length>0)for(const f of m)(0,p.$bG)(f)&&u.push(f.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(u=>s.push(u)),s}addBreakpoints(s){const u=s.filter(f=>{const S=f.id;return this.w.has(S)?!1:(this.w.set(S,f),!0)});this.U(u,[],[]);const d=[],m=new Map;for(const f of u)if(f instanceof A.$7L){let S=m.get(f.location.uri.toString());S||(S={type:"sourceMulti",uri:f.location.uri,lines:[]},m.set(f.location.uri.toString(),S),d.push(S)),S.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.$8L&&d.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const u=s.filter(S=>this.w.delete(S.id));this.U([],u,[]);const d=u.filter(S=>S instanceof A.$7L).map(S=>S.id),m=u.filter(S=>S instanceof A.$8L).map(S=>S.id),f=u.filter(S=>S instanceof A.$9L).map(S=>S.id);return this.k.$unregisterBreakpoints(d,m,f)}startDebugging(s,u,d){return this.k.$startDebugging(s?s.uri:void 0,u,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,u,d){if(!u)return new A.$7K(()=>{});const m=this.d++;return this.f.push({type:s,handle:m,provider:u}),this.k.$registerDebugConfigurationProvider(s,d,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,m),new A.$7K(()=>{this.f=this.f.filter(f=>f.provider!==u),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(s,u,d){if(!d)return new A.$7K(()=>{});if(!this.Q(s,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:u,handle:m,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(u,m),new A.$7K(()=>{this.h=this.h.filter(f=>f.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(s,u){if(!u)return new A.$7K(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:u}),new A.$7K(()=>{this.j=this.j.filter(m=>m.factory!==u)})}async $runInTerminal(s,u){return Promise.resolve(void 0)}async $substituteVariables(s,u){let d;const m=await this.W(s);return m&&(d={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,u)}K(s,u){if(s.type==="implementation")return new c(s.implementation)}L(){}async $startDASession(s,u){const d=this,m=await this.V(u);return this.S(this.N(m.type),m).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const S=this.M(f),L=this.K(S,m);if(!L)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const v=L;return this.B.set(s,v),this.R(m).then(y=>(y&&this.C.set(s,y),v.onMessage(async D=>{if(D.type==="request"&&D.command==="handshake"){const N=D,O={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const H=await this.D.sign(N.arguments.value);O.body={signature:H},v.sendResponse(O)}else throw new Error("no signer")}catch(H){O.success=!1,O.message=H.message,v.sendResponse(O)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(D),D=(0,p.$gG)(D,!0),d.k.$acceptDAMessage(s,D)}),v.onError(D=>{y&&y.onError&&y.onError(D),this.k.$acceptDAError(s,D.name,D.message,D.stack)}),v.onExit(D=>{y&&y.onExit&&y.onExit(D??void 0,void 0),this.k.$acceptDAExit(s,D??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),v.startSession()))})}$sendDAMessage(s,u){u=(0,p.$fG)(u,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(u),this.B.get(s)?.sendMessage(u)}$stopDASession(s){const u=this.C.get(s);this.C.delete(s),u&&u.onWillStopSession&&u.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const u=[],d=[],m=[];if(s.added)for(const f of s.added){const S=f.id;if(S&&!this.w.has(S)){let L;if(f.type==="function")L=new A.$8L(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")L=new A.$9L(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const v=I.URI.revive(f.uri);L=new A.$7L(new A.$gL(v,new A.$8K(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,A.$5L)(L,S),this.w.set(S,L),u.push(L)}}if(s.removed)for(const f of s.removed){const S=this.w.get(f);S&&(this.w.delete(f),d.push(S))}if(s.changed){for(const f of s.changed)if(f.id){const S=this.w.get(f.id);if(S){if(S instanceof A.$8L&&f.type==="function"){const L=S;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.functionName=f.functionName}else if(S instanceof A.$7L&&f.type==="source"){const L=S;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.location=new A.$gL(I.URI.revive(f.uri),new A.$8K(f.line,f.character))}m.push(S)}}}this.U(u,d,m)}async $acceptStackFrameFocus(s){let u;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?u=new A.$cM(d,s.threadId):u=new A.$bM(d,s.threadId,s.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(s,u,d){return(0,E.$Xg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(u);return m.provideDebugConfigurations(f,d)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(s,u,d,m){return(0,E.$Xg)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(u);return f.resolveDebugConfiguration(S,d,m)})}$resolveDebugConfigurationWithSubstitutedVariables(s,u,d,m){return(0,E.$Xg)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(u);return f.resolveDebugConfigurationWithSubstitutedVariables(S,d,m)})}async $provideDebugAdapter(s,u){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(u);return this.S(d,m).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(s){const u=await this.V(s);this.m.fire(u)}async $acceptDebugSessionTerminated(s){const u=await this.V(s);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,u){(await this.V(s))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(s,u){const m={session:await this.V(s),event:u.event,body:u.body};this.u.fire(m)}M(s){if(s instanceof A.$0L)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$$L)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$_L)return{type:"pipeServer",path:s.path};if(s instanceof A.$aM)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const u=this.h.filter(d=>d.type===s);if(u.length>0)return u[0].factory}O(s){const u=this.h.filter(d=>d.handle===s);if(u.length>0)return u[0].factory}P(s){const u=this.f.filter(d=>d.handle===s);if(u.length>0)return u[0].provider}Q(s,u){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const m of d)if(m.label&&m.type&&m.type===u)return!0}}return!1}R(s){const d=s.configuration.type,m=this.j.filter(f=>f.type===d||f.type==="*").map(f=>(0,E.$Xg)(()=>f.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all(m).then(f=>{const S=f.filter(L=>!!L);if(S.length>0)return new a(S)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(s,u){const d=u.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new A.$$L(d));if(s){const f=await this.F.getExtensionRegistry();return(0,E.$Xg)(()=>s.createDebugAdapterDescriptor(u,this.T(u,f))).then(S=>{if(S)return S})}const m=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,m))}T(s,u){}U(s,u,d){(s.length>0||u.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:u,changed:d}))}async V(s){if(s)if(typeof s=="string"){const u=this.l.get(s);if(u)return u}else{let u=this.l.get(s.id);if(!u){const d=await this.W(s.folderUri),m=s.parent?this.l.get(s.parent):void 0;u=new t(this.k,s.id,s.type,s.name,d,s.configuration,m),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(s){if(s){const u=I.URI.revive(s);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$Ygc=o,e.$Ygc=o=Je([He(0,b.$9M),He(1,k.$egc),He(2,g.$Sgc),He(3,w.$hgc),He(4,$.$tgc),He(5,r.$Vgc)],o);class t{constructor(s,u,d,m,f,S,L){this.d=s,this.f=u,this.g=d,this.h=m,this.i=f,this.j=S,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,u){return this.d.$customDebugAdapterRequest(this.f,s,u)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Zgc=t;class n{constructor(s){this.value=Object.freeze({append(u){s.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$1gc=n;class a{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(u=>u.onError?u.onError(s):void 0)}onExit(s,u){this.d.forEach(d=>d.onExit?d.onExit(s,u):void 0)}}class c extends l.$Clb{constructor(s){super(),this.h=s,s.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends o{constructor(s,u,d,m,f,S){super(s,u,d,m,f,S)}};e.$2gc=h,e.$2gc=h=Je([He(0,b.$9M),He(1,k.$egc),He(2,g.$Sgc),He(3,w.$hgc),He(4,$.$tgc),He(5,r.$Vgc)],h)}),define(Pe[287],Re([1,0,15,88,2,3,275,14,70,71,27,184,17,57,38,59]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=e.$4hc=void 0;class o{static async installEarlyHandler(a){Error.stackTraceLimit=100;const c=a.get($.$mj),i=a.get(l.$9M).getProxy(M.$5K.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{c.error(s);const u=E.$3(s);i.$onUnexpectedError(u)})}static async installFullHandler(a){const c=a.get($.$mj),h=a.get(l.$9M),i=a.get(w.$Sgc),s=a.get(r.$qN),u=h.getProxy(M.$5K.MainThreadExtensionService),d=h.getProxy(M.$5K.MainThreadErrors),m=await i.getExtensionPathIndex(),f=new WeakMap;function S(y,D){if(f.has(y))return f.get(y).stack;let N="",O,H;for(const W of D)N+=`
	at ${W.toString()}`,H=W.getFileName(),!O&&H&&(O=m.findSubstr(I.URI.file(H)));const U=`${y.name||"Error"}: ${y.message||""}${N}`;return f.set(y,{extensionIdentifier:O?.identifier,stack:U}),U}const L=Symbol("prepareStackTrace wrapped");let v=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(y){if(y===S||!y||y[L]){v=y||S;return}v=function(D,N){return S(D,N),y.call(Error,D,N)},Object.assign(v,{[L]:!0})}}),E.setUnexpectedErrorHandler(y=>{c.error(y);const D=E.$3(y),N=f.get(y);if(!N?.extensionIdentifier){d.$onUnexpectedError(D);return}u.$onExtensionRuntimeError(N.extensionIdentifier,D);const O=s.onExtensionError(N.extensionIdentifier,y);c.trace("forwarded error to extension?",O,N)})}}e.$4hc=o;class t{constructor(a,c,h,i,s){this.a=h,this.b=new R.$_7b(a,null,i),c=t.e(c,this.b);const u=new b.$3h(...(0,g.$Yr)());u.set(A.$mN,{_serviceBrand:void 0,...c,messagePorts:s}),u.set(l.$9M,new l.$0M(this.b)),u.set(p.$bgc,new p.$cgc(i)),u.set(w.$Qgc,h);const d=new k.$Dq(u,!0);d.invokeFunction(o.installEarlyHandler),this.d=d.invokeFunction(m=>m.get($.$mj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(m=>m.get(w.$Sgc)),this.c.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(a){const c=this.b.getProxy(M.$5K.MainThreadExtensionService);return I.URI.revive(await c.$asBrowserUri(a))}terminate(a){this.c.terminate(a)}static e(a,c){a.extensions.allExtensions.forEach(i=>{i.extensionLocation=I.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),a.environment.appRoot=I.URI.revive(c.transformIncomingURIs(a.environment.appRoot));const h=a.environment.extensionDevelopmentLocationURI;return h&&(a.environment.extensionDevelopmentLocationURI=h.map(i=>I.URI.revive(c.transformIncomingURIs(i)))),a.environment.extensionTestsLocationURI=I.URI.revive(c.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=I.URI.revive(c.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=I.URI.revive(c.transformIncomingURIs(a.environment.workspaceStorageHome)),a.environment.extensionTelemetryLogResource=I.URI.revive(c.transformIncomingURIs(a.environment.extensionTelemetryLogResource)),a.nlsBaseUrl=I.URI.revive(c.transformIncomingURIs(a.nlsBaseUrl)),a.logsLocation=I.URI.revive(c.transformIncomingURIs(a.logsLocation)),a.workspace=c.transformIncomingURIs(a.workspace),a}}e.$5hc=t}),define(Pe[288],Re([1,0,18,13,20,40,12,19,25,2,44]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=e.$fhc=e.$ehc=e.$dhc=void 0;class k{constructor(n,a,c,h){this.d=n,this.e=a,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,a){const c=this.d.folderQueries||[],h=new I.$5d(a);return new Promise((i,s)=>{this.a=new p(n);let u=!1;const d=(m,f)=>{if(!u&&!this.b){const S=this.h(m);r(m)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,u=!0,h.cancel(),m=this.j(m,this.d.maxResults-this.c));const L=this.h(m);this.c+=L,(L>0||!r(m))&&this.a.add(m,f)}};Promise.all(c.map((m,f)=>this.k(m,S=>d(S,f),h.token))).then(m=>{h.dispose(),this.a.flush();const f=m.some(S=>!!S&&!!S.limitHit);i({limitHit:this.b||f,messages:(0,E.$Rb)(m.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},m=>{h.dispose();const f=(0,M.$Pi)(m);s(new Error(f))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,a){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,a),preview:{matches:h.slice(0,a),text:n.preview.text},uri:n.uri}}async k(n,a,c){const h=new A.$IJ(this.d,n),i=[],s={report:m=>{if(!this.l(m))return;const f=n.folder.scheme===R.Schemas.file?(0,A.$JJ)(()=>this.f.readdir(g.$Fg(m.uri))):void 0,S=g.$Ig(n.folder,m.uri);if(S){const L=h.includedInQuery(S,$.$nc(S),f);(0,T.$Rg)(L)?i.push(L.then(v=>{v&&a(m)})):L&&a(m)}}},u=this.n(n),d=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,s,c);return i.length&&await Promise.all(i),d}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const a=(0,A.$HJ)(this.d.includePattern,n.includePattern),c=(0,A.$HJ)(this.d.excludePattern,n.excludePattern),h={folder:b.URI.from(n.folder),excludes:c,includes:a,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$dhc=k;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class p{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,a=>this.g(a))}add(n,a){this.d&&(this.b!==a||!g.$zg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=a,this.d={resource:n.uri,results:[]}),this.d.results.push(w(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$ehc=p;function w(t){return r(t)?{preview:{matches:(0,E.$2b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,E.$2b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function r(t){return!!t.preview}e.$fhc=r;class o{static{this.a=4e3}static{this.b=50}constructor(n,a){this.g=n,this.h=a,this.c=0,this.d=[],this.e=0}addItem(n,a){n&&this.j(n,a)}addItems(n,a){n&&this.k(n,a)}j(n,a){this.d.push(n),this.e+=a,this.l()}k(n,a){this.d=this.d.concat(n),this.e+=a,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$ghc=o}),define(Pe[118],Re([1,0,6,3,4,283,17,57,14,2,288]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=e.$ihc=e.$hhc=void 0,e.$hhc=(0,I.$5h)("IExtHostSearch");let k=class{constructor(r,o,t){this.k=r,this.l=o,this.n=t,this.c=this.k.getProxy(T.$5K.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$chc}o(r){return this.l.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const t=this.d++;return this.e.set(t,o),this.c.$registerTextSearchProvider(t,this.o(r)),(0,E.$Rc)(()=>{this.g.delete(r),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(r,o){if(this.i.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.i.add(r);const t=this.d++;return this.h.set(t,o),this.c.$registerFileSearchProvider(t,this.o(r)),(0,E.$Rc)(()=>{this.i.delete(r),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(r,o,t,n){const a=l(t),c=this.h.get(r);if(c)return this.j.fileSearch(a,c,h=>{this.c.$handleFileMatch(r,o,h.map(i=>i.resource))},n);throw new Error("unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,t){return{messages:[]}}$clearCache(r){return this.j.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,t,n){const a=this.e.get(r);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const c=l(t);return this.q(c,a).search(i=>this.c.$handleTextMatch(r,o,i),n)}$enableExtensionHostSearch(){}q(r,o){return new A.$dhc(r,o,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$ihc=k,e.$ihc=k=Je([He(0,R.$9M),He(1,$.$bgc),He(2,g.$mj)],k);function l(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(p),extraFileResources:w.extraFileResources&&w.extraFileResources.map(r=>b.URI.revive(r))}}e.$jhc=l;function p(w){return{...w,folder:b.URI.revive(w.folder)}}}),define(Pe[289],Re([1,0,20,15,5,6,12,31,2,146,142,130,93,22,42,14,55,56,197,3,230,238,81,231,232,233,234,235,236,237,212,32,239,37,271,117,110,241,242,243,219,244,61,62,246,38,247,63,248,43,27,249,250,251,252,253,254,82,83,256,282,221,201,222,257,258,112,259,223,260,261,17,262,118,84,263,264,265,85,86,115,59,64,266,267,209,268,224,87,8,7,269,57,270,65,272,273,111,36,207,79,23,114]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c,h,i,s,u,d,m,f,S,L,v,y,D,N,O,H,U,W,P,C,J,ae,fe,we,ye,he,ve,ee,De,se,x,V,ne,Ie,Me,Ce,ce,ie,Q,te,me,pe,Ae,le,be,F,q,K,z,X,Y,Ee,Te,We,Ke,Ze,st,nt,tt,at,ct,je,vt,Z,_,$e,Be,Qe,it,rt,Ne,Pt,Tt,Kt,Bt,yt,Ht,Nt,Xt,Ut,Rt,Ye,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;function Jt(lt){const $t=lt.get(x.$mN),jt=lt.get(se.$Vfc),Wt=lt.get(ee.$jgc),Dt=lt.get(he.$Sgc),dt=lt.get(Xt.$egc),Ct=lt.get(je.$qN),xt=lt.get(N.$hgc),kt=lt.get(Tt.$bgc),qe=lt.get(Ee.$9M),Mt=lt.get(tt.$Cgc),Vt=lt.get(at.$kgc),Qt=lt.get(r.$nj),ft=lt.get(r.$mj),Ft=lt.get(it.$hyb),Se=lt.get(i.$Yfc),Fe=lt.get(Nt.$Xhc),de=lt.get(Ke.$Kgc),G=lt.get(we.$tgc),Le=lt.get(Q.$Ogc);qe.set(a.$6K.ExtHostFileSystemInfo,jt),qe.set(a.$6K.ExtHostLogLevelServiceShape,Qt),qe.set(a.$6K.ExtHostWorkspace,dt),qe.set(a.$6K.ExtHostConfiguration,xt),qe.set(a.$6K.ExtHostExtensionService,Dt),qe.set(a.$6K.ExtHostStorage,Mt),qe.set(a.$6K.ExtHostTunnelService,Ft),qe.set(a.$6K.ExtHostWindow,Fe),qe.set(a.$6K.ExtHostSecretState,de),qe.set(a.$6K.ExtHostTelemetry,Ct),qe.set(a.$6K.ExtHostEditorTabs,G),qe.set(a.$6K.ExtHostManagedSockets,Le);const ze=qe.set(a.$6K.ExtHostDecorations,lt.get(U.$4gc)),Xe=qe.set(a.$6K.ExtHostDocumentsAndEditors,lt.get(fe.$hN)),Ve=qe.set(a.$6K.ExtHostCommands,lt.get(y.$sN)),_e=qe.set(a.$6K.ExtHostTerminalService,lt.get(vt.$Fgc)),mt=qe.set(a.$6K.ExtHostDebugService,lt.get(H.$Xgc)),zt=qe.set(a.$6K.ExtHostSearch,lt.get(We.$hhc)),Et=qe.set(a.$6K.ExtHostTask,lt.get(ct.$Khc)),St=qe.set(a.$6K.ExtHostOutputService,lt.get(q.$xhc)),bt=qe.set(a.$6K.ExtHostLocalization,lt.get(ie.$Ngc)),gi=qe.set(a.$6K.ExtHostUrls,new Kt.$Uhc(qe)),At=qe.set(a.$6K.ExtHostDocuments,new ae.$Tfc(qe,Xe)),Si=qe.set(a.$6K.ExtHostDocumentContentProviders,new C.$6gc(qe,Xe,ft)),Gi=qe.set(a.$6K.ExtHostDocumentSaveParticipant,new J.$7gc(ft,At,qe.getProxy(a.$5K.MainThreadBulkEdits))),It=qe.set(a.$6K.ExtHostNotebook,new me.$khc(qe,Ve,Xe,At,Wt,zt)),ri=qe.set(a.$6K.ExtHostNotebookDocuments,new Ae.$rhc(It)),mi=qe.set(a.$6K.ExtHostNotebookEditors,new le.$shc(ft,It)),ci=qe.set(a.$6K.ExtHostNotebookKernels,new be.$thc(qe,$t,It,Ve,ft)),Ii=qe.set(a.$6K.ExtHostNotebookRenderers,new F.$vhc(qe,It)),Ci=qe.set(a.$6K.ExtHostNotebookDocumentSaveParticipant,new pe.$qhc(ft,It,qe.getProxy(a.$5K.MainThreadBulkEdits))),Ot=qe.set(a.$6K.ExtHostEditors,new _.$$fc(qe,Xe)),$i=qe.set(a.$6K.ExtHostTreeViews,new Qe.$Shc(qe.getProxy(a.$5K.MainThreadTreeViews),Ve,ft)),Pi=qe.set(a.$6K.ExtHostEditorInsets,new v.$_fc(qe.getProxy(a.$5K.MainThreadEditorInsets),Ot,$t.remote)),ui=qe.set(a.$6K.ExtHostDiagnostics,new W.$Xfc(qe,ft,jt,Xe)),li=qe.set(a.$6K.ExtHostLanguages,new ce.$ohc(qe,At,Ve.converter,kt)),ht=qe.set(a.$6K.ExtHostLanguageFeatures,new Ce.$2fc(qe,kt,At,Ve,ui,ft,Se,Ct)),Ji=qe.set(a.$6K.ExtHostFileSystem,new ve.$9gc(qe,ht)),_t=qe.set(a.$6K.ExtHostFileSystemEventService,new De.$0gc(qe,ft,Xe)),si=qe.set(a.$6K.ExtHostQuickOpen,(0,Y.$Bhc)(qe,dt,Ve)),pi=qe.set(a.$6K.ExtHostSCM,new Te.$Dhc(qe,Ve,At,ft)),Ri=qe.set(a.$6K.ExtHostQuickDiff,new X.$Ahc(qe,kt)),Qi=qe.set(a.$6K.ExtHostShare,new Ze.$Ehc(qe,kt)),Ai=qe.set(a.$6K.ExtHostComments,(0,D.$agc)(qe,Ve,At)),vi=qe.set(a.$6K.ExtHostProgress,new z.$zhc(qe.getProxy(a.$5K.MainThreadProgress))),Xi=qe.set(a.$6K.ExtHostLabelService,new Me.$nhc(qe)),Li=qe.set(a.$6K.ExtHostTheming,new $e.$Phc(qe)),hi=qe.set(a.$6K.ExtHostAuthentication,new s.$4fc(qe)),Zi=qe.set(a.$6K.ExtHostTimeline,new Be.$Rhc(qe,Ve)),wi=qe.set(a.$6K.ExtHostWebviews,new Bt.$ogc(qe,$t.remote,dt,ft,Se)),Mi=qe.set(a.$6K.ExtHostWebviewPanels,new yt.$rgc(qe,wi,dt)),un=qe.set(a.$6K.ExtHostCustomEditors,new O.$sgc(qe,At,Vt,wi,Mi)),Fi=qe.set(a.$6K.ExtHostWebviewViews,new Ht.$Vhc(qe,wi)),oi=qe.set(a.$6K.ExtHostTesting,new Z.$Lhc(qe,ft,Ve,Xe)),ln=qe.set(a.$6K.ExtHostUriOpeners,new Pt.$Thc(qe)),hn=qe.set(a.$6K.ExtHostProfileContentHandlers,new K.$yhc(qe));qe.set(a.$6K.ExtHostInteractive,new ne.$lhc(qe,It,Xe,Ve,ft));const Yi=qe.set(a.$6K.ExtHostInlineChat,new V.$$gc(qe,Ve,At,ft)),di=qe.set(a.$6K.ExtHostChatProvider,new f.$7fc(qe,ft)),xi=qe.set(a.$6K.ExtHostChatAgents2,new m.$8fc(qe,di,ft)),_i=qe.set(a.$6K.ExtHostChatVariables,new S.$9fc(qe)),bi=qe.set(a.$6K.ExtHostChat,new d.$6fc(qe)),en=qe.set(a.$6K.ExtHostAiRelatedInformation,new c.$Sfc(qe)),Ti=qe.set(a.$6K.ExtHostAiEmbeddingVector,new ye.$8gc(qe)),Ni=qe.set(a.$6K.ExtHostIssueReporter,new Ie.$mhc(qe)),ei=qe.set(a.$6K.ExtHostStatusBar,new nt.$Hhc(qe,Ve.converter)),yi=qe.set(a.$6K.ExtHostSpeech,new st.$Fhc(qe)),dn=Object.values(a.$6K);qe.assertRegistered(dn);const Zt=new u.$5fc(qe,Xe),Ei=new L.$0fc(qe),Di=new te.$phc(qe,ft),Oi=new P.$5gc(qe);return h.$3fc.register(Ve),function(Ue,ti,tn){function et(re){return(ue,Oe,ot)=>{const wt=re(Lt=>{try{ue.call(Oe,Lt)}catch(cn){T.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event`,{cause:cn})),Ct.onExtensionError(Ue.identifier,cn)}});return ot?.push(wt),wt}}const pt=function(){let re=!Ue.isUnderDevelopment;function ue(){re||(ft.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(ot){if(Array.isArray(ot))ot.forEach(Oe);else if(typeof ot=="string")ue();else{const wt=ot;typeof wt.scheme>"u"&&ue(),typeof wt.exclusive=="boolean"&&(0,Ye.$CF)(Ue,"documentFiltersExclusive")}return ot}}(),fn={getSession(re,ue,Oe){return hi.getSession(Ue,re,ue,Oe)},getSessions(re,ue){return(0,Ye.$CF)(Ue,"authGetSessions"),hi.getSessions(Ue,re,ue)},async hasSession(re,ue){return(0,Ye.$CF)(Ue,"authSession"),!!await hi.getSession(Ue,re,ue,{silent:!0})},get onDidChangeSessions(){return et(hi.onDidChangeSessions)},registerAuthenticationProvider(re,ue,Oe,ot){return hi.registerAuthenticationProvider(re,ue,Oe,ot)}},gn={registerCommand(re,ue,Oe){return Ve.registerCommand(!0,re,ue,Oe,void 0,Ue)},registerTextEditorCommand(re,ue,Oe){return Ve.registerCommand(!0,re,(...ot)=>{const wt=Ot.getActiveTextEditor();if(!wt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Lt=>{ue.apply(Oe,[wt,Lt,...ot])}).then(Lt=>{Lt||ft.warn("Edits from command "+re+" were not applied.")},Lt=>{ft.warn("An error occurred while running command "+re,Lt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(re,ue,Oe)=>((0,Ye.$CF)(Ue,"diffCommand"),Ve.registerCommand(!0,re,async(...ot)=>{const wt=Xe.activeEditor(!0);if(!wt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(wt.id);ue.apply(Oe,[Lt,...ot])},void 0,void 0,Ue)),executeCommand(re,...ue){return Ve.executeCommand(re,...ue)},getCommands(re=!1){return Ve.getCommands(re)}},Ui={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return _e.getDefaultShell(!1)},get onDidChangeShell(){return et(_e.onDidChangeShell)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return et(Ct.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$CF)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$CF)(Ue,"telemetry"),et(Ct.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,je.$pN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,ue){return je.$oN.validateSender(re),Ct.instantiateLogger(Ue,re,ue)},openExternal(re,ue){return Fe.openUri(re,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===$t.environment.appUriScheme)return gi.createAppUri(re);try{return await Fe.asExternalUri(re,{allowTunneling:!!$t.remote.authority})}catch(ue){if((0,R.$dg)(re,R.Schemas.http)||(0,R.$dg)(re,R.Schemas.https))return re;throw ue}},get remoteName(){return(0,o.$al)($t.remote.authority)},get remoteAuthority(){return(0,Ye.$CF)(Ue,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return et(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(re){return(0,Ye.$CF)(Ue,"handleIssueUri"),Ni.registerIssueUriRequestHandler(Ue,re)},registerIssueDataProvider(re){return(0,Ye.$CF)(Ue,"handleIssueUri"),Ni.registerIssueDataProvider(Ue,re)},get appQuality(){return(0,Ye.$CF)(Ue,"resolvers"),$t.quality},get appCommit(){return(0,Ye.$CF)(Ue,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Ui);const ji={createTestController(re,ue,Oe){return oi.createTestController(Ue,re,ue,Oe)},createTestObserver(){return(0,Ye.$CF)(Ue,"testObserver"),oi.createTestObserver()},runTests(re){return(0,Ye.$CF)(Ue,"testObserver"),oi.runTests(re)},get onDidChangeTestResults(){return(0,Ye.$CF)(Ue,"testObserver"),et(oi.onResultsChanged)},get testResults(){return(0,Ye.$CF)(Ue,"testObserver"),oi.results}},fi=$t.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,nn={getExtension(re,ue){(0,Ye.$BF)(Ue,"extensionsAny")||(ue=!1);const Oe=ti.mine.getExtensionDescription(re);if(Oe)return new he.$Tgc(Dt,Ue.identifier,Oe,fi,!1);if(ue){const ot=ti.all.getExtensionDescription(re);if(ot)return new he.$Tgc(Dt,Ue.identifier,ot,fi,!0)}},get all(){const re=[];for(const ue of ti.mine.getAllExtensionDescriptions())re.push(new he.$Tgc(Dt,Ue.identifier,ue,fi,!1));return re},get allAcrossExtensionHosts(){(0,Ye.$CF)(Ue,"extensionsAny");const re=new p.$lm(ti.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ti.all.getAllExtensionDescriptions()){const ot=!re.has(Oe.identifier);ue.push(new he.$Tgc(Dt,Ue.identifier,Oe,fi,ot))}return ue},get onDidChange(){return(0,Ye.$BF)(Ue,"extensionsAny")?et(I.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):et(ti.mine.onDidChange)}},rn={createDiagnosticCollection(re){return ui.createDiagnosticCollection(Ue.identifier,re)},get onDidChangeDiagnostics(){return et(ui.onDidChangeDiagnostics)},getDiagnostics:re=>ui.getDiagnostics(re),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(re,ue){return li.changeLanguage(re.uri,ue)},match(re,ue){const Oe=At.getDocumentData(ue.uri)?.notebook;return(0,A.$At)(rt.LanguageSelector.from(re),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,ue,Oe){return ht.registerCodeActionProvider(Ue,pt(re),ue,Oe)},registerDocumentPasteEditProvider(re,ue,Oe){return(0,Ye.$CF)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,pt(re),ue,Oe)},registerCodeLensProvider(re,ue){return ht.registerCodeLensProvider(Ue,pt(re),ue)},registerDefinitionProvider(re,ue){return ht.registerDefinitionProvider(Ue,pt(re),ue)},registerDeclarationProvider(re,ue){return ht.registerDeclarationProvider(Ue,pt(re),ue)},registerImplementationProvider(re,ue){return ht.registerImplementationProvider(Ue,pt(re),ue)},registerTypeDefinitionProvider(re,ue){return ht.registerTypeDefinitionProvider(Ue,pt(re),ue)},registerHoverProvider(re,ue){return ht.registerHoverProvider(Ue,pt(re),ue,Ue.identifier)},registerEvaluatableExpressionProvider(re,ue){return ht.registerEvaluatableExpressionProvider(Ue,pt(re),ue,Ue.identifier)},registerInlineValuesProvider(re,ue){return ht.registerInlineValuesProvider(Ue,pt(re),ue,Ue.identifier)},registerDocumentHighlightProvider(re,ue){return ht.registerDocumentHighlightProvider(Ue,pt(re),ue)},registerMultiDocumentHighlightProvider(re,ue){return ht.registerMultiDocumentHighlightProvider(Ue,pt(re),ue)},registerLinkedEditingRangeProvider(re,ue){return ht.registerLinkedEditingRangeProvider(Ue,pt(re),ue)},registerReferenceProvider(re,ue){return ht.registerReferenceProvider(Ue,pt(re),ue)},registerRenameProvider(re,ue){return ht.registerRenameProvider(Ue,pt(re),ue)},registerDocumentSymbolProvider(re,ue,Oe){return ht.registerDocumentSymbolProvider(Ue,pt(re),ue,Oe)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(Ue,re)},registerDocumentFormattingEditProvider(re,ue){return ht.registerDocumentFormattingEditProvider(Ue,pt(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return ht.registerDocumentRangeFormattingEditProvider(Ue,pt(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Oe,...ot){return ht.registerOnTypeFormattingEditProvider(Ue,pt(re),ue,[Oe].concat(ot))},registerDocumentSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentSemanticTokensProvider(Ue,pt(re),ue,Oe)},registerDocumentRangeSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentRangeSemanticTokensProvider(Ue,pt(re),ue,Oe)},registerSignatureHelpProvider(re,ue,Oe,...ot){return typeof Oe=="object"?ht.registerSignatureHelpProvider(Ue,pt(re),ue,Oe):ht.registerSignatureHelpProvider(Ue,pt(re),ue,typeof Oe>"u"?[]:[Oe,...ot])},registerCompletionItemProvider(re,ue,...Oe){return ht.registerCompletionItemProvider(Ue,pt(re),ue,Oe)},registerInlineCompletionItemProvider(re,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Ye.$CF)(Ue,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$CF)(Ue,"inlineCompletionsAdditions"),Oe&&(0,Ye.$CF)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,pt(re),ue,Oe)},registerDocumentLinkProvider(re,ue){return ht.registerDocumentLinkProvider(Ue,pt(re),ue)},registerColorProvider(re,ue){return ht.registerColorProvider(Ue,pt(re),ue)},registerFoldingRangeProvider(re,ue){return ht.registerFoldingRangeProvider(Ue,pt(re),ue)},registerSelectionRangeProvider(re,ue){return ht.registerSelectionRangeProvider(Ue,re,ue)},registerCallHierarchyProvider(re,ue){return ht.registerCallHierarchyProvider(Ue,re,ue)},registerTypeHierarchyProvider(re,ue){return ht.registerTypeHierarchyProvider(Ue,re,ue)},setLanguageConfiguration:(re,ue)=>ht.setLanguageConfiguration(Ue,re,ue),getTokenInformationAtPosition(re,ue){return(0,Ye.$CF)(Ue,"tokenInformation"),li.tokenAtPosition(re,ue)},registerInlayHintsProvider(re,ue){return ht.registerInlayHintsProvider(Ue,re,ue)},createLanguageStatusItem(re,ue){return li.createLanguageStatusItem(Ue,re,ue)},registerDocumentDropEditProvider(re,ue,Oe){return ht.registerDocumentOnDropEditProvider(Ue,re,ue,(0,Ye.$BF)(Ue,"dropMetadata")?Oe:void 0)}},mn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return _e.activeTerminal},get terminals(){return _e.terminals},async showTextDocument(re,ue,Oe){const ot=await(g.URI.isUri(re)?Promise.resolve(sn.openTextDocument(re)):Promise.resolve(re));return Ot.showTextDocument(ot,ue,Oe)},createTextEditorDecorationType(re){return Ot.createTextEditorDecorationType(Ue,re)},onDidChangeActiveTextEditor(re,ue,Oe){return et(Ot.onDidChangeActiveTextEditor)(re,ue,Oe)},onDidChangeVisibleTextEditors(re,ue,Oe){return et(Ot.onDidChangeVisibleTextEditors)(re,ue,Oe)},onDidChangeTextEditorSelection(re,ue,Oe){return et(Ot.onDidChangeTextEditorSelection)(re,ue,Oe)},onDidChangeTextEditorOptions(re,ue,Oe){return et(Ot.onDidChangeTextEditorOptions)(re,ue,Oe)},onDidChangeTextEditorVisibleRanges(re,ue,Oe){return et(Ot.onDidChangeTextEditorVisibleRanges)(re,ue,Oe)},onDidChangeTextEditorViewColumn(re,ue,Oe){return et(Ot.onDidChangeTextEditorViewColumn)(re,ue,Oe)},onDidCloseTerminal(re,ue,Oe){return et(_e.onDidCloseTerminal)(re,ue,Oe)},onDidOpenTerminal(re,ue,Oe){return et(_e.onDidOpenTerminal)(re,ue,Oe)},onDidChangeActiveTerminal(re,ue,Oe){return et(_e.onDidChangeActiveTerminal)(re,ue,Oe)},onDidChangeTerminalDimensions(re,ue,Oe){return(0,Ye.$CF)(Ue,"terminalDimensions"),et(_e.onDidChangeTerminalDimensions)(re,ue,Oe)},onDidChangeTerminalState(re,ue,Oe){return et(_e.onDidChangeTerminalState)(re,ue,Oe)},onDidWriteTerminalData(re,ue,Oe){return(0,Ye.$CF)(Ue,"terminalDataWriteEvent"),et(_e.onDidWriteTerminalData)(re,ue,Oe)},onDidExecuteTerminalCommand(re,ue,Oe){return(0,Ye.$CF)(Ue,"terminalExecuteCommandEvent"),et(_e.onDidExecuteTerminalCommand)(re,ue,Oe)},get state(){return Fe.getState(Ue)},onDidChangeWindowState(re,ue,Oe){return et(Fe.onDidChangeWindowState)(re,ue,Oe)},showInformationMessage(re,...ue){return Di.showMessage(Ue,$.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return Di.showMessage(Ue,$.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return Di.showMessage(Ue,$.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Oe){return si.showQuickPick(Ue,re,ue,Oe)},showWorkspaceFolderPick(re){return si.showWorkspaceFolderPick(re)},showInputBox(re,ue){return si.showInput(re,ue)},showOpenDialog(re){return Oi.showOpenDialog(Ue,re)},showSaveDialog(re){return Oi.showSaveDialog(re)},createStatusBarItem(re,ue,Oe){let ot,wt,Lt;return typeof re=="string"?(ot=re,wt=ue,Lt=Oe):(wt=re,Lt=ue),ei.createStatusBarEntry(Ue,ot,wt,Lt)},setStatusBarMessage(re,ue){return ei.setStatusBarMessage(re,ue)},withScmProgress(re){return Se.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),vi.withProgress(Ue,{location:Ne.ProgressLocation.SourceControl},(ue,Oe)=>re({report(ot){}}))},withProgress(re,ue){return vi.withProgress(Ue,re,ue)},createOutputChannel(re,ue){return St.createOutputChannel(re,ue,Ue)},createWebviewPanel(re,ue,Oe,ot){return Mi.createWebviewPanel(Ue,re,ue,Oe,ot)},createWebviewTextEditorInset(re,ue,Oe,ot){return(0,Ye.$CF)(Ue,"editorInsets"),Pi.createWebviewEditorInset(re,ue,Oe,ot,Ue)},createTerminal(re,ue,Oe){return typeof re=="object"?"pty"in re?_e.createExtensionTerminal(re):_e.createTerminalFromOptions(re):_e.createTerminal(re,ue,Oe)},registerTerminalLinkProvider(re){return _e.registerLinkProvider(re)},registerTerminalProfileProvider(re,ue){return _e.registerProfileProvider(Ue,re,ue)},registerTerminalQuickFixProvider(re,ue){return(0,Ye.$CF)(Ue,"terminalQuickFixProvider"),_e.registerTerminalQuickFixProvider(re,Ue.identifier.value,ue)},registerTreeDataProvider(re,ue){return $i.registerTreeDataProvider(re,ue,Ue)},createTreeView(re,ue){return $i.createTreeView(re,ue,Ue)},registerWebviewPanelSerializer:(re,ue)=>Mi.registerWebviewPanelSerializer(Ue,re,ue),registerCustomEditorProvider:(re,ue,Oe={})=>un.registerCustomEditorProvider(Ue,re,ue,Oe),registerFileDecorationProvider(re){return ze.registerFileDecorationProvider(re,Ue)},registerUriHandler(re){return gi.registerUriHandler(Ue,re)},createQuickPick(){return si.createQuickPick(Ue)},createInputBox(){return si.createInputBox(Ue)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Oe){return et(Li.onDidChangeActiveColorTheme)(re,ue,Oe)},registerWebviewViewProvider(re,ue,Oe){return Fi.registerWebviewViewProvider(Ue,re,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Oe){return et(It.onDidChangeActiveNotebookEditor)(re,ue,Oe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return et(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(re,ue,Oe){return et(mi.onDidChangeNotebookEditorSelection)(re,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Oe){return et(mi.onDidChangeNotebookEditorVisibleRanges)(re,ue,Oe)},showNotebookDocument(re,ue){return It.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Oe){return(0,Ye.$CF)(Ue,"externalUriOpener"),ln.registerExternalUriOpener(Ue.identifier,re,ue,Oe)},registerProfileContentHandler(re,ue){return(0,Ye.$CF)(Ue,"profileContentHandlers"),hn.registerProfileContentHandler(Ue,re,ue)},registerQuickDiffProvider(re,ue,Oe,ot){return(0,Ye.$CF)(Ue,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(re),ue,Oe,ot)},get tabGroups(){return G.tabGroups},registerShareProvider(re,ue){return(0,Ye.$CF)(Ue,"shareProvider"),Qi.registerShareProvider(pt(re),ue)}},sn={get rootPath(){return Se.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(re){throw new T.$9("rootPath")},getWorkspaceFolder(re){return dt.getWorkspaceFolder(re)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(re){throw new T.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(re){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(re,ue,...Oe)=>dt.updateWorkspaceFolders(Ue,re,ue||0,...Oe),onDidChangeWorkspaceFolders:function(re,ue,Oe){return et(dt.onDidChangeWorkspace)(re,ue,Oe)},asRelativePath:(re,ue)=>dt.getRelativePath(re,ue),findFiles:(re,ue,Oe,ot)=>dt.findFiles(re,ue,Oe,Ue.identifier,ot),findTextInFiles:(re,ue,Oe,ot)=>{(0,Ye.$CF)(Ue,"findTextInFiles");let wt,Lt;return typeof ue=="object"?(wt=ue,Lt=Oe):(wt={},Lt=ue,ot=Oe),dt.findTextInFiles(re,wt||{},Lt,Ue.identifier,ot)},save:re=>dt.save(re),saveAs:re=>dt.saveAs(re),saveAll:re=>dt.saveAll(re),applyEdit(re,ue){return Zt.applyWorkspaceEdit(re,Ue,ue)},createFileSystemWatcher:(re,ue,Oe,ot)=>{let wt;return typeof ue=="boolean"?wt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ot,correlate:!1}:ue&&((0,Ye.$CF)(Ue,"createFileSystemWatcher"),wt={...ue,correlate:!0}),_t.createFileSystemWatcher(dt,Ue,re,wt)},get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new T.$9("textDocuments")},openTextDocument(re){let ue;const Oe=re;if(typeof re=="string")ue=Promise.resolve(g.URI.file(re));else if(g.URI.isUri(re))ue=Promise.resolve(re);else if(!Oe||typeof Oe=="object")ue=At.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ot=>At.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(re,ue,Oe)=>et(At.onDidAddDocument)(re,ue,Oe),onDidCloseTextDocument:(re,ue,Oe)=>et(At.onDidRemoveDocument)(re,ue,Oe),onDidChangeTextDocument:(re,ue,Oe)=>et(At.onDidChangeDocument)(re,ue,Oe),onDidSaveTextDocument:(re,ue,Oe)=>et(At.onDidSaveDocument)(re,ue,Oe),onWillSaveTextDocument:(re,ue,Oe)=>et(Gi.getOnWillSaveTextDocumentEvent(Ue))(re,ue,Oe),get notebookDocuments(){return It.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ue){let Oe;if(g.URI.isUri(re))Oe=re,await It.openNotebookDocument(re);else if(typeof re=="string")Oe=g.URI.revive(await It.createNotebookDocument({viewType:re,content:ue}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,ue,Oe){return et(ri.onDidSaveNotebookDocument)(re,ue,Oe)},onDidChangeNotebookDocument(re,ue,Oe){return et(ri.onDidChangeNotebookDocument)(re,ue,Oe)},onWillSaveNotebookDocument(re,ue,Oe){return et(Ci.getOnWillSaveNotebookDocumentEvent(Ue))(re,ue,Oe)},get onDidOpenNotebookDocument(){return et(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return et(It.onDidCloseNotebookDocument)},registerNotebookSerializer(re,ue,Oe,ot){return It.registerNotebookSerializer(Ue,re,ue,Oe,(0,Ye.$BF)(Ue,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(re,ue,Oe)=>et(tn.onDidChangeConfiguration)(re,ue,Oe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,tn.getConfiguration(re,ue,Ue)},registerTextDocumentContentProvider(re,ue){return Si.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Se.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Ue,re,ue)),registerFileSystemProvider(re,ue,Oe){return(0,M.$Qc)(Ji.registerFileSystemProvider(Ue,re,ue,Oe),Wt.addFileSystemProvider(re,ue,Oe))},get fs(){return Wt.value},registerFileSearchProvider:(re,ue)=>((0,Ye.$CF)(Ue,"fileSearchProvider"),zt.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,Ye.$CF)(Ue,"textSearchProvider"),zt.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,Ye.$CF)(Ue,"resolvers"),Dt.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,Ye.$CF)(Ue,"resolvers"),Xi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Ye.$CF)(Ue,"resolvers"),Dt.getRemoteExecServer(re)),onDidCreateFiles:(re,ue,Oe)=>et(_t.onDidCreateFile)(re,ue,Oe),onDidDeleteFiles:(re,ue,Oe)=>et(_t.onDidDeleteFile)(re,ue,Oe),onDidRenameFiles:(re,ue,Oe)=>et(_t.onDidRenameFile)(re,ue,Oe),onWillCreateFiles:(re,ue,Oe)=>et(_t.getOnWillCreateFileEvent(Ue))(re,ue,Oe),onWillDeleteFiles:(re,ue,Oe)=>et(_t.getOnWillDeleteFileEvent(Ue))(re,ue,Oe),onWillRenameFiles:(re,ue,Oe)=>et(_t.getOnWillRenameFileEvent(Ue))(re,ue,Oe),openTunnel:re=>((0,Ye.$CF)(Ue,"tunnels"),Ft.openTunnel(Ue,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ye.$CF)(Ue,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(re,ue,Oe)=>((0,Ye.$CF)(Ue,"tunnels"),et(Ft.onDidChangeTunnels)(re,ue,Oe)),registerPortAttributesProvider:(re,ue)=>((0,Ye.$CF)(Ue,"portsAttributes"),Ft.registerPortsAttributesProvider(re,ue)),registerTunnelProvider:(re,ue)=>((0,Ye.$CF)(Ue,"tunnelFactory"),Ft.registerTunnelProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,Ye.$CF)(Ue,"timeline"),Zi.registerTimelineProvider(re,ue,Ue.identifier,Ve.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:re=>((0,Ye.$CF)(Ue,"workspaceTrust"),dt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ue,Oe)=>et(dt.onDidGrantWorkspaceTrust)(re,ue,Oe),registerEditSessionIdentityProvider:(re,ue)=>((0,Ye.$CF)(Ue,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(re,ue)),onWillCreateEditSessionIdentity:(re,ue,Oe)=>((0,Ye.$CF)(Ue,"editSessionIdentityProvider"),et(dt.getOnWillCreateEditSessionIdentityEvent(Ue))(re,ue,Oe)),registerCanonicalUriProvider:(re,ue)=>((0,Ye.$CF)(Ue,"canonicalUriProvider"),dt.registerCanonicalUriProvider(re,ue)),getCanonicalUri:(re,ue,Oe)=>((0,Ye.$CF)(Ue,"canonicalUriProvider"),dt.provideCanonicalUri(re,ue,Oe))},on={get inputBox(){return Se.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(Ue)},createSourceControl(re,ue,Oe){return pi.createSourceControl(Ue,re,ue,Oe)}},an={createCommentController(re,ue){return Ai.createCommentController(Ue,re,ue)}},zi={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(re,ue,Oe){return et(mt.onDidStartDebugSession)(re,ue,Oe)},onDidTerminateDebugSession(re,ue,Oe){return et(mt.onDidTerminateDebugSession)(re,ue,Oe)},onDidChangeActiveDebugSession(re,ue,Oe){return et(mt.onDidChangeActiveDebugSession)(re,ue,Oe)},onDidReceiveDebugSessionCustomEvent(re,ue,Oe){return et(mt.onDidReceiveDebugSessionCustomEvent)(re,ue,Oe)},onDidChangeBreakpoints(re,ue,Oe){return et(mt.onDidChangeBreakpoints)(re,ue,Oe)},onDidChangeStackFrameFocus(re,ue,Oe){return(0,Ye.$CF)(Ue,"debugFocus"),et(mt.onDidChangeStackFrameFocus)(re,ue,Oe)},registerDebugConfigurationProvider(re,ue,Oe){return mt.registerDebugConfigurationProvider(re,ue,Oe||Ut.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return mt.registerDebugAdapterDescriptorFactory(Ue,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return mt.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?mt.startDebugging(re,ue,{parentSession:Oe}):mt.startDebugging(re,ue,Oe||{})},stopDebugging(re){return mt.stopDebugging(re)},addBreakpoints(re){return mt.addBreakpoints(re)},removeBreakpoints(re){return mt.removeBreakpoints(re)},asDebugSourceUri(re,ue){return mt.asDebugSourceUri(re,ue)}},Bi={registerTaskProvider:(re,ue)=>Et.registerTaskProvider(Ue,re,ue),fetchTasks:re=>Et.fetchTasks(re),executeTask:re=>Et.executeTask(Ue,re),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(re,ue,Oe)=>et(Et.onDidStartTask)(re,ue,Oe),onDidEndTask:(re,ue,Oe)=>et(Et.onDidEndTask)(re,ue,Oe),onDidStartTaskProcess:(re,ue,Oe)=>et(Et.onDidStartTaskProcess)(re,ue,Oe),onDidEndTaskProcess:(re,ue,Oe)=>et(Et.onDidEndTaskProcess)(re,ue,Oe)},Wi={createNotebookController(re,ue,Oe,ot,wt){return ci.createNotebookController(Ue,re,ue,Oe,ot,(0,Ye.$BF)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,ue)=>It.registerNotebookCellStatusBarItemProvider(Ue,re,ue),createRendererMessaging(re){return Ii.createRendererMessaging(Ue,re)},createNotebookControllerDetectionTask(re){return(0,Ye.$CF)(Ue,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(Ue,re)},registerKernelSourceActionProvider(re,ue){return(0,Ye.$CF)(Ue,"notebookKernelSource"),ci.registerKernelSourceActionProvider(Ue,re,ue)},onDidChangeNotebookCellExecutionState(re,ue,Oe){return(0,Ye.$CF)(Ue,"notebookCellExecutionState"),et(ci.onDidChangeNotebookCellExecutionState)(re,ue,Oe)}},ki={t(...re){if(typeof re[0]=="string"){const ue=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return bt.getMessage(Ue.identifier.value,{message:ue,args:Oe})}return bt.getMessage(Ue.identifier.value,re[0])},get bundle(){return bt.getBundle(Ue.identifier.value)},get uri(){return bt.getBundleUri(Ue.identifier.value)}},Vi={_version:1,registerInteractiveEditorSessionProvider(re,ue){return(0,Ye.$CF)(Ue,"interactive"),Yi.registerProvider(Ue,re,ue)},registerInteractiveSessionProvider(re,ue){return(0,Ye.$CF)(Ue,"interactive"),bi.registerChatProvider(Ue,re,ue)},sendInteractiveRequestToProvider(re,ue){return(0,Ye.$CF)(Ue,"interactive"),bi.sendInteractiveRequestToProvider(re,ue)},transferChatSession(re,ue){return(0,Ye.$CF)(Ue,"interactive"),bi.transferChatSession(re,ue)}},qi={getRelatedInformation(re,ue){return(0,Ye.$CF)(Ue,"aiRelatedInformation"),en.getRelatedInformation(Ue,re,ue)},registerRelatedInformationProvider(re,ue){return(0,Ye.$CF)(Ue,"aiRelatedInformation"),en.registerRelatedInformationProvider(Ue,re,ue)},registerEmbeddingVectorProvider(re,ue){return(0,Ye.$CF)(Ue,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(Ue,re,ue)}},$n={registerChatResponseProvider(re,ue,Oe){return(0,Ye.$CF)(Ue,"chatProvider"),di.registerProvider(Ue.identifier,re,ue,Oe)},requestChatAccess(re){return(0,Ye.$CF)(Ue,"chatRequestAccess"),di.requestChatResponseProvider(Ue.identifier,re)},registerVariable(re,ue,Oe){return(0,Ye.$CF)(Ue,"chatVariables"),_i.registerVariableResolver(Ue,re,ue,Oe)},registerMappedEditsProvider(re,ue){return(0,Ye.$CF)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,re,ue)},createChatAgent(re,ue){return(0,Ye.$CF)(Ue,"chatAgents2"),xi.createChatAgent(Ue,re,ue)}},pn={registerSpeechProvider(re,ue){return(0,Ye.$CF)(Ue,"speech"),yi.registerProvider(Ue.identifier,re,ue)}};return{version:$t.version,ai:qi,authentication:fn,commands:gn,comments:an,chat:$n,debug:zi,env:Ui,extensions:nn,interactive:Vi,l10n:ki,languages:rn,notebooks:Wi,scm:on,speech:pn,tasks:Bi,tests:ji,window:mn,workspace:sn,Breakpoint:Ne.$6L,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$XM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$WM,CallHierarchyIncomingCall:Ne.$sL,CallHierarchyItem:Ne.$rL,CallHierarchyOutgoingCall:Ne.$tL,CancellationError:T.$5,CancellationTokenSource:E.$5d,CandidatePortSource:a.CandidatePortSource,CodeAction:Ne.$oL,CodeActionKind:Ne.$pL,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$uL,Color:Ne.$HL,ColorInformation:Ne.$IL,ColorPresentation:Ne.$JL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$BL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$CL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$RL,DebugAdapterExecutable:Ne.$0L,DebugAdapterInlineImplementation:Ne.$aM,DebugAdapterNamedPipeServer:Ne.$_L,DebugAdapterServer:Ne.$$L,DebugConfigurationProviderTriggerKind:Ut.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$iL,DiagnosticRelatedInformation:Ne.$hL,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$7K,DocumentHighlight:Ne.$kL,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$lL,DocumentLink:Ne.$GL,DocumentSymbol:Ne.$nL,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$dM,InlineValueText:Ne.$eM,InlineValueVariableLookup:Ne.$fM,InlineValueEvaluatableExpression:Ne.$gM,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$Ud,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$qM,FileDecoration2:Ne.$qM,FileSystemError:Ne.$iM,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Ne.$jM,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$8L,InlineCompletionItem:Ne.$DL,InlineCompletionList:Ne.$EL,Hover:Ne.$jL,IndentAction:k.IndentAction,Location:Ne.$gL,MarkdownString:Ne.$vL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$wL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$8K,ProcessExecution:Ne.$PL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$pM,Range:Ne.$9K,RelativePattern:Ne.$4L,Selection:Ne.$0K,SelectionRange:Ne.$qL,SemanticTokens:Ne.$mM,SemanticTokensBuilder:Ne.$lM,SemanticTokensEdit:Ne.$nM,SemanticTokensEdits:Ne.$oM,SemanticTokensLegend:Ne.$kM,ShellExecution:Ne.$QL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$yL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$xL,SnippetString:Ne.$fL,SourceBreakpoint:Ne.$7L,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$mL,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$SL,TaskGroup:Ne.$OL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$KL,TerminalQuickFixTerminalCommand:Ne.$ML,TerminalQuickFixOpener:Ne.$LL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$NL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$bL,SnippetTextEdit:Ne.$dL,TextEditorCursorStyle:b.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$3L,ThemeIcon:Ne.$2L,TreeItem:Ne.$TL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$LM,UIKind:Rt.UIKind,Uri:g.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$eL,DocumentDropEdit:Ne.$ZL,DocumentPasteEdit:Ne.$1L,InlayHint:Ne.$AL,InlayHintLabelPart:Ne.$zL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$aL,ResolvedAuthority:Ne.$$K,ManagedResolvedAuthority:Ne.$_K,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$AM,NotebookRange:Ne.$sM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$tM,NotebookData:Ne.$uM,NotebookRendererScript:Ne.$yM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$wM,NotebookCellOutputItem:Ne.$vM,NotebookCellStatusBarItem:Ne.$xM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$cL,NotebookKernelSourceAction:Ne.$zM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$CM,LinkedEditingRanges:Ne.$BM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$DM,TestMessage:Ne.$EM,TestMessage2:Ne.$EM,TestTag:Ne.$FM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Ne.$YL,DataTransferItem:Ne.$UL,CoveredCount:Ne.$GM,FileCoverage:Ne.$HM,StatementCoverage:Ne.$IM,BranchCoverage:Ne.$JM,FunctionCoverage:Ne.$KM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$MM,TabInputTextDiff:Ne.$NM,TabInputTextMerge:Ne.$OM,TabInputCustom:Ne.$PM,TabInputNotebook:Ne.$RM,TabInputNotebookDiff:Ne.$SM,TabInputWebview:Ne.$QM,TabInputTerminal:Ne.$TM,TabInputInteractiveWindow:Ne.$UM,TabInputChat:Ne.$VM,TelemetryTrustedValue:t.$Jo,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$bM,ThreadFocus:Ne.$cM,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$Yhc=Jt}),define(Pe[290],Re([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,255,14,116,82,83]),function(ge,e,E,T,I,M,R,$,g,b,A,k,l,p,w,r,o,t,n,a,c,h,i,s,u,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Xr)(d.$Ngc,d.$Mgc,1),(0,E.$Xr)(s.$nj,i.$Zhc,1),(0,E.$Xr)(r.$Yfc,r.$Zfc,1),(0,E.$Xr)($.$sN,$.$rN,0),(0,E.$Xr)(R.$hgc,R.$fgc,0),(0,E.$Xr)(t.$jgc,t.$igc,0),(0,E.$Xr)(k.$Xgc,k.$2gc,0),(0,E.$Xr)(M.$4gc,M.$3gc,0),(0,E.$Xr)(g.$hN,g.$gN,0),(0,E.$Xr)(m.$Ogc,m.$Pgc,0),(0,E.$Xr)(n.$Vfc,n.$Ufc,0),(0,E.$Xr)(T.$xhc,T.$whc,1),(0,E.$Xr)(l.$hhc,l.$ihc,0),(0,E.$Xr)(p.$Cgc,p.$Bgc,0),(0,E.$Xr)(A.$Khc,A.$Jhc,0),(0,E.$Xr)(b.$Fgc,b.$Igc,0),(0,E.$Xr)(w.$hyb,w.$iyb,0),(0,E.$Xr)(o.$Xhc,o.$Whc,0),(0,E.$Xr)(I.$egc,I.$dgc,0),(0,E.$Xr)(a.$Kgc,a.$Jgc,0),(0,E.$Xr)(c.$qN,c.$nN,0),(0,E.$Xr)(h.$tgc,h.$ugc,0),(0,E.$Xr)(u.$Vgc,u.$Wgc,0)}),define(Pe[291],Re([1,0,289,38,2,286,7,13,274]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;class b extends M.$3hc{j(){}getModule(p,w){for(const r of this.b){const o=r(p);if(o){p=o;break}}if(this.a.has(p))return this.a.get(p).load(p,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends T.$Rgc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$0jc);const p=this.h.invokeFunction(E.$Yhc);this.r=this.h.createInstance(b,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,w,r){w=w.with({path:k(w.path,".js")});const o=p?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const t=I.URI.revive(await this.C.$asBrowserUri(w)),n=await fetch(t.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const a=await n.text(),c=`${w.toString(!0)}#vscode-extension`,h=`${a}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(m){throw console.error(o?`Loading code for extension ${o} failed: ${m.message}`:`Loading code failed: ${m.message}`),console.error(`${w.toString(!0)}${typeof m.line=="number"?` line ${m.line}`:""}${typeof m.column=="number"?` column ${m.column}`:""}`),console.error(m),m}p&&await this.w.initializeLocalizedMessages(p);const s={},u={exports:s},d=m=>{const f=this.r.getModule(m,w);if(f===void 0)throw new Error(`Cannot load module '${m}'`);return f};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(u,s,d),u.exports!==s?u.exports:s}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+p;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,$.$6g)(10)}}e.$$jc=A;function k(l,p){return l.endsWith(p)?l:l+p}}),define(Pe[292],Re([1,0,69,70,14,38,199,86,291]),function(ge,e,E,T,I,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Xr)(I.$mj,new E.$2h(R.$2hc,[!0],!0)),(0,T.$Xr)(M.$Sgc,g.$$jc,0),(0,T.$Xr)($.$kgc,$.$lgc,0)}),define(Pe[297],Re([1,0,24,5,79,287,276,19,88,12,2,290,292]),function(ge,e,E,T,I,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(i){return/^(file|vscode-remote):/i.test(i)}const w=fetch.bind(self);function r(i){self.fetch=async function(s,u){return s instanceof Request||p(String(s))&&(s=(await i(A.URI.parse(String(s)))).toString(!0)),w(s,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,u,d,m,f){(async()=>(p(u.toString())&&(u=(await i(A.URI.parse(u.toString()))).toString(!0)),super.open(s,u,d??!0,m,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(s,u){if(/^file:/i.test(s.toString()))s=b.$ng.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const m=`(${function(v){function y(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const D=fetch.bind(self);self.fetch=function(O,H){return O instanceof Request?D(O,H):D(y(O),H)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,H,U,W,P){return super.open(O,y(H),U??!0,W,P)}};const N=importScripts.bind(self);self.importScripts=(...O)=>{N(...O.map(y))},N(v)}.toString()}('${s}'))`;u=u||{},u.name=u.name||$.$nc(s.toString());const f=new Blob([m],{type:"application/javascript"}),S=URL.createObjectURL(f);return new i(S,u)}}else self.Worker=class extends R.$_jc{constructor(i,s){super(l,i,{name:$.$nc(i.toString()),...s})}};const o=new class{constructor(){this.pid=void 0}exit(i){k()}};class t{constructor(){const s=new MessageChannel,u=new T.$Ud;let d=!1;l(s.port2,[s.port2]),s.port1.onmessage=m=>{const{data:f}=m;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const S=E.$ie.wrap(new Uint8Array(f,0,f.byteLength));if((0,I.$tm)(S,2)){d=!0,a("received terminate message from renderer");return}u.fire(S)},this.protocol={onMessage:u.event,send:m=>{if(!d){const f=m.buffer.buffer.slice(m.buffer.byteOffset,m.buffer.byteOffset+m.buffer.byteLength);s.port1.postMessage(f,[f])}}}}}function n(i){return new Promise(s=>{const u=i.onMessage(d=>{u.dispose();const m=JSON.parse(d.toString());i.send((0,I.$sm)(0)),s({protocol:i,initData:m})});i.send((0,I.$sm)(1))})}let a=i=>k();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(s){c(s)&&n(i.protocol).then(u=>{g.mark("code/extHost/didWaitForInitData");const d=new M.$5hc(u.protocol,u.initData,o,null,s.data);r(m=>d.asBrowserUri(m)),a=m=>d.terminate(m)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c973ec767338f7846710cc2ee46e38b4504a044c/core/vs/workbench/api/worker/extensionHostWorker.js.map
